﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_Authentication : System.Web.UI.Page
{
    protected string mAuthName = "";
    protected string mAuthUser = "";
    protected string mAuthTel = "";
    protected string mAuthEmail = "";
    protected string mAuthKey = "";
    protected string mAuthPublic = "";
    protected string mAuthMsg = "";
    protected string mProductVersion = "";
    protected int mUserCount = 0;
    private WebFunction WF = null;
    private AuthKey ak = null;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Mail/Main.aspx");
        }

        ak = new AuthKey();

        if (!Page.IsPostBack)
        {
            if (File.Exists(Passkorea.Configuration.GetMailDirPath + "\\AuthKeyInfo.dat"))
            {
                tblFormAuthKey.Visible = false;
                tblShowAuthInfo.Visible = true;
                this.CheckAuthKey();
            }
            else
            {
                tblFormAuthKey.Visible = true;
                tblShowAuthInfo.Visible = false;
            }
        }

        ibAuthBtn.Attributes.Add("onclick", "if (!AddAuthKey()) return false; else return true;");
        Page.DataBind();
    }

    private void CheckAuthKey()
    {
        if (!ak.AuthenticationKey())
        {
            WF.WriteMessage(ak.ErrorMessage.Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        mAuthName = ak.Company;
        mAuthUser = ak.AuthUser;
        mAuthTel = ak.AuthTel;
        mAuthEmail = ak.AuthEmail;
        mAuthKey = ak.Key;
        mAuthPublic = ak.Public;
        mAuthMsg = ak.ErrorMessage;
        mProductVersion = ak.ProductVertion;

        if (mAuthKey.Trim() == "")
        {
            WF.WriteMessage("인증키가 등록되지 않았습니다.");
            return;
        }

        if (!Passkorea.Configuration.CheckAuthKey(mAuthKey))
        {
            WF.WriteMessage("잘못된 인증키 입니다.\\r\\n\\r\\n인증키가 잘못되면 메일 발송시에 Nmail 광고 문구가 붙어서 발송됩니다.");
            return;
        }
        mUserCount = Passkorea.Configuration.UserCount;
    }

    #region 인증키 등록
    /// <summary>
    /// 인증키 등록
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAuthBtn_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strAuthName = tbAuthName.Text;
        string strAuthUser = tbAuthUser.Text;
        string strAuthTel = tbAuthTel.Text;
        string strAuthEMail = tbAuthEmail.Text;
        string strAuthKey = tbAuthKey1.Text + "-" + tbAuthKey2.Text + "-" + tbAuthKey3.Text + "-" + tbAuthKey4.Text;
        bool bStatus = false;

        bStatus = ak.RegistryAuthKey(strAuthName, strAuthUser, strAuthTel, strAuthEMail, strAuthKey);

        if (!bStatus)
        {
            WF.WriteMessage(ak.ErrorMessage.Replace("\r\n", "\\r\\n"));
            return;
        }

        WF.WriteMessage("인증키가 등록되었습니다.");
        WF.MovePage("Authentication.aspx");
        return;
    }
    #endregion
}
