﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_BoardInfo_AddBoard : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbDataAdapter Adap;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbTransaction Trans;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private WebFunction WF;
    private UserInfo UI;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        // 권한 체크
        // 권한이 1이 아니면 메인화면으로 페이지를 이동시킨다.
        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Mail/Main.aspx");
        }

        if (!Page.IsPostBack)
        {
            // 게시판 생성 기본값 설정
            // 게시판 관리자 아이디는 웹메일 관리자 아이디로 기본 설정
            tbBrdDocCnt.Text = "10";
            tbBrdListCnt.Text = "10";
            tbBrdAdminId.Text = Session["USER_ID"].ToString();
            rblBrdIsAttach.SelectedIndex = 0;
            this.UserPermitCodeBind();
        }

        ibAddBoard.Attributes.Add("onclick", "if (!AddBoard()) return false; else return true;");
    }

    #region 회원 권한 코드를 가져온다.
    /// <summary>
    /// 회원 권한 코드를 가져온다.
    /// </summary>
    private void UserPermitCodeBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("AddBoard.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUserPermit";

            Cmd.Parameters.Clear();

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "CODE");
            dt = ds.Tables["CODE"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    string strCodeName = dr["CODE_NAME"].ToString();
                    string strCodeId = dr["CODE_ID"].ToString();

                    ListItem liList = new ListItem(strCodeName, strCodeId);
                    ListItem liRead = new ListItem(strCodeName, strCodeId);
                    ListItem liWrite = new ListItem(strCodeName, strCodeId);
                    ListItem liModify = new ListItem(strCodeName, strCodeId);
                    ListItem liDelete = new ListItem(strCodeName, strCodeId);
                    ListItem liReply = new ListItem(strCodeName, strCodeId);

                    ddlAuthList.Items.Add(liList);
                    ddlAuthRead.Items.Add(liRead);
                    ddlAuthWrite.Items.Add(liWrite);
                    ddlAuthModify.Items.Add(liModify);
                    ddlAuthDelete.Items.Add(liDelete);
                    ddlAuthReply.Items.Add(liReply);
                }

                ddlAuthList.SelectedIndex = 1;
                ddlAuthRead.SelectedIndex = 1;
                ddlAuthWrite.SelectedIndex = 1;
                ddlAuthModify.SelectedIndex = 1;
                ddlAuthDelete.SelectedIndex = 1;
                ddlAuthReply.SelectedIndex = 1;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("사용자 권한을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 게시판 등록 버튼
    /// <summary>
    /// 게시판 등록 버튼
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAddBoard_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strBrdName = tbBrdName.Text;
        string strBrdDocCnt = tbBrdDocCnt.Text;
        string strBrdListCnt = tbBrdListCnt.Text;
        string strAdminId = tbBrdAdminId.Text;
        string strIsAttach = rblBrdIsAttach.SelectedValue;
        string strBrdHeader = tbBrdHeader.Text;
        string strBrdFooter = tbBrdFooter.Text;
        string strAuthList = ddlAuthList.SelectedValue;
        string strAuthRead = ddlAuthRead.SelectedValue;
        string strAuthWrite = ddlAuthWrite.SelectedValue;
        string strAuthModify = ddlAuthModify.SelectedValue;
        string strAuthDelete = ddlAuthDelete.SelectedValue;
        string strAuthReply = ddlAuthReply.SelectedValue;
        int iBrdMaxNo = 0;

        if (strBrdName.Length > 20)
        {
            WF.WriteMessage("게시판 이름이 제한길이 20자를 초과했습니다.");
            WF.HistoryBack();
            return;
        }

        if (strAdminId.Length > 15)
        {
            WF.WriteMessage(strAdminId + " 아이디 길이가 15자를 초과했습니다.\\r\\n\\r\\n다른아이디를 선택해 주세요.");
            WF.HistoryBack();
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("AddBoard.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prAddBoard";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 이름
            sParams = Cmd.Parameters.Add("@varBrdName", OleDbType.VarWChar, strBrdName.Length);
            sParams.Direction = ParameterDirection.Input;

            // 도메인명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 출력 게시물 수
            sParams = Cmd.Parameters.Add("@iDocCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 페이지 리스트 수
            sParams = Cmd.Parameters.Add("@iBrdListCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 첨부파일 사용여부
            sParams = Cmd.Parameters.Add("@chrBrdIsAttach", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 머릿말
            sParams = Cmd.Parameters.Add("@varHeader", OleDbType.VarWChar, strBrdHeader.Length);
            sParams.Direction = ParameterDirection.Input;

            // 꼬릿말
            sParams = Cmd.Parameters.Add("@varFooter", OleDbType.VarWChar, strBrdFooter.Length);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 접근 권한
            sParams = Cmd.Parameters.Add("@chrAuthList", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 읽기 권한
            sParams = Cmd.Parameters.Add("@chrAuthRead", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 쓰기 권한
            sParams = Cmd.Parameters.Add("@chrAuthWrite", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 수정 권한
            sParams = Cmd.Parameters.Add("@chrAuthModify", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 삭제 권한
            sParams = Cmd.Parameters.Add("@chrAuthDelete", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 답변 권한
            sParams = Cmd.Parameters.Add("@chrAuthReply", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 관리자 아이지
            sParams = Cmd.Parameters.Add("@varAdminId", OleDbType.VarChar, strAdminId.Length);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 생성자 PC IP
            sParams = Cmd.Parameters.Add("@chrCreateIp", OleDbType.Char, 15);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 고유번호 결과값
            sParams = Cmd.Parameters.Add("@iBrdMaxNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varBrdName"].Value = strBrdName;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@iDocCnt"].Value = int.Parse(strBrdDocCnt);
            Cmd.Parameters["@iBrdListCnt"].Value = int.Parse(strBrdListCnt);
            Cmd.Parameters["@chrBrdIsAttach"].Value = strIsAttach;
            Cmd.Parameters["@varHeader"].Value = strBrdHeader;
            Cmd.Parameters["@varFooter"].Value = strBrdFooter;
            Cmd.Parameters["@chrAuthList"].Value = strAuthList;
            Cmd.Parameters["@chrAuthRead"].Value = strAuthRead;
            Cmd.Parameters["@chrAuthWrite"].Value = strAuthWrite;
            Cmd.Parameters["@chrAuthModify"].Value = strAuthModify;
            Cmd.Parameters["@chrAuthDelete"].Value = strAuthDelete;
            Cmd.Parameters["@chrAuthReply"].Value = strAuthReply;
            Cmd.Parameters["@varAdminId"].Value = strAdminId;
            Cmd.Parameters["@chrCreateIp"].Value = Request.UserHostAddress;

            Cmd.ExecuteNonQuery();

            // 게시판 번호
            iBrdMaxNo = int.Parse(Cmd.Parameters["@iBrdMaxNo"].Value.ToString());
            // 실행 결과값
            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                Trans.Rollback();
                WF.WriteMessage("게시판을 추가 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류내용: SQL Stored Procedure Error!!!\\r\\n\\r\\n" +
                    "오류번호: " + iValue.ToString());
                WF.HistoryBack();
                return;
            }

            Trans.Commit();

            // 첨부파일을 사용하면 게시판 폴더에 게시판 번호로 된 폴더를 생성한다.
            if (strIsAttach == "Y")
            {
                // 실제 사용되고 있는 경로를 가져온다.
                string strBrdPath = Request.PhysicalApplicationPath;

                strBrdPath += "\\Board";

                if (!Directory.Exists(strBrdPath))
                    Directory.CreateDirectory(strBrdPath);

                strBrdPath += "\\Data";

                if (!Directory.Exists(strBrdPath))
                    Directory.CreateDirectory(strBrdPath);

                strBrdPath += "\\" + iBrdMaxNo.ToString();

                if (!Directory.Exists(strBrdPath))
                    Directory.CreateDirectory(strBrdPath);
            }
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage("게시판을 추가하려다 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("AddBoard.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("게시판이 추가되었습니다.");
        WF.MovePage("BoardList.aspx");
    }
    #endregion
}
