﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_BoardInfo_FindUserId : System.Web.UI.Page
{
    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private int iPage = 0;
    private int iPageSize = 10;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            WF.OpenDocPageMove("../Mail/Main.aspx");
            WF.WndClose();
            return;
        }

        iPage = WF.StringToInt(Request.Params["iPage"], 1);

        this.FindUserIdList();
    }

    #region 사용자 아이디 찾기
    /// <summary>
    /// 사용자 아이디 찾기
    /// </summary>
    private void FindUserIdList()
    {
        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbDataAdapter Adap = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();
        int iTotCnt = 0;

        try
        {
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("FindUserId.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListUserId";

            // 현재 페이지 수
            sParams = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 출력 게시물 수
            sParams = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 도메인 명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 전체수
            sParams = Cmd.Parameters.Add("@iTotPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = iPage;
            Cmd.Parameters["@iPageSize"].Value = iPageSize;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "MAIL_USER");
            dt = ds.Tables["MAIL_USER"];
            iTotCnt = int.Parse(Cmd.Parameters["@iTotPage"].Value.ToString(), System.Globalization.NumberStyles.Number);

            int iRowCnt = dt.Rows.Count;
            int iCnt = 0;
            string[,] arrUserId = new string[iRowCnt, 3];

            foreach (DataRow dr in dt.Rows)
            {
                int iValue = iCnt + 1;
                arrUserId[iCnt, 0] = iValue.ToString();
                arrUserId[iCnt, 1] = dr["USER_ID"].ToString();
                arrUserId[iCnt, 2] = dr["USER_NAME"].ToString();
                ++iCnt;
            }

            dt.Clear();
            dt.Columns.Add("USER_NO", System.Type.GetType("System.String"));

            int iNo = (iPage - 1) * 10;

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();
                dr["USER_NO"] = int.Parse(arrUserId[iLoop, 0]) + iNo;
                dr["USER_ID"] = arrUserId[iLoop, 1];
                dr["USER_NAME"] = arrUserId[iLoop, 2];
                dt.Rows.Add(dr);
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("아이디 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }
        finally
        {
            Con.Close();
        }

        rptFindUserIdList.DataSource = dt.DefaultView;
        rptFindUserIdList.DataBind();

        // 페이지수 계산
        int iTotPage = iTotCnt / iPageSize;

        if ((iTotCnt % iPageSize) > 0)
            iTotPage++;

        if (iTotPage <= 0)
            iTotPage++;

        lblPageLink.Text = WF.PageLink(iTotPage, iPage, "FindUserId.aspx", "", iPageSize, "", "", "", "");
    }
    #endregion
}
