﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_BoardInfo_ModifyBoard : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private WebFunction WF;
    private UserInfo UI;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private int iBrdNo = 0;
    private string strBrdNo = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        strBrdNo = Request.Params["brdNo"];

        try
        {
            if (strBrdNo != "" && strBrdNo != null)
                iBrdNo = int.Parse(strBrdNo);
            else
            {
                WF.WriteMessage("게시판 번호가 입력되지 않았습니다.");
                WF.MovePage("BoardList.aspx");
                return;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("게시판 번호를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n") + "\\r\\n\\r\\n" +
                "오류변수값: " + strBrdNo);
            WF.MovePage("BoardList.aspx");
            return;
        }

        if (!Page.IsPostBack)
        {
            this.UserPermitCodeBind();
            this.BoardInfoBind();
        }

        //ibModifyBoard.Attributes.Add("onclick", "alert('데모라서 게시판 정보를 수정할 수 없습니다.'); return false;");
        ibModifyBoard.Attributes.Add("onclick", "if (!ModifyBoard()) return false; else return true;");
    }

    #region 회원 권한 코드를 가져온다.
    /// <summary>
    /// 회원 권한 코드를 가져온다.
    /// </summary>
    private void UserPermitCodeBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("BoardList.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUserPermit";

            Cmd.Parameters.Clear();

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "CODE");
            dt = ds.Tables["CODE"];
            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    string strCodeName = dr["CODE_NAME"].ToString();
                    string strCodeId = dr["CODE_ID"].ToString();

                    ListItem liList = new ListItem(strCodeName, strCodeId);
                    ListItem liRead = new ListItem(strCodeName, strCodeId);
                    ListItem liWrite = new ListItem(strCodeName, strCodeId);
                    ListItem liModify = new ListItem(strCodeName, strCodeId);
                    ListItem liDelete = new ListItem(strCodeName, strCodeId);
                    ListItem liReply = new ListItem(strCodeName, strCodeId);

                    ddlAuthList.Items.Add(liList);
                    ddlAuthRead.Items.Add(liRead);
                    ddlAuthWrite.Items.Add(liWrite);
                    ddlAuthModify.Items.Add(liModify);
                    ddlAuthDelete.Items.Add(liDelete);
                    ddlAuthReply.Items.Add(liReply);
                }
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("사용자 권한을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("BoardList.aspx");
            return;
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }
    }
    #endregion

    #region 선택된 게시판 정보를 가져온다.
    /// <summary>
    /// 선택된 게시판 정보를 가져온다.
    /// </summary>
    private void BoardInfoBind()
    {
        string strAttach = "";
        string strList = "";
        string strRead = "";
        string strWrite = "";
        string strModify = "";
        string strDelete = "";
        string strReply = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("BoardList.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prBoardInfo";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 고유번호
            sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 해당 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "BRD_INFO");
            dt = ds.Tables["BRD_INFO"];

            int iRowCnt = dt.Rows.Count;

            // 레코드가 두개 이상이면 메세지를 출력한다.
            if (iRowCnt > 1)
            {
                WF.WriteMessage("동일한 게시판이 두개이상 존재합니다.\\r\\n\\r\\n서버 관리자에게 문의하세요.");
                WF.MovePage("BoardList.aspx");
                return;
            }
            else if (iRowCnt == 1)
            {
                // 선택 게시판 정보 레코드가 하나이면 해당 객체에 값을 설정한다.
                foreach (DataRow dr in dt.Rows)
                {
                    int iDocCnt = int.Parse(dr["BRD_DOC_CNT"].ToString(), System.Globalization.NumberStyles.Number);
                    int iListCnt = int.Parse(dr["BRD_LIST_CNT"].ToString(), System.Globalization.NumberStyles.Number);
                    string strIsAttach = dr["BRD_IS_ATTACH"].ToString();
                    string strModifyDate = dr["BRD_MODIFY_DATE"].ToString();
                    string strModifyIp = dr["BRD_MODIFY_IP"].ToString();

                    tbBrdName.Text = dr["BRD_NAME"].ToString();
                    tbBrdDocCnt.Text = iDocCnt.ToString();
                    tbBrdListCnt.Text = iListCnt.ToString();
                    tbBrdAdminId.Text = dr["BRD_ADMIN_ID"].ToString();
                    hfAdminId.Value = tbBrdAdminId.Text;
                    tbBrdHeader.Text = dr["BRD_HEADER"].ToString();
                    tbBrdFooter.Text = dr["BRD_FOOTER"].ToString();
                    lblBrdCreateDate.Text = dr["BRD_CREATE_DATE"].ToString();
                    lblBrdCreateIp.Text = dr["BRD_CREATE_IP"].ToString();

                    if (strModifyDate == null)
                        lblBrdModifyDate.Text = "&nbsp;";
                    else
                    {
                        if (strModifyDate.Trim() == "")
                            strModifyDate = "&nbsp;";

                        lblBrdModifyDate.Text = strModifyDate;
                    }

                    if (strModifyIp == null)
                        lblBrdModifyIp.Text = "&nbsp;";
                    else
                    {
                        if (strModifyIp.Trim() == "")
                            strModifyIp = "&nbsp;";

                        lblBrdModifyIp.Text = strModifyIp;
                    }

                    // 첨부파일 사용여부
                    strAttach = dr["BRD_IS_ATTACH"].ToString();
                    strList = dr["BRD_AUTH_LIST"].ToString();
                    strRead = dr["BRD_AUTH_READ"].ToString();
                    strWrite = dr["BRD_AUTH_WRITE"].ToString();
                    strModify = dr["BRD_AUTH_MODIFY"].ToString();
                    strDelete = dr["BRD_AUTH_DELETE"].ToString();
                    strReply = dr["BRD_AUTH_REPLY"].ToString();

                    WF.CtrlDataChecked(rblBrdIsAttach, strAttach);
                    WF.CtrlDataChecked(ddlAuthList, strList);
                    WF.CtrlDataChecked(ddlAuthRead, strRead);
                    WF.CtrlDataChecked(ddlAuthWrite, strWrite);
                    WF.CtrlDataChecked(ddlAuthModify, strModify);
                    WF.CtrlDataChecked(ddlAuthDelete, strDelete);
                    WF.CtrlDataChecked(ddlAuthReply, strReply);

                    break;
                }
            }
            else
            {
                WF.WriteMessage("선택한 게시판 정보가 없습니다.");
                WF.MovePage("BoardList.aspx");
                return;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("게시판 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("BoardList.aspx");
            return;
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }
    }
    #endregion

    #region 게시판 정보 수정
    /// <summary>
    /// 게시판 정보 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibModifyBoard_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strBrdName = tbBrdName.Text;
        string strBrdDocCnt = tbBrdDocCnt.Text;
        string strBrdListCnt = tbBrdListCnt.Text;
        string strAdminId = hfAdminId.Value;
        string strIsAttach = rblBrdIsAttach.SelectedValue;
        string strBrdHeader = tbBrdHeader.Text;
        string strBrdFooter = tbBrdFooter.Text;
        string strAuthList = ddlAuthList.SelectedValue;
        string strAuthRead = ddlAuthRead.SelectedValue;
        string strAuthWrite = ddlAuthWrite.SelectedValue;
        string strAuthModify = ddlAuthModify.SelectedValue;
        string strAuthDelete = ddlAuthDelete.SelectedValue;
        string strAuthReply = ddlAuthReply.SelectedValue;

        if (strBrdName.Length > 20)
        {
            WF.WriteMessage("게시판 이름이 제한길이 20자를 초과했습니다.");
            WF.MovePage("ModifyBoard.aspx?brdNo" + strBrdNo);
            return;
        }

        if (strAdminId.Length > 15)
        {
            WF.WriteMessage(strAdminId + " 아이디 길이가 15자를 초과했습니다.\\r\\n\\r\\n다른아이디를 선택해 주세요.");
            WF.MovePage("ModifyBoard.aspx?brdNo" + strBrdNo);
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ModifyBoard.aspx?brdNo" + strBrdNo);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyBoard";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 고유번호
            sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 명
            sParams = Cmd.Parameters.Add("@varBrdName", OleDbType.VarWChar, strBrdName.Length);
            sParams.Direction = ParameterDirection.Input;

            // 도메인명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 출력 게시물 수 
            sParams = Cmd.Parameters.Add("@iDocCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 출력 페이지수
            sParams = Cmd.Parameters.Add("@iBrdListCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 첨부파일 사용여부
            sParams = Cmd.Parameters.Add("@chrBrdIsAttach", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 머릿말
            sParams = Cmd.Parameters.Add("@varHeader", OleDbType.VarWChar, strBrdHeader.Length);
            sParams.Direction = ParameterDirection.Input;

            // 꼬릿말
            sParams = Cmd.Parameters.Add("@varFooter", OleDbType.VarWChar, strBrdFooter.Length);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 접근권한
            sParams = Cmd.Parameters.Add("@chrAuthList", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 읽기권한
            sParams = Cmd.Parameters.Add("@chrAuthRead", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 쓰기권한
            sParams = Cmd.Parameters.Add("@chrAuthWrite", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 수정권한
            sParams = Cmd.Parameters.Add("@chrAuthModify", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 삭제권한
            sParams = Cmd.Parameters.Add("@chrAuthDelete", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 답글권한
            sParams = Cmd.Parameters.Add("@chrAuthReply", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 관리자 아이디
            sParams = Cmd.Parameters.Add("@varAdminId", OleDbType.VarChar, strAdminId.Length);
            sParams.Direction = ParameterDirection.Input;

            // 게시판 수정자 아이피
            sParams = Cmd.Parameters.Add("@chrModifyIp", OleDbType.Char, Request.UserHostAddress.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
            Cmd.Parameters["@varBrdName"].Value = strBrdName;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@iDocCnt"].Value = int.Parse(strBrdDocCnt);
            Cmd.Parameters["@iBrdListCnt"].Value = int.Parse(strBrdListCnt);
            Cmd.Parameters["@chrBrdIsAttach"].Value = strIsAttach;
            Cmd.Parameters["@varHeader"].Value = strBrdHeader;
            Cmd.Parameters["@varFooter"].Value = strBrdFooter;
            Cmd.Parameters["@chrAuthList"].Value = strAuthList;
            Cmd.Parameters["@chrAuthRead"].Value = strAuthRead;
            Cmd.Parameters["@chrAuthWrite"].Value = strAuthWrite;
            Cmd.Parameters["@chrAuthModify"].Value = strAuthModify;
            Cmd.Parameters["@chrAuthDelete"].Value = strAuthDelete;
            Cmd.Parameters["@chrAuthReply"].Value = strAuthReply;
            Cmd.Parameters["@varAdminId"].Value = strAdminId;
            Cmd.Parameters["@chrModifyIp"].Value = Request.UserHostAddress;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                Trans.Rollback();
                WF.WriteMessage("게시판 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류내용: SQL Stored Procedure Error!!!\\r\\n\\r\\n" +
                    "오류번호: " + iValue.ToString());
                WF.MovePage("ModifyBoard.aspx?brdNo" + strBrdNo);
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage("게시판 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n") + "\\r\\n\\r\\n");
            WF.MovePage("ModifyBoard.aspx?brdNo" + strBrdNo);
            return;
        }
        finally
        {
            // 게시판이 첨부파일 사용이면 폴더가 존재하는지 확인하고 존재하지 않으면
            // 폴더를 생성한다.
            if (strIsAttach == "Y")
            {
                string strBrdPath = Request.PhysicalApplicationPath;

                strBrdPath += "\\Board";

                if (!Directory.Exists(strBrdPath))
                    Directory.CreateDirectory(strBrdPath);

                strBrdPath += "\\Data";

                if (!Directory.Exists(strBrdPath))
                    Directory.CreateDirectory(strBrdPath);

                strBrdPath += "\\" + iBrdNo.ToString();

                if (!Directory.Exists(strBrdPath))
                    Directory.CreateDirectory(strBrdPath);
            }

            Con.Close();
        }

        WF.WriteMessage("게시판 정보를 수정했습니다.");
        WF.MovePage("BoardList.aspx");
        return;
    }
    #endregion
}
