﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_DomainConfig_DomainList : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
            return;
        }
        
        if (Passkorea.Configuration.GetConfigField("serverinfo", "root_domain") != strDomain)
        {
            WF.WriteMessage("여기는 전체 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Default.aspx");
            return;
        }

        if (!Page.IsPostBack)
        {
            DomainList();
        }
    }

    private void DomainList()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListUser.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDomainList";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "Webmail_Domain_Config");
            dt = ds.Tables["Webmail_Domain_Config"];

            rptDomainList.DataSource = dt.DefaultView;
            rptDomainList.DataBind();
        }
        catch (Exception e)
        {
            WF.WriteMessage("도메인 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                e.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Default.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }

    protected void btnSyncDomain_Click(Object sender, EventArgs e)
    {
        ArrayList alDomain = Passkorea.Configuration.DomainList();
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prAddDomain";

            sParams = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@iAllocateSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@iUserCount", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strJoinType", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@iDefaultSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strPop3Allow", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strCopyright", OleDbType.VarWChar, 2000);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 600);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iAllocateSize"].Value = 10000;
            Cmd.Parameters["@iUserCount"].Value = 50;
            Cmd.Parameters["@strJoinType"].Value = "Y";
            Cmd.Parameters["@iDefaultSize"].Value = 30;
            Cmd.Parameters["@strPop3Allow"].Value = "Y";
            Cmd.Parameters["@strCopyright"].Value = "";

            for (int i = 0; i < alDomain.Count; i++)
            {
                Cmd.Parameters["@strDomain"].Value = alDomain[i].ToString();

                Cmd.ExecuteNonQuery();

                //int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage(err.Message.Replace("\r\n", "\\r\\n"));
            WF.HistoryBack();
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("도메인이 동기화 되었습니다.\\r\\n도메인은 List.txt값을 기준으로 동기화 됩니다.");
        WF.MovePage("DomainList.aspx");
    }

    protected void btnDelete_Command(Object sender, CommandEventArgs e)
    {
        string strDomain = e.CommandArgument.ToString();

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteDomain";

            sParams = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 600);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();

            int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

            if (iResult != 0)
            {
                Trans.Rollback();
                WF.WriteMessage(Cmd.Parameters["@strReturnValue"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.HistoryBack();
                return;
            }

            if (!Passkorea.Configuration.DeleteDomain(strDomain))
            {
                Trans.Rollback();
                WF.WriteMessage(Passkorea.Configuration.GetErrorMessage);
                WF.HistoryBack();
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage(err.Message.Replace("\r\n", "\\r\\n"));
            WF.HistoryBack();
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strDomain + " 도메인 정보가 삭제되었습니다.");
        WF.MovePage("DomainList.aspx");
    }

    protected void rptDomainList_ItemDataBound(Object sender, RepeaterItemEventArgs e)
    {
        string strScript = "";
        int iItemCnt = e.Item.Controls.Count;

        for (int i = 0; i < iItemCnt; i++)
        {
            ImageButton iBtn = (ImageButton)e.Item.Controls[i].FindControl("btnDelete");

            if (iBtn != null)
            {
                strScript = "if (!DeleteDomain('" + iBtn.CommandArgument.ToString() + "')) return false; else return true;";
                iBtn.Attributes.Add("onclick", strScript);
            }
        }
    }
}
