﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_MailAddress_EditCommonGroup : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    protected string strGroupName = "";
    private string isCommon = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strGroupName = Request.Params["groupName"];

        UserInfo UI = new UserInfo(strUserId, strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            WF.MovePage("../../Mail/Main.aspx");
            WF.WndClose();
            return;
        }

        int iPos = strGroupName.IndexOf("│");

        if (iPos > 0)
        {
            isCommon = strGroupName.Substring(iPos + 1, 1);
            strGroupName = strGroupName.Substring(0, iPos);
        }
        else
        {
            strGroupName = "";
            isCommon = "N";
        }

        if (strGroupName.Trim() == "")
        {
            WF.WriteMessage("미지정 그룹은 수정할 수 없는 그룹 입니다.");
            WF.MovePage("ControlGroup.aspx");
        }

        if (!Page.IsPostBack)
        {
            this.AddrGroupDataBind();
            this.AddrInfoDataBind();
            Page.DataBind();
        }
    }

    #region 그룹 & 주소록 데이터 바인드
    /// <summary>
    /// 그룹 & 주소록 데이터를 바인드한다.
    /// </summary>
    private void AddrGroupDataBind()
    {
        tbGroupName.Text = strGroupName;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ControlGroup.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectGroupDesc";

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroupName"].Value = strGroupName;
            Cmd.Parameters["@chrCommon"].Value = isCommon;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP");
            dt = ds.Tables["MAIL_GROUP"];

            if (dt.Rows.Count > 0)
            {
                tbGroupDesc.Text = dt.Rows[0]["GROUP_DESC"].ToString();
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage(strGroupName + " 그룹 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ControlGroup.aspx");
            return;
        }
        finally
        {
            Con.Close();
            Cmd.Parameters.Clear();

        }
    }
    #endregion

    #region 그룹에 등록된 주소록 데이터 바인드
    /// <summary>
    /// 그룹에 등록되어 있는 주소록 데이터를 바인드 한다.
    /// </summary>
    private void AddrInfoDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ControlGroup.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupEmailInfo";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroupName"].Value = "";
            Cmd.Parameters["@chrCommon"].Value = isCommon;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];

            lbGroupAddr.DataSource = dt.DefaultView;
            lbGroupAddr.DataTextField = "EMAIL_ADDR";
            lbGroupAddr.DataValueField = "EMAIL_ID";
            lbGroupAddr.DataBind();

            Cmd.Parameters["@varGroupName"].Value = strGroupName;
            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP_ADDR");

            dt = ds.Tables["MAIL_GROUP_ADDR"];
            lbAddAddrList.DataSource = dt.DefaultView;
            lbAddAddrList.DataTextField = "EMAIL_ADDR";
            lbAddAddrList.DataValueField = "EMAIL_ID";
            lbAddAddrList.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("전체 주소록 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 공유 그룹 정보 수정
    /// <summary>
    /// 공유 그룹 정보 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibEditGroup_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strGroup = tbGroupName.Text;
        string strGroupDesc = tbGroupDesc.Text;
        int iAddrCnt = lbAddAddrList.Items.Count;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EditGroupInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
            return;
        }

        try
        {
            string strCngValue = "";

            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyGroupInfo";

            if (iAddrCnt > 0)
            {
                for (int iLoop = 0; iLoop < iAddrCnt; iLoop++)
                    strCngValue += lbAddAddrList.Items[iLoop].Value + ",";

                strCngValue = strCngValue.Substring(0, strCngValue.Length - 1);
            }

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Change Group Name)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroup.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Change Group Description)
            sParams = Cmd.Parameters.Add("@varGroupDesc", OleDbType.VarWChar, strGroupDesc.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address Item Count)
            sParams = Cmd.Parameters.Add("@intAddrCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varCngValue", OleDbType.VarWChar, strCngValue.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroupName"].Value = strGroupName;
            Cmd.Parameters["@varGroup"].Value = strGroup;
            Cmd.Parameters["@varGroupDesc"].Value = strGroupDesc;
            Cmd.Parameters["@chrCommon"].Value = isCommon;
            Cmd.Parameters["@intAddrCnt"].Value = iAddrCnt;
            Cmd.Parameters["@varCngValue"].Value = strCngValue;

            Cmd.ExecuteNonQuery();

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage(strGroupName + " 공유 그룹 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EditCommonGroup.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strGroupName + " 공유 그룹 정보를 수정하였습니다.");
        WF.MovePage("EditCommonGroup.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
    }
    #endregion

    #region 다른그룹에 등록된 주소록을 선택된 그룹으로 이동
    /// <summary>
    /// 다른그룹에 등록된 주소록을 선택된 그룹으로 이동
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibSelectAddr_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        int iRowCnt = lbGroupAddr.Items.Count;
        int iRowCnt2 = lbAddAddrList.Items.Count;

        for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
        {
            if (lbGroupAddr.Items[iLoop].Selected)
            {
                bool bExists = false;
                for (int iLoop2 = 0; iLoop2 < iRowCnt2; iLoop2++)
                {
                    if (lbGroupAddr.Items[iLoop].Value == lbAddAddrList.Items[iLoop2].Value)
                    {
                        bExists = true;
                        break;
                    }
                }

                if (!bExists)
                {
                    ListItem li = new ListItem(lbGroupAddr.Items[iLoop].Text, lbGroupAddr.Items[iLoop].Value);
                    lbAddAddrList.Items.Add(li);
                }
            }
        }
    }
    #endregion

    protected void ibAddAddrList_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        int iRowCnt = lbAddAddrList.Items.Count;
        int iRowCnt2 = lbGroupAddr.Items.Count;

        for (int iLoop = iRowCnt - 1; iLoop >= 0; iLoop--)
        {
            if (lbAddAddrList.Items[iLoop].Selected)
            {
                bool bExists = false;
                for (int iLoop2 = 0; iLoop2 < iRowCnt; iLoop2++)
                {
                    if (lbAddAddrList.Items[iLoop].Value == lbAddAddrList.Items[iLoop2].Value)
                    {
                        bExists = true;
                        break;
                    }
                }

                lbAddAddrList.Items.RemoveAt(iLoop);

                if (!bExists)
                {
                    ListItem li = new ListItem(lbAddAddrList.Items[iLoop].Text, lbAddAddrList.Items[iLoop].Value);
                    lbGroupAddr.Items.Add(li);
                }
            }
        }
    }
}
