﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_MailBoxSize : System.Web.UI.Page
{
    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string tblMailuser = Passkorea.Configuration.GetConfigField("fieldInfo", "mailuser");
    private string fldUserPermit = Passkorea.Configuration.GetConfigField("fieldInfo", "use_allow");
    private string fldUserAuthority = Passkorea.Configuration.GetConfigField("fieldInfo", "usertype");
    private string fldUserMailboxSize = Passkorea.Configuration.GetConfigField("fieldInfo", "maxsize");
    private string fldUserDomain = Passkorea.Configuration.GetConfigField("fieldInfo", "domain");

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/Login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            WF.OpenDocPageMove("../Mail/Main.aspx");
            WF.WndClose();
            return;
        }

        if (!Page.IsPostBack)
        {
            lblDomain.Text = strDomain;
        }

        //ibModify.Attributes.Add("onclick", "alert('데모라서 메일용량을 일괄 수정할 수 없습니다.'); return false;");
    }

    protected void ibModify_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string modifySize = tbModifySize.Text;
        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbTransaction Trans = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();

        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("MailBoxSize.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUpdateMailBoxSize";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;
            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, 20);
            sParams.Direction = ParameterDirection.Input;
            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;
            // 변경할 메일박스 용량
            sParams = Cmd.Parameters.Add("@intMailboxSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = "";
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@intMailboxSize"].Value = int.Parse(modifySize, System.Globalization.NumberStyles.Number);

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

            if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();

                /*
                WF.WriteMessage(strDomain + "에 등록된 메일 사용 가능한 사용자의 메일박스 용량을 " + modifySize + " MB로 일괄 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 발생 프로시져: prUpdateMailBoxSize\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                */
                WF.WriteMessage(Cmd.Parameters["@strReturnValue"].Value.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
                WF.MovePage("MailBoxSize.aspx");
                return;
            }
            
            Trans.Commit();
        }
        catch (Exception err)
        {
            WF.WriteMessage("메일박스 용량을 일괄 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("MailBoxSize.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("메일박스 용량이 " + modifySize + " MB로 일괄 수정 되었습니다.");
        WF.WndClose();
    }
}
