﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_MailingList_AddMailing : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private UserInfo UI;
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    protected System.Web.UI.WebControls.ValidationSummary vsMailing;
    private string strDomain = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            WF.MovePage("../../Mail/Main.aspx");
            WF.WndClose();
            return;
        }

        ibAdd.Attributes.Add("onclick", "if (!AddMailingList()) return false; else return true;");
    }

    #region 메일링 리스트 등록 버튼
    /// <summary>
    /// 메일링 리스트 등록 버튼
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAdd_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strId = tbMailingId.Text;
        string strName = tbMailingName.Text;

        int iValue = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("AddMailing.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertMailingUser";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (Mailing User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing User Name)
            sParams = Cmd.Parameters.Add("@varUserName", OleDbType.VarWChar, strName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing User Password)
            sParams = Cmd.Parameters.Add("@varUserPwd", OleDbType.VarChar, strId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing User Max Size)
            sParams = Cmd.Parameters.Add("@intUserMaxSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing User Auth)
            sParams = Cmd.Parameters.Add("@chrUserAuth", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing User Mailbox Path)
            sParams = Cmd.Parameters.Add("@varMailboxPath", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing User Permittion)
            sParams = Cmd.Parameters.Add("@chrUserPermit", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing Is Use)
            sParams = Cmd.Parameters.Add("@bIsMailing", OleDbType.Boolean);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing Description)
            sParams = Cmd.Parameters.Add("@varDest", OleDbType.VarWChar, strName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing Is Use)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strId;
            Cmd.Parameters["@varUserName"].Value = strName;
            Cmd.Parameters["@varUserPwd"].Value = strId;
            Cmd.Parameters["@intUserMaxSize"].Value = int.Parse(Passkorea.Configuration.GetConfigField("serverinfo", "default_maxsize"));
            Cmd.Parameters["@chrUserPermit"].Value = "0";
            Cmd.Parameters["@chrUserAuth"].Value = "1";
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varMailboxPath"].Value = Passkorea.Configuration.GetMailDirPath + "\\" + strDomain + "\\0000\\" + strId;
            Cmd.Parameters["@bIsMailing"].Value = 1;
            Cmd.Parameters["@varDest"].Value = strName;

            Cmd.ExecuteNonQuery();

            iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일링 리스트 사용자를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                WF.HistoryBack();
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일링 리스트 사용자를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.HistoryBack();
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage("오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.HistoryBack();
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("메일링 리스트가 등록되었습니다.");
        WF.OpenDocPageMove("ListMailing.aspx");
        WF.WndClose();
    }
    #endregion
}
