﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_MailingList_AddMailingEmail : System.Web.UI.Page
{
    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string mailingId = "";
    private string attachPath = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.

        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        mailingId = Request.Params["mailing"];

        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Mail/Main.aspx");
        }

        if (mailingId == "")
        {
            WF.WriteMessage("잘못된 접근입니다.\\r\\n\\r\\n메일링 리스트 아이디가 없습니다.");
            WF.HistoryBack();
            return;
        }
        else
        {
            if (mailingId.IndexOf("@") > 0)
            {
                int iAtPos = mailingId.IndexOf("@");
                int cutSize = mailingId.Length - (iAtPos + 1);
                mailingId = mailingId.Substring(0, iAtPos);
            }
        }

        attachPath = UI.UserPath + "\\temp\\";
    }

    #region 메일주소 등록 버튼
    /// <summary>
    /// 메일주소 등록 버튼
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAddEmail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strEmailAddr = "";
        string[] arrEmailAddr = null;
        string domain = "";
        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbTransaction Trans = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();

        if (rbAddType1.Checked)
        {
            if (tbEmailAddr.Text == "")
            {
                WF.WriteMessage("메일링 리스트에 등록할 메일주소를 입력해 주세요.");
                WF.MovePage("AddMailingEmail.aspx?mailing=" + mailingId);
                return;
            }

            strEmailAddr = tbEmailAddr.Text;
            strEmailAddr = strEmailAddr.Replace(",", ";");
            arrEmailAddr = strEmailAddr.Split(';');
        }
        else if (rbAddType2.Checked)
        {
            if (fEmail.Value == "")
            {
                WF.WriteMessage("메일링 리스트에 등록할 메일주소가 입력되어 있는 파일을 선택해 주세요.");
                WF.MovePage("AddMailingEmail.aspx?mailing=" + mailingId);
                return;
            }

            if (fEmail.PostedFile != null)
            {
                string fEmailAddr = fEmail.Value;

                if (fEmailAddr != "")
                {
                    byte[] buf = new byte[128];
                    fEmailAddr = Path.GetFileName(fEmailAddr);
                    fEmail.PostedFile.SaveAs(attachPath + fEmailAddr);

                    FileStream fs = new FileStream(attachPath + fEmailAddr, FileMode.Open, FileAccess.Read, FileShare.None);

                    while (fs.Read(buf, 0, 128) > 0)
                        strEmailAddr += Encoding.Default.GetString(buf);
                    arrEmailAddr = strEmailAddr.Replace("\r\n", ";").Split(';');
                }
            }
        }
        else
        {
            WF.WriteMessage("메일주소 입력인지 파일 업로드인지 선택해 주세요.");
            WF.MovePage("AddMailingEmail.aspx?mailing=" + mailingId);
            return;
        }

        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("AddMailingEmail.aspx?mailing=" + mailingId);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertMailingEmail";

            Cmd.Parameters.Clear();

            // Command Parameter (Mailing List Id)
            sParams = Cmd.Parameters.Add("@varMailingId", OleDbType.VarChar, mailingId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing Email Address)
            sParams = Cmd.Parameters.Add("@varEmail", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            for (int iCount = 0; iCount < arrEmailAddr.Length; iCount++)
            {
                domain = arrEmailAddr[iCount].Substring(arrEmailAddr[iCount].IndexOf("@") + 1);

                Cmd.Parameters["@varMailingId"].Value = mailingId;
                Cmd.Parameters["@varEmail"].Value = arrEmailAddr[iCount];
                Cmd.Parameters["@varDomain"].Value = domain;

                Cmd.ExecuteNonQuery();
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("메일주소를 메일링 리스트에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("AddMailingEmail.aspx?mailing=" + mailingId);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("입력하신 메일 주소가 메일링 리스트에 등록되었습니다.");
        WF.MovePage("ListMailing.aspx");
    }
    #endregion
}
