﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_MailingList_ListMailing : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbDataAdapter Adap;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;
    private UserInfo UI;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string tblMailuser = Passkorea.Configuration.GetConfigField("fieldinfo", "mailuser");
    private string fldUserId = Passkorea.Configuration.GetConfigField("fieldinfo", "users");

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Mail/Main.aspx");
        }

        if (!Page.IsPostBack)
        {
            this.MailingDataBind();
        }

        string strScript = "";

        strScript = "if (!DeleteMailingList()) return false; else return true;";
        this.ibDelMailing.Attributes.Add("onclick", strScript);
    }

    #region 메일링 리스트 데이터 바인드
    /// <summary>
    /// 메일링 리스트 데이터 바인드
    /// </summary>
    private void MailingDataBind()
    {

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Default.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailingUser";

            Cmd.Parameters.Clear();

            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "LIST");
            dt = ds.Tables["LIST"];

            rptListMailing.DataSource = dt.DefaultView;
            rptListMailing.DataBind();
        }
        catch (Exception err)
        {
            lblErrMsg.Text = err.Message;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 메일링 삭제
    /// <summary>
    /// 메일링 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelMailing_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailingId = hidMailingId.Value;
        string[] arrMailingId;

        if (strMailingId == "")
        {
            WF.WriteMessage("삭제하려는 메일링 리스트 사용자를 선택해 주세요.");
            WF.MovePage("ListMailing.aspx");
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListMailing.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteMailing";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (Mailing List Id)
            sParams = Cmd.Parameters.Add("@varMailingId", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDomain"].Value = strDomain;

            if (strMailingId.EndsWith("|"))
                strMailingId = strMailingId.Substring(0, strMailingId.Length - 1);

            arrMailingId = strMailingId.Split('|');

            for (int iLoop = 0; iLoop < arrMailingId.Length; iLoop++)
            {
                Cmd.Parameters["@varMailingId"].Value = arrMailingId[iLoop];

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    Trans.Rollback();
                    Con.Close();

                    WF.WriteMessage(arrMailingId[iLoop] + " 메일링 리스트를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "삭제해서는 안되는 메일링 아이디(테이블 명) 입니다.");
                    return;
                }
                else if (iValue != 0)
                {
                    Trans.Rollback();
                    Con.Close();

                    WF.WriteMessage(arrMailingId[iLoop] + " 메일링 리스트를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    return;
                }
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("메일링 리스트를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListMailing.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("선택한 메일링 리스트가 삭제되었습니다.");
        WF.MovePage("ListMailing.aspx");
        return;
    }
    #endregion
}

