﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_MailingList_ViewMailingEmail : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private int iPage = 0;
    private int iPageSize = 15;
    private string mailingId = "";
    private string strMovePage = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        mailingId = Request.Params["mailing"];
        strMovePage = Request.PhysicalPath;
        strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);

        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        iPage = WF.StringToInt(Request.Params["iPage"], 1);

        if (mailingId.IndexOf("@") > 0)
            mailingId = mailingId.Substring(0, mailingId.IndexOf("@"));

        ShowEmailList();

        ibDelete.Attributes.Add("onclick", "if (!DeleteEmail()) return false; else return true;");
    }

    #region 메일 리스트
    /// <summary>
    /// 메일 리스트
    /// </summary>
    private void ShowEmailList()
    {
        int iTotCnt = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListMailing.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailingEmail";

            Cmd.Parameters.Clear();

            // Command Parameter (This Page)
            sParams = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Page Size)
            sParams = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing List Id)
            sParams = Cmd.Parameters.Add("@varMailingId", OleDbType.VarChar, mailingId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailing Total Count)
            sParams = Cmd.Parameters.Add("@iTotCnt", OleDbType.VarChar, mailingId.Length);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = iPage;
            Cmd.Parameters["@iPageSize"].Value = iPageSize;
            Cmd.Parameters["@varMailingId"].Value = mailingId;

            OleDbDataAdapter Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAILING");
            dt = ds.Tables[1];

            iTotCnt = int.Parse(Cmd.Parameters["@iTotCnt"].Value.ToString());

            rptEmailList.DataSource = dt.DefaultView;
            rptEmailList.DataBind();
        }
        catch (Exception err)
        {
            Con.Close();
            WF.WriteMessage(mailingId + " 메일링에 있는 메일주소를 불러오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListMailing.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        int iTotPage = 0;

        iTotPage = iTotCnt / iPageSize;

        if ((iTotPage % iPageSize) > 0)
            iTotPage++;

        if (iTotPage <= 0)
            iTotPage++;

        lblPageLink.Text = WF.PageLink(iTotPage, iPage, strMovePage, "&mailing=" + mailingId, 10, "", "", "", "");
    }
    #endregion

    #region 선택한 메일주소 삭제
    /// <summary>
    /// 선택한 메일주소 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelete_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strEmailList = hidEmailList.Value;
        string[] arrEmail;

        if (strEmailList == "")
        {
            WF.WriteMessage("삭제하려는 메일주소를 선택해 주세요.");
            WF.MovePage("ListMailing.aspx");
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListMailing.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteMailingListEmail";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (Mailing List Id)
            sParams = Cmd.Parameters.Add("@varMailingId", OleDbType.VarChar, mailingId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varEmail", OleDbType.VarChar, 512);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varMailingId"].Value = mailingId;

            if (strEmailList.EndsWith("|"))
                strEmailList = strEmailList.Substring(0, strEmailList.Length - 1);

            arrEmail = strEmailList.Split('|');

            for (int iLoop = 0; iLoop < arrEmail.Length; iLoop++)
            {
                Cmd.Parameters["@varEmail"].Value = arrEmail[iLoop];

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue != 0)
                {
                    Trans.Rollback();
                    Con.Close();

                    WF.WriteMessage(arrEmail[iLoop] + " 메일주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    return;
                }
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("선택한 메일주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListMailing.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("선택한 메일주소가 삭제되었습니다.");
        WF.MovePage("ViewMailingEmail.aspx?mailing=" + mailingId);
        return;
    }
    #endregion
}
