﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MIME;

public partial class AdminMenu_SendMailAll : System.Web.UI.Page
{
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private UserInfo UI;
    private WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Mail/Main.aspx");
        }

        ibSendMail.Attributes.Add("onclick", "if (!Sendmail()) return false; else return true;");
    }

    protected void ibSendMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string subject = tbSubject.Text;
        string content = tbContent.Text;
        string to = "";
        string[] arrTo = null;
        string ErrMsg = "";
        int iCnt = 0;

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbDataAdapter Adap = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        try
        {
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("SendMailAll.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListEmail";

            Cmd.Parameters.Clear();

            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "MAIL_USER");
            dt = ds.Tables["MAIL_USER"];

            foreach (DataRow dr in dt.Rows)
            {
                to += dr["USER_NAME"].ToString() + " <" + dr["USER_EMAIL"].ToString() + ">;";
                iCnt++;
            }

            to = to.Substring(0, to.Length - 1);

            arrTo = to.Split(';');
        }
        catch (Exception err)
        {
            Response.Redirect("SendSuccess.aspx?errMsg=" + err.Message);
            return;
        }
        finally
        {
            dt.Clear();
            ds.Clear();
            Con.Close();
        }

        try
        {
            MimeConstructor mc = new MimeConstructor(Session["USER_ID"].ToString(), strDomain);
            mc.UserPath = UI.UserPath;
            mc.From = Session["USER_ID"].ToString() + "@" + strDomain;
            mc.To = arrTo;
            mc.Subject = subject;
            mc.ContentHtml = content.Replace("\r\n", "<br>\r\n");
            mc.CharSet = "euc-kr";
            mc.EncodeType = "8bit";

            mc.SendMail(1);
        }
        catch (MimeException err)
        {
            ErrMsg = err.Message;
        }

        if (iCnt > 0)
        {
            to = arrTo[0];
            iCnt--;
        }

        Response.Redirect("SendSuccess.aspx?errMsg=" + ErrMsg + "&Cnt=" + iCnt.ToString() + "&To=" + to);
    }
}
