﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_UpdateAuthKey : System.Web.UI.Page
{
    private AuthKey ak = null;
    private WebFunction WF = null;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Mail/Main.aspx");
        }

        ak = new AuthKey();

        if (!Page.IsPostBack)
        {
            this.AuthKeyData();
        }

        ibMdfAuthKey.Attributes.Add("onclick", "if (!UpdateAuthKey()) return false; else return true;");
        Page.DataBind();
    }

    private void AuthKeyData()
	{
		string strKey = "";

		if (ak.AuthenticationKey())
		{
			tbMdfAuthName.Text = ak.Company;
			tbMdfAuthUser.Text = ak.AuthUser;
			tbMdfTel.Text = ak.AuthTel;
			tbMdfEmailAddr.Text = ak.AuthEmail;
			strKey = ak.Key;
			tbMdfAuthKey1.Text = strKey.Substring(0, 3);
			tbMdfAuthKey2.Text = strKey.Substring(4, 4);
			tbMdfAuthKey3.Text = strKey.Substring(9, 4);
			tbMdfAuthKey4.Text = strKey.Substring(14, 4);
		}
	}

	protected void ibMdfAuthKey_Click(object e, System.Web.UI.ImageClickEventArgs args)
	{
		string strAuthName = tbMdfAuthName.Text;
		string strAuthUser = tbMdfAuthUser.Text;
		string strAuthTel = tbMdfTel.Text;
		string strAuthEMail = tbMdfEmailAddr.Text;
		string strAuthKey = tbMdfAuthKey1.Text + "-" + tbMdfAuthKey2.Text + "-" + tbMdfAuthKey3.Text + "-" + tbMdfAuthKey4.Text;
		bool bStatus = false;

		bStatus = ak.RegistryAuthKey(strAuthName, strAuthUser, strAuthTel, strAuthEMail, strAuthKey);

		if (!bStatus)
		{
			WF.WriteMessage(ak.ErrorMessage.Replace("\r\n", "\\r\\n"));
			return;
		}

		WF.WriteMessage("인증키가 업데이트 되었습니다.");
		WF.MovePage("Authentication.aspx");
		return;
	}
}
