﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_User_AddUser : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbDataAdapter Adap;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private DataTable dt = new DataTable();
    private DataSet ds = new DataSet();
    private WebFunction WF;
    private Domain dm = new Domain();

    protected string strDomain;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strSql;
    private string tblMailUser;
    private string fldUserId;
    private string fldUserPwd;
    private string fldUserDomain;
    private string fldUserMailing;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        strDomain = Request.Params["dm"];
        dm.DomainName = strDomain;
        dm.LoadDomain(strCon);

        // 메일유저 테이블과 필드를 가져온다.
        tblMailUser = Passkorea.Configuration.GetConfigField("fieldinfo", "mailuser");
        fldUserId = Passkorea.Configuration.GetConfigField("fieldinfo", "users");
        fldUserPwd = Passkorea.Configuration.GetConfigField("fieldinfo", "pw");
        fldUserDomain = Passkorea.Configuration.GetConfigField("fieldinfo", "domain");
        fldUserMailing = Passkorea.Configuration.GetConfigField("fieldinfo", "mailinglist");

        if (!Page.IsPostBack)
        {
            this.LastEduDataBind();
            this.JobDataBind();
            FormInitialize();
            tbMailboxSize.Text = dm.DefaultSize.ToString();
        }

        ibUserJoin.Attributes.Add("onclick", "if (!AddUser()) return false; else return true;");
    }

    #region 최종학력 데이터 바인드
    /// <summary>
    /// 최종학력 데이터를 바인드 한다.
    /// </summary>
    private void LastEduDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("UserJoin.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListCodeData";

            Cmd.Parameters.Add("@chrCodeClass", OleDbType.Char, 3);
            Cmd.Parameters["@chrCodeClass"].Value = "LE";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "LAST_EDU_CODE");
            dt = ds.Tables["LAST_EDU_CODE"];
        }
        catch (Exception err)
        {
            WF.WriteMessage("최종학력 코드 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("UserJoin.aspx");
            return;
        }
        finally
        {
            Con.Close();
            Cmd.Parameters.Clear();
        }

        ddlLastEdu.DataSource = dt.DefaultView;
        ddlLastEdu.DataTextField = "CODE_NAME";
        ddlLastEdu.DataValueField = "CODE_ID";
        ddlLastEdu.DataBind();
    }
    #endregion

    #region 직업 데이터 바인드
    /// <summary>
    /// 직업 데이터를 바인드 한다.
    /// </summary>
    /// <param name="e"></param>
    private void JobDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("UserJoin.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListCodeData";

            Cmd.Parameters.Add("@chrCodeClass", OleDbType.Char, 3);
            Cmd.Parameters["@chrCodeClass"].Value = "JO";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "JOB_CODE");
            dt = ds.Tables["JOB_CODE"];
        }
        catch (Exception err)
        {
            WF.WriteMessage("직업 코드 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("UserJoin.aspx");
            return;
        }
        finally
        {
            Con.Close();
            Cmd.Parameters.Clear();
        }
        ddlUserJob.DataSource = dt.DefaultView;
        ddlUserJob.DataTextField = "CODE_NAME";
        ddlUserJob.DataValueField = "CODE_ID";
        ddlUserJob.DataBind();
    }
    #endregion

    private void FormInitialize()
    {
        if (dm.JoinType == "Y")
            ddlUserAuthority.SelectedValue = "1";
        else
            ddlUserAuthority.SelectedValue = "0";

        if (dm.Pop3Allow == "Y")
            rblPop3Allow.SelectedValue = "0";
        else
            rblPop3Allow.SelectedValue = "1";
    }

    #region 회원 등록버튼
    /// <summary>
    /// 회원가입
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibUserJoin_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        // 기본정보
        string userId = tbUserId.Text;
        string userName = tbUserName.Text;
        string userPwd = tbUserPwd.Value;
        string strMaxSize = tbMailboxSize.Text;
        string strAuth = ddlUserAuthority.SelectedValue;
        string strPop3Allow = rblPop3Allow.SelectedValue;
        string strUserPath = "";
        string strRootPath = "";

        // 개인 정보
        string userSex = "";
        string userBirthday = tbUserBdYear.Text + tbUserBdMonth.Text + tbUserBdDay.Text;
        string userLastEdu = "";
        string userJob = "";
        string userMarry = "";
        string userPosition = tbUserPosition.Text;
        string userTel = tbUserTel1.Text + "-" + tbUserTel2.Text + "-" + tbUserTel3.Text;
        string userMobile = tbUserMobile1.Text + "-" + tbUserMobile2.Text + "-" + tbUserMobile3.Text;
        string strZipCode = hidZipCode.Value;
        string userAddress1 = hidAddress1.Value;
        string userAddress2 = tbAddress2.Text;

        // 성별
        for (int i = 0; i < rblUserSex.Items.Count; i++)
        {
            if (rblUserSex.Items[i].Selected)
                userSex = rblUserSex.Items[i].Value;
        }

        // 최종학력
        for (int i = 0; i < ddlLastEdu.Items.Count; i++)
        {
            if (ddlLastEdu.Items[i].Selected)
                userLastEdu = ddlLastEdu.Items[i].Value;
        }

        // 직업
        for (int i = 0; i < ddlUserJob.Items.Count; i++)
        {
            if (ddlUserJob.Items[i].Selected)
                userJob = ddlUserJob.Items[i].Value;
        }

        // 결혼 여부
        for (int i = 0; i < rblUserMarry.Items.Count; i++)
        {
            if (rblUserMarry.Items[i].Selected)
                userMarry = rblUserMarry.Items[i].Value;
        }

        if (dm.AllocateSize < (dm.UseSize + int.Parse(tbMailboxSize.Text)))
        {
            WF.WriteMessage("할당된 용량보다 많은 용량을 사용하려고 하였습니다.\r\n" +
                "도메인 할당 용량을 늘리거나 사용자 기본 용량줄여서 등록하십시오.");
            WF.HistoryBack();
            return;
        }

        if (dm.UserCount < (1 + dm.JoinUserCount))
        {
            WF.WriteMessage("할당된 사용자수를 초과하였습니다.\r\n" +
                "도메인에 할당된 사용자수를 늘려서 사용자를 등록시키세요.");
            WF.HistoryBack();
            return;
        }

        strUserPath = Passkorea.Configuration.GetMailDirPath + "\\" + strDomain + "\\";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("AddUser.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUserCount";

            Cmd.Parameters.Clear();

            sParams = Cmd.Parameters.Add("@intUserCount", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();
            int iValue = int.Parse(Cmd.Parameters["@intUserCount"].Value.ToString(), System.Globalization.NumberStyles.Number);

            iValue = iValue / 2000;

            switch (iValue.ToString().Length)
            {
                case 1:
                    strUserPath += "000";
                    break;
                case 2:
                    strUserPath += "00";
                    break;
                case 3:
                    strUserPath += "0";
                    break;
            }

            if (iValue > 0)
                --iValue;

            strRootPath = strUserPath + iValue.ToString();
            strUserPath += iValue.ToString() + "\\" + userId;

            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertMailUser";
            
            Cmd.Parameters.Clear();

            // 메일 사용자 정보 입력 성공 여부값
            sParams = Cmd.Parameters.Add("@iValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, userId.Length);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 이름
            sParams = Cmd.Parameters.Add("@varUserName", OleDbType.VarWChar, userName.Length);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 비밀번호
            sParams = Cmd.Parameters.Add("@varUserPwd", OleDbType.VarChar, userPwd.Length);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 할당 용량
            sParams = Cmd.Parameters.Add("@intUserMaxSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 메일 사용 여부
            sParams = Cmd.Parameters.Add("@chrUserAuth", OleDbType.Char, strAuth.Length);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 메일박스 경로
            sParams = Cmd.Parameters.Add("@varMailboxPath", OleDbType.VarWChar, strUserPath.Length);
            sParams.Direction = ParameterDirection.Input;

            // 사용 권한 (관리자 또는 일반 사용자)
            sParams = Cmd.Parameters.Add("@chrUserPermit", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 메일링 리스트 사용자 여부
            sParams = Cmd.Parameters.Add("@bIsMailing", OleDbType.Boolean);
            sParams.Direction = ParameterDirection.Input;

            // POP3 사용 여부
            sParams = Cmd.Parameters.Add("@chrPop3Allow", OleDbType.Char, strPop3Allow.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = userId;
            Cmd.Parameters["@varUserName"].Value = userName;
            Cmd.Parameters["@varUserPwd"].Value = userPwd;
            Cmd.Parameters["@intUserMaxSize"].Value = Convert.ToInt32(strMaxSize);
            Cmd.Parameters["@chrUserAuth"].Value = strAuth;
            Cmd.Parameters["@varMailboxPath"].Value = strUserPath;
            Cmd.Parameters["@chrUserPermit"].Value = "0";
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@bIsMailing"].Value = 0;
            Cmd.Parameters["@chrPop3Allow"].Value = strPop3Allow;

            Cmd.ExecuteNonQuery();

            iValue = int.Parse(Cmd.Parameters["@iValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

            if (iValue != 0)
            {
                string errMsg = "";

                if (iValue == -1)
                    errMsg = userId + " 아이디는 등록된 사용자 아이디 입니다.";
                else if (iValue == -2)
                    errMsg = userId + " 아이디는 다른 도메인에서 동일한 비밀번호를 사용하고 있습니다.\\r\\n\\r\\n비밀번호를 변경해서 등록해 주세요.";
                else
                    errMsg = "사용자 정보(MAIL_USER) 테이블에 사용자 정보를 입력하는 도중 오류가 발생했습니다.";

                Trans.Rollback();
                Con.Close();

                WF.WriteMessage(errMsg );
                WF.HistoryBack();
                return;
            }

            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertUserInfo";

            Cmd.Parameters.Clear();

            // 메일 사용자 정보 입력 성공 여부값
            sParams = Cmd.Parameters.Add("@iValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, userId.Length);
            sParams.Direction = ParameterDirection.Input;

            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 권한
            sParams = Cmd.Parameters.Add("@chrUserPermit", OleDbType.VarChar, 2);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 성별
            sParams = Cmd.Parameters.Add("@chrSex", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 생일
            sParams = Cmd.Parameters.Add("@chrBirthDay", OleDbType.Char, 10);
            sParams.Direction = ParameterDirection.Input;

            // 학력
            sParams = Cmd.Parameters.Add("@chrLastEdu", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;

            // 직업
            sParams = Cmd.Parameters.Add("@chrJob", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;

            // 결혼여부
            sParams = Cmd.Parameters.Add("@chrMarry", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 소속
            sParams = Cmd.Parameters.Add("@varPosition", OleDbType.VarWChar, userPosition.Length);
            sParams.Direction = ParameterDirection.Input;

            // 전화번호
            sParams = Cmd.Parameters.Add("@chrTel", OleDbType.Char, userTel.Length);
            sParams.Direction = ParameterDirection.Input;

            // 이동전화
            sParams = Cmd.Parameters.Add("@chrMobile", OleDbType.Char, userMobile.Length);
            sParams.Direction = ParameterDirection.Input;

            // 우편번호
            sParams = Cmd.Parameters.Add("@chrZipCode", OleDbType.Char, 6);
            sParams.Direction = ParameterDirection.Input;

            // 주소1
            sParams = Cmd.Parameters.Add("@varAddress1", OleDbType.VarWChar, userAddress1.Length);
            sParams.Direction = ParameterDirection.Input;

            // 주소2
            sParams = Cmd.Parameters.Add("@varAddress2", OleDbType.VarWChar, userAddress2.Length);
            sParams.Direction = ParameterDirection.Input;

            // 리턴값
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = userId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrUserPermit"].Value = "2";
            Cmd.Parameters["@chrSex"].Value = userSex;
            Cmd.Parameters["@chrBirthDay"].Value = userBirthday;
            Cmd.Parameters["@chrLastEdu"].Value = userLastEdu;
            Cmd.Parameters["@chrJob"].Value = userJob;
            Cmd.Parameters["@chrMarry"].Value = userMarry;
            Cmd.Parameters["@varPosition"].Value = userPosition;
            Cmd.Parameters["@chrTel"].Value = userTel;
            Cmd.Parameters["@chrMobile"].Value = userMobile;
            Cmd.Parameters["@chrZipCode"].Value = strZipCode;
            Cmd.Parameters["@varAddress1"].Value = userAddress1;
            Cmd.Parameters["@varAddress2"].Value = userAddress2;

            Cmd.ExecuteNonQuery();

            iValue = int.Parse(Cmd.Parameters["@iValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

            if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage("사용자 정보(USER_INFO) 테이블에 사용자 정보를 입력하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Message: " + Cmd.Parameters["@varRtnVal"].ToString().Replace("\r\n", "\\r\\n") +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("AddUser.aspx");
                return;
            }

            Webhard_Passkorea.WebSource.Member mem = new Webhard_Passkorea.WebSource.Member();

            mem.ConnectionString = strCon;
            mem.Domain = Session["MAIL_DOMAIN"].ToString();
            mem.MemberId = userId;
            mem.MemberPwd = userPwd;

            // 웹하드 회원 테이블에 사용자가 없으면 사용자를 등록한다.
            if (!mem.Login())
            {
                mem.Domain = strDomain;
                mem.MemberName = userId;
                mem.EmailAddr = userId + "@" + strDomain;
                mem.Path = System.Configuration.ConfigurationSettings.AppSettings["WebhardPath"] + "\\" + strDomain + "\\User_Data\\" + userId;
                mem.AllocateSize = int.Parse(System.Configuration.ConfigurationSettings.AppSettings["UserDefaultSize"]);
                mem.Permission = "M1";

                if (!mem.JoinMember())
                {
                    WF.WriteMessage(mem.ErrorMessage.Replace("\r\n", "\\r\\n\\r\\n"));
                    WF.HistoryBack();
                    return;
                }
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage("회원을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "서버 관리자에게 문의 하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("AddUser.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        // 사용 승인 이면 사용자 폴더를 생성한다.
        if (strAuth == "1")
        {
            if (!Directory.Exists(strRootPath))
                Directory.CreateDirectory(strRootPath);

            if (!Directory.Exists(strUserPath))
                Directory.CreateDirectory(strUserPath);

            if (Directory.Exists(strUserPath))
            {
                Directory.CreateDirectory(strUserPath + "\\mailbox");
                Directory.CreateDirectory(strUserPath + "\\inbox");
                Directory.CreateDirectory(strUserPath + "\\outbox");
                Directory.CreateDirectory(strUserPath + "\\delbox");
                Directory.CreateDirectory(strUserPath + "\\spambox");
                Directory.CreateDirectory(strUserPath + "\\savebox");
                Directory.CreateDirectory(strUserPath + "\\tempbox");
                Directory.CreateDirectory(strUserPath + "\\temp");
            }
        }

        WF.WriteMessage(userId + " 아이디를 회원으로 등록했습니다.");
        WF.MovePage("AddUser.aspx?dm=" + strDomain);
    }
    #endregion
}
