﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_User_ChangePassword : System.Web.UI.Page
{
    private UserInfo UI;
    private WebFunction WF;
    private JavaScript _js = new JavaScript();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", true);
        _js.Page = Page;
        
        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            WF.WndClose();
            return;
        }

        strDomain = Request.Params["dm"];
        strUserId = Request.Params["strUserId"];

        //ibModifyPwd.Attributes.Add("onclick", "alert('데모라서 비밀번호를 변경할 수 없습니다.'); return false;");
    }

    protected void ibModifyPwd_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strNewPwd = tbNewPwd.Value;
        bool result = false;

        OleDbConnection Con;
        OleDbTransaction Trans;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ChangePassword.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUpdateUserPwd";

            Cmd.Parameters.Clear();

            // 비밀번호 수정 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;
            // 비밀번호
            sParams = Cmd.Parameters.Add("@varUserPwd", OleDbType.VarChar, strNewPwd.Length);
            sParams.Direction = ParameterDirection.Input;
            // 사용자 아아디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;
            

            Cmd.Parameters["@varUserPwd"].Value = strNewPwd;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

            if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage(strUserId + " 사용자 비밀번호를 변경하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.HistoryBack();
                return;
            }

            Webhard_Passkorea.WebSource.Member _member = new Webhard_Passkorea.WebSource.Member();

            _member.ConnectionString = strCon;
            _member.Domain = strDomain;
            _member.MemberId = strUserId;
            _member.MemberPwd = strNewPwd;

            try
            {
                result = _member.ChangePassword();
            }
            catch (Exception err)
            {
                _js.MessageBox(err.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(strUserId + " 회원 비밀번호를 수정하는 도중 오류가 발생했습니다.\r\n" + _member.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();

            WF.WriteMessage("비밀번호를 변경하던 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ChangePassword.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("비밀번호가 변경되었습니다.");
        WF.OpenDocPageMove("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
        WF.WndClose();
    }
}
