﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_User_ListUser : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strSchType = "";
    private string strSchValue = "";
    protected string strDomain = "";
    protected int iPage = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        strDomain = Request.Params["dm"];
        iPage = WF.StringToInt(Request.Params["iPage"], 1);
        strSchType = WF.StringDefaultValue(Request.Params["schType"], "");
        strSchValue = WF.StringDefaultValue(Request.Params["schValue"], "");
        string strPageSize = Request.Params["listCnt"];
        string strUserAuth = Request.Params["userAuth"];

        if (!Page.IsPostBack)
        {
            try
            {
                if (strPageSize != "" && strPageSize != null)
                    ddlListCount.SelectedValue = strPageSize;

                if (strUserAuth != "" && strUserAuth != null)
                    ddlUserAuth.SelectedValue = strUserAuth;
            }
            catch
            {
                ddlListCount.SelectedIndex = 0;
                ddlUserAuth.SelectedIndex = 0;
            }

            this.UserDataBind(strSchType, strSchValue);
        }

        string strScript = "";

        strScript = "if (!ModifyMailBoxSize()) return false; else return true;";
        // 데모 제한
        //strScript = "alert('데모라서 메일용량을 수정할 수 없습니다.'); return false;";
        lbModifyMailBoxSize.Attributes.Add("onclick", strScript);

        strScript = "if (!ChangeUserAuth()) return false; else return true;";
        // 데모 제한
        //strScript = "alert('데모라서 사용승인할 수 없습니다.'); return false;";
        ibUserAuth.Attributes.Add("onclick", strScript);

        strScript = "if (!ChangeAllUserAuth()) return false; else return true;";
        // 데모 제한
        //strScript = "alert('데모라서 전체 사용승인을 할 수 없습니다.'); return false;";
        ibAllUserAuth.Attributes.Add("onclick", strScript);

        strScript = "if (!Search()) return false; else return true;";
        ibSearch.Attributes.Add("onclick", strScript);
    }

    #region 사용자 리스트 데이터 바인드
    /// <summary>
    /// 사용자 리스트 데이터 바인드
    /// </summary>
    private void UserDataBind(string strSchType, string strSchValue)
    {
        int iTotCnt = 0;
        // 2006년 11월 27일 수정
        // 리스트 갯수를 DropDownList 컨트롤 선택값을 받아온다.
        int iPageSize = int.Parse(ddlListCount.SelectedValue);
        string strUserAuth = ddlUserAuth.SelectedValue;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Default.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListUserData";

            Cmd.Parameters.Clear();

            // Command Parameter (This Page)
            sParams = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (View Count)
            sParams = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Search Type)
            sParams = Cmd.Parameters.Add("@varSchType", OleDbType.VarChar, strSchType.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Search Value)
            sParams = Cmd.Parameters.Add("@varSchValue", OleDbType.VarChar, strSchValue.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Authority)
            sParams = Cmd.Parameters.Add("@chrUserAuth", OleDbType.Char, strUserAuth.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Doc Total Count)
            sParams = Cmd.Parameters.Add("@iTotCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = iPage;
            Cmd.Parameters["@iPageSize"].Value = iPageSize;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varSchType"].Value = strSchType;
            Cmd.Parameters["@varSchValue"].Value = strSchValue;
            Cmd.Parameters["@chrUserAuth"].Value = strUserAuth;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_USER");
            dt = ds.Tables["MAIL_USER"];

            iTotCnt = int.Parse(Cmd.Parameters["@iTotCnt"].Value.ToString());

            int iRowCount = dt.Rows.Count;
            int iCount = 0;
            string[,] arrUserInfo = new string[iRowCount, 6];

            foreach (DataRow dr in dt.Rows)
            {
                arrUserInfo[iCount, 0] = dr["USER_ID"].ToString();
                arrUserInfo[iCount, 1] = dr["USER_NAME"].ToString();
                arrUserInfo[iCount, 2] = dr["USER_MAILBOX_SIZE"].ToString();
                arrUserInfo[iCount, 3] = dr["USER_AUTHORITY"].ToString();
                arrUserInfo[iCount, 4] = dr["USER_MAILBOX_PATH"].ToString();
                arrUserInfo[iCount, 5] = dr["MAX_CONN_DATE"].ToString();
                ++iCount;
            }

            dt.Clear();

            dt.Columns.Clear();
            dt.Columns.Add("USER_LINK", System.Type.GetType("System.String"));
            dt.Columns.Add("USER_ID", System.Type.GetType("System.String"));
            dt.Columns.Add("USER_NAME", System.Type.GetType("System.String"));
            dt.Columns.Add("USER_MAILBOX_SIZE", System.Type.GetType("System.Int32"));
            dt.Columns.Add("USER_AUTHORITY", System.Type.GetType("System.String"));
            dt.Columns.Add("USER_USE_MAILBOX_SIZE", System.Type.GetType("System.Int32"));
            dt.Columns.Add("MAX_CONN_DATE", System.Type.GetType("System.String"));

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                long lngtmp = WF.UserMailboxSize(arrUserInfo[iLoop, 4]);
                if (arrUserInfo[iLoop, 3] == "1")
                    arrUserInfo[iLoop, 3] = "사용중";
                else
                    arrUserInfo[iLoop, 3] = "사용중지";

                DataRow dr = dt.NewRow();
                dr["USER_ID"] = arrUserInfo[iLoop, 0];
                dr["USER_NAME"] = arrUserInfo[iLoop, 1];
                dr["USER_MAILBOX_SIZE"] = arrUserInfo[iLoop, 2];
                dr["USER_AUTHORITY"] = arrUserInfo[iLoop, 3];
                dr["USER_USE_MAILBOX_SIZE"] = lngtmp;

                if (arrUserInfo[iLoop, 5] != "")
                    dr["MAX_CONN_DATE"] = arrUserInfo[iLoop, 5];
                else
                    dr["MAX_CONN_DATE"] = "접속안함";
                dt.Rows.Add(dr);
            }

            rptListUser.DataSource = dt.DefaultView;
            rptListUser.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("사용자 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Default.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        int iTotPage = 0;

        iTotPage = iTotCnt / iPageSize;

        if ((iTotCnt % iPageSize) > 0)
            iTotPage++;

        if (iTotPage <= 0)
            iTotPage++;

        string strArgs = "&dm=" + strDomain + "&schType=" + strSchType + "&schValue=" + Server.UrlEncode(strSchValue) + "&listCnt=" + iPageSize.ToString() +
            "&userAuth=" + strUserAuth;

        lblPageLink.Text = WF.PageLink(iTotPage, iPage, "ListUser.aspx", strArgs, 15, "", "", "", "");
    }
    #endregion

    #region 선택한 사용자 메일박스 용량 수정
    /// <summary>
    /// 선택한 사용자 메일박스 용량 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbModifyMailBoxSize_Click(object sender, EventArgs e)
    {
        string strMailBoxSize = tbMailBoxSize.Text;
        string strUserId = hidUserId.Value;
        string[] arrUserId;

        if (strMailBoxSize == null || strMailBoxSize == "")
        {
            WF.WriteMessage("수정할 메일박스 용량을 입력해 주세요.");
            WF.MovePage("ListUser.aspx?dm=" + strDomain);
            return;
        }

        if (strUserId == "")
        {
            WF.WriteMessage("메일박스 용량을 수정할 사용자를 선택해 주세요.");
            WF.MovePage("ListUser.aspx?dm=" + strDomain);
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListUser.aspx?dm=" + strDomain);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUpdateMailBoxSize";

            Cmd.Parameters.Clear();

            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, 15);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@intMailboxSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@intMailboxSize"].Value = int.Parse(strMailBoxSize);

            if (strUserId.EndsWith("|"))
                strUserId = strUserId.Substring(0, strUserId.Length - 1);

            arrUserId = strUserId.Split('|');

            for (int iLoop = 0; iLoop < arrUserId.Length; iLoop++)
            {
                Cmd.Parameters["@varUserId"].Value = arrUserId[iLoop];

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

                if (iValue != 0)
                {
                    Trans.Rollback();
                    Con.Close();

                    WF.WriteMessage("사용자 메일박스 용량을 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 발생 프로시져: prUpdateMailBoxSize\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString() + "\\r\\n\\r\\n" +
                        Cmd.Parameters["@strReturnValue"].Value.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
                    WF.HistoryBack();
                    return;
                }
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("선택된 사용자 메일용량을 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListUser.aspx?dm=" + strDomain);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("선택한 사용자 메일박스 용량이 " + strMailBoxSize + " MB로 수정되었습니다.");
        WF.MovePage("ListUser.aspx?dm=" + strDomain);
    }
    #endregion

    #region 사용자 검색
    /// <summary>
    /// 사용자 검색
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strSchType = ddlSearchType.SelectedValue;
        string strSchValue = tbSearch.Text;
        this.UserDataBind(strSchType, strSchValue);
    }
    #endregion

    // 2006년 11월 27일 추가
    // 사용자 리스트 페이징 갯수 선택
    #region 사용자 리스트 페이징 갯수 선택
    /// <summary>
    /// 사용자 리스트 페이징 갯수 선택
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ddlListCount_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        UserDataBind(strSchType, strSchValue);
    }
    #endregion

    // 2006년 11월 28일 추가
    // 사용자 권한별 보기 기능 추가
    protected void ddlUserAuth_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        UserDataBind(strSchType, strSchValue);
    }

    // 2006년 11월 28일 추가
    // 사용자 사용 승인 버튼 추가
    #region 사용자 메일 사용 승인
    /// <summary>
    /// 사용자 메일 사용 승인
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibUserAuth_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        UpdateUserAuth(hidUserId.Value);
    }
    #endregion

    // 2006년 11월 28일 추가
    // 전체 사용자 승인 버튼 추가
    protected void ibAllUserAuth_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        UpdateUserAuth("");
    }

    #region 사용자 메일 사용여부값 변경
    /// <summary>
    /// 사용자 메일 사용여부값 변경
    /// </summary>
    /// <param name="strUser"></param>
    private void UpdateUserAuth(string strUser)
    {
        string strUserId = strUser;
        string[] arrUserId;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListUser.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUpdateUserAuth";

            Cmd.Parameters.Clear();

            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, 15);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@chrUserAuth", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrUserAuth"].Value = "1";

            if (strUserId.Trim() != "")
            {
                if (strUserId.EndsWith("|"))
                    strUserId = strUserId.Substring(0, strUserId.Length - 1);

                arrUserId = strUserId.Split('|');

                for (int iLoop = 0; iLoop < arrUserId.Length; iLoop++)
                {
                    Cmd.Parameters["@varUserId"].Value = arrUserId[iLoop];

                    Cmd.ExecuteNonQuery();

                    int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                    if (iValue != 0)
                    {
                        Trans.Rollback();
                        Con.Close();

                        WF.WriteMessage("사용자 메일 사용여부를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                            "오류 발생 프로시져: prUpdateUserAuth\\r\\n\\r\\n" +
                            "SQL Error Number: " + iValue.ToString());
                        WF.MovePage("ListUser.aspx?dm=" + strDomain + "&iPage=" + iPage.ToString());
                        return;
                    }
                }
            }
            else
            {
                Cmd.Parameters["@varUserId"].Value = "";

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue != 0)
                {
                    Trans.Rollback();
                    Con.Close();

                    WF.WriteMessage("사용자 메일 사용여부를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 발생 프로시져: prUpdateUserAuth\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    WF.MovePage("ListUser.aspx?dm=" + strDomain + "&iPage=" + iPage.ToString());
                    return;
                }
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("사용자 메일 사용여부를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListUser.aspx?dm=" + strDomain + "&iPage=" + iPage.ToString());
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("선택한 사용자 메일 사용여부가 변경 되었습니다.");
        WF.MovePage("ListUser.aspx?dm=" + strDomain + "&iPage=" + iPage.ToString());
    }
    #endregion
}
