﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class AdminMenu_User_ViewUserInfo : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    protected string strDomain = "";
    protected string strUserId = "";
    protected int iPage = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        iPage = WF.StringToInt(Request.Params["iPage"], 1);
        strDomain = Request.Params["dm"];
        strUserId = Request.QueryString["userId"];

        if (!Page.IsPostBack)
        {
            this.UserPermitCodeBind();
            this.UserDataBind();
        }

        //ibModify.Attributes.Add("onclick", "alert('데모라서 사용자 정보를 수정할 수 없습니다.'); return false;");
        //ibDelete.Attributes.Add("onclick", "alert('데모라서 사용자를 삭제할 수 없습니다.'); return false;");
        ibDelete.Attributes.Add("onclick", "if (!DeleteUser()) return false; else return true;");
    }

    #region 회원 권한 코드를 가져온다.
    /// <summary>
    /// 회원 권한 코드를 가져온다.
    /// </summary>
    private void UserPermitCodeBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListUser.aspx?dm=" + strDomain);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUserPermit";

            Cmd.Parameters.Clear();

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "CODE");
            dt = ds.Tables["CODE"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    string strCodeName = dr["CODE_NAME"].ToString();
                    string strCodeId = dr["CODE_ID"].ToString();

                    ListItem li = new ListItem(strCodeName, strCodeId);

                    ddlUserPermit.Items.Add(li);
                }
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("사용자 권한을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 사용자 정보 데이터 바인드
    /// <summary>
    /// 지정한 사용자 정보 데이터를 바인드 한다.
    /// </summary>
    private void UserDataBind()
    {
        string strUserName = "";
        string strUserPwd = "";
        string strUserMailboxSize = "";
        string strUserAuthority = "";
        string strUserMailboxPath = "";
        string strUserPermit = "";
        string strPop3Allow = "";
        string strUserSex = "";
        string strUserBirthday = "";
        string strUserLastEdu = "";
        string strUserJob = "";
        string strUserMarry = "";
        string strUserPosition = "";
        string strUserTel = "";
        string strUserMobile = "";
        string strUserZipCode = "";
        string strUserAddress1 = "";
        string strUserAddress2 = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListUser.aspx?dm=" + strDomain);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prViewMailUserInfo";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;
            // 리턴값
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_USER");

            int iRtnVal = (int)Cmd.Parameters["@iRtnValue"].Value;

            if (iRtnVal != 0)
            {
                Con.Close();

                WF.WriteMessage("사용자 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Message: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("ListUser.aspx?dm=" + strDomain);
                return;
            }

            dt = ds.Tables["MAIL_USER"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    strUserName = dr["USER_NAME"].ToString();
                    strUserPwd = dr["USER_PWD"].ToString();
                    strUserMailboxSize = dr["USER_MAILBOX_SIZE"].ToString();
                    strUserAuthority = dr["USER_AUTHORITY"].ToString();
                    strUserMailboxPath = dr["USER_MAILBOX_PATH"].ToString();
                    strUserPermit = dr["USER_PERMIT"].ToString();
                    strPop3Allow = dr["POP3_ALLOW"].ToString();

                    strUserSex = dr["USER_SEX"].ToString();
                    strUserBirthday = dr["USER_BIRTHDAY"].ToString();
                    strUserLastEdu = dr["USER_LAST_EDU"].ToString();
                    strUserJob = dr["USER_JOB"].ToString();
                    strUserMarry = dr["USER_MARRY"].ToString();
                    strUserPosition = dr["USER_POSITION"].ToString();
                    strUserTel = dr["USER_TEL"].ToString();
                    strUserMobile = dr["USER_MOBILE"].ToString();
                    strUserZipCode = dr["USER_ZIPCODE"].ToString();
                    strUserAddress1 = dr["USER_ADDRESS1"].ToString();
                    strUserAddress2 = dr["USER_ADDRESS2"].ToString();
                    break;
                }

                string strTmp = "";

                for (int iLoop = 0; iLoop < strUserPwd.Length; iLoop++)
                    strTmp += "*";

                strUserPwd = strTmp;

                lblUserId.Text = strUserId;
                tbUserName.Text = strUserName;
                lblUserPwd.Text = strUserPwd;
                lblUseMailboxSize.Text = WF.UserMailboxSize(strUserMailboxPath).ToString() + " MB";
                tbUserMailboxSize.Text = strUserMailboxSize;

                // 사용 여부
                int iCount = ddlUserAuthority.Items.Count;

                for (int iLoop = 0; iLoop < iCount; iLoop++)
                {
                    if (ddlUserAuthority.Items[iLoop].Value == strUserAuthority)
                    {
                        ddlUserAuthority.Items[iLoop].Selected = true;
                        break;
                    }
                }

                // 사용 권한
                iCount = ddlUserPermit.Items.Count;

                for (int iLoop = 0; iLoop < iCount; iLoop++)
                {
                    if (ddlUserPermit.Items[iLoop].Value == strUserPermit.Trim())
                    {
                        ddlUserPermit.Items[iLoop].Selected = true;
                        break;
                    }
                }

                // POP3 사용 여부
                iCount = rblPop3Allow.Items.Count;

                if (strPop3Allow == null)
                    strPop3Allow = "0";

                for (int iLoop = 0; iLoop < iCount; iLoop++)
                {
                    if (rblPop3Allow.Items[iLoop].Value == strPop3Allow)
                    {
                        rblPop3Allow.Items[iLoop].Selected = true;
                        break;
                    }
                }

                // 성별
                if (strUserSex != "")
                {
                    if (strUserSex == "M")
                        strUserSex = "남성";
                    else if (strUserSex == "F")
                        strUserSex = "여성";

                    lblUserSex.Text = strUserSex;
                }

                // 생년월일
                if (strUserBirthday != "")
                {
                    if (strUserBirthday.Length == 8)
                    {
                        strUserBirthday = strUserBirthday.Substring(0, 4) + "년 " + strUserBirthday.Substring(4, 2) + "월 " +
                            strUserBirthday.Substring(6, 2) + "일";
                    }
                    else if (strUserBirthday.Length == 6)
                    {
                        strUserBirthday = strUserBirthday.Substring(0, 2) + "년 " + strUserBirthday.Substring(2, 2) + "월 " +
                            strUserBirthday.Substring(4, 2) + "일";
                    }
                    else
                        strUserBirthday = "";

                    lblUserBirthday.Text = strUserBirthday;
                }

                // 최종학력
                if (strUserLastEdu != "")
                    lblUserLastEdu.Text = strUserLastEdu;

                // 직업
                if (strUserJob != "")
                    lblUserJob.Text = strUserJob;

                // 결혼여부
                if (strUserMarry != "")
                {
                    if (strUserMarry == "Y")
                        strUserMarry = "기혼";
                    else if (strUserMarry == "N")
                        strUserMarry = "미혼";

                    lblUserMarry.Text = strUserMarry;
                }

                // 소속
                if (strUserPosition != "")
                    lblUserPosition.Text = strUserPosition;

                // 전화번호
                if (strUserTel != "")
                    lblUserTel.Text = strUserTel;

                // 이동전화
                if (strUserMobile != "")
                    lblUserMobile.Text = strUserMobile;

                // 우편번호
                if (strUserZipCode != "")
                {
                    strUserZipCode = strUserZipCode.Substring(0, 3) + " - " + strUserZipCode.Substring(3, 3);
                    lblUserZipCode.Text = strUserZipCode;
                }

                // 주소
                if (strUserAddress1 != "")
                    lblUserAddress.Text = strUserAddress1 + " " + strUserAddress2;
            }
            else
            {
                return;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage(strUserId + " 사용자의 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListUser.aspx?dm=" + strDomain);
            return;
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }
    }
    #endregion

    #region 사용자 정보 수정
    /// <summary>
    /// 사용자 정보를 수정한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibModify_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strUserName = tbUserName.Text;
        string strUserPermit = ddlUserPermit.SelectedValue;
        string strUserAuthority = ddlUserAuthority.SelectedValue;
        string strUserMailBoxSize = tbUserMailboxSize.Text;
        string strPop3Allow = rblPop3Allow.SelectedValue;
        int iValue = 0;

        Domain dm = new Domain();
        dm.DomainName = strDomain;
        dm.LoadDomain(strCon);

        if (dm.AllocateSize < (int.Parse(strUserMailBoxSize) + dm.UseSize))
        {
            WF.WriteMessage("수정하려는 용량이 할당된 용량보다 큽니다.\\r\\n\\r\\n" +
                "용량을 다시 입력해 주세요.\\r\\n\\r\\n" +
                "할당된 용량: " + dm.AllocateSize.ToString() + " MB\\r\\n\\r\\n" +
                "사용된 용량: " + dm.UseSize.ToString() + " MB\\r\\n\\r\\n" +
                "수정하려는 용량: " + strUserMailBoxSize + " MB");
            WF.HistoryBack();
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUpdateUserInfo";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;
            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (User Name)
            sParams = Cmd.Parameters.Add("@varUserName", OleDbType.VarWChar, strUserName.Length);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (User Permittion)
            sParams = Cmd.Parameters.Add("@chrUserPermit", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (User Authority)
            sParams = Cmd.Parameters.Add("@chrUserAuth", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (User Mailbox Size)
            sParams = Cmd.Parameters.Add("@intUserMaxSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (Pop3 Allow)
            sParams = Cmd.Parameters.Add("@chrPop3Allow", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
            sParams.Direction = ParameterDirection.Output;
            
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varUserName"].Value = strUserName;
            Cmd.Parameters["@chrUserPermit"].Value = strUserPermit;
            Cmd.Parameters["@chrUserAuth"].Value = strUserAuthority;
            Cmd.Parameters["@intUserMaxSize"].Value = strUserMailBoxSize;
            Cmd.Parameters["@chrPop3Allow"].Value = strPop3Allow;

            Cmd.ExecuteNonQuery();

            iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage(strUserId + " 사용자 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
                WF.MovePage("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage(strUserId + " 사용자 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
                return;
            }

            // 웹하드 사용자 정보를 수정한다.
            if (strUserAuthority == "1")
            {
                Webhard_Passkorea.WebSource.Member mem = new Webhard_Passkorea.WebSource.Member();
                
                mem.ConnectionString = strCon;
                mem.Domain = strDomain;
                mem.MemberId = strUserId;
                mem.MemberName = strUserName;
                mem.EmailAddr = strUserId + "@" + strDomain;
                mem.Permission = "M0";

                if (!mem.ModifyMemberInfo())
                {
                    /*
                    WF.WriteMessage(mem.ErrorMessage.Replace("\r\n", "\\r\\n\\r\\n"));
                    WF.HistoryBack();
                    return;
                    */
                }
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            WF.WriteMessage(strUserId + " 사용자의 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strUserId + " 회원님의 메일계정 정보가 변경되었습니다.");
        WF.MovePage("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
    }
    #endregion

    #region 사용자 삭제
    /// <summary>
    /// 사용자 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelete_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strUserPath = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteMailUser";

            Cmd.Parameters.Clear();
        
            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;
            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
            sParams.Direction = ParameterDirection.Output;
            
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();

            int iResult = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iResult < 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage(strUserId + " 사용자 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
                WF.MovePage("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
                return;
            }

            strUserPath = Cmd.Parameters["@varRtnVal"].Value.ToString();

            Member mem = new Member();

            mem.ConnectionString = strCon;
            mem.Domain = strDomain;
            mem.MemberId = strUserId;

            mem.DeleteMemberInfo();

            // 사용자 폴더 삭제
            if (Directory.Exists(strUserPath))
                Directory.Delete(strUserPath, true);

            Trans.Commit();
        }
        catch (Exception err)
        {
            WF.WriteMessage(strUserId + " 사용자의 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ViewUserInfo.aspx?dm=" + strDomain + "&userId=" + strUserId);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strUserId + " 사용자의 정보를 모두 삭제하였습니다.");
        WF.MovePage("ListUser.aspx?dm=" + strDomain);
    }
    #endregion
}
