﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class AdminMenu_GroupList : System.Web.UI.Page
{
    protected string strPageLink = "";

    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strPath = ConfigurationSettings.AppSettings["WebhardPath"].ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);
        strDomain = Session["MAIL_DOMAIN"].ToString();

        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        _js.Page = Page;

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../../Default.aspx", "top");
            return;
        }
        else
        {
            string strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../../Default.aspx", "top");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../../Default.aspx", "top");
                return;
            }

            /*
            // 관리자인지 확인한다.
            Webhard_Passkorea.WebSource.Member _member = new Webhard_Passkorea.WebSource.Member();
            _member.ConnectionString = strCon;
            _member.Domain = strDomain;

            if (!_member.LoadMemberInfo(strMemberId))
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.MovePage("../../Main.aspx", "top");
                return;
            }

            if (!_member.Permission.Trim().Equals("M0"))
            {
                _js.MessageBox("이 페이지는 관리자만 접근할 수 있습니다.");
                _js.MovePage("../../Main.aspx", "top");
                return;
            }
            */
        }

        if (!Page.IsPostBack)
        {
            this.GroupDataBind();
        }

        string script = "if (!CreateGroup()) return false; else return true;";
        btnCreateGroup.Attributes.Add("onclick", script);

        Page.DataBind();
    }

    private void GroupDataBind()
    {
        Group group = new Group();
        bool result = false;

        group.ConnectionString = strCon;

        try
        {
            result = group.GetGroupList(strDomain);
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            return;
        }

        if (!result)
        {
            _js.MessageBox(group.ErrorMessage);
            return;
        }

        if (group.GroupListData.Rows.Count > 0)
        {
            DataTable dt = group.GroupListData;

            int iRowCnt = dt.Rows.Count;
            string[,] groupData = new string[iRowCnt, 6];

            for(int i = 0; i < iRowCnt; i++)
            {
                groupData[i, 0] = dt.Rows[i]["Group_Name"].ToString();
                groupData[i, 1] = dt.Rows[i]["Grp_Owner_Id"].ToString();
                groupData[i, 2] = dt.Rows[i]["Grp_Allocate_Size"].ToString();
                groupData[i, 3] = dt.Rows[i]["Member_Count"].ToString();
                groupData[i, 4] = dt.Rows[i]["Grp_Use_Accept"].ToString();
                groupData[i, 5] = dt.Rows[i]["Grp_Create_Date"].ToString();
            }

            dt.Rows.Clear();
            dt.Columns.Remove("Grp_Allocate_Size");
            dt.Columns.Add("Grp_Allocate_Size", Type.GetType("System.String"));
            dt.Columns.Add("Group_Name_Link", Type.GetType("System.String"));

            for (int i = 0; i < iRowCnt; i++)
            {
                DataRow dr = dt.NewRow();

                dr["Group_Name"] = groupData[i, 0];
                dr["Group_Name_Link"] = "<a href=\"ModifyGroupInfo.aspx?Grp=" + Server.UrlEncode(groupData[i, 0]) + "\">" + groupData[i, 0] + "</a>";
                dr["Grp_Owner_Id"] = groupData[i, 1];
                dr["Grp_Allocate_Size"] = ProcSize(groupData[i, 2]);
                dr["Member_Count"] = groupData[i, 3];
                dr["Grp_Use_Accept"] = groupData[i, 4];
                dr["Grp_Create_Date"] = groupData[i, 5];

                dt.Rows.Add(dr);
            }

            rptGroupList.DataSource = dt;
        }
        else
            rptGroupList.DataSource = group.GroupListData;
        
        rptGroupList.DataBind();
    }

    #region 그룹 생성
    /// <summary>
    /// 그룹을 생성한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnCreateGroup_Click(Object sender, EventArgs e)
    {
        bool result = false;
        string strGroupName = tbGroupName.Text;
        string strOwnerId = hfGroupOwnerId.Value;
        string strAllocateSize = tbAllocateSize.Text;
        string strUseAccept = rblUseAccept.SelectedValue;

        if (strGroupName.Trim() == "")
        {
            _js.MessageBox("그룹명이 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strOwnerId.Trim() == "")
        {
            _js.MessageBox("그룹 관리자 아이디가 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strAllocateSize.Trim() == "")
        {
            _js.MessageBox("그룹 할당용량이 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strUseAccept.Trim() == "")
        {
            _js.MessageBox("그룹 사용여부가 선택되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        // 그룹 생성
        Group group = new Group();

        group.ConnectionString = strCon;

        try
        {
            strPath += "\\" + strDomain + "\\Webhard_Group\\" + strGroupName;
            result = group.CreateGroup(strDomain, strGroupName, strOwnerId, int.Parse(strAllocateSize), strUseAccept, strPath);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(group.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        // 그룹내 사용자 등록
        GroupMember _groupMember = new GroupMember();

        _groupMember.ConnectionString = strCon;

        try
        {
            result = _groupMember.AddGroupMember(strDomain, strGroupName, strOwnerId);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_groupMember.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        _js.MovePage("GroupList.aspx", "");
        return;
    }
    #endregion

    #region 그룹 삭제
    /// <summary>
    /// 해당 그룹을 삭제한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDeleteGroup_Command(Object sender, CommandEventArgs e)
    {
        bool result = false;
        string strGroup = e.CommandArgument.ToString();

        if (strGroup.Trim() == "")
        {
            _js.MessageBox("삭제할 그룹명이 없습니다.");
            return;
        }

        Group _group = new Group();

        _group.ConnectionString = strCon;

        try
        {
            result = _group.DeleteGroup(strDomain, strGroup);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_group.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        _js.MovePage("GroupList.aspx", "");
    }
    #endregion

    #region 리피터 컨트롤 내 버튼에 속성 지정
    /// <summary>
    /// 리피터 컨트롤 내 버튼에 속성에 자바스크립트를 넣는다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void rptGroupList_ItemDataBound(Object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
    {
        string strScript = "";
        int iCnt = e.Item.Controls.Count;

        for (int i = 0; i < iCnt; i++)
        {
            ImageButton ibDelete = (ImageButton)e.Item.Controls[i].FindControl("ibDeleteGroup");

            if (ibDelete != null)
            {
                string strGroup = ibDelete.CommandArgument;

                strScript = "if (!DeleteGroup('" + strGroup + "')) return false; else return true;";
                ibDelete.Attributes.Add("onclick", strScript);
            }
        }
    }
    #endregion

    private string ProcSize(string strSize)
    {
        float lSize = 0;

        try
        {
            if (strSize == null)
                return "0 Byte";
            else if (strSize == "")
                return "0 Byte";

            lSize = long.Parse(strSize);
        }
        catch
        {
            return "0 byte";
        }

        if (lSize > 0)
        {
            if (lSize > 1024)
            {
                lSize /= 1024;
                strSize = string.Format("{0}", Math.Round(lSize, 2)) + " GB";
            }
            else
                strSize = lSize.ToString() + " MB";
        }

        return strSize;
    }
}
