﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class AdminMenu_MemberList : System.Web.UI.Page
{
    protected string strPageLink = "";
    protected int iPage = 1;

    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Member _member = new Webhard_Passkorea.WebSource.Member();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();

    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strAllocateSize = ConfigurationSettings.AppSettings["UserDefaultSize"].ToString();
    private string strWebhardPath = ConfigurationSettings.AppSettings["WebhardPath"].ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        _js.Page = Page;
        string strPage = Request.Params["iPage"];
        strDomain = Session["MAIL_DOMAIN"].ToString();

        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../../Default.aspx", "top");
            return;
        }
        else
        {
            string strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../../Default.aspx", "top");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../../Default.aspx", "top");
                return;
            }

            /*
            _member.Domain = strDomain;
            _member.ConnectionString = strCon;
            // 관리자인지 확인한다.
            if (!_member.LoadMemberInfo(strMemberId))
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.MovePage("../../Main.aspx", "top");
                return;
            }

            if (!_member.Permission.Trim().Equals("M0"))
            {
                _js.MessageBox("이 페이지는 관리자만 접근할 수 있습니다.");
                _js.MovePage("../../Main.aspx", "top");
                return;
            }
            */
        }

        if (strPage != null && strPage != "")
            iPage = int.Parse(strPage);

        if (!Page.IsPostBack)
        {
            MemberList();
        }

        Page.DataBind();
    }

    private void MemberList()
    {
        bool result = false;
        int iTotalPage = 0;
        Member mem = new Member();

        mem.ConnectionString = strCon;
        mem.Domain = strDomain;
        mem.Page = iPage;

        try
        {
            result = mem.MemberList();
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            return;
        }

        if (!result)
        {
            _js.MessageBox(mem.ErrorMessage);
            return;
        }

        rptMemberList.DataSource = mem.MemberListData;
        rptMemberList.DataBind();

        WebhardCommon Wc = new WebhardCommon();

        iTotalPage = mem.TotalCount / mem.PageSize;
        if ((mem.TotalCount % mem.PageSize) > 0) ++iTotalPage;

        strPageLink = Wc.PageLink(iTotalPage, iPage, "MemberList.aspx", "", 10, "", "", "", "");
    }

    protected void btnSyncMember_Click(object sender, ImageClickEventArgs e)
    {
        int iRowCnt = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("MemberList.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListTotalMember";

            sParams = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "Total_Member");
            dt = ds.Tables["Total_Member"];

            iRowCnt = dt.Rows.Count;

            if (iRowCnt > 0)
            {
                Member mem = new Member();

                mem.ConnectionString = strCon;
                mem.Domain = strDomain;

                for (int i = 0; i < iRowCnt; i++)
                {
                    DataRow dr = dt.Rows[i];
                    string strUserId = dr["User_Id"].ToString();
                    string strUserName = dr["User_Name"].ToString();

                    // 이름이 없으면 아이디로 대체한다.
                    if (strUserName.Trim() == "") strUserName = strUserId;

                    mem.MemberId = strUserId;
                    mem.MemberName = strUserName;
                    mem.MemberPwd = dr["User_Pwd"].ToString();
                    mem.EmailAddr = strUserId + "@" + strDomain;
                    mem.AllocateSize = int.Parse(strAllocateSize);
                    
                    if (dr["USER_PERMIT"].ToString().Trim() == "1")
                        mem.Permission = "M0";
                    else
                        mem.Permission = "M2";
                    
                    mem.Path = strWebhardPath + "\\" + strDomain + "\\user_data\\" + strUserId;

                    mem.JoinMember();
                }
            }
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            return;
        }

        _js.MessageBox("메일 회원과 웹하드 회원 리스트가 동기화 되었습니다.");
        _js.MovePage("MemberList.aspx", "");
        return;
    }
}
