﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class AdminMenu_MemberView : System.Web.UI.Page
{
    protected int iPage = 1;
    protected string memberId = "";
    protected long lUseSize = 0;

    private Member _member = new Member();
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        string strPage = Request.Params["iPage"];
        memberId = Request.Params["memberId"];
        strDomain = Session["MAIL_DOMAIN"].ToString();

        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        _js.Page = Page;
        _member.Domain = strDomain;
        _member.ConnectionString = strCon;

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../../Default.aspx", "top");
            return;
        }
        else
        {
            string strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../../Default.aspx", "top");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../../Default.aspx", "top");
                return;
            }

            /*
            // 관리자인지 확인한다.
            if (!_member.LoadMemberInfo(strMemberId))
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.MovePage("../../Main.aspx", "top");
                return;
            }

            if (!_member.Permission.Trim().Equals("M0"))
            {
                _js.MessageBox("이 페이지는 관리자만 접근할 수 있습니다.");
                _js.MovePage("../../Main.aspx", "top");
                return;
            }
            */
        }
        
        if (strPage != null && strPage != "")
            iPage = int.Parse(strPage);

        if (!Page.IsPostBack)
        {
            this.PermissionCode();
            this.MemberDataBind();
        }

        Page.DataBind();

        //btnModifyMemberInfo.Attributes.Add("onclick", "alert('데모라서 사용자의 웹하드 정보를 수정할 수 없습니다.'); return false;");
    }

    private void PermissionCode()
    {
        bool result = false;
        Code cd = new Code();

        cd.ConnectionString = strCon;
        cd.GroupCode = "PM";

        try
        {
            result = cd.GetCodeData();
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            return;
        }

        if (!result)
        {
            _js.MessageBox(cd.ErrorMessage);
            return;
        }

        foreach (DataRow row in cd.CodeData.Rows)
        {
            ListItem item = new ListItem(row[1].ToString(), row[0].ToString());

            ddlPermission.Items.Add(item);
        }
    }

    private void MemberDataBind()
    {
        bool result = false;
        _member.ConnectionString = strCon;
        _member.Domain = strDomain;
        _member.MemberId = memberId;

        try
        {
            result = _member.LoadMemberInfo();
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            return;
        }

        if (!result)
        {
            _js.MessageBox(_member.ErrorMessage);
            return;
        }

        tbMemberId.Text = _member.MemberId;
        tbMemberName.Text = _member.MemberName;
        tbEmail.Text = _member.EmailAddr;
        tbAllocateSize.Text = _member.AllocateSize.ToString();
        tbPath.Text = _member.Path;
        
        
        for (int i = 0; i < ddlPermission.Items.Count; i++)
        {
            if (ddlPermission.Items[i].Value == _member.Permission.Trim())
            {
                ddlPermission.Items[i].Selected = true;
                break;
            }
        }
    }

    protected void btnModifyMemberInfo_Click(object sender, EventArgs e)
    {
        bool result = false;
        string strMemberId = tbMemberId.Text;
        string strMemberName = tbMemberName.Text;
        string strMemberEmail = tbEmail.Text;
        string strAllocateSize = tbAllocateSize.Text;
        string strPermission = ddlPermission.SelectedValue;
        string strPath = tbPath.Text;

        if (memberId.Trim() == "")
        {
            _js.MessageBox("아이디가 없습니다.");
            return;
        }
        else if (strMemberName.Trim() == "")
        {
            _js.MessageBox("이름을 입력해 주세요.");
            return;
        }
        else if (strMemberEmail.Trim() == "")
        {
            _js.MessageBox("메일주소를 입력해 주세요.");
            return;
        }
        else if (strPath.Length == 2 && strPath.Substring(1) == ":")
        {
            _js.MessageBox(strPath + " 드라이브는 저장경로로 사용할 수 없습니다.");
            return;
        }

        _member.ConnectionString = strCon;
        _member.Domain = strDomain;
        _member.MemberId = memberId;
        _member.MemberName = strMemberName;
        _member.EmailAddr = strMemberEmail;
        _member.AllocateSize = int.Parse(strAllocateSize);
        _member.Permission = strPermission;
        _member.Path = strPath;

        lUseSize = _member.UseSize();

        try
        {
            result = _member.ModifyMemberInfo();
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            return;
        }

        if (!result)
        {
            _js.MessageBox(_member.ErrorMessage);
            return;
        }

        _js.MessageBox(memberId + " 회원 정보를 수정하였습니다.");
        _js.MovePage("MemberView.aspx?iPage=" + iPage.ToString() + "&memberId=" + memberId, "");
    }
}
