﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class AdminMenu_ModifyGroupInfo : System.Web.UI.Page
{
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();

    protected string strGroupName = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        string strScript = "";

        strGroupName = Request.Params["Grp"];
        strDomain = Session["MAIL_DOMAIN"].ToString();

        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        _js.Page = Page;

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../../Default.aspx", "top");
            return;
        }
        else
        {
            string strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../../Default.aspx", "top");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../../Default.aspx", "top");
                return;
            }

            /*
            // 관리자인지 확인한다.
            Webhard_Passkorea.WebSource.Member _member = new Webhard_Passkorea.WebSource.Member();
            _member.ConnectionString = strCon;
            _member.Domain = strDomain;

            if (!_member.LoadMemberInfo(strMemberId))
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.MovePage("../../Main.aspx", "top");
                return;
            }

            if (!_member.Permission.Trim().Equals("M0"))
            {
                _js.MessageBox("이 페이지는 관리자만 접근할 수 있습니다.");
                _js.MovePage("../../Main.aspx", "top");
                return;
            }
            */
        }

        if (!Page.IsPostBack)
        {
            GroupDataBind(strGroupName);
            GroupMemberListBind(strGroupName);
        }

        strGroupName = Request.Params["grp"];

        // 그룹 삭제 버튼에 속성 지정
        strScript = "if (!DeleteGroup()) return false; else return true;";
        btnDeleteGroup.Attributes.Add("onclick", strScript);

        // 그룹에 등록된 회원 삭제 버튼 속성 지정
        strScript = "if (!CheckDeleteMember()) return false; else return true;";
        btnDeleteMember.Attributes.Add("onclick", strScript);

        // 다운로드 허용 버튼 속성 지정
        strScript = "if (!CheckGroupMember(\"다운로드 허용\")) return false; else return true;";
        btnAllowDownload.Attributes.Add("onclick", strScript);

        // 다운로드 금지 버튼 속성 지정
        strScript = "if (!CheckGroupMember(\"다운로드 금지\")) return false; else return true;";
        btnForbidDownload.Attributes.Add("onclick", strScript);

        // 업로드 허용 버튼 속성 지정
        strScript = "if (!CheckGroupMember(\"업로드 허용\")) return false; else return true;";
        btnAllowUpload.Attributes.Add("onclick", strScript);

        // 업로드 금지 버튼 속성 지정
        strScript = "if (!CheckGroupMember(\"업로드 금지\")) return false; else return true;";
        btnForbidUpload.Attributes.Add("onclick", strScript);

        // 삭제 허용 버튼 속성 지정
        strScript = "if (!CheckGroupMember(\"삭제 허용\")) return false; else return true;";
        btnAllowDelete.Attributes.Add("onclick", strScript);

        // 삭제 금지 버튼 속성 지정
        strScript = "if (!CheckGroupMember(\"삭제 금지\")) return false; else return true;";
        btnForbidDelete.Attributes.Add("onclick", strScript);

        Page.DataBind();
    }

    #region 그룹 정보 바인드
    /// <summary>
    /// 그룹 정보를 가져온다.
    /// </summary>
    /// <param name="strGroupName"></param>
    private void GroupDataBind(string strGroupName)
    {
        bool result = false;
        Group group = new Group();

        group.ConnectionString = strCon;

        try
        {
            result = group.LoadGroupInfo(strDomain, strGroupName);
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(group.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        tbGroupName.Text = strGroupName;
        tbGroupOwnerId.Text = group.OwnerId;
        hfGroupOwnerId.Value = group.OwnerId;
        tbAllocateSize.Text = group.AllocateSize.ToString();
        tbPath.Text = group.GroupPath;
        rblUseAccept.SelectedValue = group.UseAccept.Trim();

        return;
    }
    #endregion

    #region 그룹에 등록된 회원 리스트 바인드
    /// <summary>
    /// 그룹에 등록된 회원 리스트를 바인드 한다.
    /// </summary>
    /// <param name="strGroupName"></param>
    private void GroupMemberListBind(string strGroupName)
    {
        bool result = false;
        GroupMember groupMember = new GroupMember();

        groupMember.ConnectionString = strCon;

        try
        {
            result = groupMember.MemberList(strDomain, strGroupName);
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(groupMember.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        rptGroupMemberList.DataSource = groupMember.GroupMemberList;
        rptGroupMemberList.DataBind();
    }
    #endregion

    #region 그룹에 등록된 사용자 권한 변경
    /// <summary>
    /// 그룹에 등록된 사용자 권한을 변경한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnAllowDownload_Click(Object sender, EventArgs e)
    {
        string strMemberId = hfGroupMemberId.Value;

        ChangePermission("다운로드 허용", strMemberId, "DN", true);
    }

    protected void btnForbidDownload_Click(Object sender, EventArgs e)
    {
        string strMemberId = hfGroupMemberId.Value;

        ChangePermission("다운로드 금지", strMemberId, "DN", false);
    }

    protected void btnAllowUpload_Click(Object sender, EventArgs e)
    {
        string strMemberId = hfGroupMemberId.Value;

        ChangePermission("업로드 허용", strMemberId, "UP", true);
    }

    protected void btnForbidUpload_Click(Object sender, EventArgs e)
    {
        string strMemberId = hfGroupMemberId.Value;

        ChangePermission("업로드 금지", strMemberId, "UP", false);
    }

    protected void btnAllowDelete_Click(Object sender, EventArgs e)
    {
        string strMemberId = hfGroupMemberId.Value;

        ChangePermission("삭제 허용", strMemberId, "DT", true);
    }

    protected void btnForbidDelete_Click(Object sender, EventArgs e)
    {
        string strMemberId = hfGroupMemberId.Value;

        ChangePermission("삭제 금지", strMemberId, "DT", false);
    }
    #endregion

    #region 사용자 권한 변경
    /// <summary>
    /// 사용자 권한을 변경한다.
    /// </summary>
    /// <param name="strText"></param>
    /// <param name="strMemberId"></param>
    /// <param name="strField"></param>
    /// <param name="bAllow"></param>
    private void ChangePermission(string strText, string strMemberId, string strField, bool bAllow)
    {
        bool result = false;
        GroupMember _groupMember = new GroupMember();

        _groupMember.ConnectionString = strCon;

        if (strMemberId.Trim() == "")
        {
            _js.MessageBox(strText + " 권한을 지정해줄 사용자 아이디가 없습니다.");
            _js.HistoryBack();
            return;
        }

        try
        {
            if (strMemberId.EndsWith(","))
                strMemberId = strMemberId.Substring(0, strMemberId.Length - 1);

            result = _groupMember.ChangePermission(strDomain, strGroupName, strMemberId, strField, bAllow);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_groupMember.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        _js.MovePage("modifyGroupInfo.aspx?grp=" + Server.UrlEncode(strGroupName), "");
    }
    #endregion

    #region 그룹 정보 수정
    /// <summary>
    /// 그룹 정보를 수정한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnModifyGroup_Click(Object sender, EventArgs e)
    {
        bool result = false;
        string strOwnerId = hfGroupOwnerId.Value;
        string strAllocateSize = tbAllocateSize.Text;
        string strUseAccept = rblUseAccept.SelectedValue;
        string strGroupPath = tbPath.Text;
        string[] strPath = strGroupPath.Split('\\');

        if (strOwnerId.Trim() == "")
            strOwnerId = tbGroupOwnerId.Text;

        Group _group = new Group();

        _group.ConnectionString = strCon;

        try
        {
            result = _group.ModifyGroup(strDomain, strGroupName, strOwnerId, int.Parse(strAllocateSize), strUseAccept);

            // 폴더가 존재하는지 확인하고 존재하지 않으면 폴더를 생성한다.
            strGroupPath = strPath[0];

            for (int i = 1; i < strPath.Length; i++)
            {
                strGroupPath += "\\" + strPath[i];

                if (!Directory.Exists(strGroupPath))
                    Directory.CreateDirectory(strGroupPath);
            }
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_group.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        GroupMember _groupMember = new GroupMember();

        _groupMember.ConnectionString = strCon;

        try
        {
            result = _groupMember.CheckGroupMember(strDomain, strGroupName, strOwnerId);

            if (!result)
                result = _groupMember.AddGroupMember(strDomain, strGroupName, strOwnerId);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_groupMember.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        _js.MovePage("ModifyGroupInfo.aspx?Grp=" + Server.UrlEncode(strGroupName), "");
    }
    #endregion

    #region 그룹 삭제
    /// <summary>
    /// 해당 그룹을 삭제한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDeleteGroup_Click(Object sender, EventArgs e)
    {
        bool result = false;

        Group _group = new Group();

        _group.ConnectionString = strCon;

        try
        {
            result = _group.DeleteGroup(strDomain, strGroupName);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_group.ErrorMessage);
            _js.HistoryBack();
            return;
        }
        
        _js.MovePage("GroupList.aspx", "");
    }
    #endregion

    #region 그룹 회원 삭제
    /// <summary>
    /// 그룹에 등록된 회원을 삭제한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDeleteMember_Click(Object sender, EventArgs e)
    {
        bool result = false;
        string strMemberId = hfGroupMemberId.Value;

        GroupMember _groupMember = new GroupMember();

        _groupMember.ConnectionString = strCon;

        try
        {
            if (strMemberId.EndsWith(","))
                strMemberId = strMemberId.Substring(0, strMemberId.Length - 1);

            result = _groupMember.DeleteMemberId(strDomain, strGroupName, strMemberId);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_groupMember.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        _js.MovePage("ModifyGroupInfo.aspx?Grp=" + Server.UrlEncode(strGroupName), "");
    }
    #endregion
}
