﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class AdminMenu_SearchMemberAdminId : System.Web.UI.Page
{
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Member _member = new Member();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strPage = "";

    protected string strGroupName = "";
    protected string strPageLink = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strPage = Request.Params["iPage"];
        strDomain = Session["MAIL_DOMAIN"].ToString();

        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        if (strPage == null || strPage == "")
            strPage = "1";

        _js.Page = Page;
        _member.Domain = strDomain;
        _member.ConnectionString = strCon;
        
        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../../Default.aspx", "opener");
            _js.WindowsClose();
            return;
        }
        else
        {
            string strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../../Default.aspx", "opener");
                    _js.WindowsClose();
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../../Default.aspx", "opener");
                _js.WindowsClose();
                return;
            }

            /*
            // 관리자인지 확인한다.
            if (!_member.LoadMemberInfo(strMemberId))
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.MovePage("../../Main.aspx", "opener");
                _js.WindowsClose();
                return;
            }

            if (!_member.Permission.Trim().Equals("M0"))
            {
                _js.MessageBox("이 페이지는 관리자만 접근할 수 있습니다.");
                _js.MovePage("../../Main.aspx", "opener");
                _js.WindowsClose();
                return;
            }
            */
        }

        if (!Page.IsPostBack)
        {
            MemberList();
        }

        Page.DataBind();
    }

    private void MemberList()
    {
        int iPage = 0;
        int iTotalPage = 0;
        bool result = false;

        if (strPage == null || strPage == "")
            iPage = 0;
        else
            iPage = int.Parse(strPage);

        try
        {
            result = _member.MemberList(iPage, 15, "", "", "", "");
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            return;
        }

        if (!result)
        {
            _js.MessageBox(_member.ErrorMessage);
            return;
        }

        rptMemberList.DataSource = _member.MemberListData;
        rptMemberList.DataBind();

        WebhardCommon _wc = new WebhardCommon();

        iTotalPage = _member.TotalCount / _member.PageSize;
        if ((_member.TotalCount % _member.PageSize) > 0) ++iTotalPage;

        strPageLink = _wc.PageLink(iTotalPage, iPage, "SearchMemberAdminId.aspx", "", 10, "", "", "", "");
    }
}
