﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class AdminMenu_WebhardFiltering : System.Web.UI.Page
{
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private UploadFilter _uf = new UploadFilter();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strDomain = "";
    private string strFileExtension = "";
    private string strIpList = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strMemberId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        string strScript = "";

        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];
        strDomain = Session["MAIL_DOMAIN"].ToString();

        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            WF.WriteMessage("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
        }

        _js.Page = Page;
        _uf.ConnectionString = strCon;

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../../Default.aspx", "top");
            return;
        }
        else
        {
            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../../Default.aspx", "top");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../../Default.aspx", "top");
                return;
            }

            /*
            // 관리자인지 확인한다.
            Webhard_Passkorea.WebSource.Member _member = new Webhard_Passkorea.WebSource.Member();
            _member.ConnectionString = strCon;
            _member.Domain = strDomain;

            if (!_member.LoadMemberInfo(strMemberId))
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.MovePage("../../Main.aspx", "top");
                return;
            }

            if (!_member.Permission.Trim().Equals("M0"))
            {
                _js.MessageBox("이 페이지는 관리자만 접근할 수 있습니다.");
                _js.MovePage("../../Main.aspx", "top");
                return;
            }
            */
        }

        FilterDataBind();

        if (!Page.IsPostBack)
        {
            hfListExtentions.Value = strFileExtension;
            hfListIp.Value = strIpList;
        }

        // 제한 확장자 등록 버튼 속성 추가
        strScript = "if (!AddFileExtension()) return false; else return true;";
        btnAddExtension.Attributes.Add("onclick", strScript);

        // 제한 아이피 등록 버튼 속성 추가
        strScript = "if (!AddIp()) return false; else return true;";
        btnAddIp.Attributes.Add("onclick", strScript);

        // 제한 확장자 삭제 버튼 속성 추가
        strScript = "if (!DeleteFileExtension()) return false; else return true;";
        btnDeleteFileExtension.Attributes.Add("onclick", strScript);

        // 제한 아이피 삭제 버튼 속성 추가
        strScript = "if (!DeleteIp()) return false; else return true;";
        btnDeleteIp.Attributes.Add("onclick", strScript);

        Page.DataBind();
    }

    private void FilterDataBind()
    {
        bool result = false;

        try
        {
            result = _uf.LoadUploadFilter(strDomain, strMemberId);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_uf.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        strFileExtension = _uf.FileExtensions;
        strIpList = _uf.IpList;

        if (strFileExtension.Trim() != "")
        {
            TableBind(strFileExtension, tblFileExtension, "F");
        }

        if (strIpList.Trim() != "")
        {
            TableBind(strIpList, tblIpList, "I");
        }
    }

    private void TableBind(string strValue, HtmlTable tbl, string strFlag)
    {
        string[] strData = strValue.Split('|');
        
        for (int i = 0; i < strData.Length; i++)
        {
            HtmlTableRow _tblRow = new HtmlTableRow();
            HtmlTableCell _tblCell = new HtmlTableCell();

            _tblRow.Height = "23";
            
            _tblCell.InnerHtml = strData[i];
            _tblCell.Style.Add("font-size", "14px");
            _tblCell.Attributes.Add("onclick", "javascript: SelectItem('" + strData[i] + "', '" + strFlag + "'); ChangeColor(this);");
            _tblCell.Attributes.Add("onmouseover", "javascript: this.style.cursor='hand';");
            
            _tblRow.Cells.Add(_tblCell);
            tbl.Rows.Add(_tblRow);

            _tblRow = new HtmlTableRow();
            _tblCell = new HtmlTableCell();

            _tblCell.Style.Add("height", "2px;");
            _tblCell.Style.Add("background-color", "#e5e5e5");
            _tblRow.Cells.Add(_tblCell);

            tbl.Rows.Add(_tblRow);
        }

        tbl.DataBind();
    }

    #region 확장자 등록
    /// <summary>
    /// 업로드 제한 확장자를 등록합니다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnAddExtension_Click(object sender, EventArgs e)
    {
        bool result = false;
        string strExtension = tbFileExtension.Text;
        string strListExtension = hfListExtentions.Value;

        if (strExtension.Trim() == "")
        {
            _js.MessageBox("업로드 제한을 하려는 확장자명이 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        try
        {
            result = _uf.ModifyFilter(strDomain, strMemberId, strListExtension, strIpList);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_uf.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        _js.MovePage("WebhardFiltering.aspx", "");
    }
    #endregion

    #region 아이피 등록
    /// <summary>
    /// 업로드 제한 아이피를 등록합니다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnAddIp_Click(object sender, EventArgs e)
    {
        bool result = false;
        string strIp1 = tbIpClass1.Text;
        string strIp2 = tbIpClass2.Text;
        string strIp3 = tbIpClass3.Text;
        string strIp4 = tbIpClass4.Text;
        string strIp = "";
        string strListIp = hfListIp.Value;

        if (strIp1.Trim() == "")
        {
            _js.MessageBox("첫번째 아이피가 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strIp2.Trim() == "")
        {
            _js.MessageBox("두번째 아이피가 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strIp3.Trim() == "")
        {
            _js.MessageBox("세번째 아이피가 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strIp4.Trim() == "")
        {
            _js.MessageBox("네번째 아이피가 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        try
        {
            result = _uf.ModifyFilter(strDomain, strMemberId, strFileExtension, strListIp);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_uf.ErrorMessage);
            _js.HistoryBack();
            return;
        }
        _js.MovePage("WebhardFiltering.aspx", "");
    }
    #endregion

    protected void btnDeleteFileExtension_Click(Object sender, EventArgs e)
    {
        bool result = false;
        string strFileExt = hfDeleteExt.Value;
        string[] strTmpExt;

        if (strFileExtension.Trim() == "")
        {
            _js.MessageBox("확장자 리스트가 없습니다.");
            _js.HistoryBack();
            return;
        }

        if (strFileExt.Trim() == "")
        {
            _js.MessageBox("삭제할 확장자가 없습니다.\r\n삭제할 확장자를 선택해 주세요.");
            _js.HistoryBack();
            return;
        }

        strTmpExt = strFileExtension.Split('|');

        strFileExtension = "";

        for (int i = 0; i < strTmpExt.Length; i++)
        {
            if (strFileExt.ToLower().LastIndexOf(strTmpExt[i].ToLower()) < 0)
                strFileExtension += strTmpExt[i] + "|";
        }

        // 문자열 앞,뒤로 파이프 문자(|)를 제거
        if (strFileExtension.StartsWith("|"))
            strFileExtension = strFileExtension.Substring(1);

        if (strFileExtension.EndsWith("|"))
            strFileExtension = strFileExtension.Substring(0, strFileExtension.Length - 1);

        try
        {
            result = _uf.ModifyFilter(strDomain, strMemberId, strFileExtension, strIpList);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_uf.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        _js.MessageBox("선택된 확장자가 업로드 제한 리스트에서 삭제되었습니다.");
        _js.MovePage("WebhardFiltering.aspx", "");
    }

    protected void btnDeleteIp_Click(Object sender, EventArgs e)
    {
        bool result = false;
        string strIp = hfDeleteIp.Value;
        string[] strTmpIp;

        if (strIpList.Trim() == "")
        {
            _js.MessageBox("확장자 리스트가 없습니다.");
            _js.HistoryBack();
            return;
        }

        if (strIp.Trim() == "")
        {
            _js.MessageBox("삭제할 아이피가 없습니다.\r\n삭제할 아이피를 선택해 주세요.");
            _js.HistoryBack();
            return;
        }

        strTmpIp = strIpList.Split('|');

        strIpList = "";

        for (int i = 0; i < strTmpIp.Length; i++)
        {
            if (strIp.ToLower().LastIndexOf(strTmpIp[i].ToLower()) < 0)
                strIpList += strTmpIp[i] + "|";
        }

        // 문자열 앞,뒤로 파이프 문자(|)를 제거
        if (strIpList.StartsWith("|"))
            strIpList = strIpList.Substring(1);

        if (strIpList.EndsWith("|"))
            strIpList = strIpList.Substring(0, strIpList.Length - 1);

        try
        {
            result = _uf.ModifyFilter(strDomain, strMemberId, strFileExtension, strIpList);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_uf.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        _js.MessageBox("선택된 아이피가 업로드 제한 리스트에서 삭제되었습니다.");
        _js.MovePage("WebhardFiltering.aspx", "");
    }
}
