﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// Domain의 요약 설명입니다.
/// </summary>
public class Domain
{
    private string strDomain = "";
    private int iAllocateSize = 0;
    private int iUseSize = 0;
    private int iUserCount = 0;
    private int iJoinUserCount = 0;
    private string strJoinType = "";
    private int iDefaultSize = 0;
    private string strPop3Allow = "";
    private string strCopyright = "";
    private string strErrMsg = "";

	public Domain()
	{
		//
		// TODO: 생성자 논리를 여기에 추가합니다.
		//
	}

    public void LoadDomain(string strCon)
    {
        if (strCon.Trim() == "")
            throw new Exception("DB 연결 문자열이 입력되지 않았습니다.");

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter Param = new OleDbParameter();
        OleDbDataAdapter Adap;
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        try
        {
            Con.Open();
        }
        catch (Exception e)
        {
            throw new Exception(e.Message);
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prLoadDomain";

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 600);
            Param.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "WDC_Domain");
            dt = ds.Tables["WDC_Domain"];

            if (dt != null)
            {
                if (dt.Rows.Count > 0)
                {
                    DataRow dr = dt.Rows[0];

                    iAllocateSize = int.Parse(dr["WDC_AllocateSize"].ToString());
                    iUseSize = int.Parse(dr["Use_Size"].ToString());
                    iUserCount = int.Parse(dr["WDC_User_Count"].ToString());
                    iJoinUserCount = int.Parse(dr["User_Count"].ToString());
                    strJoinType = dr["WDC_Join_Type"].ToString();
                    iDefaultSize = int.Parse(dr["WDC_Default_Size"].ToString());
                    strPop3Allow = dr["WDC_Pop3_Allow"].ToString();
                    strCopyright = dr["WDC_Copyright"].ToString();
                }
            }
        }
        catch (Exception e)
        {
            throw new Exception(e.Message);
        }
        finally
        {
            Con.Close();
        }
    }

    public string DomainName
    {
        set { strDomain = value; }
    }

    public int AllocateSize
    {
        get { return iAllocateSize; }
    }

    public int UseSize
    {
        get { return iUseSize; }
    }

    public int UserCount
    {
        get { return iUserCount; }
    }

    public int JoinUserCount
    {
        get { return iJoinUserCount; }
    }

    public string JoinType
    {
        get { return strJoinType; }
    }

    public int DefaultSize
    {
        get { return iDefaultSize; }
    }

    public string Pop3Allow
    {
        get { return strPop3Allow; }
    }

    public string Copyright
    {
        get { return strCopyright; }
    }

    public string ErrorMessage
    {
        get { return strErrMsg; }
    }
}
