﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// UserInfo의 요약 설명입니다.
/// </summary>
public class UserInfo
{
    private string strSql = "";
	private string tblMailUser = "";
	private string fldUserNo = "";
	private string fldUserId = "";
	private string fldUserPwd = "";
	private string fldUserName = "";
	private string fldUserPath = "";
	private string fldUserDomain = "";
	private string fldUserMaxSize = "";
	private string fldUserAuthority = "";
	private string fldUserMailing = "";
	private string strErrMsg = "";

	private string sUserId = "";
	private string sDomain = "";
	private string sCon = "";

	private int mUserNo = 0;
	private int mUserMaxSize = 0;
	private string mUserPwd = "";
	private string mUserName = "";
	private string mUserPath = "";
	private string mUserPermit = "";
	private string mUserAuthority = "";
	private bool mUserMailing = false;
	private string mLoginDate = "";

	public UserInfo()
	{
		//
		// TODO: 여기에 생성자 논리를 추가합니다.
		//
		tblMailUser = Passkorea.Configuration.GetConfigField("fieldinfo", "mailuser");
		fldUserNo = Passkorea.Configuration.GetConfigField("fieldinfo", "id");
		fldUserId = Passkorea.Configuration.GetConfigField("fieldinfo", "users");
		fldUserPwd = Passkorea.Configuration.GetConfigField("fieldinfo", "pw");
		fldUserName = Passkorea.Configuration.GetConfigField("fieldinfo", "name");
		fldUserPath = Passkorea.Configuration.GetConfigField("fieldinfo", "path");
		fldUserDomain = Passkorea.Configuration.GetConfigField("fieldinfo", "domain");
		fldUserMaxSize = Passkorea.Configuration.GetConfigField("fieldinfo", "maxsize");
		fldUserAuthority = Passkorea.Configuration.GetConfigField("fieldinfo", "use_allow");
		fldUserMailing = Passkorea.Configuration.GetConfigField("fieldinfo", "mailinglist");

		tblMailUser = this.CheckIsNull(tblMailUser, "MAIL_USER");
		fldUserNo = this.CheckIsNull(fldUserNo, "USER_NO");
		fldUserId = this.CheckIsNull(fldUserId, "USER_ID");
		fldUserPwd = this.CheckIsNull(fldUserPwd, "USER_PWD");
		fldUserName = this.CheckIsNull(fldUserName, "USER_NAME");
		fldUserPath = this.CheckIsNull(fldUserPath, "USER_MAILBOX_PATH");
		fldUserDomain = this.CheckIsNull(fldUserDomain, "USER_DOMAIN");
		fldUserMaxSize = this.CheckIsNull(fldUserMaxSize, "USER_MAILBOX_SIZE");
		fldUserAuthority = this.CheckIsNull(fldUserAuthority, "USER_AUTHORITY");
		fldUserMailing = this.CheckIsNull(fldUserMailing, "IS_MAILING");
	}

	#region 사용자 정보 셋팅
	/// <summary>
	/// 사용자 정보를 셋팅한다.
	/// </summary>
	/// <param name="strUserId"></param>
	/// <param name="strDomain"></param>
	/// <param name="strCon"></param>
	public UserInfo(string strUserId, string strDomain, string strCon)
	{
		tblMailUser = Passkorea.Configuration.GetConfigField("fieldinfo", "mailuser");
		fldUserNo = Passkorea.Configuration.GetConfigField("fieldinfo", "id");
		fldUserId = Passkorea.Configuration.GetConfigField("fieldinfo", "users");
		fldUserPwd = Passkorea.Configuration.GetConfigField("fieldinfo", "pw");
		fldUserName = Passkorea.Configuration.GetConfigField("fieldinfo", "name");
		fldUserPath = Passkorea.Configuration.GetConfigField("fieldinfo", "path");
		fldUserDomain = Passkorea.Configuration.GetConfigField("fieldinfo", "domain");
		fldUserMaxSize = Passkorea.Configuration.GetConfigField("fieldinfo", "maxsize");
		fldUserAuthority = Passkorea.Configuration.GetConfigField("fieldinfo", "use_allow");
		fldUserMailing = Passkorea.Configuration.GetConfigField("fieldinfo", "mailinglist");

		tblMailUser = this.CheckIsNull(tblMailUser, "MAIL_USER");
		fldUserNo = this.CheckIsNull(fldUserNo, "USER_NO");
		fldUserId = this.CheckIsNull(fldUserId, "USER_ID");
		fldUserPwd = this.CheckIsNull(fldUserPwd, "USER_PWD");
		fldUserName = this.CheckIsNull(fldUserName, "USER_NAME");
		fldUserPath = this.CheckIsNull(fldUserPath, "USER_MAILBOX_PATH");
		fldUserDomain = this.CheckIsNull(fldUserDomain, "USER_DOMAIN");
		fldUserMaxSize = this.CheckIsNull(fldUserMaxSize, "USER_MAILBOX_SIZE");
		fldUserAuthority = this.CheckIsNull(fldUserAuthority, "USER_AUTHORITY");
		fldUserMailing = this.CheckIsNull(fldUserMailing, "IS_MAILING");

		if (strUserId == "") return;
			
		if (strDomain == "") return;
			
		if (strCon == "") return;

		sUserId = strUserId;
		sDomain = strDomain;
		sCon = strCon;

		GetUserInfo(sUserId, sDomain, sCon);
	}
	#endregion

	#region 메일 엔진 사용자 정보
	/// <summary>
	/// 메일엔진에서 사용되는 사용자 정보를 가져온다.
	/// </summary>
	/// <param name="strUserId"></param>
	/// <param name="strDomain"></param>
	/// <param name="strCon"></param>
	private void GetUserInfo(string strUserId, string strDomain, string strCon)
	{
		// 커넥션 생성
        OleDbConnection Con = new OleDbConnection(strCon);
		
		// 쿼리문
		strSql = "SELECT " + fldUserNo + ", " + fldUserPwd + ", " + fldUserName + ", " + fldUserPath +
			", " + fldUserAuthority + ", " + fldUserMailing + ", " + fldUserMaxSize + ", ISNULL(UI.USER_PERMIT, MU.USER_PERMIT) AS USER_PERMIT, " +
			"(SELECT TOP 1 CONN_DATE FROM LOGIN_INFO WHERE LOGIN_ID = '" + strUserId + "' AND USER_DOMAIN = '" + strDomain + "' ORDER BY CONN_DATE DESC) AS LOGIN_DATE " +
			" FROM " + tblMailUser + " AS MU LEFT JOIN USER_INFO AS UI ON " +
			"MU." + fldUserId + " = UI.USER_ID AND MU." + fldUserDomain + " = UI.USER_DOMAIN " +
			"WHERE MU." + fldUserId + " = '" + strUserId + "' AND MU." +
			fldUserDomain + " = '" + strDomain + "'";

        OleDbDataAdapter Adapter = new OleDbDataAdapter(strSql, Con);
		
        DataSet ds = new DataSet();
		DataTable dt = new DataTable();

        try
        {
            // 데이터 어댑터를 사용해서 데이터 셋에 데이터를 채운다.
            Adapter.Fill(ds, tblMailUser);
            // 데이터 셋에 있는 데이터를 테이블만 데이터 테이블 객체로 옮긴다.
            dt = ds.Tables[tblMailUser];

            // 데이터가 있으면 해당 데이터를 각 필드에 넣는다.
            if (dt.Rows.Count > 0)
            {
                DataRow dr = dt.Rows[0];

                mUserNo = Convert.ToInt32(dr[fldUserNo].ToString());
                mUserPwd = dr[fldUserPwd].ToString();
                mUserName = dr[fldUserName].ToString();
                mUserPath = dr[fldUserPath].ToString();
                mUserPermit = dr["USER_PERMIT"].ToString().Trim();
                mUserAuthority = dr[fldUserAuthority].ToString();
                mUserMaxSize = Convert.ToInt32(dr[fldUserMaxSize].ToString());
                mUserMailing = Convert.ToBoolean(dr[fldUserMailing].ToString());
                mLoginDate = dr["LOGIN_DATE"].ToString();
            }
            else
            {
                ErrMsg = strUserId + " 사용자가 등록되지 않았습니다.";
            }
        }
        catch (Exception err)
        {
            throw new Exception("사용자 정보를 가져오는 도중 오류가 발생했습니다.\r\n\r\n" +
                    "오류내용: " + err.Message + "\r\n\r\n" +
                    "사용 쿼리: " + strSql);

        }
        finally
        {
            Con.Close();
        }
	}
	#endregion

	#region 전체 사용자 수
	/// <summary>
	/// 전체 사용자 수
	/// </summary>
	/// <param name="strDomain"></param>
	/// <returns></returns>
	public int TotalUserCount(string strDomain)
	{
		int iUserCnt = 0;
		try
		{
			if (strDomain != "")
			{
                OleDbConnection Con = new OleDbConnection(sCon);
                OleDbCommand Cmd = new OleDbCommand();

				strSql = "SELECT COUNT(" + fldUserNo + ") AS USER_CNT FROM " +
					tblMailUser + " WHERE " + fldUserDomain + " = '" + strDomain + "'";

				Con.Open();
				Cmd.Connection = Con;
				Cmd.CommandType = CommandType.Text;
				Cmd.CommandText = strSql;
			
				iUserCnt = (int)Cmd.ExecuteScalar();

				Con.Close();
			} 
			else
				iUserCnt = 0;
		} 
		catch
		{
			iUserCnt = 0;
		}

		return iUserCnt;
	}
	#endregion

	#region 사용자 아이디
	/// <summary>
	/// 사용자 아이디 프로퍼티
	/// </summary>
	public int UserId
	{
		get { return mUserNo; }
	}
	#endregion

	#region 사용자 비밀번호
	/// <summary>
	/// 사용자 비밀번호 프로퍼티
	/// </summary>
	public string UserPwd
	{
		get { return mUserPwd; }
	}
	#endregion

	#region 사용자 이름
	/// <summary>
	/// 사용자 이름 프로퍼티
	/// </summary>
	public string UserName
	{
		get { return mUserName; }
	}
	#endregion

	#region 사용자 메일박스 경로
	/// <summary>
	/// 사용자 메일박스 경로 프로퍼티
	/// </summary>
	public string UserPath
	{
		get { return mUserPath; }
	}
	#endregion

	#region 사용자 메일 사용여부
	/// <summary>
	/// 사용자 메일 사용여부 프로퍼티
	/// </summary>
	public string UserPermit
	{
		get { return mUserPermit; }
	}
	#endregion

	#region 관리자 여부
	/// <summary>
	/// 관리자 여부 프로퍼티
	/// </summary>
	public string UserAuthority
	{
		get { return mUserAuthority; }
	}
	#endregion

	#region 사용자 메일박스 용량
	/// <summary>
	/// 사용자 메일박스 용량 프로퍼티
	/// </summary>
	public int UserMailBoxSize
	{
		get { return mUserMaxSize; }
	}
	#endregion

	#region 메일링 리스트 사용자 여부
	/// <summary>
	/// 메일링 리스트 사용자 여부 프로퍼티
	/// </summary>
	public bool UserMailing
	{
		get { return mUserMailing; }
	}
	#endregion

	#region 최종 로그인 시간
	// 최종 로그인 시간
	public string LoginDate
	{
		get { return mLoginDate; }
	}
	#endregion

	#region 에러 메세지
	/// <summary>
	/// 에러 메세지 프로퍼티
	/// </summary>
	public string ErrMsg
	{
		get { return strErrMsg; }
		set { strErrMsg = value; }
	}
	#endregion

	#region 해당 문자가 공백 또는 null값이면 지정한 값으로 셋팅
	/// <summary>
	/// 해당 문자가 공백 또는 null값이면 지정한 값으로 셋팅
	/// </summary>
	/// <param name="strValue"></param>
	/// <param name="strRtnVal"></param>
	/// <returns></returns>
	private string CheckIsNull(string strValue, string strRtnVal)
	{
		if (strValue == "" || strValue == null)
			return strRtnVal;

		return strValue;
	}
	#endregion
}
