﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// Common의 요약 설명입니다.
/// </summary>
public class WebhardCommon
{
    public WebhardCommon()
	{
		//
		// TODO: 생성자 논리를 여기에 추가합니다.
		//
	}

    public string StrPlus(string strValue, int iLen, string strPlus)
    {
        string strTmp = "";

        if (strValue.Length < iLen)
        {
            for (int i = 0; i < (iLen - strValue.Length); i++)
                strTmp += strPlus;

            strTmp += strValue;
        }
        else
            strTmp = strValue;

        return strTmp;
    }

    public string StringExchange(string strValue, string strCompare, string strExchange)
    {
        if (strValue.Equals(strCompare))
            strValue = strExchange;

        return strValue;
    }

    public bool CheckLogin(HttpCookie cookie)
    {
        if (cookie != null)
        {
            if (cookie["WB_MEMBER_ID"].Trim() == "")
                return false;
            else
                return true;
        }
        else
            return false;
    }

    public bool CheckLogin(HttpRequest request, string hostName)
    {
        bool bUse = false;

        if (request.Cookies != null)
        {
            HttpCookieCollection cookies = request.Cookies;

            int iCkCnt = cookies.Count;

            for (int i = 0; i < iCkCnt; i++)
            {
                if (cookies[i].Name == "WB_MEMBER_INFO")
                {
                    // 쿠키 번호 설정
                    iCkCnt = i;
                    bUse = true;
                    break;
                }
            }

            if (bUse)
            {
                if (cookies[iCkCnt] != null)
                {
                    if (cookies[iCkCnt]["WB_MEMBER_ID"].Trim() == "")
                        return false;
                    else
                        return true;
                }
                else
                    return false;
            }
            else
                return bUse;
        }
        else
            return bUse;
    }

    public string PageLink(int intTotPage, int intThisPage, string strMovePage, string strUrlArgs, int intPageSize, string firstIcon, string lastIcon, string prevIcon, string nextIcon)
    {
        string strLink = "";
        int intModPage = 0;
        int intAvgPage = 0;
        int intNextPage = 0;

        if (intTotPage <= 0) intTotPage = 1;

        intModPage = intThisPage % intPageSize--;
        intAvgPage = intThisPage - intModPage;

        if (intAvgPage > 1)
        {
            intAvgPage = intAvgPage + 1;
            intNextPage = intAvgPage + intPageSize;
        }

        if (intAvgPage <= 0)
        {
            intAvgPage = 1;
            intNextPage = intAvgPage + intPageSize;
        }

        if (intModPage == 0)
        {
            intAvgPage = intThisPage - intPageSize;
            intNextPage = intThisPage;
        }

        if (intNextPage > intTotPage) intNextPage = intTotPage;

        // 첫 페이지 아이콘
        firstIcon = PageLinkIcon(firstIcon, "◀◀");
        // 이전 페이지 아이콘
        prevIcon = PageLinkIcon(prevIcon, "◁");
        // 다음 페이지 아이콘
        nextIcon = PageLinkIcon(nextIcon, "▷");
        // 마지막 페이지 아이콘
        lastIcon = PageLinkIcon(lastIcon, "▶▶");

        if (intThisPage > 1)
            strLink = "<a href=\"" + strMovePage + "?iPage=1" + strUrlArgs + "\">" + firstIcon + "</a>\r\n";
        else
            strLink = firstIcon + "\r\n";

        if (intAvgPage > 10)
            strLink += "<a href=\"" + strMovePage + "?iPage=" + (intAvgPage - 1) + strUrlArgs + "\">" + prevIcon + "</a>\r\n";
        else
            strLink += prevIcon + "\r\n";

        strLink += "|&nbsp;";

        for (int iCount = intAvgPage; iCount <= intNextPage; iCount++)
        {
            if (intThisPage == iCount)
                strLink += "<font color=\"#E24A00\"><b>" + iCount + "</b></font>&nbsp;|\r\n";
            else
                strLink += "<a href=\"" + strMovePage + "?iPage=" + iCount + strUrlArgs + "\"><b>" + iCount + "</b></a>&nbsp;|\r\n";
        }

        if (intTotPage > intNextPage)
            strLink += "<a href=\"" + strMovePage + "?iPage=" + (intNextPage + 1) + strUrlArgs + "\">" + nextIcon + "</a>\r\n";
        else
            strLink += nextIcon + "\r\n";

        if (intThisPage < intTotPage)
            strLink += "<a href=\"" + strMovePage + "?iPage=" + intTotPage + strUrlArgs + "\">" + lastIcon + "</a>\r\n";
        else
            strLink += lastIcon + "\r\n";

        return strLink;
    }

    #region 게시판 페이지 링크 아이콘
    /// <summary>
    /// 게시판 페이지 링크 아이콘
    /// </summary>
    private string PageLinkIcon(string strIcon, string strAlt)
    {
        if (strIcon != "")
            return "<img src=\"" + strIcon + "\" border=\"0\" align=\"absmiddle\">";
        else
            return strAlt;
    }
    #endregion
}
