﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Board_ModifyDoc : System.Web.UI.Page
{
    // 게시판 정보
    protected string strBrdName = "";
    protected string strHeader = "";
    protected string strFooter = "";
    protected string strPageLink = "";
    protected string strBrdNo = "";
    protected string strPage = "";
    protected string strDocNo = "";

    // 첨부파일명
    protected string strAttachFile = "";
    protected long iAttachSize = 0;
    protected int iPage = 0;

    private OleDbConnection Con;
    private OleDbDataAdapter Adap;
    private OleDbTransaction Trans;
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbCommand Cmd = new OleDbCommand();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;
    private UserInfo UI;
    private BoardInfo BI;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private int iBrdNo = 0;

   
    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strDocNo = Request.Params["docNo"];
        strBrdNo = Request.Params["brdNo"];

        iBrdNo = int.Parse(strBrdNo);
        iPage = WF.StringToInt(Request.Params["page"], 1);

        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);
        BI = new BoardInfo(iBrdNo, Session["USER_ID"].ToString(), strDomain, "MD");

        strBrdName = BI.BoardName;

        if (BI.ErrMsg != "")
        {
            WF.WriteMessage(BI.ErrMsg);
            WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }

        if (!BI.BoardAuth())
        {
            WF.WriteMessage(BI.ErrMsg);
            WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }

        if (!Page.IsPostBack)
        {
            this.DocInfoBind();

            strHeader = BI.Header;
            strFooter = BI.Footer;
        }

        string strScript = "if (!ModifyDoc()) return false; else return true;";
        ibModifyDoc.Attributes.Add("onclick", strScript);

        Page.DataBind();
    }

    #region 선택된 게시물을 보여준다.
    /// <summary>
    /// 선택된 게시물을 보여준다.
    /// </summary>
    private void DocInfoBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prViewDoc";

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 번호
            sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 번호
            sParams = Cmd.Parameters.Add("@iDocNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 도메인 명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
            Cmd.Parameters["@iDocNo"].Value = int.Parse(strDocNo);
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "DOC_INFO");
            dt = ds.Tables["DOC_INFO"];

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                WF.WriteMessage("선택한 게시물을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
                return;
            }

            int iRowCnt = dt.Rows.Count;

            if (iRowCnt <= 0)
            {
                WF.WriteMessage("선택한 게시물이 존재하지 않습니다.");
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
                return;
            }
            else if (iRowCnt == 1)
            {
                DataRow dr = dt.Rows[0];

                tbSubject.Text = dr["DOC_SUBJECT"].ToString();
                tbContent.Text = dr["DOC_CONTENT"].ToString();

                // 첨부파일 사용일때
                if (BI.IsAttach)
                {
                    if (dr["DOC_ATTACH_FILE"].ToString().Trim() != "")
                    {
                        strAttachFile = "&nbsp;" + dr["DOC_ATTACH_FILE"].ToString() +
                            "(" + WF.GetFileSize(int.Parse(dr["DOC_ATTACH_SIZE"].ToString())) + ")<br>";
                    }
                }
            }
            else
            {
                WF.WriteMessage("선택한 게시물이 존재하지 않습니다.");
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo);
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("선택한 게시물을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.ToString().Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
            return;
        }
    }
    #endregion

    #region 게시물 수정 버튼
    /// <summary>
    /// 게시물 수정 버튼
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibModifyDoc_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strSubject = tbSubject.Text;
        string strContent = tbContent.Text;
        string strOldAttachFile = "";
        int iOldAttachSize = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ModifyDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;

            // 첨부파일 사용일 경우
            if (BI.IsAttach)
            {
                // 첨부파일명을 가져온다.
                Cmd.CommandText = "prViewDoc";

                // 실행 결과값
                sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                sParams.Direction = ParameterDirection.ReturnValue;

                // 게시판 번호
                sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
                sParams.Direction = ParameterDirection.Input;

                // 게시물 번호
                sParams = Cmd.Parameters.Add("@iDocNo", OleDbType.Integer);
                sParams.Direction = ParameterDirection.Input;

                // 도메인명
                sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                sParams.Direction = ParameterDirection.Input;

                Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
                Cmd.Parameters["@iDocNo"].Value = int.Parse(strDocNo);
                Cmd.Parameters["@varDomain"].Value = strDomain;

                Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "DOC_INFO");
                dt = ds.Tables["DOC_INFO"];

                int iVal = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iVal != 0)
                {
                    WF.WriteMessage("수정할 게시물을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "SQL Error Number: " + iVal.ToString());
                    WF.MovePage("ModifyDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                    return;
                }

                int iRowCnt = dt.Rows.Count;

                if (iRowCnt <= 0)
                {
                    WF.WriteMessage("수정할 게시물이 존재하지 않습니다.");
                    WF.MovePage("ModifyDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                    return;
                }
                else if (iRowCnt == 1)
                {
                    DataRow dr = dt.Rows[0];

                    strOldAttachFile = dr["DOC_ATTACH_FILE"].ToString();
                    iOldAttachSize = int.Parse(dr["DOC_ATTACH_SIZE"].ToString());

                    // 첨부파일을 업로드 한다.
                    if (!this.AttachFile(strAttachFile))
                    {
                        // 업로드 실패시 트랜잭션을 RollBack 하고
                        // 작업을 취소한다.
                        Trans.Rollback();
                        Con.Close();
                        WF.WriteMessage("첨부파일이 업로드되지 않았습니다.\\r\\n\\r\\n게시물 수정작업을 중단합니다.");
                        WF.MovePage("ModifyDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                        return;
                    }

                    // 첨부파일이 존재하는 경우
                    if (strAttachFile.Trim() != "")
                    {
                        // 이전에 등록된 첨부파일 삭제
                        if (!BI.AttachFileDelete(this.Page, strBrdNo, strOldAttachFile))
                        {
                            Trans.Rollback();
                            Con.Close();
                            // 삭제 실패시 해당 메서드 내에서 메세지 출력
                            BI.AttachFileDelete(this.Page, strBrdNo, strAttachFile);
                            WF.WriteMessage("이전에 등록된 첨부파일을 삭제 작업이 실패하였습니다.\\r\\n\\r\\n게시물 수정작업을 중단합니다.");
                            WF.MovePage("ModifyDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                            return;
                        }
                    }
                    else
                    {
                        if (strOldAttachFile.Trim() != "")
                        {
                            strAttachFile = strOldAttachFile;
                            iAttachSize = iOldAttachSize;
                        }
                    }
                }
                else
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("수정할 게시물이 존재하지 않습니다.");
                    WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                    return;
                }
            }

            dt.Clear();
            Cmd.CommandText = "prModifyDoc";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 번호
            sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 번호
            sParams = Cmd.Parameters.Add("@iDocNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 도메인명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 제목
            sParams = Cmd.Parameters.Add("@varSubject", OleDbType.VarWChar, strSubject.Length);
            sParams.Direction = ParameterDirection.Input;

            // 내용
            sParams = Cmd.Parameters.Add("@txtContent", OleDbType.LongVarWChar);
            sParams.Direction = ParameterDirection.Input;

            // 첨부파일명
            sParams = Cmd.Parameters.Add("@varAttachFile", OleDbType.VarWChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // 첨부파일 용량
            sParams = Cmd.Parameters.Add("@iAttachSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 리턴값
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
            Cmd.Parameters["@iDocNo"].Value = int.Parse(strDocNo);
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varSubject"].Value = strSubject;
            Cmd.Parameters["@txtContent"].Value = strContent;
            Cmd.Parameters["@varAttachFile"].Value = strAttachFile;
            Cmd.Parameters["@iAttachSize"].Value = iAttachSize;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("게시물을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("ModifyDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("게시물을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ModifyDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("게시물을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.ToString().Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ModifyDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("게시물이 수정되었습니다.");
        WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
        return;
    }
    #endregion

    #region 첨부파일 업로드
    /// <summary>
    /// 첨부파일 업로드
    /// </summary>
    /// <returns></returns>
    private bool AttachFile(string sOldAttach)
    {
        // 첨부파일이 업로드될 경로를 가져온다.
        string strSavePath = Request.MapPath("./") + "\\Data\\" + strBrdNo;

        // 현재 게시판이 첨부파일 사용인 상태인데
        // 업로드될 경로가 존재하지 않으면 경로를 생성한다.
        if (BI.IsAttach && !Directory.Exists(strSavePath))
            Directory.CreateDirectory(strSavePath);

        // 첨부파일 객체가 null이 아니면 파일을 업로드 한다.
        if (txtAttachFile.PostedFile != null)
        {
            // 클라이언트에 있는 첨부파일 전체 경로를 가져온다.
            strAttachFile = txtAttachFile.Value;

            // 값이 있으면 서버에 업로드한다.
            if (strAttachFile != "")
            {
                // 첨부파일명
                strAttachFile = Path.GetFileName(strAttachFile);
                // 첨부파일을 서버에 업로드
                txtAttachFile.PostedFile.SaveAs(strSavePath + "\\" + strAttachFile);

                // 업로드한 파일에 대한 파일 객체를 생성한다.
                // 이렇게 하는 이유는 첨부파일 용량을 가져오기 위해서 이다.
                FileInfo fi = new FileInfo(strSavePath + "\\" + strAttachFile);
                // 첨부파일 용량
                iAttachSize = fi.Length;

                return true;
            }
            else
                return true;
        }
        else
            return false;
    }
    #endregion
}
