﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Board_ViewDoc : System.Web.UI.Page
{
    protected System.Web.UI.HtmlControls.HtmlTableRow trAttach;

    // 게시판 정보
    protected string strBrdName = "";
    protected string strHeader = "";
    protected string strFooter = "";
    protected string strPageLink = "";
    protected string strBrdNo = "";
    protected string strPage = "";
    protected string strDocNo = "";

    // 게시물 관련 전역 변수
    protected string strSubject = "";
    protected string strReadCnt = "";
    protected string strWriterName = "";
    protected string strEmail = "";
    protected string strRecomCnt = "";
    protected string strContent = "";
    protected string strAttachFile = "";
    protected string strAttachSize = "";

    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbCommand Cmd = new OleDbCommand();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;
    private UserInfo UI;
    private BoardInfo BI;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private int iBrdNo = 0;
    private int iPage = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strDocNo = Request.Params["docNo"];
        strBrdNo = Request.Params["brdNo"];

        iBrdNo = int.Parse(strBrdNo);

        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);
        BI = new BoardInfo(iBrdNo, Session["USER_ID"].ToString(), strDomain, "RD");

        strBrdName = BI.BoardName;

        if (BI.ErrMsg != "")
        {
            WF.WriteMessage(BI.ErrMsg);
            WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo);
            return;
        }

        if (!BI.BoardAuth())
        {
            WF.WriteMessage(BI.ErrMsg);
            WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo);
            return;
        }

        iPage = WF.StringToInt(Request.Params["page"], 1);

        if (!Page.IsPostBack)
        {
            this.DocInfoBind();
            this.ModifyDocReadCnt();

            strHeader = BI.Header;
            strFooter = BI.Footer;
        }
        Page.DataBind();
    }

    #region 선택된 게시물을 보여준다.
    /// <summary>
    /// 선택된 게시물을 보여준다.
    /// </summary>
    private void DocInfoBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prViewDoc";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 번호
            sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 번호
            sParams = Cmd.Parameters.Add("@iDocNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 도메인 명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
            Cmd.Parameters["@iDocNo"].Value = int.Parse(strDocNo);
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "DOC_INFO");
            dt = ds.Tables["DOC_INFO"];

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                WF.WriteMessage("선택한 게시물을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
                return;
            }

            int iRowCnt = dt.Rows.Count;

            if (iRowCnt <= 0)
            {
                WF.WriteMessage("선택한 게시물이 존재하지 않습니다.");
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
                return;
            }
            else if (iRowCnt == 1)
            {
                DataRow dr = dt.Rows[0];

                strSubject = dr["DOC_SUBJECT"].ToString();
                strReadCnt = dr["DOC_READ_CNT"].ToString();
                strWriterName = dr["USER_NAME"].ToString();
                strEmail = dr["EMAIL"].ToString();
                strRecomCnt = dr["DOC_RECOM_CNT"].ToString();
                strContent = dr["DOC_CONTENT"].ToString();
                strContent = strContent.Replace("\r\n", "<br>\r\n");

                if (BI.IsAttach)
                {
                    strAttachFile = dr["DOC_ATTACH_FILE"].ToString();

                    if (strAttachFile.Trim() != "")
                    {
                        strAttachSize = " (" + WF.GetFileSize(int.Parse(dr["DOC_ATTACH_SIZE"].ToString())) + ")";
                    }
                }
            }
            else
            {
                WF.WriteMessage("선택한 게시물이 존재하지 않습니다.");
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("선택한 게시물을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.ToString().Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 게시물 조회수를 1 증가시킨다.
    /// <summary>
    /// 게시물 조회수를 1 증가시킨다.
    /// </summary>
    private void ModifyDocReadCnt()
    {
        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyDocReadCnt";

            Cmd.Parameters.Clear();

            // 실행결과값
            sParams = Cmd.Parameters.Add("@iValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 번호
            sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 번호
            sParams = Cmd.Parameters.Add("@iDocNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 도메인 명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 리턴값
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
            Cmd.Parameters["@iDocno"].Value = int.Parse(strDocNo);
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                WF.WriteMessage("게시물 조회수를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                WF.WriteMessage("게시물 조회수를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + Cmd.Parameters["@iValue"].Value.ToString());
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage("게시물 조회수를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.ToString().Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo + "&page=" + iPage.ToString());
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 첨부파일 다운로드
    /// <summary>
    /// 첨부파일 다운로드
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbAttachDownload_DownCommand(object sender, EventArgs e)
    {
        this.DocInfoBind();
        BI.AttachFileDownload(this.Page, strBrdNo, strAttachFile);
        return;
    }
    #endregion

    #region 게시물 삭제
    /// <summary>
    /// 게시물 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDeleteDoc_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        BI = new BoardInfo(iBrdNo, Session["USER_ID"].ToString(), strDomain, "DT");

        if (BI.ErrMsg != "")
        {
            WF.WriteMessage(BI.ErrMsg);
            WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }

        if (!BI.BoardAuth())
        {
            WF.WriteMessage(BI.ErrMsg);
            WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteDoc";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 번호
            sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 번호
            sParams = Cmd.Parameters.Add("@iDocNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 도메인명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 리턴값
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
            Cmd.Parameters["@iDocNo"].Value = int.Parse(strDocNo);
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                WF.WriteMessage("게시물을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                WF.WriteMessage("게시물을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("게시물을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.ToString().Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ViewDoc.aspx?brdNo=" + strBrdNo + "&docNo=" + strDocNo + "&page=" + iPage.ToString());
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("해당 게시물이 삭제 되었습니다.");
        WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo);
        return;
    }
    #endregion
}
