﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Board_WriteDoc : System.Web.UI.Page
{
    protected string strBrdName = "";
    protected string strHeader = "";
    protected string strFooter = "";
    protected string strBrdNo = "";
    protected string strPage = "";

    // 첨부파일명
    protected string strAttachFile = "";
    protected long iAttachSize = 0;

    private WebFunction WF;
    private UserInfo UI;
    private BoardInfo BI;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private int iBrdNo = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strBrdNo = Request.Params["brdNo"];

        iBrdNo = int.Parse(strBrdNo);
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);
        BI = new BoardInfo(iBrdNo, Session["USER_ID"].ToString(), strDomain, "WT");

        strBrdName = BI.BoardName;

        if (!Page.IsPostBack)
        {
            if (BI.ErrMsg != "")
            {
                WF.WriteMessage(BI.ErrMsg);
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo);
                return;
            }

            if (!BI.BoardAuth())
            {
                WF.WriteMessage(BI.ErrMsg);
                WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo);
                return;
            }

            if (!BI.IsAttach)
                trAttach.Visible = false;

            strHeader = BI.Header;
            strFooter = BI.Footer;
        }

        string strScript = "if (!WriteDoc()) return false; else return true;";
        ibWriteDoc.Attributes.Add("onclick", strScript);

        Page.DataBind();
    }

    protected void ibWriteDoc_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strSubject = tbSubject.Text;
        string strContent = tbContent.Text;
        string strWriterId = Session["USER_ID"].ToString();
        string strRemoteIp = Request.UserHostAddress;

        // 2006년 12월 5일 추가
        if (strSubject == "" || strSubject == null)
        {
            WF.WriteMessage("제목을 입력해 주세요.");
            return;
        }

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();
        OleDbTransaction Trans = null;

        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("WriteDoc.aspx?brdNo=" + strBrdNo);
            return;
        }

        if (BI.IsAttach)
        {
            if (!this.AttachFile())
            {
                WF.WriteMessage("첨부파일이 업로드되지 않았습니다.\\r\\n\\r\\n게시물 쓰기를 중지합니다.");
                WF.MovePage("WriteDoc.aspx?brdNo=" + strBrdNo);
                return;
            }
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertDocInfo";

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 게시판 번호
            sParams = Cmd.Parameters.Add("@iBrdNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 도메인명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 작성자 아이디
            sParams = Cmd.Parameters.Add("@varWriterId", OleDbType.VarChar, strWriterId.Length);
            sParams.Direction = ParameterDirection.Input;

            // 제목
            sParams = Cmd.Parameters.Add("@varSubject", OleDbType.VarWChar, strSubject.Length);
            sParams.Direction = ParameterDirection.Input;

            // 내용
            sParams = Cmd.Parameters.Add("@txtContent", OleDbType.LongVarWChar);
            sParams.Direction = ParameterDirection.Input;

            // 게시물 작성자 PC IP
            sParams = Cmd.Parameters.Add("@varRemoteIp", OleDbType.VarChar, strRemoteIp.Length);
            sParams.Direction = ParameterDirection.Input;

            // 첨부파일
            sParams = Cmd.Parameters.Add("@varAttachFile", OleDbType.VarWChar, strAttachFile.Length);
            sParams.Direction = ParameterDirection.Input;

            // 첨부파일 용량
            sParams = Cmd.Parameters.Add("@iAttachSize", OleDbType.Decimal);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@iBrdNo"].Value = iBrdNo;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varWriterId"].Value = strWriterId;
            Cmd.Parameters["@varSubject"].Value = strSubject;
            Cmd.Parameters["@txtContent"].Value = strContent;
            Cmd.Parameters["@varRemoteIp"].Value = strRemoteIp;
            Cmd.Parameters["@varAttachFile"].Value = strAttachFile;
            Cmd.Parameters["@iAttachSize"].Value = iAttachSize;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                Trans.Rollback();
                WF.WriteMessage("게시물을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("WriteDoc.aspx?brdNo=" + strBrdNo);
                return;
            }
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("게시물을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.ToString().Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("WriteDoc.aspx?brdNo=" + strBrdNo);
            return;
        }
        finally
        {
            Trans.Commit();
            Con.Close();
        }

        WF.WriteMessage("게시물이 등록되었습니다.");
        WF.MovePage("ListDoc.aspx?brdNo=" + strBrdNo);
        return;
    }

    #region 첨부파일 업로드
    /// <summary>
    /// 첨부파일 업로드
    /// </summary>
    /// <returns></returns>
    private bool AttachFile()
    {
        // 첨부파일이 업로드될 경로를 가져온다.
        string strSavePath = Request.MapPath("./") + "\\Data\\" + strBrdNo;

        // 현재 게시판이 첨부파일 사용인 상태인데
        // 업로드될 경로가 존재하지 않으면 경로를 생성한다.
        if (BI.IsAttach && !Directory.Exists(strSavePath))
            Directory.CreateDirectory(strSavePath);

        // 첨부파일 객체가 null이 아니면 파일을 업로드 한다.
        if (txtAttachFile.PostedFile != null)
        {
            // 클라이언트에 있는 첨부파일 전체 경로를 가져온다.
            strAttachFile = txtAttachFile.Value;

            // 값이 있으면 서버에 업로드한다.
            if (strAttachFile != "")
            {
                // 첨부파일명
                strAttachFile = Path.GetFileName(strAttachFile);
                // 첨부파일을 서버에 업로드
                txtAttachFile.PostedFile.SaveAs(strSavePath + "\\" + strAttachFile);

                // 업로드한 파일에 대한 파일 객체를 생성한다.
                // 이렇게 하는 이유는 첨부파일 용량을 가져오기 위해서 이다.
                FileInfo fi = new FileInfo(strSavePath + "\\" + strAttachFile);
                // 첨부파일 용량
                iAttachSize = fi.Length;

                return true;
            }
            else
                return true;
        }
        else
            return false;
    }
    #endregion
}
