﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Common_FindZipCode : System.Web.UI.Page
{
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);

        if (!Page.IsPostBack)
        {
        }

        string strScript = "if (!SearchZipCode()) return false; else return true;";
        ibSearch.Attributes.Add("onclick", strScript);
    }

    protected void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strDong = tbDong.Text;
        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();
        OleDbDataAdapter Adap;
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        if (strDong == "")
        {
            WF.WriteMessage("찾을 동이름을 입력해 주세요");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListZipCode";

            sParams = Cmd.Parameters.Add("@varDong", OleDbType.VarWChar, strDong.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDong"].Value = strDong;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "ZIP_CODE");
            dt = ds.Tables["ZIP_CODE"];

            int iRowCnt = dt.Rows.Count;

            if (iRowCnt > 0)
            {
                lblSchMsg.Text = strDong + " (으)로 " + iRowCnt.ToString() + " 개의 우편번호가 검색되었습니다.";
                rptFindZipCode.DataSource = dt.DefaultView;
            }
            else
            {
                lblSchMsg.Text = strDong + " (으)로 검색된 우편번호가 없습니다.";
                return;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage(strDong + " (으)로 우편번호를 검색하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 원인: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("FindZipCode.aspx");
            return;
        }

        rptFindZipCode.DataBind();
    }
}
