﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Common_SearchEmail : System.Web.UI.Page
{
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["USER_ID"] == null || Session["MAIL_DOMAIN"] == null)
            return;

        string strValue = Request.Params["q"];
        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();

        if (!Page.IsPostBack)
        {
            SearchEmailAddress(strValue);
        }
    }

    private void SearchEmailAddress(string value)
    {
        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter Param = new OleDbParameter();
        OleDbDataAdapter Adap;
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();
        StringBuilder sb = new StringBuilder(1024);

        int iRowCnt = 0;

        try
        {
            Con.Open();
        }
        catch (Exception e)
        {
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSearchAddr";

            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;
            
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varSch", OleDbType.VarWChar, value.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varSch"].Value = value;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "Search_Email_Address");
            dt = ds.Tables["Search_Email_Address"];

            iRowCnt = dt.Rows.Count;
            if (iRowCnt > 0)
            {
                for (int i = 0; i < iRowCnt; i++)
                {
                    DataRow dr = dt.Rows[i];
                    sb.Append("\"" + dr["EMAIL_NAME"].ToString() + "\" <" + dr["EMAIL_ADDR"].ToString() + ">");

                    if (i != (iRowCnt - 1))
                        sb.Append("|!|");
                }
            }

            Cmd.Parameters.Clear();

            Cmd.CommandText = "prLoadSendEmailAddr";

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strEmailAddr", OleDbType.VarWChar, value.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@strEmailAddr"].Value = value;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "Email_Address");
            dt = ds.Tables["Email_Address"];

            iRowCnt = dt.Rows.Count;
            if (iRowCnt > 0)
            {
                sb.Append("|!|");

                for (int i = 0; i < iRowCnt; i++)
                {
                    DataRow dr = dt.Rows[i];
                    sb.Append("\"" + dr["EMAIL_ADDR"].ToString() + "\" <" + dr["EMAIL_ADDR"].ToString() + ">");

                    if (i != (iRowCnt - 1))
                        sb.Append("|!|");
                }
            }
        }
        catch (Exception e)
        {
            return;
        }

        Response.Write(sb.ToString());
    }
}
