﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Common_SubLeft : System.Web.UI.UserControl
{
    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private UserInfo UI;
    private WebFunction WF;
    protected string strInboxName = "";
    protected string strOutboxName = "";
    protected string strTempboxName = "";
    protected string strTrashName = "";
    protected string strSpamboxName = "";
    protected int iInboxSize = 0;
    protected int iOutboxSize = 0;
    protected int iTempboxSize = 0;
    protected int iTrashSize = 0;
    protected int iSpamboxSize = 0;
    protected int iBrdCnt = 0;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strThisMailbox = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        strThisMailbox = Request.Params["strMailBox"];

        this.MailBoxDataBind();
        this.BoardListBind();

        Page.DataBind();

        if (UI.UserPermit.Trim() != "1")
            tblAdminMenu.Visible = false;

        string strScript = "";

        strScript = "var iCnt = " + iSpamboxSize.ToString() + "; " +
            "if (iCnt <= 0) { alert('삭제할 편지가 없습니다.'); return false; } " +
            "else { if (confirm('스팸편지함을 정말 비우겠습니까?')) return true; else return false;}";

        // 데모 제한
        //strScript = "alert('데모라서 스팸편지함을 비울수 없습니다.'); return false;";
        lbSpamBoxEmpty.Attributes.Add("onclick", strScript);

        strScript = "var iCnt = " + iTrashSize.ToString() + "; " +
            "if (iCnt <= 0) { alert('삭제할 편지가 없습니다.'); return false; } " +
            "else { if (confirm('휴지통을 정말 비우겠습니까?')) return true; else return false;}";

        // 데모 제한
        //strScript = "alert('데모라서 휴지통을 비울수 없습니다.'); return false;";
        lbTrashEmpty.Attributes.Add("onclick", strScript);
    }

    #region 개인 편지함 데이터 바인드
    /// <summary>
    /// 개인 편지함 데이터 바인드
    /// </summary>
    private void MailBoxDataBind()
    {
        int iMailCnt = 0;
        int iNoReadCnt = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, Session["USER_ID"].ToString().Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = Session["USER_ID"].ToString();
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            int iRowCount = dt.Rows.Count;
            int iCount = 0;
            string[,] arrMailbox = new string[iRowCount, 2];

            foreach (DataRow dr in dt.Rows)
            {
                arrMailbox[iCount, 0] = dr["M_MAILBOX"].ToString();
                arrMailbox[iCount, 1] = dr["M_MAILBOX_NAME"].ToString();

                ++iCount;
            }

            dt.Clear();

            HtmlTableRow tblRow;
            HtmlTableCell tblCell;

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                iNoReadCnt = WF.NoReadMailCount(UI.UserPath + "\\" + arrMailbox[iLoop, 0]);
                iMailCnt = WF.ExtMailCount(UI.UserPath + "\\" + arrMailbox[iLoop, 0], ".eml");

                tblRow = new HtmlTableRow();
                tblCell = new HtmlTableCell();
                tblCell.Height = "20";
                tblCell.Align = "left";
                tblCell.InnerHtml = "<a href=\"../../Mail/ListMail.aspx?strMailBox=" + Server.UrlEncode(arrMailbox[iLoop, 0]) + "\">" + arrMailbox[iLoop, 1] + "</a>";
                tblCell.InnerHtml += "&nbsp;(<b><font color=#0000ff>" + iNoReadCnt.ToString() + "</font></b> / <b><font color=#ff0000>" + iMailCnt.ToString() + "</font></b>)";
                tblRow.Cells.Add(tblCell);
                tblPublicMailBox.Rows.Add(tblRow);
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("편지함 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }

        // 받은편지함
        iNoReadCnt = WF.NoReadMailCount(UI.UserPath + "\\inbox");
        iInboxSize = WF.ExtMailCount(UI.UserPath + "\\inbox", ".eml");

        if (iInboxSize < 1) iInboxSize = WF.ExtMailCount(UI.UserPath + "\\mailbox", ".eml");
        strInboxName = "<a href=\"../../Mail/ListMail.aspx?strMailBox=inbox\">받은편지함</a>";

        if (iInboxSize > 0)
            strInboxName += "&nbsp;(<b><font color=#0000ff>" + iNoReadCnt.ToString() + "</font></b> / <b><font color=#ff0000>" + iInboxSize.ToString() + "</font></b>)";

        // 보낸 편지함
        iNoReadCnt = WF.NoReadMailCount(UI.UserPath + "\\outbox");
        iOutboxSize = WF.ExtMailCount(UI.UserPath + "\\outbox", ".eml");
        strOutboxName = "<a href=\"../../Mail/ListMail.aspx?strMailBox=outbox\">보낸편지함</a>";

        if (iOutboxSize > 0)
            strOutboxName += "&nbsp;(<b><font color=#0000ff>" + iNoReadCnt.ToString() + "</font></b> / <b><font color=#ff0000>" + iOutboxSize.ToString() + "</font></b>)";

        // 휴지통
        iNoReadCnt = WF.NoReadMailCount(UI.UserPath + "\\delbox");
        iTrashSize = WF.ExtMailCount(UI.UserPath + "\\delbox", ".eml");
        strTrashName = "<a href=\"../../Mail/ListMail.aspx?strMailBox=delbox\">휴지통</a>";

        if (iTrashSize > 0)
            strTrashName += "&nbsp;(<b><font color=#0000ff>" + iNoReadCnt.ToString() + "</font></b> / <b><font color=#ff0000>" + iTrashSize.ToString() + "</font></b>)";

        // 임지편지함
        //iNoReadCnt = WF.NoReadMailCount(UI.UserPath + "\\savebox");
        //iTempboxSize = WF.ExtMailCount(UI.UserPath + "\\savebox", ".eml");
        strTempboxName = "<a href=\"../../Mail/ListMail.aspx?strMailBox=savebox\">임시저장함</a>";

        //if (iTempboxSize > 0)
        //    strTempboxName += "&nbsp;(<b><font color=#0000ff>" + iNoReadCnt.ToString() + "</font></b> / <b><font color=#ff0000>" + iTempboxSize.ToString() + "</font></b>)";

        // 스팸편지함
        iNoReadCnt = WF.NoReadMailCount(UI.UserPath + "\\spambox");
        iSpamboxSize = WF.ExtMailCount(UI.UserPath + "\\spambox", ".eml");
        strSpamboxName = "<a href=\"../../Mail/ListMail.aspx?strMailBox=spambox\">스팸편지함</a>";

        if (iSpamboxSize > 0)
            strSpamboxName += "&nbsp;(<b><font color=#0000ff>" + iNoReadCnt.ToString() + "</font></b> / <b><font color=#ff0000>" + iSpamboxSize.ToString() + "</font></b>)";
    }
    #endregion

    #region 게시판 데이터 바인드
    /// <summary>
    /// 게시판 데이터 바인드
    /// </summary>
    private void BoardListBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListBoard";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 도메인 명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 출력값
            sParams = Cmd.Parameters.Add("@iBoardCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;
            
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "BRD_INFO");
            dt = ds.Tables["BRD_INFO"];

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                WF.WriteMessage("게시판 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "관리자에게 문의 하십시요.");
                return;
            }

            if (Cmd.Parameters["@iBoardCnt"].Value != null)
                iBrdCnt = int.Parse(Cmd.Parameters["@iBoardCnt"].Value.ToString());

            int iRowCnt = dt.Rows.Count;
            int iCnt = 0;
            string[,] arrBoard = new string[iRowCnt, 2];

            foreach (DataRow dr in dt.Rows)
            {
                arrBoard[iCnt, 0] = dr["BRD_NO"].ToString();
                arrBoard[iCnt, 1] = dr["BRD_NAME"].ToString();
                ++iCnt;
            }

            dt.Clear();

            HtmlTableRow tblRow;
            HtmlTableCell tblCell;

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                tblRow = new HtmlTableRow();
                tblCell = new HtmlTableCell();

                tblCell.Height = "10";

                if (iRowCnt == 1)
                {
                    tblCell.InnerHtml = "<img src=\"../../images/line_ss.gif\">";
                }
                else if (iRowCnt > 1)
                {
                    if (iLoop == 0)
                        tblCell.InnerHtml = "<img src=\"../../images/line_st.gif\">";
                    else if (iLoop == (iRowCnt - 1))
                        tblCell.InnerHtml = "<img src=\"../../images/line_sb.gif\">";
                    else
                        tblCell.InnerHtml = "<img src=\"../../images/line_sm.gif\">";
                }

                tblRow.Cells.Add(tblCell);

                tblCell = new HtmlTableCell();
                tblCell.Height = "20";
                tblCell.Align = "left";
                tblCell.Style.Add("padding", "3 0 0 0");

                tblCell.InnerHtml = "<a href=\"../../Board/ListDoc.aspx?brdNo=" + arrBoard[iLoop, 0] + "\">" + arrBoard[iLoop, 1] + "</a>";
                tblRow.Cells.Add(tblCell);
                tblBoard.Rows.Add(tblRow);
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("게시판 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }
    }
    #endregion

    #region 스팸편지함 삭제
    /// <summary>
    /// 스팸편지함 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbSpamBoxEmpty_DeleteCommand(object sender, EventArgs e)
    {
        WF.EmptyFolder(UI.UserPath + "\\spambox");
        WF.MovePage(Request.Url.ToString());
    }
    #endregion

    #region 휴지통 삭제
    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbTrashEmpty_DeleteCommand(object sender, EventArgs e)
    {
        WF.EmptyFolder(UI.UserPath + "\\delbox");
        WF.MovePage(Request.Url.ToString());
    }
    #endregion

    #region 로그아웃
    /// <summary>
    /// 로그아웃
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibLogout_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        // 웹하드 로그아웃
        Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();

        try
        {
            int idxNo = 0;

            // 중복 로그인 확인
            if (Request.Cookies["WB_MEMBER_INFO"] != null)
            {
                _login.ConnectionString = strCon;
                idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());

                if (_login.CheckLoginState(strDomain, Session["USER_ID"].ToString(), idxNo))
                    _login.Logout(strDomain, Session["USER_ID"].ToString(), idxNo);
            }
        }
        catch (Exception err)
        {
            return;
        }

        if (Session["USER_ID"] != null)
            Session["USER_ID"] = null;

        Session.Clear();
        Session.Abandon();

        Response.Redirect("../../Log/Login.aspx");
    }
    #endregion
}
