﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_AutoReply_ListAutoReply : System.Web.UI.Page
{
    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private UserInfo UI;
    private WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (!Page.IsPostBack)
        {
            this.AutoReplyDataBind();
        }
    }

    #region 자동응답 데이터 바인딩
    /// <summary>
    /// 자동응답 데이터를 웹페이지에 바인딩 한다.
    /// </summary>
    private void AutoReplyDataBind()
    {
        int iCnt = rblUseAutoReply.Items.Count;

        if (File.Exists(UI.UserPath + "\\autoreply.htm"))
        {
            tbAutoReplyContent.Text = this.FileRead(UI.UserPath, "autoreply.htm");

            for (int iLoop = 0; iLoop < iCnt; iLoop++)
            {
                if (rblUseAutoReply.Items[iLoop].Value.ToLower() == "yes")
                {
                    rblUseAutoReply.Items[iLoop].Selected = true;
                    break;
                }
            }
        }
        else if (File.Exists(UI.UserPath + "\\autoreply.htm.no"))
        {
            tbAutoReplyContent.Text = this.FileRead(UI.UserPath, "autoreply.htm.no");

            for (int iLoop = 0; iLoop < iCnt; iLoop++)
            {
                if (rblUseAutoReply.Items[iLoop].Value.ToLower() == "no")
                {
                    rblUseAutoReply.Items[iLoop].Selected = true;
                    break;
                }
            }
        }
    }
    #endregion

    #region 파일 내용 읽기
    /// <summary>
    /// 파일 내용을 읽는다.
    /// </summary>
    /// <param name="strPath"></param>
    /// <param name="strFileName"></param>
    /// <returns></returns>
    private string FileRead(string strPath, string strFileName)
    {
        string strValue = "";

        if (File.Exists(strPath + "\\" + strFileName))
        {
            FileStream fs = new FileStream(strPath + "\\" + strFileName, FileMode.Open, FileAccess.Read, FileShare.None);
            byte[] buf = new byte[512];

            while (fs.Read(buf, 0, buf.Length) > 0)
                strValue += Encoding.Default.GetString(buf);

            fs.Close();
        }

        strValue = strValue.Replace("<br>\r\n", "\r\n");
        return strValue;
    }
    #endregion

    #region 수정 버튼
    /// <summary>
    /// 자동응답 수정 버튼
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibEdit_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strContent = tbAutoReplyContent.Text;
        string strUseAutoReply = rblUseAutoReply.SelectedValue;

        try
        {
            if (strUseAutoReply.ToLower() == "yes")
                this.ModifyFileContent(UI.UserPath, "autoreply.htm", "autoreply.htm.no", strContent);
            else if (strUseAutoReply.ToLower() == "no")
                this.ModifyFileContent(UI.UserPath, "autoreply.htm.no", "autoreply.htm", strContent);
        }
        catch (Exception err)
        {
            WF.WriteMessage("자동응답을 설정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListAutoReply.aspx");
            return;
        }

        WF.WriteMessage("자동응답이 설정 되었습니다.");
        WF.MovePage("ListAutoReply.aspx");
    }
    #endregion

    #region 자동응답 내용 수정
    /// <summary>
    /// 자동응답 내용을 수정한다.
    /// </summary>
    /// <param name="strPath"></param>
    /// <param name="strFileName"></param>
    /// <param name="strDestFile"></param>
    /// <param name="strContent"></param>
    private void ModifyFileContent(string strPath, string strFileName, string strDestFile, string strContent)
    {
        FileStream fs;
        StreamWriter sw;

        try
        {
            if (File.Exists(strPath + "\\" + strDestFile))
                File.Move(strPath + "\\" + strDestFile, strPath + "\\" + strFileName);

            byte[] buf = Encoding.Default.GetBytes(strDestFile);
            fs = new FileStream(strPath + "\\" + strFileName, FileMode.Create, FileAccess.Write, FileShare.None);
            sw = new StreamWriter(fs, Encoding.Default);
        }
        catch (Exception err)
        {
            WF.WriteMessage("자동응답을 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListAutoReply.aspx");
            return;
        }
        sw.Flush();
        sw.Write(strContent.Replace("\r\n", "<br>\r\n"));
        sw.Close();
        fs.Close();
    }
    #endregion
}
