﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_EmailList_EmailList : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbCommand Cmd = new OleDbCommand();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private WebFunction WF;
    private int iPage = 0;
    private int iPageSize = 15;

    protected void Page_Load(object sender, EventArgs e)
    {
        string strScript = "";

        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        iPage = WF.StringToInt(Request.Params["iPage"], 1);

        if (!Page.IsPostBack)
            this.EmailDataBind();

        // 포워딩 삭제버튼 속성 추가
        strScript = "if (!SelectItem()) return false; else return true";
        ibDelEmail.Attributes.Add("onclick", strScript);
    }

    #region 메일발송 메일주소 리스트 바인드
    /// <summary>
    /// 메일발송 메일주소 리스트 바인드
    /// </summary>
    private void EmailDataBind()
    {
        string strMovePage = "";
        int iTotCnt = 0;
        int iTotPage = 1;

        strMovePage = Request.PhysicalPath;
        strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListSendEmailAddr";

            Cmd.Parameters.Clear();

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // 도메인 명
            sParams = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 리턴값
            sParams = Cmd.Parameters.Add("@iTotalCount", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "EmailList");

            rptEmailList.DataSource = ds.Tables["EmailList"];
            rptEmailList.DataBind();

            iTotCnt = int.Parse(Cmd.Parameters["@iTotalCount"].Value.ToString());
        }
        catch (Exception err)
        {
            WF.WriteMessage("메일주소 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 수신거부 메일주소 삭제
    /// <summary>
    /// 수신거부 메일주소 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelEmail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strEmail = hidEmail.Value;
        string[] arrEmail;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EmailList.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteSendEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Spam Email Address)
            sParams = Cmd.Parameters.Add("@strEmailAddr", OleDbType.VarWChar, 512);
            sParams.Direction = ParameterDirection.Input;

            if (strEmail.EndsWith("|"))
                strEmail = strEmail.Substring(0, strEmail.Length - 1);
            
            arrEmail = strEmail.Split('|');

            for (int iLoop = 0; iLoop < arrEmail.Length; iLoop++)
            {
                // Command Parameter Value Setting
                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@strEmailAddr"].Value = arrEmail[iLoop];

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    Trans.Rollback();
                    WF.WriteMessage("메일주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 메일 주소: " + arrEmail[iLoop]);
                    WF.MovePage("EmailList.aspx");
                    return;
                }
                else if (iValue != 0)
                {
                    Trans.Rollback();
                    WF.WriteMessage("메일주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 메일 주소: " + arrEmail[iLoop] + "\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    WF.MovePage("EmailList.aspx");
                    return;
                }
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();

            WF.WriteMessage("선택한 메일주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("EmailList.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("선택한 메일주소를 삭제 했습니다.");
        WF.MovePage("EmailList.aspx");
    }
    #endregion
}
