﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_Filtering_ModifyFiltering : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private Passkorea.WebFunction WF;
    private string strFilterNo = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strFilterNo = Request.Params["iFilterNo"];

        if (!Page.IsPostBack)
        {
            this.FilterAddDataBind();
            this.MailBoxDataBind();
            this.FilterDataBind();
        }

        string strScript = "if (!ModifyFiltering()) return false; else return true;";
        ibModifyFilter.Attributes.Add("onclick", strScript);
    }

    #region 필터링 적용 데이터 바인드
    /// <summary>
    /// 
    /// </summary>
    private void FilterAddDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListFiltering.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListCodeData";

            Cmd.Parameters.Clear();

            sParams = Cmd.Parameters.Add("@chrCodeClass", OleDbType.Char, 3);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@chrCodeClass"].Value = "MF";

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "CODE");
            dt = ds.Tables["CODE"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    ListItem li = new ListItem(dr["CODE_NAME"].ToString(), dr["CODE_ID"].ToString());
                    ddlTarget.Items.Add(li);
                }
                ddlTarget.DataBind();
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("적용대상 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.HistoryBack();
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 메일박스 데이터 바인드
    /// <summary>
    /// 
    /// </summary>
    private void MailBoxDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListFiltering.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListUserMailBox";

            Cmd.Parameters.Clear();

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            int intRowCount = dt.Rows.Count + 4;
            int iCount = 3;
            string[,] arrMailbox = new string[intRowCount, 2];

            // 받은편지함
            arrMailbox[0, 0] = "inbox";
            arrMailbox[0, 1] = "받은편지함";

            // 보낸편지함
            arrMailbox[1, 0] = "outbox";
            arrMailbox[1, 1] = "보낸편지함";

            // 휴지통
            arrMailbox[2, 0] = "delbox";
            arrMailbox[2, 1] = "휴지통";

            // 삭제
            arrMailbox[intRowCount - 1, 0] = "delete";
            arrMailbox[intRowCount - 1, 1] = "삭제";

            foreach (DataRow dr in dt.Rows)
            {
                arrMailbox[iCount, 0] = dr["M_MAILBOX"].ToString();
                arrMailbox[iCount, 1] = dr["M_MAILBOX_NAME"].ToString();
                ++iCount;
            }

            for (int iLoop = 0; iLoop < intRowCount; iLoop++)
            {
                ListItem li = new ListItem(arrMailbox[iLoop, 1], arrMailbox[iLoop, 0]);
                ddlMoveMailbox.Items.Add(li);
            }

            ddlMoveMailbox.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("사용자 편지함 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.HistoryBack();
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 필터링 데이터 바인드
    /// <summary>
    /// 
    /// </summary>
    private void FilterDataBind()
    {
        string strWords = "";
        string strTarget = "";
        string strMailbox = "";
        string strUse = "";
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListFiltering.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prViewFilteringInfo";

            Cmd.Parameters.Clear();

            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            
            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;
            
            // 필터링 번호
            sParams = Cmd.Parameters.Add("@intFilterNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@intFilterNo"].Value = strFilterNo;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "FILTER");
            dt = ds.Tables["FILTER"];

            int iCount = dt.Rows.Count;

            if (iCount > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    strWords = dr["F_WORDS"].ToString();
                    strTarget = dr["F_TARGET"].ToString();
                    strMailbox = dr["F_MAILBOX"].ToString();
                    strUse = dr["F_IS_USE"].ToString();
                    break;
                }

                tbWords.Text = strWords;

                iCount = ddlTarget.Items.Count;

                for (int iLoop = 0; iLoop < iCount; iLoop++)
                {
                    if (ddlTarget.Items[iLoop].Value.Trim() == strTarget)
                        ddlTarget.Items[iLoop].Selected = true;
                }

                iCount = ddlMoveMailbox.Items.Count;

                for (int iLoop = 0; iLoop < iCount; iLoop++)
                {
                    if (ddlMoveMailbox.Items[iLoop].Value.Trim() == strMailbox)
                        ddlMoveMailbox.Items[iLoop].Selected = true;
                }

                iCount = rblUse.Items.Count;

                for (int iLoop = 0; iLoop < iCount; iLoop++)
                {
                    if (rblUse.Items[iLoop].Value == strUse)
                        rblUse.Items[iLoop].Selected = true;
                }
            }
            else
            {
                WF.WriteMessage("수정하려는 자동 편지분류가 없습니다.");
                WF.HistoryBack();
                return;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("수정하려는 자동 편지분류를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListFiltering.aspx");
            return;
        }
    }
    #endregion

    #region 필터링 정보 수정
    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibModifyFilter_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strWords = tbWords.Text;
        string strTarget = ddlTarget.SelectedValue;
        string strMailbox = ddlMoveMailbox.SelectedValue;
        string strUse = rblUse.SelectedValue;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyFilter";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (Filter No)
            sParams = Cmd.Parameters.Add("@iFilterNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Filtering Word)
            sParams = Cmd.Parameters.Add("@varWords", OleDbType.VarWChar, strWords.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Filtering Target)
            sParams = Cmd.Parameters.Add("@chrTarget", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Filtering Target Mailbox)
            sParams = Cmd.Parameters.Add("@varMailbox", OleDbType.VarChar, strMailbox.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Filterig Is Use)
            sParams = Cmd.Parameters.Add("@chrIsUse", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iFilterNo"].Value = int.Parse(strFilterNo);
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varWords"].Value = strWords;
            Cmd.Parameters["@chrTarget"].Value = strTarget;
            Cmd.Parameters["@varMailbox"].Value = strMailbox;
            Cmd.Parameters["@chrIsUse"].Value = strUse;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("편지 자동분류를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
                WF.HistoryBack();
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("편지 자동분류를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.HistoryBack();
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("자동 편지분류를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ModifyFiltering.aspx?iFilterNo=" + strFilterNo);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("선택한 자동 편지분류를 수정했습니다.");
        WF.MovePage("ListFiltering.aspx");
    }
    #endregion
}
