﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_Forwarding_AddForwarding : System.Web.UI.Page
{
    private WebFunction WF;
    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        string strScript = "if (!AddForwarding()) return false; else return true;";
        ibAddForwardId.Attributes.Add("onclick", strScript);
    }

    protected void ibAddForwardId_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strForwardId = tbForwardId.Text;

        try
        {
            UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

            if (File.Exists(UI.UserPath + "\\forwarding.txt"))
            {
                byte[] tmp = new byte[1024];
                string strTmp = "";
                FileStream f = new FileStream(UI.UserPath + "\\forwarding.txt", FileMode.Open, FileAccess.Read);

                while (f.Read(tmp, 0, tmp.Length) != 0)
                    strTmp += Encoding.Default.GetString(tmp, 0, tmp.Length);

                f.Close();

                if (strTmp.ToLower().IndexOf(strForwardId.ToLower()) > -1)
                {
                    WF.WriteMessage(strForwardId + " 메일주소는 등록된 메일 주소 입니다.");
                    return;
                }
            }

            FileStream fs = new FileStream(UI.UserPath + "\\forwarding.txt", FileMode.Append, FileAccess.Write, FileShare.None);

            byte[] buf = Encoding.ASCII.GetBytes("\r\n" + strForwardId);
            fs.Write(buf, 0, buf.Length);

            fs.Close();
        }
        catch (Exception err)
        {
            WF.WriteMessage(strForwardId + " 메일주소를 포워딩에 추가하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n").Replace("\"", "\\\""));
            return;
        }

        WF.WriteMessage(strForwardId + " 메일주소를 포워딩에 추가했습니다.");
        WF.OpenDocPageMove("ListForwarding.aspx");
        WF.WndClose();
    }
}
