﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_Forwarding_ListForwarding : System.Web.UI.Page
{
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private UserInfo UI;
    private WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strScript = "";

        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (!Page.IsPostBack)
        {
            ForwardingDataBind();
        }

        // 포워딩 삭제버튼 속성 추가
        strScript = "if (!SelectItem()) return false; else return true;";
        ibDelete.Attributes.Add("onclick", strScript);
    }

    private void ForwardingDataBind()
    {
        DataTable dt = new DataTable();

        if (File.Exists(UI.UserPath + "\\forwarding.txt"))
        {
            string strForward = "";
            string[] arrForward = null;
            int intPos = 0;
            FileStream fs = new FileStream(UI.UserPath + "\\forwarding.txt", FileMode.Open, FileAccess.Read, FileShare.None);
            byte[] buf = new byte[512];
            while (fs.Read(buf, 0, 512) > 0)
                strForward += Encoding.Default.GetString(buf);

            fs.Close();

            intPos = strForward.IndexOf("\0");

            if (intPos > 0)
                strForward = strForward.Substring(0, intPos);

            strForward = strForward.Replace("\r\n", ";");
            arrForward = strForward.Split(';');

            dt.Columns.Add("FORWARD_EMAIL", System.Type.GetType("System.String"));

            for (int iLoop = 0; iLoop < arrForward.Length; iLoop++)
            {
                if (arrForward[iLoop].ToString() != "")
                {
                    DataRow dr = dt.NewRow();

                    dr["FORWARD_EMAIL"] = arrForward[iLoop].ToString();

                    dt.Rows.Add(dr);
                }
            }
        }

        rptForwarding.DataSource = dt.DefaultView;
        rptForwarding.DataBind();
    }

    protected void ibDelete_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        int intPos = 0;
        string strForwardId = hidForwardingId.Value;
        string strForward = "";
        string strTemp = "";
        string strTemp2 = "";
        string[] arrForwardId;

        if (strForwardId == "")
        {
            WF.MovePage("ListForwarding.aspx");
            return;
        }

        FileStream ofs = new FileStream(UI.UserPath + "\\forwarding.txt", FileMode.Open, FileAccess.Read, FileShare.None);
        byte[] buf = new byte[512];
        while (ofs.Read(buf, 0, 512) > 0)
            strForward += Encoding.Default.GetString(buf);

        ofs.Close();

        intPos = strForward.IndexOf("\0");

        if (intPos > 0)
            strForward = strForward.Substring(0, intPos);

        if (strForward != "")
            strForward = strForward.Replace("\r\n", "|") + "|";

        if (strForwardId.EndsWith("|"))
            strForwardId = strForwardId.Substring(0, strForwardId.Length - 1);

        arrForwardId = strForwardId.Split('|');

        for (int iLoop = 0; iLoop < arrForwardId.Length; iLoop++)
        {
            int iPos = strForward.LastIndexOf(arrForwardId[iLoop]);

            if (iPos > -1)
            {
                if (arrForwardId[iLoop] != "")
                {
                    strTemp = strForward.Substring(0, iPos);
                    strTemp2 = strForward.Substring(iPos + arrForwardId[iLoop].Length + 1);

                    strForward = strTemp + strTemp2;
                }
            }
        }

        if (strForward.StartsWith("|"))
            strForward = strForward.Substring(1);

        strForward = strForward.Replace("|", "\r\n");

        try
        {
            if (strForward.Trim() != "")
            {
                intPos = strForward.LastIndexOf("\r\n");

                if (intPos > 0)
                    strForward = strForward.Substring(0, intPos);

                if (File.Exists(UI.UserPath + "\\forwarding.txt"))
                {
                    FileStream fs = new FileStream(UI.UserPath + "\\forwarding.txt", FileMode.Create, FileAccess.Write, FileShare.None);
                    StreamWriter sw = new StreamWriter(fs);

                    sw.Write(strForward);

                    sw.Close();
                    fs.Close();
                }
            }
            else
            {
                if (File.Exists(UI.UserPath + "\\forwarding.txt"))
                    File.Delete(UI.UserPath + "\\forwarding.txt");
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("선택한 포워딩 주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\"", "\\\""));
            WF.HistoryBack();
            return;
        }

        WF.WriteMessage("선택한 포워딩 메일주소를 삭제했습니다.");
        WF.MovePage("ListForwarding.aspx");
    }
}
