﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_MailBox_CreateMailBox : System.Web.UI.Page
{
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private UserInfo UI;
    private Passkorea.WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        UI = new UserInfo(strUserId, strDomain, strCon);

        string strScript = "if (!CreateMailBox()) return false; else return true;";
        ibCreateMailBox.Attributes.Add("onclick", strScript);
    }

    protected void ibCreateMailBox_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strFolderName = tbFolderName.Text;
        string strMailBoxName = tbMailBoxName.Text;

        if (strFolderName.ToLower() == "inbox" || strFolderName.ToLower() == "outbox" ||
            strFolderName.ToLower() == "delbox" || strFolderName.ToLower() == "spambox" ||
            strFolderName.ToLower() == "mailbox" || strFolderName.ToLower() == "savebox" ||
            strFolderName.ToLower() == "temp" || strFolderName.ToLower() == "tempbox")
        {
            WF.WriteMessage(strFolderName + " 폴더명은 사용할 수 없는 폴더명 입니다.\\r\\n\\r\\n다른 폴더 이름을 입력해 주세요.");
            return;
        }

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbTransaction Trans = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();

        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("CreateMailBox.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertMailbox";

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailbox Folder Name)
            sParams = Cmd.Parameters.Add("@varMailbox", OleDbType.VarWChar, strFolderName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailbox Name)
            sParams = Cmd.Parameters.Add("@varMailboxName", OleDbType.VarWChar, strMailBoxName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varMailbox"].Value = strFolderName;
            Cmd.Parameters["@varMailboxName"].Value = strMailBoxName;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage("편지함을 생성하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
                WF.MovePage("CreateMailBox.aspx");
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage("편지함을 생성하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("CreateMailBox.aspx");
                return;
            }

            if (!Directory.Exists(UI.UserPath + "\\" + strFolderName))
                Directory.CreateDirectory(UI.UserPath + "\\" + strFolderName);

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage(strMailBoxName + " 편지함을 생성하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("CreateMailBox.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strMailBoxName + " 편지함을 생성 했습니다.");
        WF.OpenDocPageMove("listMailBox.aspx");
        WF.WndClose();
    }
}
