﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_MailBox_ListMailBox : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private int intMailCount = 0;
    private float fMailboxSize = 0;
    private string strMailboxSize = "";
    private UserInfo UI;
    private WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        UI = new UserInfo(strUserId, strDomain, strCon);

        if (!Page.IsPostBack)
        {
            this.MailBoxDataBind();

            int iCount = rptMailBox.Items.Count;

            for (int iLoop = 0; iLoop < iCount; iLoop++)
            {
                ImageButton ib = (ImageButton)rptMailBox.Items[iLoop].FindControl("ibDelMailBox");

                if (ib.CommandName == "inbox" || ib.CommandName == "outbox" || ib.CommandName == "delbox" || ib.CommandName == "SaveBox")
                    ib.Visible = false;
            }

            DirectoryInfo di = new DirectoryInfo(UI.UserPath);

            foreach (FileInfo fi in di.GetFiles())
            {
                if (fi.Extension.ToLower() == ".zip")
                    fi.Delete();
            }
        }
    }

    #region 메일박스 데이터 Bind 함수
    private void MailBoxDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "MAIL_BOX");

            dt = ds.Tables["MAIL_BOX"];

            int iRowCount = dt.Rows.Count + 5;
            int iCount = 5;
            string[,] arrMailbox = new string[iRowCount, 2];

            // 받은편지함
            arrMailbox[0, 0] = "inbox";
            arrMailbox[0, 1] = "받은편지함";

            // 보낸편지함
            arrMailbox[1, 0] = "outbox";
            arrMailbox[1, 1] = "보낸편지함";

            // 휴지통
            arrMailbox[2, 0] = "delbox";
            arrMailbox[2, 1] = "휴지통";

            // 임시저장함
            arrMailbox[3, 0] = "savebox";
            arrMailbox[3, 1] = "임시저장함";

            // 스팸편지함
            arrMailbox[4, 0] = "spambox";
            arrMailbox[4, 1] = "스팸편지함";

            foreach (DataRow dr in dt.Rows)
            {
                arrMailbox[iCount, 0] = dr["M_MAILBOX"].ToString();
                arrMailbox[iCount, 1] = dr["M_MAILBOX_NAME"].ToString();

                ++iCount;
            }

            dt.Clear();

            dt.Columns.Add("MAIL_COUNT", System.Type.GetType("System.Int32"));
            dt.Columns.Add("MAILBOX_SIZE", System.Type.GetType("System.String"));

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                this.GetFolderInfo(UI.UserPath + "\\" + arrMailbox[iLoop, 0]);

                DataRow dr = dt.NewRow();
                dr["M_MAILBOX"] = arrMailbox[iLoop, 0];
                dr["M_MAILBOX_NAME"] = arrMailbox[iLoop, 1];
                dr["MAIL_COUNT"] = this.intMailCount;
                dr["MAILBOX_SIZE"] = strMailboxSize;
                dt.Rows.Add(dr);
            }

            rptMailBox.DataSource = dt.DefaultView;
            rptMailBox.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("편지함 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 각 폴더에 있는 메일 갯수와 용량을 가져오는 함수
    private void GetFolderInfo(string strFolder)
    {
        intMailCount = 0;
        fMailboxSize = 0;
        strMailboxSize = "0 Byte";

        DirectoryInfo di = new DirectoryInfo(strFolder);

        if (di.Exists)
        {
            foreach (FileInfo fi in di.GetFiles())
            {
                if (fi.Extension.ToLower() == ".eml")
                {
                    intMailCount++;
                    fMailboxSize += (int)fi.Length;
                }
            }

            if (fMailboxSize > 0)
            {
                if (fMailboxSize > 1073741824)
                {
                    fMailboxSize /= 1073741824;
                    strMailboxSize = string.Format("{0}", Math.Round(fMailboxSize, 2)) + " GB";
                }
                else if (fMailboxSize > 1048576)
                {
                    fMailboxSize /= 1048576;
                    strMailboxSize = string.Format("{0}", Math.Round(fMailboxSize, 2)) + " MB";
                }
                else if (fMailboxSize > 1024)
                {
                    fMailboxSize /= 1024;
                    strMailboxSize = string.Format("{0}", Math.Round(fMailboxSize, 2)) + " KB";
                }
                else
                    strMailboxSize = fMailboxSize.ToString() + " Byte";
            }
        }
    }
    #endregion

    #region 메일박스 백업
    /// <summary>
    /// 메일박스 백업
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibBackupMailBox_BackupCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
    {
        string strMailBox = e.CommandName;
        int iCount = 0;
        string strCompressFile = "";
        string[] strMailFile = null;

        strCompressFile = strUserId + "_" + strMailBox + ".zip";

        DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\" + strMailBox);

        if (di.GetFiles().Length > 0)
        {
            strMailFile = new string[di.GetFiles().Length];

            foreach (FileInfo fi in di.GetFiles())
                strMailFile[iCount++] = fi.Name;

            java.io.FileOutputStream fos = new java.io.FileOutputStream(UI.UserPath + "\\temp\\" + strCompressFile);
            java.util.zip.ZipOutputStream zos = new java.util.zip.ZipOutputStream(fos);

            for (int iLoop = 0; iLoop < strMailFile.Length; iLoop++)
            {
                string filename = UI.UserPath + "\\" + strMailBox + "\\" + strMailFile[iLoop];

                java.io.FileInputStream fis = new java.io.FileInputStream(filename);
                java.util.zip.ZipEntry ze = new java.util.zip.ZipEntry(strMailFile[iLoop]);
                zos.putNextEntry(ze);
                sbyte[] buf = new sbyte[1024];
                int len = 0;

                while ((len = fis.read(buf)) >= 0)
                    zos.write(buf, 0, len);

                zos.closeEntry();
                fis.close();
            }
            zos.close();
            fos.close();

            FileInfo f = new FileInfo(UI.UserPath + "\\temp\\" + strCompressFile);

            if (f.Exists)
            {
                Response.Clear();
                Response.ClearContent();
                Response.ContentType = "Application/Octet-stream";
                Response.AddHeader("Content-Disposition", "attachment; filename=" + f.Name);
                Response.WriteFile(f.FullName);
            }
        }
        else
        {
            WF.WriteMessage("백업할 편지가 없습니다.");
            WF.MovePage("ListMailBox.aspx");
        }
    }
    #endregion

    #region 메일박스 비우기
    protected void ibEmptyMailBox_EmptyCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
    {
        string strMailBox = e.CommandName;

        if (Directory.Exists(UI.UserPath + "\\" + strMailBox))
        {
            Directory.Delete(UI.UserPath + "\\" + strMailBox, true);
            Directory.CreateDirectory(UI.UserPath + "\\" + strMailBox);
        }

        Response.Redirect("listMailBox.aspx");
    }
    #endregion

    #region 메일박스 삭제
    /// <summary>
    /// 메일박스 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelMailBox_DeleteCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
    {
        string strMailBox = e.CommandName.ToLower();
        string strMailBoxName = e.CommandArgument.ToString();

        if (strMailBox == "inbox" || strMailBox == "outbox" || strMailBox == "delbox" || strMailBox == "savebox" || strMailBox == "spambox")
        {
            WF.WriteMessage(strMailBoxName + " 은(는) 삭제할 수 없는 편지함 입니다.");
            WF.HistoryBack();
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("listMailBox.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteMailbox";

            Cmd.Parameters.Clear();
 
            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mailbox Folder Name)
            sParams = Cmd.Parameters.Add("@varMailbox", OleDbType.VarWChar, strMailBox.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varMailbox"].Value = strMailBox;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage("편지함을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                WF.MovePage("listMailBox.aspx");
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();

                WF.WriteMessage(strMailBox + " 편지함을 삭제하는 도중 오류가 발생했니다.\\r\\n\\r\\n" +
                    "오류 발생 프로시져: prDeleteMailBox\\r\\n\\r\\n" +
                    "SQl Error Number: " + iValue.ToString());
                WF.MovePage("listMailBox.aspx");
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage(strMailBoxName + " 편지함을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("listMailBox.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        if (strMailBox.Trim() != "")
        {
            if (Directory.Exists(UI.UserPath + "\\" + strMailBox))
                Directory.Delete(UI.UserPath + "\\" + strMailBox, true);
        }

        WF.WriteMessage(strMailBoxName + " 편지함을 삭제했습니다.");
        WF.MovePage("listMailBox.aspx");
    }
    #endregion

    #region Repeater 컨트롤 아이템 데이터 바운드
    /// <summary>
    /// Repeater 컨트롤에 바운드 되는 ImageButton에 onclick 속성을 추가한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void rptMailBox_ItemDataBound(object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
    {
        string strEmptyScript = "if (confirm('해당 메일박스를 비우겠습니까?')) return true; else return false;";
        string strDeleteScript = "if (confirm('해당 메일박스를 삭제하겠습니까?')) return true; else return false;";
        int iItmCnt = e.Item.Controls.Count;

        try
        {
            for (int i = 0; i < iItmCnt; i++)
            {
                // 편지함 비우기 ImageButton
                ImageButton ibEmpty = (ImageButton)e.Item.Controls[i].FindControl("ibEmptyMailBox");
                // 편지함 삭제 ImageButton
                ImageButton ibDelete = (ImageButton)e.Item.Controls[i].FindControl("ibDelMailBox");

                // 편지함 비우기 ImageButton 객체가 정의되어 있을때
                // 클라이언트 onclick 이벤트를 넣는다.
                if (ibEmpty != null)
                {
                    //strEmptyScript = "alert('데모라서 해당 편지함을 비울수 없습니다.'); return false;";
                    ibEmpty.Attributes.Add("onclick", strEmptyScript);
                }

                // 편지함 삭제 ImageButton 객체가 정의되어 있을때
                // 클라이언트 onclick 이벤트를 넣는다.
                if (ibDelete != null)
                {
                    //strDeleteScript = "alert('데모라서 해당 편지함을 삭제할 수 없습니다.'); return false;";
                    ibDelete.Attributes.Add("onclick", strDeleteScript);
                }
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage(err.Message.Replace("\r\n", "\\r\\n"));
        }
    }
    #endregion
}
