﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_MailBox_ModifyMailBox : System.Web.UI.Page
{
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string strMailBox = "";
    private WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strMailBoxName = "";
        bool bNoDel = false;

        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["strMailBox"].ToLower();

        if (!Page.IsPostBack)
        {
            if (strMailBox == "inbox")
            {
                strMailBoxName = "받은편지함";
                bNoDel = true;
            }
            else if (strMailBox == "outbox")
            {
                strMailBoxName = "보낸편지함";
                bNoDel = true;
            }
            else if (strMailBox == "delbox")
            {
                strMailBoxName = "휴지통";
                bNoDel = true;
            }
            else if (strMailBox == "savebox")
            {
                strMailBoxName = "임시저장함";
                bNoDel = true;
            }
            else if (strMailBox == "spambox")
            {
                strMailBoxName = "스팸편지함";
                bNoDel = true;
            }

            if (bNoDel)
            {
                WF.WriteMessage(strMailBoxName + "은 수정할 수 없는 편지함 입니다.");
                WF.WndClose();
                Response.End();
            }

            tbFolderName.Text = strMailBox;
        }

        string strScript = "if (!ModifyMailBox()) return false; else return true;";
        ibModifyMailBox.Attributes.Add("onclick", strScript);
    }

    protected void ibModifyMailBox_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strFolderName = tbFolderName.Text;
        string strMailBoxName = tbMailBoxName.Text;

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbTransaction Trans = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();

        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ModifyMailBox.aspx?strMailBox=" + strMailBox);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyMailbox";
            
            // 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            //사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            
            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;
            
            // 메일 폴더명
            sParams = Cmd.Parameters.Add("@varMailbox", OleDbType.VarWChar, strFolderName.Length);
            sParams.Direction = ParameterDirection.Input;
            
            // 편지함 이름
            sParams = Cmd.Parameters.Add("@varMailboxName", OleDbType.VarWChar, strMailBoxName.Length);
            sParams.Direction = ParameterDirection.Input;
            
            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;
            
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varMailbox"].Value = strFolderName;
            Cmd.Parameters["@varMailboxName"].Value = strMailBoxName;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage("메일박스를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
                WF.MovePage("ModifyMailBox.aspx?strMailBox=" + strMailBox);
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage("메일박스를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ModifyMailBox.aspx?strMailBox=" + strMailBox);
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage(strFolderName + " 폴더 편지함명을 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ModifyMailBox.aspx?strMailBox=" + strMailBox);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strFolderName + " 폴더 편지함명을 수정 했습니다.");
        WF.OpenDocPageMove("ListMailbox.aspx");
        WF.WndClose();
    }
}
