﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_MailBox_RestoreMail : System.Web.UI.Page
{
    private UserInfo UI;
    private WebFunction WF;
    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strMailBox = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strMailBox = Request.Params["strMailBox"];
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        string strScript = "if (!Restore()) return false; else return true;";
        ibRestoreMail.Attributes.Add("onclick", strScript);
    }

    protected void ibRestoreMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strCompressFile = "";

        if (tbCompressFile.PostedFile != null)
        {
            strCompressFile = tbCompressFile.Value;

            if (strCompressFile != "")
            {
                FileInfo fi = new FileInfo(strCompressFile);

                if (fi.Extension.ToLower() == ".zip")
                {
                    strCompressFile = Path.GetFileName(strCompressFile);
                    tbCompressFile.PostedFile.SaveAs(UI.UserPath + "\\" + strCompressFile);
                    this.ExtractFile(strCompressFile);
                }
                else
                {
                    WF.WriteMessage(fi.Name + " 파일은 zip형식으로된 압축파일이 아닙니다.");
                    WF.HistoryBack();
                    return;
                }

                WF.WriteMessage("해당 편지함이 복구되었습니다.");
                WF.OpenDocPageMove("ListMailBox.aspx");
                WF.WndClose();
                return;
            }
            else
            {
                WF.WriteMessage("복구할 메일이 압축된 압축파일을 선택해 주세요.");
                WF.HistoryBack();
                return;
            }
        }
    }

    private void ExtractFile(string strCompressFile)
    {
        sbyte[] buf = new sbyte[1024];
        string strExtractFile = UI.UserPath + "\\" + strCompressFile;
        int len = 0;

        if (File.Exists(strExtractFile))
        {
            try
            {
                java.io.FileInputStream fis = new java.io.FileInputStream(strExtractFile);
                java.util.zip.ZipInputStream zis = new java.util.zip.ZipInputStream(fis);
                java.util.zip.ZipEntry ze;

                if (!Directory.Exists(UI.UserPath + "\\" + strMailBox))
                    Directory.CreateDirectory(UI.UserPath + "\\" + strMailBox);

                while ((ze = zis.getNextEntry()) != null)
                {
                    string strFilename = ze.getName();

                    int idx = strFilename.LastIndexOf('/');

                    if (idx > 1)
                    {
                        string folder = strFilename.Substring(0, idx);
                        DirectoryInfo di = new DirectoryInfo(folder);

                        if (!di.Exists)
                            di.Create();
                    }

                    java.io.FileOutputStream fos = new java.io.FileOutputStream(UI.UserPath + "\\" + strMailBox + "\\" + strFilename);

                    while ((len = zis.read(buf)) >= 0)
                        fos.write(buf, 0, len);

                    fos.close();
                }

                zis.close();
                fis.close();

                if (File.Exists(strExtractFile))
                    File.Delete(strExtractFile);
            }
            catch (Exception err)
            {
                WF.WriteMessage("압축파일을 해제 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                WF.HistoryBack();
                return;
            }

            if (File.Exists(strExtractFile))
                File.Delete(strExtractFile);
        }
    }
}
