﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_MailReject_ListRejectEmail : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbCommand Cmd = new OleDbCommand();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private WebFunction WF;
    private int iPage = 0;
    private int iPageSize = 15;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strScript = "";

        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        iPage = WF.StringToInt(Request.Params["iPage"], 1);

        if (!Page.IsPostBack)
            this.RejectEmailDataBind();

        // 포워딩 삭제버튼 속성 추가
        strScript = "if (!SelectItem()) return false; else return true";
        ibDelRejectEmail.Attributes.Add("onclick", strScript);
    }

    #region 수신거부 메일주소 리스트 바인드
    /// <summary>
    /// 수신거부 메일주소 리스트 바인드
    /// </summary>
    private void RejectEmailDataBind()
    {
        string strMovePage = "";
        int iTotCnt = 0;
        int iTotPage = 1;

        strMovePage = Request.PhysicalPath;
        strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListRejectEmailAddr";

            Cmd.Parameters.Clear();

            // 현재 페이지
            sParams = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 출력할 게시물 수
            sParams = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // 도메인 명
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // 리턴값
            sParams = Cmd.Parameters.Add("@iTotCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = iPage;
            Cmd.Parameters["@iPageSize"].Value = iPageSize;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "USERSPAMMER");

            rptRejectEmail.DataSource = ds.Tables["USERSPAMMER"];
            rptRejectEmail.DataBind();

            iTotCnt = int.Parse(Cmd.Parameters["@iTotCnt"].Value.ToString());
            iTotPage = iTotCnt / 15;

            if ((iTotCnt % 15) > 0)
                iTotPage++;
        }
        catch (Exception err)
        {
            WF.WriteMessage("수신거부 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        lblPageLink.Text = WF.PageLink(iTotPage, iPage, "ListRejectEmail.aspx", "", iPageSize, "", "", "", "");
    }
    #endregion

    #region 수신거부 메일주소 삭제
    /// <summary>
    /// 수신거부 메일주소 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelRejectEmail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strRejectEmail = hidRejectEmail.Value;
        string[] arrRejectEmail;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListRejectEmail.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteRejectEmail";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Spam Email Address)
            sParams = Cmd.Parameters.Add("@varRejectEmail", OleDbType.VarChar, strRejectEmail.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 1100);
            sParams.Direction = ParameterDirection.Output;

            if (strRejectEmail.EndsWith("|"))
                strRejectEmail = strRejectEmail.Substring(0, strRejectEmail.Length - 1);
            arrRejectEmail = strRejectEmail.Split('|');
            for (int iLoop = 0; iLoop < arrRejectEmail.Length; iLoop++)
            {
                // Command Parameter Value Setting
                Cmd.Parameters["@varUserId"].Value = strUserId;
                Cmd.Parameters["@varDomain"].Value = strDomain;
                Cmd.Parameters["@varRejectEmail"].Value = arrRejectEmail[iLoop];

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    Trans.Rollback();
                    WF.WriteMessage("스팸 메일 주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 메일 주소: " + strRejectEmail + "\\r\\n\\r\\n" +
                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                    WF.MovePage("ListRejectEmail.aspx");
                    return;
                }
                else if (iValue != 0)
                {
                    Trans.Rollback();
                    WF.WriteMessage("스팸 메일 주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 메일 주소: " + strRejectEmail + "\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    WF.MovePage("ListRejectEmail.aspx");
                    return;
                }
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();

            WF.WriteMessage("선택한 수신거부 메일주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListRejectEmail.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("선택한 수신거부 메일주소를 삭제 했습니다.");
        WF.MovePage("ListRejectEmail.aspx");
    }
    #endregion
}
