﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_POP3_EditPop3Info : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbDataAdapter Adap;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private WebFunction WF;
    private UserInfo UI;
    private string strPop3No = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strPop3No = Request.Params["pop3No"];

        UI = new UserInfo(strUserId, strDomain, strCon);

        if (!Page.IsPostBack)
        {
            this.MailBoxDataBind();
            this.Pop3InfoDataBind();
        }
        string strScript = "if (!EditPop3()) return false; else return true;";
        ibEditPop3Info.Attributes.Add("onclick", strScript);
    }

    #region 개인 편지함 데이터 바인드
    /// <summary>
    /// 개인 편지함 DropDownList 컨트롤에 데이터를 바인드 한다.
    /// </summary>
    private void MailBoxDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListPop3Info.aspx");
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, Session["USER_ID"].ToString().Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = Session["USER_ID"].ToString();
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            int iRowCount = dt.Rows.Count + 4;
            int iCount = 4;
            string[,] arrMailbox = new string[iRowCount, 2];

            // 받은편지함
            arrMailbox[0, 0] = "inbox";
            arrMailbox[0, 1] = "받은편지함";

            // 보낸편지함
            arrMailbox[1, 0] = "outbox";
            arrMailbox[1, 1] = "보낸편지함";

            // 휴지통
            arrMailbox[2, 0] = "delbox";
            arrMailbox[2, 1] = "휴지통";

            // 임시저장함
            arrMailbox[3, 0] = "SaveBox";
            arrMailbox[3, 1] = "임시저장함";

            foreach (DataRow dr in dt.Rows)
            {
                arrMailbox[iCount, 0] = dr["M_MAILBOX"].ToString();
                arrMailbox[iCount, 1] = dr["M_MAILBOX_NAME"].ToString();

                ++iCount;
            }

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                ListItem li = new ListItem(arrMailbox[iLoop, 1], arrMailbox[iLoop, 0]);
                ddlSaveBox.Items.Add(li);
            }
            ddlSaveBox.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("편지함 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListPop3Info.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 개인 외부메일 정보 데이터 바인드(POP3)
    /// <summary>
    /// 개인 외부메일 정보 데이터 바인드(POP3)
    /// </summary>
    private void Pop3InfoDataBind()
    {
        string strPop3ServerName = "";
        string strPop3UserId = "";
        string strPop3UserPwd = "";
        string strPop3IsDel = "";
        string strPop3Savebox = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListPop3Info.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectPop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (Pop3 No)
            sParams = Cmd.Parameters.Add("@iPop3No", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPop3No"].Value = int.Parse(strPop3No);
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_POP3");
            dt = ds.Tables["MAIL_POP3"];

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                WF.WriteMessage("선택한 POP3 정보를 가져하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("ListPOP3Info.aspx");
                return;
            }
            else if (iValue != 0)
            {
                WF.WriteMessage("선택한 POP3 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ListPOP3Info.aspx");
                return;
            }

            strPop3ServerName = dt.Rows[0]["POP3_SERVER"].ToString();
            strPop3UserId = dt.Rows[0]["POP3_USER_ID"].ToString();
            strPop3UserPwd = dt.Rows[0]["POP3_USER_PWD"].ToString();
            strPop3IsDel = dt.Rows[0]["POP3_IS_DEL"].ToString();
            strPop3Savebox = dt.Rows[0]["POP3_SAVEBOX"].ToString();

            tbPop3ServerName.Text = strPop3ServerName;
            tbPop3UserId.Text = strPop3UserId;
            tbPop3UserPwd.Value = strPop3UserPwd;

            WF.CtrlDataChecked(rblPop3IsDel, strPop3IsDel);
            WF.CtrlDataChecked(ddlSaveBox, strPop3Savebox);
        }
        catch (Exception err)
        {
            WF.WriteMessage("해당 POP3 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListPop3Info.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 개인 외부메일 정보 수정
    /// <summary>
    /// 개인 외부메일 정보 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibEditPop3Info_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strPop3ServerName = tbPop3ServerName.Text;
        string strPop3UserId = tbPop3UserId.Text;
        string strPop3UserPwd = tbPop3UserPwd.Value;
        string strPop3IsDel = rblPop3IsDel.SelectedValue;
        string strPop3Savebox = "";
        bool bChecked = chkIsNewSaveBox.Checked;
        int iValue = 0;
        int iPop3No = int.Parse(strPop3No);

        if (!bChecked)
            strPop3Savebox = ddlSaveBox.SelectedValue;
        else
            strPop3Savebox = tbNewSaveBox.Text;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EditPop3Info.aspx?pop3No=" + strPop3No);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyPop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Pop3 No)
            sParams = Cmd.Parameters.Add("@iPop3No", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Pop3 Server)
            sParams = Cmd.Parameters.Add("@varPop3Server", OleDbType.VarChar, strPop3ServerName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Pop3 Login User Id)
            sParams = Cmd.Parameters.Add("@varPop3UserId", OleDbType.VarChar, strPop3UserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Pop3 Login User Password)
            sParams = Cmd.Parameters.Add("@varPop3UserPwd", OleDbType.VarChar, strPop3UserPwd.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Pop3 Server Mail Is Delete)
            sParams = Cmd.Parameters.Add("@chrPop3IsDel", OleDbType.Char, strPop3IsDel.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Pop3 Server Mail Save Mailbox)
            sParams = Cmd.Parameters.Add("@varPop3Savebox", OleDbType.VarWChar, strPop3Savebox.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@iPop3No"].Value = iPop3No;
            Cmd.Parameters["@varPop3Server"].Value = strPop3ServerName;
            Cmd.Parameters["@varPop3UserId"].Value = strPop3UserId;
            Cmd.Parameters["@varPop3UserPwd"].Value = strPop3UserPwd;
            Cmd.Parameters["@chrPop3IsDel"].Value = strPop3IsDel;
            Cmd.Parameters["@varPop3Savebox"].Value = strPop3Savebox;

            // 쿼리를 실행한다.
            Cmd.ExecuteNonQuery();

            iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                WF.WriteMessage("POP3 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("EditPop3Info.aspx?pop3No=" + strPop3No);
                return;
            }
            else if (iValue != 0)
            {
                WF.WriteMessage("POP3 정보를 수정오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("EditPop3Info.aspx?pop3No=" + strPop3No);
                return;
            }
            Trans.Commit();

            if (bChecked)
            {
                if (!Directory.Exists(UI.UserPath + "\\" + strPop3Savebox))
                    Directory.CreateDirectory(UI.UserPath + "\\" + strPop3Savebox);
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("해당 POP3 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EditPop3Info.aspx?pop3No=" + strPop3No);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("해당 POP3 정보를 수정 하였습니다.");
        WF.MovePage("ListPop3Info.aspx");
    }
    #endregion

    protected void chkIsNewSaveBox_CheckedChanged(object sender, EventArgs e)
    {
        if (chkIsNewSaveBox.Checked)
        {
            ddlSaveBox.Enabled = false;
            tbNewSaveBox.Enabled = true;
        }
        else
        {
            ddlSaveBox.Enabled = true;
            tbNewSaveBox.Enabled = false;
        }
    }
}
