﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.POP3;

public partial class Config_POP3_ListPop3Info : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private WebFunction WF;
    private UserInfo UI;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();

        UI = new UserInfo(strUserId, strDomain, strCon);

        //if (!Page.IsPostBack)
        //{
            this.Pop3InfoDataBind();
            this.MailBoxDataBind();
        //}

        string strScript = "if (!AddPop3()) return false; else return true;";
        ibAddPop3Info.Attributes.Add("onclick", strScript);
    }

    #region POP3 정보 데이터 바인드
    /// <summary>
    /// POP3 계정 정보 데이터를 바인드 한다.
    /// </summary>
    private void Pop3InfoDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListPop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(ds, "MAIL_POP3");

            if (ds.Tables.Count > 0)
            {
                dt = ds.Tables["MAIL_POP3"];

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue != 0)
                {
                    Con.Close();
                    WF.WriteMessage("POP3 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    WF.MovePage("../Config.aspx");
                    return;
                }

                int iRowCnt = dt.Rows.Count;
                string[,] arrPop3Info = new string[iRowCnt, 6];

                for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
                {
                    arrPop3Info[iLoop, 0] = dt.Rows[iLoop]["POP3_NO"].ToString();
                    arrPop3Info[iLoop, 1] = dt.Rows[iLoop]["POP3_SERVER"].ToString();
                    arrPop3Info[iLoop, 2] = dt.Rows[iLoop]["POP3_USER_ID"].ToString();
                    arrPop3Info[iLoop, 3] = dt.Rows[iLoop]["POP3_USER_PWD"].ToString();
                    arrPop3Info[iLoop, 4] = dt.Rows[iLoop]["POP3_IS_DEL"].ToString();
                    arrPop3Info[iLoop, 5] = dt.Rows[iLoop]["POP3_SAVEBOX"].ToString();
                }

                dt.Rows.Clear();

                for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
                {
                    if (arrPop3Info[iLoop, 4] == "N")
                        arrPop3Info[iLoop, 4] = "사본저장";
                    else
                        arrPop3Info[iLoop, 4] = "사본삭제";

                    DataRow dr = dt.NewRow();
                    dr["POP3_NO"] = int.Parse(arrPop3Info[iLoop, 0]);
                    dr["POP3_SERVER"] = arrPop3Info[iLoop, 1];
                    dr["POP3_USER_ID"] = arrPop3Info[iLoop, 2];
                    dr["POP3_USER_PWD"] = arrPop3Info[iLoop, 3];
                    dr["POP3_IS_DEL"] = arrPop3Info[iLoop, 4];
                    dr["POP3_SAVEBOX"] = arrPop3Info[iLoop, 5];
                    dt.Rows.Add(dr);
                }
            }
            rptPop3Info.DataSource = dt.DefaultView;
            rptPop3Info.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("POP3 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 개인 편지함 데이터 바인드
    /// <summary>
    /// 개인 편지함 DropDownList 컨트롤에 데이터를 바인드 한다.
    /// </summary>
    private void MailBoxDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                Con.Close();
                WF.WriteMessage("POP3 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("../Config.aspx");
                return;
            }

            int iRowCount = dt.Rows.Count + 4;
            int iCount = 4;
            string[,] arrMailbox = new string[iRowCount, 2];

            // 받은편지함
            arrMailbox[0, 0] = "inbox";
            arrMailbox[0, 1] = "받은편지함";

            // 보낸편지함
            arrMailbox[1, 0] = "outbox";
            arrMailbox[1, 1] = "보낸편지함";

            // 휴지통
            arrMailbox[2, 0] = "delbox";
            arrMailbox[2, 1] = "휴지통";

            // 임시저장함
            arrMailbox[3, 0] = "SaveBox";
            arrMailbox[3, 1] = "임시저장함";

            foreach (DataRow dr in dt.Rows)
            {
                arrMailbox[iCount, 0] = dr["M_MAILBOX"].ToString();
                arrMailbox[iCount, 1] = dr["M_MAILBOX_NAME"].ToString();

                ++iCount;
            }

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                ListItem li = new ListItem(arrMailbox[iLoop, 1], arrMailbox[iLoop, 0]);
                ddlSaveBox.Items.Add(li);
            }
            ddlSaveBox.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("편지함 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region POP3 정보 추가
	/// <summary>
	/// POP3 정보를 DB에 추가한다.
	/// </summary>
	/// <param name="sender"></param>
	/// <param name="e"></param>
	protected void ibAddPop3Info_Click(object sender, System.Web.UI.ImageClickEventArgs e)
	{
		string strPop3ServerName = tbPop3ServerName.Text;
		string strPop3UserId = tbPop3UserId.Text;
		string strPop3UserPwd = tbPop3UserPwd.Value;
		string strPop3IsDel = rblPop3IsDel.SelectedValue;
		string strPop3Savebox = "";
		bool bChecked = chkIsNewSaveBox.Checked;
		int iValue = 0;

		if (!bChecked)
			strPop3Savebox = ddlSaveBox.SelectedValue;
		else
			strPop3Savebox = tbNewSaveBox.Text;
		
		try
		{
			Con = new OleDbConnection(strCon);
			Con.Open();
			Trans = Con.BeginTransaction();
		} 
		catch (Exception err)
		{
			WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
				err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
			WF.MovePage("ListPop3Info.aspx");
			return;
		}
		
		try
		{
			Cmd.Connection = Con;
			Cmd.Transaction = Trans;
			Cmd.CommandType = CommandType.StoredProcedure;
			Cmd.CommandText = "prInsertPop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

			// Command Parameter (User Id)
			sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Domain)
			sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server Name or Address)
			sParams = Cmd.Parameters.Add("@varPop3Server", OleDbType.VarChar, strPop3ServerName.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server User Id)
			sParams = Cmd.Parameters.Add("@varPop3UserId", OleDbType.VarChar, strPop3UserId.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server User Password)
			sParams = Cmd.Parameters.Add("@varPop3UserPwd", OleDbType.VarChar, strPop3UserPwd.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server Mail Is Delete)
			sParams = Cmd.Parameters.Add("@chrPop3IsDel", OleDbType.Char, 1);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Pop3 Server Mail Save Mailbox)
			sParams = Cmd.Parameters.Add("@varPop3Savebox", OleDbType.VarWChar, strPop3Savebox.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Output Value)
			sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 600);
			sParams.Direction = ParameterDirection.Output;

			// Command Parameter Value Setting
			Cmd.Parameters["@varUserId"].Value = strUserId;
			Cmd.Parameters["@varDomain"].Value = strDomain;
			Cmd.Parameters["@varPop3Server"].Value = strPop3ServerName;
			Cmd.Parameters["@varPop3UserId"].Value = strPop3UserId;
			Cmd.Parameters["@varPop3UserPwd"].Value = strPop3UserPwd;
			Cmd.Parameters["@chrPop3IsDel"].Value = strPop3IsDel;
			Cmd.Parameters["@varPop3Savebox"].Value = strPop3Savebox;

			// Execute
			Cmd.ExecuteNonQuery();

			iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

			if (iValue < 0)
			{
				Trans.Rollback();
				WF.WriteMessage("POP3 정보를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
					"오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
				WF.MovePage("ListPOP3Info.aspx");
				return;
			} 
			else if (iValue != 0)
			{
				Trans.Rollback();
				WF.WriteMessage("POP3 정보를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
					"오류 POP3 Server: " + strPop3ServerName + "\\r\\n\\r\\n" +
					"SQL Error Number: " + iValue.ToString());
				WF.MovePage("ListPOP3Info.aspx");
				return;
			}

			// 새편지함 생성일 경우에 편지함을 개인 편지함에 등록하고 폴더를 새로 생성한다.
			if (bChecked)
			{
				Cmd.Parameters.Clear();
				Cmd.CommandText = "prInsertMailbox";

                // Command Parameter (Execute Return Value)
                sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                sParams.Direction = ParameterDirection.ReturnValue;

				// Command Parameter (User Id)
				sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
				sParams.Direction = ParameterDirection.Input;
			
				// Command Parameter (Domain)
				sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
				sParams.Direction = ParameterDirection.Input;
			
				// Command Parameter (Mailbox Folder Name)
				sParams = Cmd.Parameters.Add("@varMailbox", OleDbType.VarWChar, strPop3Savebox.Length);
				sParams.Direction = ParameterDirection.Input;
			
				// Command Parameter (Mailbox Name)
				sParams = Cmd.Parameters.Add("@varMailboxName", OleDbType.VarWChar, strPop3Savebox.Length);
				sParams.Direction = ParameterDirection.Input;

				// Command Parameter (Output Value)
				sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
				sParams.Direction = ParameterDirection.Output;
			
				Cmd.Parameters["@varUserId"].Value = strUserId;
				Cmd.Parameters["@varDomain"].Value = strDomain;
				Cmd.Parameters["@varMailbox"].Value = strPop3Savebox;
				Cmd.Parameters["@varMailboxName"].Value = strPop3Savebox;

				Cmd.ExecuteNonQuery();

				iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

				if (iValue < 0)
				{
					Trans.Rollback();
					WF.WriteMessage(strPop3Savebox + " 편지함을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
						"오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
					WF.MovePage("ListPOP3Info.aspx");
					return;
				} 
				else if (iValue != 0)
				{
					Trans.Rollback();
					WF.WriteMessage(strPop3Savebox + " 편지함을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
						"SQL Error Number: " + iValue.ToString());
					WF.MovePage("ListPOP3Info.aspx");
					return;
				}
			}
		} 
		catch (Exception err)
		{
			WF.WriteMessage(strPop3ServerName + " 서버 POP3 계정을 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
				"오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
			WF.MovePage("ListPop3Info.aspx");
			return;
		} 
		finally
		{
			if (bChecked)
			{
				if (!Directory.Exists(UI.UserPath + "\\" + strPop3Savebox))
					Directory.CreateDirectory(UI.UserPath + "\\" + strPop3Savebox);
			}

			Trans.Commit();
			Con.Close();
			Cmd.Parameters.Clear();
			 
		}

		WF.WriteMessage(strPop3ServerName + " 서버 POP3 계정이 등록되었습니다.");
		WF.MovePage("ListPop3Info.aspx");
	}
	#endregion

	protected void chkIsNewSaveBox_CheckedChanged(object sender, EventArgs e)
	{
		if (chkIsNewSaveBox.Checked)
		{
			ddlSaveBox.Enabled = false;
			tbNewSaveBox.Enabled = true;
		}
		else
		{
			ddlSaveBox.Enabled = true;
			tbNewSaveBox.Enabled = false;
		}
	}

	#region 개인 외부메일 정보 삭제(POP3)
	/// <summary>
	/// 개인 외부메일 정보 삭제(POP3)
	/// </summary>
	/// <param name="sender"></param>
	/// <param name="e"></param>
	protected void ibDelPop3_DelCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
	{
		int iPop3No = int.Parse(e.CommandName);
		
		try
		{
			Con = new OleDbConnection(strCon);
			Con.Open();
			Trans = Con.BeginTransaction();
		}
		catch (Exception err)
		{
			WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
				err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
			WF.MovePage("ListPop3Info.aspx");
			return;
		}
		
		try
		{
			Cmd.Connection = Con;
			Cmd.Transaction = Trans;
			Cmd.CommandType = CommandType.StoredProcedure;
			Cmd.CommandText = "prDeletePop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

			// Command Parameter (Pop3 Info No)
			sParams = Cmd.Parameters.Add("@iPop3No", OleDbType.Integer);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (User Id)
			sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
			sParams.Direction = ParameterDirection.Input;
			
			// Command Parameter (Domain)
			sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
			sParams.Direction = ParameterDirection.Input;
			
			// Command Parameter (Output Value)
			sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
			sParams.Direction = ParameterDirection.Output;
			
			Cmd.Parameters["@iPop3No"].Value = iPop3No;
			Cmd.Parameters["@varUserId"].Value = strUserId;
			Cmd.Parameters["@varDomain"].Value = strDomain;
			
			Cmd.ExecuteNonQuery();

			int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

			if (iValue < 0)
			{
				Trans.Rollback();
				Con.Close();
				WF.WriteMessage("POP3 정보를 삭제하려는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
					"오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\\", "\\r\\n\\r\\n"));
				WF.MovePage("ListPop3Info.aspx");
				return;
			} 
			else if (iValue != 0)
			{
				Trans.Rollback();
				Con.Close();
				WF.WriteMessage("POP3 정보를 삭제하려는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
					"SQL Error Number: " + iValue.ToString());
				WF.MovePage("ListPop3Info.aspx");
				return;
			}
		} 
		catch (Exception err)
		{
			Trans.Rollback();
			Con.Close();
			WF.WriteMessage("POP3 정보를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
				"오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
			WF.MovePage("ListPop3Info.aspx");
			return;
		} 
		finally
		{
			Trans.Commit();
			Con.Close();
			Cmd.Parameters.Clear();
			 
		}

		WF.WriteMessage("POP3정보를 삭제하였습니다.");
		WF.MovePage("ListPop3Info.aspx");
	}
	#endregion

	#region 외부메일 가져오기(POP3)
	/// <summary>
	/// 외부메일 가져오기(POP3)
	/// </summary>
	/// <param name="sender"></param>
	/// <param name="e"></param>
	protected void ibReadPop3_ReadCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
	{
		int iPop3No = int.Parse(e.CommandName);
		string strPop3ServerName = "";
		string strPop3UserId = "";
		string strPop3UserPwd = "";
		string strPop3Savebox = "";
		bool bPop3IsDelMail = false;

		try
		{
			Con = new OleDbConnection(strCon);
			Con.Open();
		}
		catch (Exception err)
		{
			WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
				err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
			WF.MovePage("ListPop3Info.aspx");
			return;
		}

		try
		{
			Cmd.Connection = Con;
			Cmd.CommandType = CommandType.StoredProcedure;
			Cmd.CommandText = "prSelectPop3";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

			// Command Parameter (Pop3 Info No)
			sParams = Cmd.Parameters.Add("@iPop3No", OleDbType.Integer);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (User Id)
			sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Domain)
			sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Output Value)
			sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
			sParams.Direction = ParameterDirection.Output;

			Cmd.Parameters["@iPop3No"].Value = iPop3No;
			Cmd.Parameters["@varUserId"].Value = strUserId;
			Cmd.Parameters["@varDomain"].Value = strDomain;

			Adap = new OleDbDataAdapter(Cmd);
			Adap.Fill(ds, "MAIL_POP3_INFO");
            dt = ds.Tables["MAIL_POP3_INFO"];

			int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

			if (iValue < 0)
			{
				Con.Close();
				WF.WriteMessage("POP3 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
					"오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\\", "\\r\\n\\r\\n"));
				WF.MovePage("ListPop3Info.aspx");
				return;
			} 
			else if (iValue != 0)
			{
				Con.Close();
				WF.WriteMessage("POP3 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
					"SQL Error Number: " + iValue.ToString());
				WF.MovePage("ListPop3Info.aspx");
				return;
			}

			int iRowCnt = dt.Rows.Count;

			if (iRowCnt == 1)
			{
				strPop3ServerName = dt.Rows[0]["POP3_SERVER"].ToString();
				strPop3UserId = dt.Rows[0]["POP3_USER_ID"].ToString();
				strPop3UserPwd = dt.Rows[0]["POP3_USER_PWD"].ToString();
				strPop3Savebox = dt.Rows[0]["POP3_SAVEBOX"].ToString();
				
				if (dt.Rows[0]["POP3_IS_DEL"].ToString() == "Y")
					bPop3IsDelMail = true;
			}
			else if (iRowCnt < 1) 
			{
				WF.WriteMessage("읽어오려는 POP3 정보가 없습니다.");
				WF.MovePage("ListPop3Info.aspx");
				return;
			}
			else if (iRowCnt > 1)
			{
				WF.WriteMessage("동일한 POP3 정보가 존재합니다.\\r\\n\\r\\nPOP3정보를 확인해 주세요.");
				WF.MovePage("ListPop3Info.aspx");
				return;
			}
		}
		catch (Exception err)
		{
			WF.WriteMessage("POP3 정보를 읽어오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
				"오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
			WF.MovePage("ListPop3Info.aspx");
			return;
		} 
		finally
		{
			Con.Close();
			Cmd.Parameters.Clear();
			 
		}

		POP3Client pop = new POP3Client();

		try
		{
			pop.POP3Read(strPop3ServerName, strPop3UserId, strPop3UserPwd, UI.UserPath + "\\" + strPop3Savebox, 10, bPop3IsDelMail);
		} 
		catch (POP3Exception err)
		{
			WF.WriteMessage("POP3에 접속해서 메일을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
				"오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n","\\r\\n\\r\\n"));
			WF.MovePage("ListPop3Info.aspx");
			return;
		}

		WF.WriteMessage("메일을 정상적으로 가져왔습니다.");
		WF.MovePage("../../Mail/ListMail.aspx?strMailBox=" + Server.UrlEncode(strPop3Savebox));
	}
	#endregion
}
