﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_Sign_Sign : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();

        if (!Page.IsPostBack)
        {
            this.SignDataBinding();
        }
    }

    #region 서명 데이터 바인드
    /// <summary>
    /// 서명 데이터 바인드
    /// </summary>
    private void SignDataBinding()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectSign";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            OleDbDataReader sr = Cmd.ExecuteReader();

            if (sr.HasRows)
            {
                while (sr.Read())
                {
                    tbSign1.Text = sr["S_SIGN1"].ToString();
                    tbSign2.Text = sr["S_SIGN2"].ToString();
                    tbSign3.Text = sr["S_SIGN3"].ToString();

                    break;
                }
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("서명 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 서명 데이터 수정 버튼
    /// <summary>
    /// 서명 데이터 수정 버튼
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibEditSign_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strSign1 = tbSign1.Text;
        string strSign2 = tbSign2.Text;
        string strSign3 = tbSign3.Text;

        this.ChkStrSizeLimit(strSign1, 2000, "서명 1");
        this.ChkStrSizeLimit(strSign2, 2000, "서명 2");
        this.ChkStrSizeLimit(strSign3, 2000, "서명 3");

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("Sign.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifySign";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Sign 1)
            sParams = Cmd.Parameters.Add("@varSign1", OleDbType.VarWChar, strSign1.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Sign 2)
            sParams = Cmd.Parameters.Add("@varSign2", OleDbType.VarWChar, strSign2.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Sign 3)
            sParams = Cmd.Parameters.Add("@varSign3", OleDbType.VarWChar, strSign3.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varSign1"].Value = strSign1;
            Cmd.Parameters["@varSign2"].Value = strSign2;
            Cmd.Parameters["@varSign3"].Value = strSign3;
            Cmd.Parameters["@varUserId"].Value = strUserId.ToString();
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("서명 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                WF.MovePage("Sign.aspx");
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("서명 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("Sign.aspx");
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            WF.WriteMessage("서명 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("Sign.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("서명 정보가 수정 되었습니다.");
        WF.MovePage("Sign.aspx");
        return;
    }
    #endregion

    private void ChkStrSizeLimit(string strValue, int iLength, string strField)
    {
        if (strValue.Length > iLength)
        {
            WF.WriteMessage("서명 정보를 등록하는 도중 " + strField + " 에 자리수 " + iLength.ToString() + " 자를 초과했습니다.");
            WF.MovePage("Sign.aspx");
            return;
        }
    }
}
