﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Common_UserInfo_UserInfo : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();

        if (!Page.IsPostBack)
        {
            this.LastEduDataBind();
            this.JobDataBind();
            this.MailUserDataBind();
        }
        //ibUserInfoEdit.Attributes.Add("onclick", "alert('데모라서 사용자 정보를 수정할 수 없습니다.'); return false;");
    }

    #region 회원 데이터 바인드
    /// <summary>
    /// 회원 데이터 바인드
    /// </summary>
    private void MailUserDataBind()
    {
        string strUserName = "";
        string strUserSex = "";
        string strUserBirthday = "";
        string strUserLastEdu = "";
        string strUserJob = "";
        string strUserMarry = "";
        string strUserPosition = "";
        string strUserTel = "";
        string strUserMobile = "";
        string strUserZipCode = "";
        string strUserAddress1 = "";
        string strUserAddress2 = "";
        int iCount = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectUserInfo";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_USER");
            dt = ds.Tables["MAIL_USER"];

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                WF.WriteMessage("사용자 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("../Config.aspx");
                return;
            }
            else if (iValue != 0)
            {
                WF.WriteMessage("사용자 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("../Config.aspx");
                return;
            }

            foreach (DataRow dr in dt.Rows)
            {
                strUserName = dr["USER_NAME"].ToString();
                strUserSex = dr["USER_SEX"].ToString();
                strUserBirthday = dr["USER_BIRTHDAY"].ToString().Trim();
                strUserLastEdu = dr["USER_LAST_EDU"].ToString();
                strUserJob = dr["USER_JOB"].ToString();
                strUserMarry = dr["USER_MARRY"].ToString();
                strUserPosition = dr["USER_POSITION"].ToString();
                strUserTel = dr["USER_TEL"].ToString();
                strUserMobile = dr["USER_MOBILE"].ToString();
                hidZipCode.Value = strUserZipCode = dr["USER_ZIPCODE"].ToString();
                hidAddress1.Value = strUserAddress1 = dr["USER_ADDRESS1"].ToString();
                strUserAddress2 = dr["USER_ADDRESS2"].ToString();
                break;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage(Session["USER_ID"].ToString() + " 회원님의 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        tbUserId.Text = Session["USER_ID"].ToString();
        tbUserName.Text = strUserName;

        // 성별
        iCount = rblUserSex.Items.Count;

        for (int iLoop = 0; iLoop < iCount; iLoop++)
        {
            if (rblUserSex.Items[iLoop].Value == strUserSex)
            {
                rblUserSex.Items[iLoop].Selected = true;
                break;
            }
        }

        // 최종학력
        iCount = ddlLastEdu.Items.Count;

        for (int iLoop = 0; iLoop < iCount; iLoop++)
        {
            if (ddlLastEdu.Items[iLoop].Value.Trim() == strUserLastEdu.Trim())
            {
                ddlLastEdu.Items[iLoop].Selected = true;
                break;
            }
        }
        //this.LastEduDataBind(strUserLastEdu);

        // 직업
        iCount = ddlUserJob.Items.Count;

        for (int iLoop = 0; iLoop < iCount; iLoop++)
        {
            if (ddlUserJob.Items[iLoop].Value == strUserJob)
            {
                ddlUserJob.Items[iLoop].Selected = true;
                break;
            }
        }

        // 결혼 여부
        iCount = rblUserMarry.Items.Count;

        for (int iLoop = 0; iLoop < iCount; iLoop++)
        {
            if (rblUserMarry.Items[iLoop].Value == strUserMarry)
            {
                rblUserMarry.Items[iLoop].Selected = true;
                break;
            }
        }

        if (strUserBirthday.Trim() != "")
        {
            if (strUserBirthday.Length == 8)
            {
                tbUserBdYear.Text = strUserBirthday.Substring(0, 4);
                tbUserBdMonth.Text = strUserBirthday.Substring(4, 2);
                tbUserBdDay.Text = strUserBirthday.Substring(6, 2);
            }
            else if (strUserBirthday.Length == 6)
            {
                tbUserBdYear.Text = strUserBirthday.Substring(0, 2);
                tbUserBdMonth.Text = strUserBirthday.Substring(2, 2);
                tbUserBdDay.Text = strUserBirthday.Substring(4, 2);
            }
        }

        if (strUserPosition.Trim() != "")
            tbUserPosition.Text = strUserPosition;

        if (strUserTel.Trim() != "")
        {
            string[] arrUserTel = null;

            arrUserTel = strUserTel.Split('-');

            if (arrUserTel.Length > 1)
            {
                tbUserTel1.Text = arrUserTel[0];
                tbUserTel2.Text = arrUserTel[1];
                tbUserTel3.Text = arrUserTel[2];
            }
        }

        if (strUserMobile.Trim() != "")
        {
            string[] arrMobile = null;

            arrMobile = strUserMobile.Split('-');

            if (arrMobile.Length > 1)
            {
                tbUserMobile1.Text = arrMobile[0];
                tbUserMobile2.Text = arrMobile[1];
                tbUserMobile3.Text = arrMobile[2];
            }
        }

        if (strUserZipCode.Trim() != "")
        {
            tbZipCode1.Text = strUserZipCode.Substring(0, 3);
            tbZipCode2.Text = strUserZipCode.Substring(3, 3);
        }

        if (strUserAddress1.Trim() != "")
            tbAddress1.Text = strUserAddress1;

        if (strUserAddress2.Trim() != "")
            tbAddress2.Text = strUserAddress2;
    }
    #endregion

    #region 최종학력 데이터 바인드
    /// <summary>
    /// 최종학력 데이터 바인드
    /// </summary>
    private void LastEduDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListCodeData";

            Cmd.Parameters.Clear();

            Cmd.Parameters.Add("@chrCodeClass", OleDbType.Char, 3);
            Cmd.Parameters["@chrCodeClass"].Value = "LE";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "LAST_EDU_CODE");
            dt = ds.Tables["LAST_EDU_CODE"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    ListItem li = new ListItem(dr["CODE_NAME"].ToString(), dr["CODE_ID"].ToString());
                    ddlLastEdu.Items.Add(li);
                }
            }
            ddlLastEdu.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("최종학력 코드 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 직업 데이터 바인드
    private void JobDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListCodeData";

            Cmd.Parameters.Clear();

            Cmd.Parameters.Add("@chrCodeClass", OleDbType.Char, 3);
            Cmd.Parameters["@chrCodeClass"].Value = "JO";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "JOB_CODE");
            dt = ds.Tables["JOB_CODE"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    ListItem li = new ListItem(dr["CODE_NAME"].ToString(), dr["CODE_ID"].ToString());
                    ddlUserJob.Items.Add(li);
                }
            }

            ddlUserJob.DataBind();
        }
        catch (Exception err)
        {
            Con.Close();
            WF.WriteMessage("직업 코드 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("../Config.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    protected void ibUserInfoEdit_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strUserName = tbUserName.Text;
        string strUserPwd = tbUserPwd.Value;
        string strUserPwdCfm = tbUserPwdCfm.Value;
        string strUserSex = rblUserSex.SelectedValue;
        string strUserBirthday = tbUserBdYear.Text + ChkStringSize(tbUserBdMonth.Text, 2, "0") + ChkStringSize(tbUserBdDay.Text, 2, "0");
        string strLastEdu = ddlLastEdu.SelectedValue;
        string strUserJob = ddlUserJob.SelectedValue;
        string strUserMarry = rblUserMarry.SelectedValue;
        string strUserPosition = tbUserPosition.Text;
        string strUserTel = tbUserTel1.Text + "-" + tbUserTel2.Text + "-" + tbUserTel3.Text;
        string strUserMobile = tbUserMobile1.Text + "-" + tbUserMobile2.Text + "-" + tbUserMobile3.Text;
        //string strZipCode = tbZipCode1.Text + tbZipCode2.Text;
        //string strUserAddress1 = tbAddress1.Text;
        string strZipCode = hidZipCode.Value;
        string strUserAddress1 = hidAddress1.Value;
        string strUserAddress2 = tbAddress2.Text;
        bool result = false;

        if (strUserPwd != strUserPwdCfm)
        {
            WF.WriteMessage("비밀번호가 틀립니다.\\r\\n\\r\\n비밀번호를 확인해 주세요.");
            WF.MovePage("UserInfo.aspx");
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("UserInfo.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyUserInfo";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Name)
            sParams = Cmd.Parameters.Add("@varUserName", OleDbType.VarWChar, strUserName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Password)
            sParams = Cmd.Parameters.Add("@varUserPwd", OleDbType.VarChar, strUserPwd.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Sex)
            sParams = Cmd.Parameters.Add("@chrUserSex", OleDbType.Char, strUserSex.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Birthday)
            sParams = Cmd.Parameters.Add("@chrBirthday", OleDbType.Char, strUserBirthday.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Last Education)
            sParams = Cmd.Parameters.Add("@chrLastEdu", OleDbType.Char, strLastEdu.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Job)
            sParams = Cmd.Parameters.Add("@chrJob", OleDbType.Char, strUserJob.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Marry)
            sParams = Cmd.Parameters.Add("@chrMarry", OleDbType.Char, strUserMarry.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Position)
            sParams = Cmd.Parameters.Add("@varPosition", OleDbType.VarWChar, strUserPosition.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Tel)
            sParams = Cmd.Parameters.Add("@chrTel", OleDbType.Char, strUserTel.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Mobile)
            sParams = Cmd.Parameters.Add("@chrMobile", OleDbType.Char, strUserMobile.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Zip Code)
            sParams = Cmd.Parameters.Add("@chrZipCode", OleDbType.Char, strZipCode.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Address1)
            sParams = Cmd.Parameters.Add("@varAddress1", OleDbType.VarWChar, strUserAddress1.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Address2)
            sParams = Cmd.Parameters.Add("@varAddress2", OleDbType.VarWChar, strUserAddress2.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varUserName"].Value = strUserName;
            Cmd.Parameters["@varUserPwd"].Value = strUserPwd;
            Cmd.Parameters["@chrUserSex"].Value = strUserSex;
            Cmd.Parameters["@chrBirthday"].Value = strUserBirthday;
            Cmd.Parameters["@chrLastEdu"].Value = strLastEdu;
            Cmd.Parameters["@chrJob"].Value = strUserJob;
            Cmd.Parameters["@chrMarry"].Value = strUserMarry;
            Cmd.Parameters["@varPosition"].Value = strUserPosition;
            Cmd.Parameters["@chrTel"].Value = strUserTel;
            Cmd.Parameters["@chrMobile"].Value = strUserMobile;
            Cmd.Parameters["@chrZipCode"].Value = strZipCode;
            Cmd.Parameters["@varAddress1"].Value = strUserAddress1;
            Cmd.Parameters["@varAddress2"].Value = strUserAddress2;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                Trans.Rollback();
                WF.WriteMessage(strUserId + "사용자 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("UserInfo.aspx");
                return;
            }

            Member mem = new Member();

            mem.ConnectionString = strCon;
            mem.Domain = strDomain;
            mem.MemberId = strUserId;
            mem.MemberName = strUserName;
            mem.EmailAddr = strUserName + "@" + strDomain;

            if (strUserPwd.Trim() != "")
                mem.MemberPwd = strUserPwd;

            mem.Birthday = strUserBirthday;
            mem.TelNo = strUserTel;
            mem.CellNo = strUserMobile;
            mem.ZipCode = strZipCode;
            mem.Address1 = strUserAddress1;
            mem.Address2 = strUserAddress2;
            mem.Job = strUserJob;

            try
            {
                result = mem.ModifyMemberInfo();
            }
            catch (Exception err)
            {
                WF.WriteMessage(err.Message);
                return;
            }

            if (!result)
            {
                WF.WriteMessage(mem.ErrorMessage.Replace("\r\n", "\\r\\n\\r\\n"));
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage(strUserId + " 사용자의 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("UserInfo.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strUserId + " 사용자의 정보를 수정했습니다.");
        WF.MovePage("UserInfo.aspx");
    }

    private string ChkStringSize(string strValue, int intSize, string str)
    {
        string strTmp = strValue;

        if (strTmp.Length < intSize)
        {
            while (strTmp.Length != intSize)
                strTmp = str + strTmp;
        }

        return strTmp;
    }
}
