﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;

public partial class Confirm_ListConfirm : System.Web.UI.Page
{
    protected System.Web.UI.WebControls.Label lblMsg;

    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private int iPage = 0;
    private int iPageSize = 15;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strScript = "";
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();

        UI = new UserInfo(strUserId, strDomain, strCon);

        iPage = WF.StringToInt(Request.Params["iPage"], 1);

        if (!Page.IsPostBack)
        {
            this.ConfirmDataBind();
        }

        strScript = "if (!delConfirm()) return false; else return true;";
        ibDelConfirm.Attributes.Add("onclick", strScript);
    }

    #region 수신확인 데이터 바인드
    /// <summary>
    /// 수신확인 데이터를 바인드 한다.
    /// </summary>
    private void ConfirmDataBind()
    {
        string strMovePage = "";
        int iValue = 0;
        int iTotPage = 0;
        int iCount = 0;

        strMovePage = Request.PhysicalPath;
        strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();
        OleDbDataAdapter Adap;
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        try
        {
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailConfirm";

            // Command Parameter (This Page)
            sParams = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (This List Count)
            sParams = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Record Total Count)
            sParams = Cmd.Parameters.Add("@iTotCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = iPage;
            Cmd.Parameters["@iPageSize"].Value = iPageSize;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_CONFIRM");
            dt = ds.Tables["MAIL_CONFIRM"];

            iValue = int.Parse(Cmd.Parameters["@iTotCnt"].Value.ToString());

            int iRowCount = dt.Rows.Count;
            string[,] confirmData = new string[iRowCount, 8];

            foreach (DataRow dr in dt.Rows)
            {
                confirmData[iCount, 0] = dr["SEND_MAIL_ID"].ToString();
                confirmData[iCount, 1] = dr["SAVE_MAIL_ID"].ToString();
                confirmData[iCount, 2] = dr["MAIL_TYPE"].ToString();
                confirmData[iCount, 3] = dr["RECEIVE_EMAIL"].ToString();
                confirmData[iCount, 4] = dr["SEND_DATE"].ToString();
                confirmData[iCount, 5] = dr["IS_READ"].ToString();
                confirmData[iCount, 6] = dr["READ_DATE"].ToString();
                confirmData[iCount, 7] = dr["MAIL_SUBJECT"].ToString();

                iCount++;
            }

            dt.Clear();

            dt.Columns.Remove("READ_DATE");
            dt.Columns.Remove("SEND_DATE");
            dt.Columns.Remove("IS_READ");

            dt.Columns.Add("READ_DATE", System.Type.GetType("System.String"));
            dt.Columns.Add("SEND_DATE", System.Type.GetType("System.String"));
            dt.Columns.Add("IS_READ", System.Type.GetType("System.String"));

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                DataRow dr = dt.NewRow();
                // 메일 제목이 있는지 없는지 확인
                if (confirmData[iLoop, 7] != null)
                {
                    if (confirmData[iLoop, 7] == "")
                        confirmData[iLoop, 7] = "제목이 없습니다.";
                    else
                    {
                        if (confirmData[iLoop, 7].Length > 20)
                            confirmData[iLoop, 7] = confirmData[iLoop, 7].Substring(0, 20) + "...";
                    }
                }
                else
                    confirmData[iLoop, 7] = "제목이 없습니다.";

                ;
                // 메일이 보낸 편지함에 있는지 확인
                if (File.Exists(UI.UserPath + "\\outbox\\" + WF.AddFileName(UI.UserPath + "\\outbox\\" + confirmData[iLoop, 1] + ".eml", 1)))
                {
                    // 메일이 있다면 파싱해서 제목을 보여준다.
                    dr["MAIL_SUBJECT"] = "<a href=\"../Mail/viewMail.aspx?strMailBox=outbox&mailFile=" + confirmData[iLoop, 1] + ".eml&iPage=" + iPage + "\">" + confirmData[iLoop, 7] + "</a>";
                }
                else
                {
                    // 메일이 없다면 메일이 없다고 보여준다.
                    dr["MAIL_SUBJECT"] = confirmData[iLoop, 7];
                }

                // 메일을 읽었는지 안읽었는지 표시를 해준다.
                if (confirmData[iLoop, 5].ToLower() == "true")
                {
                    dr["IS_READ"] = "읽음";
                    dr["READ_DATE"] = confirmData[iLoop, 6];
                }
                else
                {
                    dr["IS_READ"] = "<b>읽지않음</b>";

                    if (confirmData[iLoop, 6] != "")
                        dr["READ_DATE"] = confirmData[iLoop, 6];
                    else
                        dr["READ_DATE"] = "----";
                }

                dr["SEND_MAIL_ID"] = confirmData[iLoop, 0];
                dr["SAVE_MAIL_ID"] = confirmData[iLoop, 1];

                // 2006년 11월 24일 수정
                // 받는 사람 메일주소값이 string 배열로 넘어 오기 때문에 DataRow에 바로 넣으면 System.String[]으로 출력되어서
                //	string 배열 변수에 담아서 처리
                string[] strMailAddr = WF.linkMailAddress(confirmData[iLoop, 3], "../Mail/writeMail.aspx?email=", 20, "...");
                dr["RECEIVE_EMAIL"] = strMailAddr[0];
                dr["SEND_DATE"] = confirmData[iLoop, 4];

                dt.Rows.Add(dr);
            }

            //iValue = 0;
            iTotPage = iValue / 15;

            if ((iTotPage % 15) > 0)
                ++iTotPage;
        }
        catch (Exception err)
        {
            WF.WriteMessage("수신확인 데이터를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "서버 관리자에게 문의하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
        }

        rptConfirm.DataSource = dt.DefaultView;
        rptConfirm.DataBind();
        lblPageLink.Text = WF.PageLink(iTotPage, iPage, strMovePage, "", 10, "", "", "", "");
    }
    #endregion

    #region 수신확인 삭제 버튼 클릭
    /// <summary>
    /// 수신확인 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelConfirm_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strConfirmId = hidSendMailId.Value;
        string[] arrConfirmId;
        string strSql = "";

        if (strConfirmId == "")
        {
            WF.WriteMessage("삭제할 수신확인 항목을 선택해 주세요.");
            WF.MovePage("ListConfirm.aspx");
            return;
        }

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();

        Con.Open();
        OleDbTransaction Trans = Con.BeginTransaction();
        Cmd.Connection = Con;
        Cmd.Transaction = Trans;

        if (strConfirmId.EndsWith("│"))
            strConfirmId = strConfirmId.Substring(0, strConfirmId.Length - 1);
        
        arrConfirmId = strConfirmId.Split('│');
        strConfirmId = "";

        for (int iLoop = 0; iLoop < arrConfirmId.Length; iLoop++)
        {
            strConfirmId += "'" + arrConfirmId[iLoop] + "',";
        }

        if (strConfirmId != "")
        {
            if (strConfirmId.EndsWith(","))
                strConfirmId = strConfirmId.Substring(0, strConfirmId.Length - 1);

            strSql = "DELETE FROM MAIL_CONFIRM WHERE SEND_MAIL_ID IN (" + strConfirmId + ") AND USER_ID = '" + Session["USER_ID"].ToString() + "' " +
                "AND USER_DOMAIN = '" + strDomain + "'";

            try
            {
                Cmd.CommandText = strSql;
                Cmd.ExecuteNonQuery();

                Trans.Commit();
            }
            catch (Exception err)
            {
                Con.Close();

                WF.WriteMessage("선택한 수신확인 정보를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                WF.HistoryBack();
            }
            finally
            {
                Con.Close();
            }

            for (int iLoop = 0; iLoop < arrConfirmId.Length; iLoop++)
            {
                if (arrConfirmId[iLoop].Trim() != "")
                {
                    if (File.Exists(UI.UserPath + "\\outbox\\" + WF.AddFileName(UI.UserPath + "\\outbox\\" + arrConfirmId[iLoop] + ".eml", 1)))
                        File.Delete(UI.UserPath + "\\outbox\\" + WF.AddFileName(UI.UserPath + "\\outbox\\" + arrConfirmId[iLoop] + ".eml", 1));
                }
            }

            WF.WriteMessage("선택한 수신확인 정보를 삭제했습니다.");
            WF.MovePage("ListConfirm.aspx");
        }
    }
    #endregion
}
