﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Log_Login : System.Web.UI.Page
{
    // 웹하드에서 필요한 모듈
    public JavaScript _js = new JavaScript();
    public Member mem = new Member();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();

    private System.Web.HttpCookie cookie;
    private string strCon = System.Configuration.ConfigurationSettings.AppSettings["strConnection"];
    //private string strDomain = ConfigurationSettings.AppSettings["strDomain"];

    private string strErrMsg;
    private UserInfo UI;
    private WebFunction WF;

    protected void Page_Load(object sender, EventArgs e)
    {
        string strScript = "";
        _js.Page = this.Page;
        WF = new WebFunction(this.Page);

        if (!Page.IsPostBack)
        {
            if (Request.Cookies["USER_ID"] != null)
            {
                // 정상 패키지 로그인 셋팅
                if (Server.HtmlEncode(Request.Cookies["USER_ID"]["IdSave"]) == "Yes")
                {
                    chkUserIdSave.Checked = true;
                    tbUserId.Text = Server.HtmlEncode(Request.Cookies["USER_ID"]["User_Id"]);
                }
                else
                {
                    chkUserIdSave.Checked = false;
                    tbUserId.Text = "";
                }
            }
        }

        strScript = "if (UserLogin()) return true; else return false;";
        ibUserLogin.Attributes.Add("onclick", strScript);
    }

    /// <summary>
    /// 쿠키값을 설정한다.
    /// </summary>
    private void SetCookie()
    {
        string strUserId = tbUserId.Text;
        bool bUserIdSave = chkUserIdSave.Checked;
        string flag = "";


        if (strUserId != "")
        {
            if (bUserIdSave)
                flag = "Yes";
            else
                flag = "No";

            cookie = new HttpCookie("USER_ID");
            cookie["User_Id"] = strUserId;
            cookie["Domain"] = Session["MAIL_DOMAIN"].ToString();
            cookie["IdSave"] = flag;
            cookie.Expires = DateTime.Now.AddDays(365);
            cookie.Path = "/";

            Response.Cookies.Add(cookie);
        }
    }

    private void SetWebhardCookie()
    {
        // 쿠키를 초기화 한다.
        Request.Cookies.Clear();

        HttpCookie ck = new HttpCookie("WB_MEMBER_INFO");
        ck["WB_MEMBER_ID"] = mem.MemberId;
        ck["WB_MEMBER_NAME"] = Server.UrlEncode(mem.MemberName);
        ck["WB_DOMAIN"] = Request.Url.Host;
        ck["WB_MEMBER_PATH"] = mem.Path;
        //ck.Path = "/Webhard_" + Request.Url.Host;
        ck.Path = "/";
        ck.Expires = DateTime.Now.AddDays(1);

        Response.Cookies.Add(ck);

        Response.Cookies["WB_MEMBER_INFO"].Domain = Request.Url.Host;
    }

    public void UserJoin(object sender, System.EventArgs e)
    {
        Response.Redirect("../User/UserJoin.aspx");
    }

    protected void ibUserLogin_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strUserId = tbUserId.Text;
        string strUserPwd = tbUserPwd.Value;
        string strSessionID = Session.SessionID;
        string strRemoteIP = Request.UserHostAddress;
        string strDomain = Request.Url.Host;

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        if (strUserId.Trim() == "")
        {
            _js.MessageBox("아이디를 입력해 주세요.");
            return;
        }
        else if (strUserPwd.Trim() == "")
        {
            _js.MessageBox("비밀번호를 입력해 주세요.");
            return;
        }

        // 도메인이 등록된 도메인인지 확인하고 등록되지 않은 도메인이면
        // 기본도메인으로 설정한다.

        ArrayList DomainList = Passkorea.Configuration.DomainList();

        if (DomainList != null)
        {
            bool bDomain = false;
            int iCnt = strDomain.Split('.').Length;

            // 도메인이 아이피인지 확인한다.
            /*
            if (iCnt == 4)
            {
                if (DomainCheckIp(strDomain))
                    strDomain = Passkorea.Configuration.DomainList()[0].ToString();
            }
            */

            for (int i = 0; i < iCnt; i++)
            {
                for (int iDomainCount = 0; iDomainCount < DomainList.Count; iDomainCount++)
                {
                    if (DomainList[iDomainCount].ToString() == strDomain)
                    {
                        strDomain = DomainList[iDomainCount].ToString();
                        bDomain = true;
                        break;
                    }
                }

                if (bDomain)
                    break;

                int iPos = strDomain.IndexOf(".");

                if (iPos > -1)
                    strDomain = strDomain.Substring(iPos + 1);
            }

            if (!bDomain)
            {
                WF.WriteMessage("입력된 도메인은 메일서버에 등록되지 않은 도메인 입니다.\\r\\n접속 하는 도메인을 확인해주시거나 서버 관리자에게 문의하세요.\\r\\n" +
                    "접속도메인: " + Request.Url.Host);
                WF.HistoryBack();
                return;
            }

            Session["MAIL_DOMAIN"] = strDomain;
        }
        else
        {
            WF.WriteMessage("메일서버에 도메인이 등록되어 있지 않습니다.\\r\\n서버 관리자에게 문의하세요.");
            WF.HistoryBack();
            return;
        }

        if (strCon != "" && strCon != null)
        {
            try
            {
                Con.Open();
            }
            catch (Exception err)
            {
                WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                    err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
                WF.MovePage("Login.aspx");
                return;
            }

            try
            {
                Cmd.Connection = Con;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prLoginUser";

                // Command Parameter (Execute Return Value)
                sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                sParams.Direction = ParameterDirection.ReturnValue;

                // Command Parameter (User Id)
                sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (Domain)
                sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, Session["MAIL_DOMAIN"].ToString().Length);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (User Password)
                sParams = Cmd.Parameters.Add("@varUserPwd", OleDbType.VarChar, strUserPwd.Length);

                // Command Parameter (Session ID)
                sParams = Cmd.Parameters.Add("@varSessionID", OleDbType.VarChar, strSessionID.Length);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (Remote IP)
                sParams = Cmd.Parameters.Add("@varRemoteIP", OleDbType.VarChar, strRemoteIP.Length);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (Output Value)
                sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
                sParams.Direction = ParameterDirection.Output;

                Cmd.Parameters["@varUserId"].Value = strUserId;
                Cmd.Parameters["@varDomain"].Value = Session["MAIL_DOMAIN"].ToString();
                Cmd.Parameters["@varUserPwd"].Value = strUserPwd;
                Cmd.Parameters["@varSessionID"].Value = strSessionID;
                Cmd.Parameters["@varRemoteIP"].Value = Request.UserHostAddress;

                OleDbDataAdapter Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "MAIL_USER");
                dt = ds.Tables["MAIL_USER"];

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    WF.WriteMessage("로그인 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                    WF.HistoryBack();
                    return;
                }
                else if (iValue != 0)
                {
                    WF.WriteMessage("로그인 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    WF.HistoryBack();
                    return;
                }

                Con.Close();

                UI = new UserInfo(strUserId, strDomain, strCon);

                if (UI.ErrMsg != "")
                {
                    WF.WriteMessage(UI.ErrMsg.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                    return;
                }

                if (!Directory.Exists(UI.UserPath + "\\temp"))
                    Directory.CreateDirectory(UI.UserPath + "\\temp");

                if (!Directory.Exists(UI.UserPath + "\\SaveBox"))
                    Directory.CreateDirectory(UI.UserPath + "\\SaveBox");

                Session["USER_ID"] = strUserId;

                // 쿠키 설정
                this.SetCookie();
            }
            catch (Exception err)
            {
                WF.WriteMessage("로그인 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n") + "\\r\\n\\r\\n" +
                    "오류 발생 객체: " + err.Source);
                return;
            }

            AuthKey ak = new AuthKey();
            string strMsg = ak.CheckUserCount(UI.TotalUserCount(strDomain));

            if (strMsg != "")
                WF.WriteMessage(strMsg.Replace("\r\n", "\\r\\n"));

            // 웹하드 로그인
            mem.ConnectionString = strCon;
            mem.Domain = Session["MAIL_DOMAIN"].ToString();
            mem.MemberId = strUserId;
            mem.MemberPwd = strUserPwd;

            // 웹하드 회원 테이블에 사용자가 없으면 사용자를 등록한다.
            if (!mem.Login())
            {
                mem.Domain = strDomain;
                mem.MemberName = strUserId;
                mem.EmailAddr = strUserId + "@" + strDomain;
                mem.Path = System.Configuration.ConfigurationSettings.AppSettings["WebhardPath"] + "\\" + strDomain + "\\User_Data\\" + strUserId;
                mem.AllocateSize = int.Parse(System.Configuration.ConfigurationSettings.AppSettings["UserDefaultSize"]);
                mem.Permission = "M1";

                if (!mem.JoinMember())
                {
                    WF.WriteMessage(mem.ErrorMessage.Replace("\r\n", "\\r\\n\\r\\n"));
                    WF.HistoryBack();
                    return;
                }

                if (!mem.LoadMemberInfo(strUserId))
                    return;
            }

            _login.ConnectionString = strCon;

            if (Request.Cookies["WB_MEMBER_INFO"] != null)
            {
                if (Session["LOGIN_INFO"] != null)
                {
                    int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                    _login.Logout(strDomain, strUserId, idxNo);
                }
                else
                {
                    // 새 브라우저 또는 다른 원격지에서 로그인 할 경우
                    if (_login.CheckLoginState(strDomain, strUserId))
                        _login.Logout(strDomain, strUserId, _login.LoginIdxNo);
                }
            }
            else
            {
                if (_login.CheckLoginState(strDomain, strUserId))
                    _login.Logout(strDomain, strUserId, _login.LoginIdxNo);
            }

            if (!_login.AddLoginInfo(strDomain, strUserId, Request.UserHostAddress))
            {
                _js.MessageBox("로그인 정보가 기록되지 않았습니다.\r\n" + _login.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            Session["LOGIN_INDEX"] = _login.LoginIdxNo;
            // 세션 허용시간 설정
            Session.Timeout = 60;

            this.SetWebhardCookie();

            if (!System.IO.Directory.Exists(mem.Path))
                System.IO.Directory.CreateDirectory(mem.Path);

            WF.MovePage("../Main.aspx");
        }
    }

    private bool DomainCheckIp(string strValue)
    {
        bool bIp = false;
        if (strValue.Trim() == "")
        {
            return false;
        }

        string[] strIp = strValue.Split('.');

        for (int i = 0; i < strIp.Length; i++)
        {
            try
            {
                int iIp = int.Parse(strIp[i]);
            }
            catch
            {
                bIp = false;
                break;
            }

            bIp = true;
        }

        return bIp;
    }

    public string ErrMsg
    {
        get { return strErrMsg; }
        set { strErrMsg = value; }
    }
}
