﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Mail_AddAddress : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    protected string strEmail = "";
    protected string strName = "";

    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/Login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strEmail = Request.Params["email"];
        strName = Request.Params["name"];
        strUserId = Session["USER_ID"].ToString();

        this.GroupListDataBind();

        Page.DataBind();
    }

    #region 그룹 리스트 데이터 바인드
    /// <summary>
    /// 그룹 리스트 데이터를 바인드한다.
    /// </summary>
    private void GroupListDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupName";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 개인 주소록
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrCommon"].Value = "N";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP");
            dt = ds.Tables["MAIL_GROUP"];

            int iRowCnt = dt.Rows.Count + 1;

            string[,] arrGroup = new string[iRowCnt, 2];

            arrGroup[0, 0] = "미지정";
            arrGroup[0, 1] = "";

            for (int iLoop = 1; iLoop < iRowCnt; iLoop++)
            {
                arrGroup[iLoop, 0] = dt.Rows[iLoop - 1]["GROUP_NAME"].ToString();
                arrGroup[iLoop, 1] = arrGroup[iLoop, 0] + "│N";
            }

            // 공유 주소록
            Cmd.Parameters["@chrCommon"].Value = "Y";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP_COMMON");
            dt = ds.Tables["MAIL_GROUP_COMMON"];

            int iCommonRowCnt = dt.Rows.Count;

            string[,] arrCommonGroup = new string[iCommonRowCnt, 2];

            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                arrCommonGroup[iLoop, 0] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                arrCommonGroup[iLoop, 1] = arrCommonGroup[iLoop, 0] + "│Y";
            }

            // 개인 주소록을 그룹(Drop Down List) 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrGroup[iLoop, 0], arrGroup[iLoop, 1]);
                ddlGroup.Items.Add(li);
            }

            // 공유 주소록을 그룹(Drop Down List) 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrCommonGroup[iLoop, 0] + "(공유)", arrCommonGroup[iLoop, 1]);
                ddlGroup.Items.Add(li);
            }

            ddlGroup.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("그룹 리스트 데이터를 바인드 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 주소록 추가
    /// <summary>
    /// 주소록 추가
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAddAddress_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strGroup = ddlGroup.SelectedValue;
        string isCommon = "";
        int iPos = 0;

        // 그룹이 개인 그룹인지 공유 그룹인지 확인한다.
        // 그룹 컨트롤에서 선택된 Value에 그룹 구분자가 들어있다.
        iPos = strGroup.LastIndexOf("│");

        if (iPos > 0)
        {
            isCommon = strGroup.Substring(iPos + 1, 1);
            strGroup = strGroup.Substring(0, iPos);
        }
        else
            isCommon = "N";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.WndClose();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertQEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User ID)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, strGroup.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address)
            sParams = Cmd.Parameters.Add("@varEmailAddr", OleDbType.VarChar, strEmail.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Name)
            sParams = Cmd.Parameters.Add("@varEmailName", OleDbType.VarWChar, strName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Telephone)
            sParams = Cmd.Parameters.Add("@chrTel", OleDbType.Char, 13);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroupName"].Value = strGroup;
            Cmd.Parameters["@varEmailAddr"].Value = strEmail;
            Cmd.Parameters["@varEmailName"].Value = strName;
            Cmd.Parameters["@chrCommon"].Value = isCommon;
            Cmd.Parameters["@chrTel"].Value = "";

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage(strEmail + " 메일주소를 주소록에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.WndClose();
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage(strEmail + " 메일주소를 주소록에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.WndClose();
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage(strEmail + " 메일을 주소록에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\"", "\\\""));
            WF.WndClose();
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strEmail + " 주소를 주소록에 등록 했습니다.");
        WF.WndClose();
    }
    #endregion
}
