﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Mail_AddSpammer : System.Web.UI.Page
{
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/Login.aspx", true);

        string strEmail = Request.Params["email"];
        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();

        tbEmail.Text = strEmail;
        Page.DataBind();
    }

    protected void ibAddReject_Click(object sender, System.Web.UI.ImageClickEventArgs e)
	{
		string strEmail = tbEmail.Text;

		OleDbConnection Con = new OleDbConnection(strCon);
		OleDbTransaction Trans = null;
		OleDbCommand Cmd = new OleDbCommand();
		OleDbParameter sParams = new OleDbParameter();

		try
		{
			Con.Open();
			Trans = Con.BeginTransaction();
		} 
		catch (Exception err)
		{
			Trans.Rollback();
			Con.Close();
			WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
				err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
			WF.WndClose();
			return;
		}

		try
		{
			Cmd.Connection = Con;
			Cmd.Transaction = Trans;
			Cmd.CommandType = CommandType.StoredProcedure;
			Cmd.CommandText = "prInsertRejectEmail";
            
            // Command Parameter (Execute Return Value)
			sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
			sParams.Direction = ParameterDirection.ReturnValue;

			// Command Parameter (User Id)
			sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Domain)
			sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Reject Email Address)
			sParams = Cmd.Parameters.Add("@varRejectEmail", OleDbType.VarChar, strEmail.Length);
			sParams.Direction = ParameterDirection.Input;

			// Command Parameter (Output Value)
			sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
			sParams.Direction = ParameterDirection.Output;

			// Command Parameter Value Setting
			Cmd.Parameters["@varUserId"].Value = strUserId;
			Cmd.Parameters["@varDomain"].Value = strDomain;
			Cmd.Parameters["@varRejectEmail"].Value = strEmail;

			Cmd.ExecuteNonQuery();

			int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

			if (iValue < 0)
			{
				Trans.Rollback();
				WF.WriteMessage(strEmail + " 메일 주소를 수신거부에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
					"오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
				WF.WndClose();
				return;
			} 
			else if (iValue != 0)
			{
				Trans.Rollback();
				WF.WriteMessage(strEmail + " 메일 주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
					"SQL Error Number: " + iValue.ToString());
				WF.WndClose();
				return;
			}
					
			Trans.Commit();
		} 
		catch (Exception err)
		{
			Trans.Rollback();
			Con.Close();
			WF.WriteMessage(strEmail + "메일을 수신거부에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
				err.Message.Replace("\\", "\\\\").Replace("\"", "\\\""));
			WF.WndClose();
			return;
		}
		finally
		{
			Con.Close();
		}
		
		WF.WriteMessage("선택한 메일을 수신거부에 등록 했습니다.");
		WF.WndClose();
	}
}
