﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Mail_ConfirmMail : System.Web.UI.Page
{
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strCode = Request.Params["code"];

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbTransaction Trans = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();

        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch
        {
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyMailConfirm";

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;
            
            // Command Parameter (Mail Confirm Code)
            sParams = Cmd.Parameters.Add("@varCode", OleDbType.VarChar, strCode.Length);
            sParams.Direction = ParameterDirection.Input;
            
            Cmd.Parameters["@varCode"].Value = strCode;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
                Trans.Rollback();
            else
                Trans.Commit();
        }
        catch
        {
        }
        finally
        {
            Con.Close();
        }
    }
}
