﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Mail_FrmMailAddr : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string strSt = "";
    private string strEd = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strSt = Request.Params["strSt"];
        strEd = Request.Params["strEd"];

        if (!Page.IsPostBack)
        {
            this.GroupDataBind();

            if ((strSt == "" && strEd == "") || (strSt == null || strEd == null))
                this.GroupListChanged();
            else
                this.StringSearch(strSt, strEd);
        }

        string strScript = "if (!SearchValue()) return false; else return true;";
        ibSearch.Attributes.Add("onclick", strScript);
    }

    #region 그룹 데이터 바인드
    /// <summary>
    /// 그룹 리스트 데이터를 바인드 한다.
    /// </summary>
    private void GroupDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupName";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrCommon"].Value = "N";

            // 개인 그룹
            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP");
            dt = ds.Tables["MAIL_GROUP"];

            int iRowCnt = dt.Rows.Count;

            string[,] arrGroup = new string[iRowCnt + 1, 2];

            arrGroup[0, 0] = "전체";
            arrGroup[0, 1] = "";

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                arrGroup[iLoop + 1, 0] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                arrGroup[iLoop + 1, 1] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
            }

            Cmd.Parameters["@chrCommon"].Value = "Y";

            // 공유 주소록
            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP_COMMON");
            dt = ds.Tables["MAIL_GROUP_COMMON"];

            int iCommonRowCnt = dt.Rows.Count;

            string[,] arrCommonGroup = new string[iCommonRowCnt, 2];

            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                arrCommonGroup[iLoop, 0] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                arrCommonGroup[iLoop, 1] = arrCommonGroup[iLoop, 0] + "│Y";
            }

            // 개인 주소록을 그룹 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iRowCnt + 1; iLoop++)
            {
                ListItem li = new ListItem(arrGroup[iLoop, 0], arrGroup[iLoop, 1]);
                ddlGroupList.Items.Add(li);
            }

            // 공유 주소록을 그룹(Drop Down List) 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrCommonGroup[iLoop, 0] + "(공유)", arrCommonGroup[iLoop, 1]);
                ddlGroupList.Items.Add(li);
            }
            ddlGroupList.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("그룹 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 그룹 변경
    /// <summary>
    /// 그룹 변경
    /// </summary>
    private void GroupListChanged()
    {
        this.GroupListChanged("");
    }

    private void GroupListChanged(string strGroup)
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }

        try
        {
            string strGroupInfo = "";
            string strGroupInfo2 = "";
            string[] arrGroup = null;
            string strCommon = "";

            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            if (strGroup == "")
            {
                Cmd.CommandText = "prListUserGroup";

                Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "CHANGE_MAIL_GROUP");
                dt = ds.Tables["CHANGE_MAIL_GROUP"];

                // 2006년 11월 22일 수정
                // 그룹에 구분자를 넣어서 공유 그룹인지 개인 그룹인지 확인하게 만든다.
                foreach (DataRow dr in dt.Rows)
                {
                    strGroupInfo += "[그룹] " + dr["GROUP_NAME"].ToString() + " (" + dr["EMAIL_COUNT"].ToString() + ")|";
                    strGroupInfo2 += "⊙" + dr["GROUP_NAME"].ToString() + "‡" + dr["IS_COMMON"].ToString() + "|";
                }

                if (strGroupInfo.Trim() != "")
                    strGroupInfo = strGroupInfo.Substring(0, strGroupInfo.LastIndexOf("|"));

                if (strGroupInfo2.Trim() != "")
                    strGroupInfo2 = strGroupInfo2.Substring(0, strGroupInfo2.LastIndexOf("|"));

                Adap = null;
            }
            else
            {
                arrGroup = strGroup.Split('│');

                if (arrGroup.Length < 2)
                {
                    strGroup = arrGroup[0];
                    strCommon = "N";
                }
                else
                {
                    strGroup = arrGroup[0];
                    strCommon = arrGroup[1];
                }
            }

            string[] arrGroupInfo = strGroupInfo.Split('|');
            string[] arrGroupInfo2 = strGroupInfo2.Split('|');

            Cmd.CommandText = "prListUserEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroup.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroup;
            Cmd.Parameters["@chrCommon"].Value = strCommon;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "GROUP_MAIL_ADDRESS");
            dt = ds.Tables["GROUP_MAIL_ADDRESS"];

            int iRowCnt = dt.Rows.Count;

            string[,] arrEmailInfo = new string[iRowCnt, 2];

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                arrEmailInfo[iLoop, 0] = dt.Rows[iLoop]["EMAIL_NAME"].ToString() + " (" + dt.Rows[iLoop]["EMAIL_ADDR"].ToString() + ")";
                arrEmailInfo[iLoop, 1] = dt.Rows[iLoop]["EMAIL_ADDR"].ToString();
            }

            dt.Rows.Clear();

            if (strGroupInfo != "")
            {
                for (int iLoop = 0; iLoop < arrGroupInfo.Length; iLoop++)
                {
                    DataRow dr = dt.NewRow();
                    dr["EMAIL_NAME"] = arrGroupInfo[iLoop];
                    dr["EMAIL_ADDR"] = arrGroupInfo2[iLoop];
                    dt.Rows.Add(dr);
                }
            }

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();
                dr["EMAIL_NAME"] = arrEmailInfo[iLoop, 0];
                dr["EMAIL_ADDR"] = arrEmailInfo[iLoop, 1];
                dt.Rows.Add(dr);
            }

            lbAddrList.DataSource = dt.DefaultView;
            lbAddrList.DataTextField = "EMAIL_NAME";
            lbAddrList.DataValueField = "EMAIL_ADDR";
        }
        catch (Exception err)
        {
            string strGroupName = "";

            if (strGroup == "")
                strGroupName = "전체 그룹";
            else
                strGroupName = strGroup;

            WF.WriteMessage(strGroupName + "을(를) 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }

        lbAddrList.DataBind();
    }
    #endregion

    #region 리스트 박스에 아이템 추가
    /// <summary>
    /// 해당 리스트 박스에 아이템을 추가한다.
    /// </summary>
    /// <param name="lb"></param>
    private void AddItem(System.Web.UI.WebControls.ListBox lb)
    {
        int iCnt = lbAddrList.Items.Count;
        string strSelectItem = "";

        for (int iLoop = 0; iLoop < iCnt; iLoop++)
        {
            if (lbAddrList.Items[iLoop].Selected)
                strSelectItem += lbAddrList.Items[iLoop].Text + "|" + lbAddrList.Items[iLoop].Value + ",";
        }

        if (strSelectItem == "")
        {
            WF.WriteMessage("선택된 주소(또는 그룹)이 없습니다.");
            return;
        }

        strSelectItem = strSelectItem.Substring(0, strSelectItem.LastIndexOf(","));

        string[] arrSelectItem = strSelectItem.Split(',');

        for (int iLoop = 0; iLoop < arrSelectItem.Length; iLoop++)
        {
            string[] arrItem = arrSelectItem[iLoop].Split('|');
            bool bExists = false;

            for (int iLoop2 = 0; iLoop2 < lb.Items.Count; iLoop2++)
            {
                if (arrItem[1] == lb.Items[iLoop2].Value)
                {
                    bExists = true;
                    break;
                }
            }

            if (!bExists)
            {
                ListItem li = new ListItem(arrItem[0], arrItem[1]);
                lb.Items.Add(li);
            }
        }
    }
    #endregion

    #region 리스트 박스에 아이템 삭제
    /// <summary>
    /// 리스트 박스에 있는 선택된 아이템을 삭제한다.
    /// </summary>
    /// <param name="lb"></param>
    private void RemoveItem(System.Web.UI.WebControls.ListBox lb)
    {
        int iCnt = lb.Items.Count - 1;

        for (int iLoop = iCnt; 0 <= iLoop; --iLoop)
        {
            if (lb.Items[iLoop].Selected)
                lb.Items.Remove(lb.Items[iLoop]);
        }
    }
    #endregion

    #region 주소록 이름 검색
    /// <summary>
    /// 주소록을 이름 첫자로 검색한다.
    /// </summary>
    /// <param name="strSt"></param>
    /// <param name="strEd"></param>
    private void StringSearch(string strSt, string strEd)
    {
        string strGroupName = ddlGroupList.SelectedValue;
        string strCommon = "";

        if (strGroupName.LastIndexOf("│") > 0)
        {
            strGroupName = strGroupName.Substring(0, strGroupName.LastIndexOf("|"));
            strGroupName = "Y";
        }
        else
            strCommon = "N";
        
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prStringSearchAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group)
            sParams = Cmd.Parameters.Add("@chrIsCommon", OleDbType.Char, strCommon.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Start Search String)
            sParams = Cmd.Parameters.Add("@chrSchSt", OleDbType.WChar, 2);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (End Search String)
            sParams = Cmd.Parameters.Add("@chrSchEd", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Total Count)
            sParams = Cmd.Parameters.Add("@iTotCount", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroupName;
            Cmd.Parameters["@chrIsCommon"].Value = strCommon;
            Cmd.Parameters["@chrSchSt"].Value = strSt;
            Cmd.Parameters["@chrSchEd"].Value = strEd;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SEARCH_MAIL_ADDRESS");
            dt = ds.Tables["SEARCH_MAIL_ADDRESS"];

            int iAddrRowCnt = dt.Rows.Count;
            string[,] arrEmailInfo = new string[iAddrRowCnt, 2];

            for (int iLoop = 0; iLoop < iAddrRowCnt; iLoop++)
            {
                arrEmailInfo[iLoop, 0] = dt.Rows[iLoop]["EMAIL_NAME"].ToString() + " (" + dt.Rows[iLoop]["EMAIL_ADDR"].ToString() + ")";
                arrEmailInfo[iLoop, 1] = dt.Rows[iLoop]["EMAIL_ADDR"].ToString();
            }

            dt.Rows.Clear();

            // 2006년 11월 23일 추가
            // 그룹 ㄱ~ㅎ 검색 추가
            Cmd.CommandText = "prStringSearchGroup";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Start Search String)
            sParams = Cmd.Parameters.Add("@chrSchSt", OleDbType.WChar, 2);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (End Search String)
            sParams = Cmd.Parameters.Add("@chrSchEd", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrSchSt"].Value = strSt;
            Cmd.Parameters["@chrSchEd"].Value = strEd;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SEARCH_MAIL_GROUP");
            dt = ds.Tables["SEARCH_MAIL_GROUP"];

            int iGrpRowCnt = dt.Rows.Count;
            string[,] arrGroupInfo = new string[iGrpRowCnt, 2];

            for (int iLoop = 0; iLoop < iGrpRowCnt; iLoop++)
            {
                string strCmn = dt.Rows[iLoop]["IS_COMMON"].ToString();

                arrGroupInfo[iLoop, 0] = "[그룹] " + dt.Rows[iLoop]["GROUP_NAME"].ToString() + " (" + dt.Rows[iLoop]["EMAIL_COUNT"].ToString() + ")";
                arrGroupInfo[iLoop, 1] = "⊙" + dt.Rows[iLoop]["GROUP_NAME"].ToString() + "‡" + dt.Rows[iLoop]["IS_COMMON"].ToString();
            }

            dt.Rows.Clear();
            dt.Columns.Add("EMAIL_NAME", Type.GetType("System.String"));
            dt.Columns.Add("EMAIL_ADDR", Type.GetType("System.String"));

            for (int iLoop = 0; iLoop < iGrpRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();
                dr["EMAIL_NAME"] = arrGroupInfo[iLoop, 0];
                dr["EMAIL_ADDR"] = arrGroupInfo[iLoop, 1];
                dt.Rows.Add(dr);
            }
            // 2006년 11월 23일 추가 완료

            for (int iLoop = 0; iLoop < iAddrRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();
                dr["EMAIL_NAME"] = arrEmailInfo[iLoop, 0];
                dr["EMAIL_ADDR"] = arrEmailInfo[iLoop, 1];
                dt.Rows.Add(dr);
            }

            lbAddrList.DataSource = dt.DefaultView;
            lbAddrList.DataTextField = "EMAIL_NAME";
            lbAddrList.DataValueField = "EMAIL_ADDR";
        }
        catch (Exception err)
        {
            WF.WriteMessage("'" + strSt + "' 검색어로 주소록을 검색하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }

        lbAddrList.DataBind();
    }
    #endregion

    #region 주소록 검색
    /// <summary>
    /// 주소록 검색
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strSch = tbSearch.Text;

        if (strSch == "")
            return;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("FrmMailAddr.aspx");
            return;

        }
        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSearchAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Search String)
            sParams = Cmd.Parameters.Add("@varSch", OleDbType.VarWChar, strSch.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varSch"].Value = strSch;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];

            int iRowCnt = dt.Rows.Count;
            string[,] arrEmailInfo = new string[iRowCnt, 2];

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                arrEmailInfo[iLoop, 0] = dt.Rows[iLoop]["EMAIL_NAME"].ToString() + " (" + dt.Rows[iLoop]["EMAIL_ADDR"].ToString() + ")";
                arrEmailInfo[iLoop, 1] = dt.Rows[iLoop]["EMAIL_ADDR"].ToString();
            }

            dt.Rows.Clear();

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();
                dr["EMAIL_NAME"] = arrEmailInfo[iLoop, 0];
                dr["EMAIL_ADDR"] = arrEmailInfo[iLoop, 1];
                dt.Rows.Add(dr);
            }

            lbAddrList.DataSource = dt.DefaultView;
            lbAddrList.DataTextField = "EMAIL_NAME";
            lbAddrList.DataValueField = "EMAIL_ADDR";
        }
        catch (Exception err)
        {
            WF.WriteMessage("'" + strSch + "' 검색어로 주소록을 검색하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("FrmMailAddr.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        lbAddrList.DataBind();
    }
    #endregion

    protected void ddlGroupList_SelectedIndexChanged(object sender, EventArgs e)
    {
        string strGroup = ddlGroupList.SelectedValue;

        this.GroupListChanged(strGroup);
    }

    protected void ibAddListTo_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.AddItem(lbSendTo);
    }

    protected void ibRemoveListTo_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.RemoveItem(lbSendTo);
    }

    protected void ibAddListCc_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.AddItem(lbSendCc);
    }

    protected void ibRemoveListCc_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.RemoveItem(lbSendCc);
    }

    protected void ibAddListBcc_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.AddItem(lbSendBcc);
    }

    protected void ibRemoveListBcc_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.RemoveItem(lbSendBcc);
    }
}
