﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;

public partial class Mail_ListMail : System.Web.UI.Page
{
    protected System.Web.UI.WebControls.Label lblMailId;

    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string strMovePage = "";
    private string mailFilePath = "";
    private string strListCount = "";
    protected string strPage = "";
    protected string strMailBox = "";
    protected string strMailBoxName = "";
    protected string strPageLink = "";
    protected string strMailNameTag = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strScript = "";
        
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["strMailBox"];
        strPage = Request.Params["iPage"];
        strListCount = Request.Params["listCnt"];
        mailFilePath = UI.UserPath;
        strMovePage = Request.PhysicalPath;

        if (strMailBox == "" || strMailBox == null) strMailBox = "inbox";

        if (!Page.IsPostBack)
        {
            this.MailBoxDataBind();
            this.MailBoxNameBind();

            if (strMailBox.ToLower() == "delbox")
                ibRestoreMail.Visible = true;

            if (strMailBox.ToLower() == "outbox" || strMailBox.ToLower() == "savebox")
                strMailNameTag = "받는이";
            else
                strMailNameTag = "보낸이";

            try
            {
                if (strListCount != "" && strListCount != null)
                    ddlListCount.SelectedValue = strListCount;
            }
            catch
            {
                ddlListCount.SelectedIndex = 0;
            }

            this.MailDataBind();
            Page.DataBind();
        }

        // 보낸 편지한 또는 임시 저장함 일때 수신거부 버튼 비활성화
        if (strMailBox.ToLower().Equals("outbox") || strMailBox.ToLower().Equals("savebox"))
            AnchorRejectMail.Visible = false;

        // 메일 삭제버튼 속성 추가
        strScript = "if (!SelectMail('삭제')) return false; else return true;";
        //strScript = "alert('데모라서 메일삭제가 되지 않습니다.'); return false;";
        ibDeleteMail.Attributes.Add("onclick", strScript);

        // 메일 백업버튼 속성 추가
        strScript = "if (!SelectMail('백업')) return false; else return true;";
        ibMailBackup.Attributes.Add("onclick", strScript);

        // 메일 이동버튼 속성 추가
        strScript = "if (!MoveMail()) return false; else return true;";
        ibMoveMail.Attributes.Add("onclick", strScript);
    }

    #region 메일박스 데이터 바인드
    private void MailBoxDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            int iRowCount = dt.Rows.Count + 4;
            int iCount = 4;
            string[,] arrMailbox = new string[iRowCount, 2];

            // 받은편지함
            arrMailbox[0, 0] = "inbox";
            arrMailbox[0, 1] = "받은편지함";

            // 보낸편지함
            arrMailbox[1, 0] = "outbox";
            arrMailbox[1, 1] = "보낸편지함";

            // 임시저장함
            arrMailbox[2, 0] = "savebox";
            arrMailbox[2, 1] = "임시저장함";

            // 스팸편지함
            arrMailbox[3, 0] = "spambox";
            arrMailbox[3, 1] = "스팸편지함";

            foreach (DataRow dr in dt.Rows)
            {
                arrMailbox[iCount, 0] = dr["M_MAILBOX"].ToString();
                arrMailbox[iCount, 1] = dr["M_MAILBOX_NAME"].ToString();

                ++iCount;
            }

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                ListItem li = new ListItem(arrMailbox[iLoop, 1], arrMailbox[iLoop, 0]);
                ddlMailBoxList.Items.Add(li);
            }
            ddlMailBoxList.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("편지함 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 메일 리스트 데이터 Bind함수
    private void MailDataBind()
    {
        int intPageCount = int.Parse(ConfigurationSettings.AppSettings["intPageCount"]);
        // 2006년 11월 27일 수정
        // 메일 출력 갯수를 DropDownList에 설정
        //int intListCount = int.Parse(ConfigurationSettings.AppSettings["intListCount"]);
        int intListCount = int.Parse(ddlListCount.SelectedValue);
        int iPage = 0;
        int iCount = 0;
        int totalPage = 0;
        int modPage = 0;
        int iLoopPage = 0;
        int iStartPage = 0;
        DataTable dtMail = new DataTable();

        MailParser mParser = null;
        ArrayList arrMailFiles = null;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();

            strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);

            // mailbox에 있는 메일들을 inbox로 옮긴다.
            if (strMailBox == "inbox")
            {
                // 자동 메일 분류
                Cmd.Connection = Con;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prSelectFiltering";

                Cmd.Parameters.Clear();

                sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                sParams.Direction = ParameterDirection.Input;

                sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                sParams.Direction = ParameterDirection.Input;

                Cmd.Parameters["@varUserId"].Value = strUserId;
                Cmd.Parameters["@varDomain"].Value = strDomain;

                Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "FILTER");
                dt = ds.Tables["FILTER"];

                int iRowCount = dt.Rows.Count;

                // 메일 자동 분류는 새편지를 기준으로 해야 하기 때문에
                // mailbox에 메일들을 가지고 분류를 한다.
                DirectoryInfo fdi = new DirectoryInfo(mailFilePath + "\\mailbox");

                // 메일 자동 분류가 설정 되어 있으면 메일을 파싱해서 자동으로 분류 시킨다.
                if (iRowCount > 0)
                {
                    foreach (FileInfo fi in fdi.GetFiles())
                    {
                        mParser = new MailParser(fi.FullName);

                        foreach (DataRow dr in dt.Rows)
                        {
                            switch (dr["F_TARGET"].ToString())
                            {
                                case "F1":	// 참조
                                    if (mParser.MailCc != "")
                                        this.MailFitering(dr["F_WORDS"].ToString(), mParser.MailCc, dr["F_MAILBOX"].ToString(), fi);
                                    break;
                                case "F2":	// 도메인
                                    if (mParser.MailFrom != "")
                                        this.MailFitering(dr["F_WORDS"].ToString(), mParser.MailFrom, dr["F_MAILBOX"].ToString(), fi);
                                    break;
                                case "F3":	// 보낸사람
                                    if (mParser.MailFrom != "")
                                        this.MailFitering(dr["F_WORDS"].ToString(), mParser.MailFrom, dr["F_MAILBOX"].ToString(), fi);
                                    break;
                                case "F4":	// 제목
                                    if (mParser.Subject != "")
                                        this.MailFitering(dr["F_WORDS"].ToString(), mParser.Subject, dr["F_MAILBOX"].ToString(), fi);
                                    break;
                                case "F5":	// 받는사람
                                    if (mParser.MailTo != "")
                                        this.MailFitering(dr["F_WORDS"].ToString(), mParser.MailTo, dr["F_MAILBOX"].ToString(), fi);
                                    break;
                            }
                        }
                    }
                }

                // mailbox 폴더가 존재하면 메일을 inbox로 이동 시킨다.
                if (fdi.Exists)
                {
                    foreach (FileInfo file in fdi.GetFiles())
                        File.Move(mailFilePath + "\\mailbox\\" + file.Name, mailFilePath + "\\" + strMailBox + "\\" + file.Name);
                }
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("메일을 자동 분류하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
        }
        finally
        {
            Con.Close();
        }

        mailFilePath += "\\" + strMailBox;

        arrMailFiles = WF.GetMailFile(mailFilePath);
        iCount = arrMailFiles.Count;

        // 전체 페이지
        totalPage = iCount / intListCount;
        // 나머지 페이지
        modPage = iCount % intListCount;

        // 나머지 페이지가 0이 아니면 전체 페이지에 1을 더한다.
        // 그러면 전체 페이지가 나온다.
        if (modPage > 0)
            ++totalPage;

        if (strPage == null)
        {
            iStartPage = totalPage * intListCount;
            iPage = 1;
        }
        else
        {
            if (strPage == "")
                iPage = 1;
            else
                iPage = int.Parse(strPage);

            if (iPage > 1)
                iStartPage = iCount - ((iPage - 1) * intListCount) - 1;
            else
                iStartPage = iCount - 1;
        }

        if (iStartPage >= iCount)
            iStartPage = iCount - 1;

        iLoopPage = iStartPage - intListCount;

        if (iLoopPage < 0)
            iLoopPage = -1;


        dtMail.Columns.Add("mailId", System.Type.GetType("System.String"));
        dtMail.Columns.Add("mailSubject", System.Type.GetType("System.String"));
        dtMail.Columns.Add("mailAddr", System.Type.GetType("System.String"));
        dtMail.Columns.Add("mailDate", System.Type.GetType("System.DateTime"));
        dtMail.Columns.Add("attachfile", System.Type.GetType("System.String"));
        dtMail.Columns.Add("mailForwardNRject", System.Type.GetType("System.String"));

        if (iCount > 0)
        {
            int ivalue = 0;
            try
            {
                for (int iLoop = iStartPage; iLoop > iLoopPage; iLoop--)
                {
                    // 메일 용량을 받아온다.
                    string strFileSize = WF.GetFileSize(mailFilePath + "\\" + arrMailFiles[iLoop].ToString());

                    mParser = new MailParser(mailFilePath + "\\" + arrMailFiles[iLoop].ToString());
                    // 첨부파일이 존재하는지 확인하는 메서드
                    // 이 메서드를 사용해야 IsAttachFile 값을 정상적으로 받아올 수 있다.
                    mParser.GetIsAttachFile();
                    // 대기시간 50ms
                    System.Threading.Thread.Sleep(50);

                    ivalue = iLoop;
                    DataRow dr = dtMail.NewRow();
                    dr["mailId"] = arrMailFiles[iLoop].ToString();

                    dr["mailDate"] = mParser.MailDateTime;

                    string strSubject = mParser.Subject;

                    // 제목
                    if (strSubject.Trim() == "")
                        strSubject = "제목이 없습니다 .";
                    else
                    {
                        if (strSubject.Length > 56)
                            strSubject = strSubject.Substring(0, 56) + "...";

                        strSubject = strSubject.Replace("<", "&lt;");
                    }

                    // 읽음 읽지 않음 여부 표시
                    if (!WF.IsMailReading(arrMailFiles[iLoop].ToString()))
                        strSubject = "<b>" + strSubject + "</b>";

                    // outbox일때는 받는사람, 그이외에는 모두 보낸 사람
                    if (strMailBox.ToLower() == "outbox" || strMailBox.ToLower() == "savebox")
                    {
                        string[] arrTmp = WF.linkMailAddress(mParser.MailTo, "writeMail.aspx?email=", 20, "...");
                        dr["mailAddr"] = arrTmp[0];
                    }
                    else
                    {
                        string[] arrTmp = WF.linkMailAddress(mParser.MailFrom, "writeMail.aspx?email=", 20, "...");
                        dr["mailAddr"] = arrTmp[0];
                    }

                    if (dr["mailAddr"].ToString().Trim() == "")
                        dr["mailAddr"] = "&nbsp;";

                    // 임시저장함일때 제목 링크를 편지쓰기로 지정한다.
                    if (strMailBox.ToLower() == "savebox")
                        dr["mailSubject"] = "<a href=\"writeMail.aspx?MailBox=" + Server.UrlEncode(strMailBox) + "&MailFile=" + Server.UrlEncode(arrMailFiles[iLoop].ToString()) + "\">" + strSubject + "</a>";
                    else
                        dr["mailSubject"] = "<a href=\"viewMail.aspx?strMailBox=" + Server.UrlEncode(strMailBox) + "&mailFile=" + Server.UrlEncode(arrMailFiles[iLoop].ToString()) + "&iPage=" + iPage + "\">" + strSubject + "</a>";

                    // 첨부파일이 존재할 경우에 이미지를 붙여준다.
                    if (mParser.IsAttachFile)
                        dr["attachfile"] = "<img src=\"../Images/Icon/attach.gif\">";
                    else
                        dr["attachfile"] = "&nbsp;";

                    string forwardNReply = WF.ForwardNReply(arrMailFiles[iLoop].ToString(), "&nbsp;");

                    // 전달 또는 답변 또는 전달/답변 일때 이미지를 붙인다.
                    if (forwardNReply == "R")
                        forwardNReply = "<img src=\"../Images/icon_check.gif\" alt=\"답변\">";
                    else if (forwardNReply == "F")
                        forwardNReply = "<img src=\"../Images/icon_reply.gif\" alt=\"전달\">";
                    else if (forwardNReply == "B")
                        forwardNReply = "<img src=\"../Images/icon_reply.gif\" alt=\"전달\">/<img src\"../Images/icon_check.gif\" alt=\"답변\">";

                    dr["mailForwardNRject"] = forwardNReply;

                    dtMail.Rows.Add(dr);
                }
            }
            catch (Exception err)
            {
                WF.WriteMessage("메일을 파싱해서 리스트를 생성하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "서버 관리자에게 문의하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n") +
                    "\\r\\n\\r\\n오류 메일: " + arrMailFiles[ivalue].ToString());
                WF.HistoryBack();
                return;
            }
        }

        rptMailList.DataSource = dtMail.DefaultView;
        rptMailList.DataBind();

        string args = "&strMailbox=" + Server.UrlEncode(strMailBox) + "&listCnt=" + intListCount;

        lblPageLink.Text = WF.PageLink(totalPage, iPage, strMovePage, args, 10, "", "", "", "");
    }
    #endregion

    #region 메일 자동 분류
    private void MailFitering(string strWord, string strTarget, string strMailbox, FileInfo fiMailFile)
    {
        // 메일 자동 분류 대상이 존재하면 메일을 구분 형식대로 분류한다.
        if (strTarget != null)
        {
            // 해당 문구에 해당 단어가 존재하면 메일이 존재하는지 체크하고 메일을 이동 시킨다.
            if (strTarget.IndexOf(strWord) > -1)
            {
                // 메일 파일이 존재하는지 체크
                if (File.Exists(fiMailFile.FullName))
                {
                    // 이동 대상이 delete 이면 메일 파일을 삭제한다.
                    if (strMailbox == "delete")
                        fiMailFile.Delete();
                    else
                    {
                        // 메일파일이 이동되려는 폴더에 존재하지 않으면 그대로 이동 시키고
                        // 존재한다면 메일 파일명 뒤에 1을 붙여서 이동 시킨다.
                        if (!File.Exists(UI.UserPath + "\\" + strMailbox + "\\" + fiMailFile.Name))
                            fiMailFile.MoveTo(UI.UserPath + "\\" + strMailbox + "\\" + fiMailFile.Name);
                        else
                        {
                            string tmpFile = fiMailFile.Name.Substring(0, fiMailFile.Name.LastIndexOf(".")) + "1.eml";
                            fiMailFile.MoveTo(UI.UserPath + "\\" + strMailbox + "\\" + tmpFile);
                        }
                    }
                }
            }
        }
    }
    #endregion

    #region 메일박스 이름
    private void MailBoxNameBind()
    {
        try
        {
            strMailBox = strMailBox.ToLower();

            if (strMailBox == "inbox")
                lblMailBox.Text = "받은편지함";
            else if (strMailBox == "outbox")
                lblMailBox.Text = "보낸편지함";
            else if (strMailBox == "delbox")
                lblMailBox.Text = "휴지통";
            else if (strMailBox == "savebox")
                lblMailBox.Text = "임시저장함";
            else if (strMailBox == "spambox")
                lblMailBox.Text = "스팸편지함";
            else
            {
                dt = ds.Tables["MAIL_BOX"];

                int iRowCount = dt.Rows.Count;

                if (iRowCount > 0)
                {
                    for (int iLoop = 0; iLoop < iRowCount; iLoop++)
                    {
                        DataRow dr = dt.Rows[iLoop];
                        if (strMailBox == dr["M_MAILBOX"].ToString().ToLower())
                        {
                            strMailBoxName = dr["M_MAILBOX_NAME"].ToString();
                            break;
                        }

                    }
                }
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("메일 박스 이름을 표시하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            return;
        }
    }
    #endregion

    #region 선택한 메일 백업
    protected void ibMailBackup_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string strCompressFile = "";
        string[] strMailFile;

        if (strMailId == "")
        {
            WF.WriteMessage("백업할 메일을 선택해 주세요.");
            WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox);
            return;
        }

        // 백업할 파일명을 사용자 아이디 + Sel + 메일박스 명으로 백업한다.
        strCompressFile = strUserId + "_Sel_" + strMailBox + ".zip";

        if (strMailId != "")
        {
            try
            {
                if (strMailId.EndsWith("|"))
                    strMailId = strMailId.Substring(0, strMailId.Length - 1);

                strMailFile = strMailId.Split('|');

                // 압축을 하기위에 자바 라이브러리에 포함되어 있는 Zip 압축 관련 라이브러리를 끌어쓴다.
                // 단, 자바 라이브러리를 사용하기 위해서는 MS Visual J# .Net 재배포 패키지를 설치해야
                // 자바 라이브러리를 사용할 수 있다.
                java.io.FileOutputStream fos = new java.io.FileOutputStream(UI.UserPath + "\\" + strCompressFile);
                java.util.zip.ZipOutputStream zos = new java.util.zip.ZipOutputStream(fos);

                for (int iLoop = 0; iLoop < strMailFile.Length; iLoop++)
                {
                    string filename = UI.UserPath + "\\" + strMailBox + "\\" + strMailFile[iLoop];

                    java.io.FileInputStream fis = new java.io.FileInputStream(filename);
                    java.util.zip.ZipEntry ze = new java.util.zip.ZipEntry(strMailFile[iLoop]);
                    zos.putNextEntry(ze);
                    sbyte[] buf = new sbyte[1024];
                    int len = 0;

                    while ((len = fis.read(buf)) >= 0)
                        zos.write(buf, 0, len);

                    zos.closeEntry();
                    fis.close();
                }
                zos.close();
                fos.close();

                FileInfo f = new FileInfo(UI.UserPath + "\\" + strCompressFile);

                Response.Clear();
                Response.ClearContent();
                Response.ContentType = "Application/Octet-stream";
                Response.AddHeader("Content-Disposition", "attachment; filename=" + strCompressFile);
                Response.WriteFile(f.FullName);
                Response.End();
            }
            catch (Exception err)
            {
                WF.WriteMessage("선택한 편지를 백업하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "서버관리자에게 문의 하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                return;
            }
        }
    }
    #endregion

    #region 선택한 메일 복원
    protected void ibRestoreMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string[] arrMailId = null;
        string strMailPath = UI.UserPath + "\\" + strMailBox + "\\";

        if (strMailId == "")
        {
            WF.WriteMessage("복원할 메일을 선택해 주세요.");
            WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox);
            return;
        }
        else if (strMailId != "")
        {
            if (strMailId.EndsWith("|"))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            arrMailId = strMailId.Split('|');

            if (strMailBox == "delbox")
            {
                try
                {
                    for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                    {
                        if (File.Exists(strMailPath + arrMailId[iLoop]))
                            File.Move(strMailPath + arrMailId[iLoop], UI.UserPath + "\\inbox\\" + arrMailId[iLoop]);
                    }
                }
                catch (Exception err)
                {
                    WF.WriteMessage("선택한 메일을 복구 하는 도중 오류가 발생했습니다.\\r\\n" +
                        "관리자에게 문의하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                    return;
                }
            }

            WF.WriteMessage("선택한 메일을 복원 하였습니다.");
            WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox);
            return;
        }
    }
    #endregion

    #region 선택한 메일 삭제
    protected void ibDeleteMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string[] arrMailId = null;
        string strMailPath = UI.UserPath + "\\" + strMailBox + "\\";

        if (strMailId == "")
        {
            WF.WriteMessage("삭제할 메일을 선택해 주세요.");
            WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox);
            return;
        }

        if (strMailId != "")
        {
            if (strMailId.EndsWith("|"))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            arrMailId = strMailId.Split('|');

            try
            {
                if (strMailBox == "delete")
                {
                    for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                    {
                        if (File.Exists(strMailPath + arrMailId[iLoop]))
                            File.Delete(strMailPath + arrMailId[iLoop]);
                    }
                }
                else if (strMailBox != "delbox")
                {
                    for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                    {
                        if (File.Exists(strMailPath + arrMailId[iLoop]))
                            File.Move(strMailPath + arrMailId[iLoop], UI.UserPath + "\\delbox\\" + arrMailId[iLoop]);
                    }
                }
                else
                {
                    for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                    {
                        if (File.Exists(strMailPath + arrMailId[iLoop]))
                            File.Delete(strMailPath + arrMailId[iLoop]);
                    }
                }
            }
            catch (Exception err)
            {
                WF.WriteMessage("선택한 메일을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "관리자에게 문의하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n").Replace("\"", "\\\""));
                return;
            }

            WF.WriteMessage("선택한 메일이 삭제 되었습니다.");
            WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox + "&iPage=" + strPage + "&listCnt=" + strListCount);
            return;
        }
    }
    #endregion

    #region 선택한 메일 이동
    protected void ibMoveMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string[] arrMailId = null;
        string strSelMailbox = ddlMailBoxList.SelectedValue;
        string strSelMailboxName = ddlMailBoxList.SelectedItem.Text;

        if (strMailId == "")
        {
            WF.WriteMessage("삭제할 메일을 선택해 주세요.");
            WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox);
            return;
        }

        if (strMailId != "")
        {
            if (strMailId.EndsWith("|"))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            arrMailId = strMailId.Split('|');

            try
            {
                for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                {
                    if (File.Exists(UI.UserPath + "\\" + strMailBox + "\\" + arrMailId[iLoop]))
                        File.Move(UI.UserPath + "\\" + strMailBox + "\\" + arrMailId[iLoop], UI.UserPath + "\\" + strSelMailbox + "\\" + arrMailId[iLoop]);
                }
            }
            catch (Exception err)
            {
                WF.WriteMessage("선택한 메일을 " + strSelMailboxName + " 편지함으로 이동 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                return;
            }
        }

        //WF.WriteMessage("선택한 메일을 " + strSelMailboxName + " 편지함으로 이동했습니다.");
        WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox);
    }
    #endregion

    #region 메일 출력 갯수
    protected void ddlListCount_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        MailBoxNameBind();
        MailDataBind();
    }
    #endregion
}
