﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Mail_MailButton : System.Web.UI.UserControl
{
    private UserInfo UI;
    private WebFunction WF;

    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strUserId = "";
    private string iPage = "";
    private string strPort = "";
    protected string mailname = "";
    protected string strMailBox = "";
    protected string strUrl = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["strMailBox"];
        mailname = Request.Params["mailFile"];
        iPage = Request.Params["iPage"];

        UI = new UserInfo(strUserId, strDomain, strCon);

        if (!Page.IsPostBack)
        {
            strPort = Request.Url.Port.ToString();
            strUrl = Request.Url.LocalPath;
            strUrl = strUrl.Substring(0, strUrl.LastIndexOf("/") + 1);

            // 2006년 11월 22일 수정
            // 포트가 변경되어 있을 경우에 주소 뒤에 포트 번호를 붙여준다.
            if (strPort != "80")
                strUrl = "http://" + Request.ServerVariables["SERVER_NAME"] + ":" + strPort + strUrl;
            else
                strUrl = "http://" + Request.ServerVariables["SERVER_NAME"] + strUrl;


            ibReply.ImageUrl = strUrl + ibReply.ImageUrl;
            ibDeleteMail.ImageUrl = strUrl + ibDeleteMail.ImageUrl;
            ibMailList.ImageUrl = strUrl + ibMailList.ImageUrl;
            ibAllReply.ImageUrl = strUrl + ibAllReply.ImageUrl;
            ibForward.ImageUrl = strUrl + ibForward.ImageUrl;


            if (strMailBox.ToLower() == "delbox")
            {
                ibRestoreMail.Visible = true;
                ibReply.Visible = false;
                ibForward.Visible = false;
            }

            Page.DataBind();
        }
    }

    #region 메일 복원
    /// <summary>
    /// 메일 복원
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibRestoreMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        if (mailname != "" && strMailBox != "")
        {
            if (strMailBox.ToLower() == "delbox")
            {
                if (File.Exists(UI.UserPath + "\\" + strMailBox + "\\" + mailname))
                    File.Move(UI.UserPath + "\\" + strMailBox + "\\" + mailname, UI.UserPath + "\\inbox\\" + mailname);
            }
        }

        WF.WriteMessage("읽고 있던 메일을 복구 하였습니다.");
        WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox);
    }
    #endregion

    #region 메일 삭제
    /// <summary>
    /// 메일 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDeleteMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        if (mailname != "" && strMailBox != "")
        {
            // 2006년 12월 13일 수정
            mailname = WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + mailname, 1);

            if (strMailBox.ToLower() == "delbox")
            {
                if (File.Exists(UI.UserPath + "\\" + strMailBox + "\\" + mailname))
                    File.Delete(UI.UserPath + "\\" + strMailBox + "\\" + mailname);
            }
            else
            {
                if (File.Exists(UI.UserPath + "\\" + strMailBox + "\\" + mailname))
                    File.Move(UI.UserPath + "\\" + strMailBox + "\\" + mailname, UI.UserPath + "\\delbox\\" + mailname);
            }
        }

        WF.WriteMessage("읽고 있던 메일이 삭제 되었습니다.");
        WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox + "&iPage=" + iPage);
    }
    #endregion

    #region 메일 리스트로 이동
    /// <summary>
    /// 메일 리스트로 이동
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibMailList_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        if (strMailBox.ToLower() == "mailbox")
            strMailBox = "inbox";

        Response.Redirect("ListMail.aspx?strMailBox=" + strMailBox + "&iPage=" + iPage);
    }
    #endregion

    #region 회신
    /// <summary>
    /// 회신
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibReply_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.MailWrite("re");
    }
    #endregion

    #region 전체회신
    /// <summary>
    /// 전체회신
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAllReply_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.MailWrite("ar");
    }
    #endregion

    #region 전달
    /// <summary>
    /// 전달
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibForward_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.MailWrite("fw");
    }
    #endregion

    #region 편지쓰기
    /// <summary>
    /// 편지쓰기
    /// </summary>
    /// <param name="strType"></param>
    protected void MailWrite(string strType)
    {
        mailname = Server.UrlEncode(WF.CheckMailFile(UI.UserPath + "\\" + strMailBox, mailname));
        Response.Redirect("WriteMail.aspx?MailFile=" + mailname + "&Mailbox=" + strMailBox + "&Type=" + strType);
    }
    #endregion
}
