﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;

public partial class Mail_PrintMail : System.Web.UI.Page
{
    private MailParser mParser = null;

    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string iPage = "";
    private string mailname = "";
    private string strPort = "";
    protected string strMailBox = "";
    protected string rFileName = "";
    protected string strAttachFiles = "";
    protected string strSubject = "";
    protected string strUrl = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["mailbox"];
        mailname = Request.Params["mailFile"];

        UI = new UserInfo(strUserId, strDomain, strCon);

        if (!this.Page.IsPostBack)
        {
            rFileName = WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + mailname, 1);
            mailname = rFileName;

            this.ThisMailParse();

            Page.DataBind();
        }
        else
            rFileName = WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + mailname, 1);
    }

    #region 해당 메일 파싱
    /// <summary>
    /// 해당 메일 파싱
    /// </summary>
    private void ThisMailParse()
    {
        string[] arrFrom = null;
        string[] arrTo = null;
        string[] arrCc = null;
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strContent = null;
        // 메일 파일명 확인
        mailname = WF.CheckMailFile(UI.UserPath + "\\" + strMailBox, mailname);
        try
        {
            mParser = new MailParser(UI.UserPath, strMailBox, mailname);
            // 내용 파싱
            mParser.ParseBody();
            // 첨부파일 갯수
            mParser.GetAttachFIles();

            strSubject = mParser.Subject;

            if (strSubject.Trim() == "")
                strSubject = "메일 제목이 없습니다.";

            strSubject = strSubject.Replace("<", "&lt;");

            arrFrom = WF.linkMailAddress(mParser.MailFrom, "writeMail.aspx?email=");
            arrTo = WF.linkMailAddress(mParser.MailTo, "writeMail.aspx?email=");
            arrCc = WF.linkMailAddress(mParser.MailCc, "writeMail.aspx?email=");

            lblMailFrom.Text = arrFrom[0];
            lblMailTo.Text = MailAddressDisplay(arrTo, "to");
            lblMailCc.Text = MailAddressDisplay(arrCc, "cc");
            lblMailDate.Text = mParser.MailDateTime.ToString();

            if (mParser.GetHtmlMailBody != "")
            {
                //strContent = WF.ChkContentCid(mParser.GetHtmlMailBody, strUrl + "ViewCidImage.aspx", strMailBox, Server.UrlEncode(mailname));
                strContent = mParser.GetHtmlMailBody;
            }
            else
            {
                strContent = mParser.GetTextMailBody;
                strContent = strContent.Replace("<", "&lt");
                strContent = strContent.Replace("\r\n", "<br>\r\n");
            }
            /*
            // 첨부파일에 이미지가 첨부되어 있을때 본문 내용 밑에 이미지를 출력한다.
            if (mParser.ImageAttach)
            {
                //foreach(object filename in mParser.AttachFiles)
                foreach (AttachFileInfo fileInfo in mParser.AttachFiles)
                {
                    string strFile = fileInfo.AttachFile;

                    if (fileInfo.ContentID.Trim() == "")
                    {
                        if (strFile.ToLower().EndsWith("png") ||
                            strFile.ToLower().EndsWith("gif") ||
                            strFile.ToLower().EndsWith("jpg") ||
                            strFile.ToLower().EndsWith("jpeg"))
                        {
                            if (strFile.StartsWith(" "))
                                strFile = strFile.Substring(1);

                            strContent += "<br>\r\n<img src=\"ViewAttachImage.aspx?mailfile=" + Server.UrlEncode(mailname) + "&image=" + Server.UrlEncode(strFile) + "&mailbox=" + strMailBox + "\">\r\n";
                        }
                    }
                }
            }
            */
            lblMailContent.Text = strContent;
        }
        catch (Exception err)
        {
            WF.WriteMessage(mailname + " 파일명을 가진 메일을 파싱하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox + "&iPage=" + iPage.ToString());
            return;
        }
    }
    #endregion

    #region 메일 주소 링크
    /// <summary>
    /// 메일 주소 링크
    /// </summary>
    /// <param name="arrEmail"></param>
    /// <param name="fValue">to, cc 만 들어올 수 있다.</param>
    /// <returns></returns>
    private string MailAddressDisplay(string[] arrEmail, string fValue)
    {
        string strTmp = "";
        int iTotCnt = 0;

        if (arrEmail == null)
            return "&nbsp;";

        if (fValue != "to" && fValue != "cc")
            return "잘못된 구분값 입니다.";

        iTotCnt = arrEmail.Length;

        if (iTotCnt >= 2)
        {
            --iTotCnt;
            for (int iCnt = 0; iCnt <= iTotCnt; iCnt++)
            {
                if (iCnt == 0)
                {
                    strTmp = arrEmail[iCnt] + " 외 " + iTotCnt.ToString() + " 명에게 발송되었습니다.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                        "<a href=\"javascript: DisplayEmail('div" + fValue + "');\">더 보기</a><br>" +
                        "<div id=\"div" + fValue + "\" style=\"display: none\">";
                }
                else
                {
                    strTmp += "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\r\n" +
                        "<tr height=\"23\"><td width=\"70%\">&nbsp;" + arrEmail[iCnt] + "</td><td width=\"30%\"></td></tr>\r\n" +
                        "</table>";
                }

                if (iCnt == iTotCnt)
                    strTmp += "</div>";

            }
        }
        else
        {
            strTmp = arrEmail[0];
        }


        if (strTmp.Trim() == "")
            strTmp = "&nbsp;";

        return strTmp;
    }
    #endregion
}
