﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;

public partial class Mail_MailReject : System.Web.UI.Page
{
    private WebFunction WF;
    private UserInfo UI;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string strMailBox = "";
    private string strMailFile = "";
    private string strSchType = "";
    private string strSchVal = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/Login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["mailbox"];
        strMailFile = Request.Params["mailfile"];
        strSchType = WF.StringDefaultValue(Request.Params["schType"], "");
        strSchVal = WF.StringDefaultValue(Request.Params["schValue"], "");

        UI = new UserInfo(strUserId, strDomain, strCon);

        if (!Page.IsPostBack)
        {
            hidSchType.Value = strSchType;
            hidSchVal.Value = strSchVal;

            if (strMailFile == "")
            {
                WF.WriteMessage("수신거부에 등록할 메일이 선택되지 않았습니다.");
                WF.WndClose();
                return;
            }
        }
    }

    #region 수신거부 등록
    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAddReject_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbTransaction Trans = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();

        string[] arrMailFile = null;
        string strMovePage = "";
        MailParser mParser = null;
        strSchType = hidSchType.Value;
        strSchVal = hidSchVal.Value;

        // Set Move Page
        if (strSchType != "")
            strMovePage = "MailSearchList.aspx?strMailBox=" + strMailBox + "&schType=" + strSchType + "&schValue=" + strSchVal;
        else
            strMovePage = "ListMail.aspx?strMailBox=" + strMailBox;

        if (strMailFile != "")
        {
            arrMailFile = strMailFile.Split('|');

            if (chkAddReject.Checked)
            {
                try
                {
                    Con.Open();
                    Trans = Con.BeginTransaction();
                }
                catch (Exception err)
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                        err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
                    WF.OpenDocPageMove(strMovePage);
                    return;
                }

                try
                {
                    Cmd.Connection = Con;
                    Cmd.Transaction = Trans;
                    Cmd.CommandType = CommandType.StoredProcedure;
                    Cmd.CommandText = "prInsertRejectEmail";

                    // Command Parameter (Execute Return Value)
                    sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                    sParams.Direction = ParameterDirection.ReturnValue;

                    // Command Parameter (User Id)
                    sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                    sParams.Direction = ParameterDirection.Input;

                    // Command Parameter (Domain)
                    sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                    sParams.Direction = ParameterDirection.Input;

                    // Command Parameter (Reject Email Address)
                    sParams = Cmd.Parameters.Add("@varRejectEmail", OleDbType.VarChar, 512);
                    sParams.Direction = ParameterDirection.Input;

                    // Command Parameter (Output Value)
                    sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
                    sParams.Direction = ParameterDirection.Output;

                    for (int iCnt = 0; iCnt < arrMailFile.Length; iCnt++)
                    {
                        // Mail Search
                        if (strSchType != "")
                        {
                            string[] arrMail = arrMailFile[iCnt].Split(':');
                            arrMail[1] = WF.AddFileName(UI.UserPath + "\\" + arrMail[0] + "\\" + arrMail[1], 1);

                            // Mail Parse
                            mParser = new MailParser(UI.UserPath + "\\" + arrMail[0] + "\\" + arrMail[1]);

                            // Set Mail Box Value
                            strMailBox = arrMail[0];
                        }
                        else
                        {
                            arrMailFile[iCnt] = WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + arrMailFile[iCnt].ToString(), 1);

                            // Mail Parse
                            mParser = new MailParser(UI.UserPath + "\\" + strMailBox + "\\" + arrMailFile[iCnt].ToString());
                        }
                        // Mail From
                        string strMailFrom = mParser.MailFrom;

                        // Split Mail From Address
                        if (strMailFrom.LastIndexOf(" ") > -1)
                        {
                            strMailFrom = strMailFrom.Substring(strMailFrom.IndexOf(" ") + 1);
                            strMailFrom = strMailFrom.Replace("<", "").Replace(">", "");
                        }

                        // Command Parameter Value Setting
                        Cmd.Parameters["@varUserId"].Value = strUserId;
                        Cmd.Parameters["@varDomain"].Value = strDomain;
                        Cmd.Parameters["@varRejectEmail"].Value = strMailFrom;

                        Cmd.ExecuteNonQuery();

                        int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                        if (iValue < 0)
                        {
                            Trans.Rollback();
                            WF.WriteMessage("스팸 메일 주소를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                                "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                            WF.OpenDocPageMove(strMovePage);
                            WF.WndClose();
                            return;
                        }
                        else if (iValue != 0)
                        {
                            Trans.Rollback();
                            WF.WriteMessage("스팸 메일 주소를 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                                "SQL Error Number: " + iValue.ToString());
                            WF.OpenDocPageMove(strMovePage);
                            WF.WndClose();
                            return;
                        }
                    }

                    Trans.Commit();
                }
                catch (Exception err)
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("선택된 메일을 수신거부에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        err.Message.Replace("\\", "\\\\").Replace("\"", "\\\""));
                    WF.OpenDocPageMove(strMovePage);
                    WF.WndClose();
                    return;
                }
                finally
                {
                    Con.Close();
                }
            }

            if (chkModeSpamBox.Checked)
            {
                // Directory Not Exists
                // Create Directory
                if (!Directory.Exists(UI.UserPath + "\\SpamBox"))
                    Directory.CreateDirectory(UI.UserPath + "\\SpamBox");

                // File Move Spambox
                for (int iCnt = 0; iCnt < arrMailFile.Length; iCnt++)
                {
                    // Mail Search
                    if (strSchType != "")
                    {
                        string[] arrMail = arrMailFile[iCnt].Split(':');

                        // Mail File Exists
                        if (File.Exists(UI.UserPath + "\\" + arrMail[0] + "\\" + arrMail[1]))
                        {
                            File.Move(UI.UserPath + "\\" + arrMail[0] + "\\" + arrMail[1],
                                UI.UserPath + "\\SpamBox\\" + arrMail[1]);
                        }
                    }
                    else
                    {
                        // Mail File Exists
                        if (File.Exists(UI.UserPath + "\\" + strMailBox + "\\" + arrMailFile[iCnt].ToLower()))
                        {
                            File.Move(UI.UserPath + "\\" + strMailBox + "\\" + arrMailFile[iCnt].ToString(),
                                UI.UserPath + "\\SpamBox\\" + arrMailFile[iCnt].ToString());
                        }
                    }
                }
            }

            WF.WriteMessage("선택한 메일을 수신거부에 등록 했습니다.");
            WF.OpenDocPageMove(strMovePage);
            WF.WndClose();
        }
        else
        {
            WF.WriteMessage("수신거부에 등록할 메일이 선택되지 않았습니다.");
            WF.WndClose();
        }
        return;
    }
    #endregion

    #region 창 닫기
    /// <summary>
    /// 창 닫기
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibWndClose_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        WF.WndClose();
    }
    #endregion
}
