﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;

public partial class Mail_MailSearchList : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string strMovePage = "";
    private string strPage = "";
    private string mailFilePath = "";
    private string strSchType = "";
    private string strSchVal = "";
    protected string strMailBox = "";
    protected string strMailBoxName = "";
    protected string strTitleMsgFromTo = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        strUserId = Session["USER_ID"].ToString();
        strPage = Request.Params["iPage"];
        mailFilePath = UI.UserPath;
        strMovePage = Request.PhysicalPath;
        strMailBox = Request.Params["strMailBox"];
        strSchType = WF.StringDefaultValue(Request.Params["schType"], "");
        strSchVal = WF.StringDefaultValue(Request.Params["schValue"], "");

        if (!Page.IsPostBack)
        {
            this.MailBoxDataBind();
            this.SearchResult(strSchType, strSchVal, strMailBox);
            /*
            if (strMailBox.ToLower() == "outbox")
                strTitleMsgFromTo = "받는이";
            else
                strTitleMsgFromTo = "보낸이";
            */
        }

        string strScript = "if (!SearchMail()) return false; else return true;";
        ibSearch.Attributes.Add("onclick", strScript);
    }

    #region 메일박스 데이터 바인드
    private void MailBoxDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            int iRowCount = dt.Rows.Count + 7;
            int iCount = 5;
            string[,] arrMailbox = new string[iRowCount, 2];

            // 받은편지함
            arrMailbox[0, 0] = "inbox";
            arrMailbox[0, 1] = "받은편지함";

            //보낸 편지함
            arrMailbox[1, 0] = "outbox";
            arrMailbox[1, 1] = "보낸편지함";

            // 휴지통
            arrMailbox[2, 0] = "delbox";
            arrMailbox[2, 1] = "휴지통";

            // 임시저장함
            arrMailbox[3, 0] = "tempbox";
            arrMailbox[3, 1] = "임시저장함";

            // 스팸편지함
            arrMailbox[4, 0] = "spambox";
            arrMailbox[4, 1] = "스팸편지함";

            foreach (DataRow dr in dt.Rows)
            {
                arrMailbox[iCount, 0] = dr["M_MAILBOX"].ToString();
                arrMailbox[iCount, 1] = dr["M_MAILBOX_NAME"].ToString();

                ++iCount;
            }

            // 구분자
            arrMailbox[iCount, 0] = "_line_";
            arrMailbox[iCount++, 1] = "==========";

            // 모든 편지함
            arrMailbox[iCount, 0] = "";
            arrMailbox[iCount, 1] = "모든편지함";

            for (int iLoop = 0; iLoop < iRowCount; iLoop++)
            {
                ListItem li = new ListItem(arrMailbox[iLoop, 1], arrMailbox[iLoop, 0]);
                ddlMailBox.Items.Add(li);

                if (arrMailbox[iLoop, 0] != "_line_" && arrMailbox[iLoop, 0] != "")
                    ddlMailBoxList.Items.Add(li);
            }

            ddlMailBox.DataBind();
            ddlMailBoxList.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("편지함 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));

            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 메일 검색 결과
    /// <summary>
    /// 메일 검색 결과
    /// </summary>
    /// <param name="strSchType">검색형식</param>
    /// <param name="strSchVal">검색어</param>
    /// <param name="strMailbox">검색할 메일박스</param>
    protected void SearchResult(string strType, string strVal, string strMailbox)
    {
        int intPageCount = int.Parse(ConfigurationSettings.AppSettings["intPageCount"]);
        int intListCount = int.Parse(ConfigurationSettings.AppSettings["intListCount"]);
        string strSql = "";
        string strQry = "";
        string strPath = "";
        string[] arrSchValue = null;
        int iPage = 0;
        int totalPage = 0;
        int modPage = 0;
        int iLoopPage = 0;
        int iStartPage = 0;
        int iCnt = 0;
        MailParser mParser = null;

        if (strType == "")
            return;
        else
            strSchType = strType;

        if (strVal == "")
            return;
        else
            strSchVal = strVal;

        hidMailBox.Value = strMailbox;
        hidSchType.Value = strType;
        hidSchValue.Value = strVal;

        // 검색 쿼리 생성 (다중 검색어 기능 추가 - 2006년 10월 24일)
        if (strSchType.ToLower() == "subject")
        {
            arrSchValue = strSchVal.Split(' ');

            for (int iLoop = 0; iLoop < arrSchValue.Length; iLoop++)
            {
                strQry += " FREETEXT(NewsSubject, '" + arrSchValue[iLoop] + "') ";

                if ((arrSchValue.Length - 1) != iLoop)
                    strQry += " OR ";
            }
        }
        else if (strSchType.ToLower() == "msgfrom")
        {
            arrSchValue = strSchVal.Split(' ');

            for (int iLoop = 0; iLoop < arrSchValue.Length; iLoop++)
            {
                strQry += " FREETEXT(MsgFrom, '" + arrSchValue[iLoop] + "') ";

                if ((arrSchValue.Length - 1) != iLoop)
                    strQry += " OR ";
            }
        }
        else if (strSchType.ToLower() == "content")
        {
            arrSchValue = strSchVal.Split(' ');

            for (int iLoop = 0; iLoop < arrSchValue.Length; iLoop++)
            {
                strQry += " FREETEXT(Contents, '" + arrSchValue[iLoop] + "') ";

                if ((arrSchValue.Length - 1) != iLoop)
                    strQry += " OR ";
            }
        }

        strQry = " AND " + strQry;

        // 검색할 위치
        if (strMailbox != "")
            strPath = UI.UserPath + "\\" + strMailbox;
        else
            strPath = UI.UserPath;

        // 메일검색 쿼리
        strSql = "SELECT Directory, Filename, Size From nWmail..Scope('\"" + strPath + "\"') where  FILENAME LIKE '%.eml' " +
            strQry + "ORDER BY NewsDate Desc";

        string oleProvider = "Provider=MSIDXS; Data Source=nWmail;";
        OleDbConnection oleCon = new OleDbConnection(oleProvider);

        try
        {
            oleCon.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);
            OleDbCommand oleCmd = new OleDbCommand(strSql, oleCon);
            OleDbDataAdapter oleAdap = new OleDbDataAdapter(oleCmd);
            oleAdap.Fill(ds, "MAIL_LIST");
            dt = ds.Tables["MAIL_LIST"];

            int iRowCnt = dt.Rows.Count;
            string[,] arrMailInfo = new string[iRowCnt, 3];

            foreach (DataRow dr in dt.Rows)
            {
                arrMailInfo[iCnt, 0] = dr["Directory"].ToString();
                arrMailInfo[iCnt, 1] = dr["Filename"].ToString();
                arrMailInfo[iCnt, 2] = dr["Size"].ToString();
                ++iCnt;
            }

            // 전체 페이지
            totalPage = iCnt / intListCount;
            // 나머지 페이지
            modPage = iCnt % intListCount;

            // 나머지 페이지가 0이 아니면 전체 페이지에 1을 더한다.
            // 그러면 전체 페이지가 나온다.
            if (modPage > 0)
                ++totalPage;

            if (strPage == null)
            {
                iStartPage = totalPage * intListCount;
                iPage = 1;
            }
            else
            {
                if (strPage == "")
                    iPage = 1;
                else
                    iPage = int.Parse(strPage);

                if (iPage > 1)
                    iStartPage = iCnt - ((iPage - 1) * intListCount);
                else
                    iStartPage = iCnt - 1;
            }

            if (iStartPage >= iCnt)
                iStartPage = iCnt - 1;

            iLoopPage = iStartPage - intListCount;

            if (iLoopPage < 0)
                iLoopPage = -1;

            dt.Clear();

            dt.Columns.Add("mailbox", System.Type.GetType("System.String"));
            dt.Columns.Add("mailboxName", System.Type.GetType("System.String"));
            dt.Columns.Add("mailId", System.Type.GetType("System.String"));
            dt.Columns.Add("mailSubject", System.Type.GetType("System.String"));
            dt.Columns.Add("mailAddr", System.Type.GetType("System.String"));
            dt.Columns.Add("mailDate", System.Type.GetType("System.DateTime"));
            dt.Columns.Add("attachfile", System.Type.GetType("System.String"));
            dt.Columns.Add("mailForwardNRject", System.Type.GetType("System.String"));

            if (iCnt > 0)
            {
                StringBuilder sb = new StringBuilder();
                sb.Append("<script language=\"javascript\">");
                sb.Append("	document.all.divMailAction.style.display = \"\"");
                sb.Append("</script>");

                Page.RegisterStartupScript("ShowMailAction", sb.ToString());

                for (int iLoop = iStartPage; iLoop > iLoopPage; iLoop--)
                {
                    string schMailBox = arrMailInfo[iLoop, 0].Substring(arrMailInfo[iLoop, 0].LastIndexOf("\\") + 1);

                    // 메일이 검색된 메일박스에 존재하는지 확인한다.
                    // 이때 다른 폴더에서 검색이되면 해당 폴더로 검색된 폴더명을 변경한다.
                    if (!File.Exists(arrMailInfo[iLoop, 0] + "\\" + arrMailInfo[iLoop, 1]))
                    {
                        for (int j = 0; j < ddlMailBoxList.Items.Count; j++)
                        {
                            if (File.Exists(UI.UserPath + "\\" + ddlMailBoxList.Items[j].Value + "\\" + arrMailInfo[iLoop, 1]))
                            {
                                schMailBox = ddlMailBoxList.Items[j].Value;
                                arrMailInfo[iLoop, 0] = UI.UserPath + "\\" + schMailBox;
                                break;
                            }
                        }
                    }

                    arrMailInfo[iLoop, 1] = WF.AddFileName(arrMailInfo[iLoop, 0] + "\\" + arrMailInfo[iLoop, 1], 1);

                    DataRow dr = dt.NewRow();

                    if (File.Exists(arrMailInfo[iLoop, 0] + "\\" + arrMailInfo[iLoop, 1]))
                    {
                        mParser = new MailParser(arrMailInfo[iLoop, 0] + "\\" + arrMailInfo[iLoop, 1]);
                        // 첨부파일이 존재하는지 확인하는 메서드
                        // 이 메서드를 사용해야 IsAttachFile 값을 정상적으로 받아올 수 있다.
                        mParser.GetIsAttachFile();
                        // 대기시간 5ms
                        System.Threading.Thread.Sleep(5);

                        

                        for (int j = 0; j < ddlMailBox.Items.Count; j++)
                        {
                            if (ddlMailBox.Items[j].Value == schMailBox)
                            {
                                dr["mailboxName"] = ddlMailBox.Items[j].Text;
                                break;
                            }
                        }

                        // 메일박스
                        dr["mailbox"] = schMailBox;
                        if (dr["mailboxName"].ToString().ToLower() == "")
                            dr["mailboxName"] = "Unknown";
                        else
                            dr["mailboxName"] = WF.StrCutByte(dr["mailboxName"].ToString(), 10, "..");

                        dr["mailId"] = arrMailInfo[iLoop, 1].ToString();

                        dr["mailDate"] = mParser.MailDateTime;

                        string strSubject = mParser.Subject;

                        // 제목
                        if (strSubject.Trim() == "")
                            strSubject = "제목이 없습니다 .";
                        else
                        {
                            if (strSubject.Length > 28)
                                strSubject = strSubject.Substring(0, 28) + "...";
                        }

                        // 읽음 읽지 않음 여부 표시
                        if (!WF.IsMailReading(arrMailInfo[iLoop, 1].ToString()))
                            strSubject = "<b>" + strSubject + "</b>";

                        // 2006년 11월 22일 수정
                        // 받는 사람 또는 보낸 사람 메일주소를 링크 메서드에서 링크를 건 다음
                        // 리턴 되는 값이 string 배열로 넘어온다.
                        // 리턴된 배열 값을 바로 DataRow에 넣어서 보낸이/받는이 이름이 String.String[]
                        // 으로 나오던 문제 수정
                        string[] strMailAddr = null;

                        // outbox일때는 받는사람, 그이외에는 모두 보낸 사람
                        if (schMailBox.ToLower() == "outbox")
                            strMailAddr = WF.linkMailAddress(mParser.MailTo, "writeMail.aspx?email=", 20, "...");
                        else
                            strMailAddr = WF.linkMailAddress(mParser.MailFrom, "writeMail.aspx?email=", 20, "...");

                        dr["mailAddr"] = strMailAddr[0];

                        if (dr["mailAddr"].ToString().Trim() == "")
                            dr["mailAddr"] = "&nbsp;";

                        // 임시저장함일때 제목 링크를 편지쓰기로 지정한다.
                        if (schMailBox.ToLower() == "savebox")
                            dr["mailSubject"] = "<a href=\"writeMail.aspx?MailBox=" + schMailBox + "&MailFile=" + Server.UrlEncode(arrMailInfo[iLoop, 1].ToString()) + "\">" + strSubject + "</a>";
                        else
                            dr["mailSubject"] = "<a href=\"viewMail.aspx?strMailBox=" + schMailBox + "&mailFile=" + Server.UrlEncode(arrMailInfo[iLoop, 1].ToString()) + "\">" + strSubject + "</a>";

                        // 첨부파일이 존재할 경우에 이미지를 붙여준다.
                        if (mParser.IsAttachFile)
                            dr["attachfile"] = "<img src=\"../Images/Icon/attach.gif\">";
                        else
                            dr["attachfile"] = "&nbsp;";

                        string forwardNReply = WF.ForwardNReply(arrMailInfo[iLoop, 1].ToString(), "&nbsp;");

                        // 전달 또는 답변 또는 전달/답변 일때 이미지를 붙인다.
                        if (forwardNReply == "R")
                            forwardNReply = "<img src=\"../Images/icon_check.gif\" alt=\"답변\">";
                        else if (forwardNReply == "F")
                            forwardNReply = "<img src=\"../Images/icon_reply.gif\" alt=\"전달\">";
                        else if (forwardNReply == "B")
                            forwardNReply = "<img src=\"../Images/icon_reply.gif\" alt=\"전달\">/<img src\"../Images/icon_check.gif\" alt=\"답변\">";

                        dr["mailForwardNRject"] = forwardNReply;
                    } else
                    {
                        dr["mailboxName"] = "삭제";
                        dr["mailAddr"] = "&nbsp;";
                        dr["mailSubject"] = "삭제된 메일 입니다.";
                        dr["attachfile"] = "&nbsp;";
                        dr["mailForwardNRject"] = "&nbsp;";
                    }
                    dt.Rows.Add(dr);
                }
                rptMailSearchList.DataSource = dt;
                rptMailSearchList.DataBind();

                lblPageLink.Text = WF.PageLink(totalPage, iPage, strMovePage, "&strMailbox=" + strMailbox + "&schType=" + strSchType + "&schValue=" + strSchVal, 10, "", "", "", "");
            }
            else
            {
                lblPageLink.Text = "<font color=\"Red\">" + strSchVal + " 검색어로 검색된 결과가 없습니다.</font>";
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage(strSchVal + " 검색어로 검색하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\"", "\\\"").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
    }
    #endregion

    #region 메일 검색
    /// <summary>
    /// 메일 검색
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailBox = ddlMailBox.SelectedValue;
        string strTarget = ddlSearchTarget.SelectedValue;
        string strSearch = tbSearch.Text;


        if (strMailBox.ToLower() == "_line_")
            strMailBox = "";

        if (strSearch.Trim() == "")
        {
            WF.WriteMessage("검색어를 입력해 주세요.");
            return;
        }

        SearchResult(strTarget, strSearch, strMailBox);
    }
    #endregion

    #region 선택한 메일 백업
    protected void ibMailBackup_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string strCompressFile = "";
        string[] strMailFile;
        strMailBox = hidMailBox.Value;
        strSchType = hidSchType.Value;
        strSchVal = hidSchValue.Value;

        if (strMailId == "")
        {
            WF.WriteMessage("백업할 메일을 선택해 주세요.");
            WF.MovePage("MailSearchList.aspx?strMailBox=" + strMailBox + "&schType=" + strSchType + "&schValue=" + strSchVal);
            return;
        }

        // 백업할 파일명을 사용자 아이디 + Sel + 메일박스 명으로 백업한다.
        strCompressFile = strUserId + "_Sel_" + strMailBox + ".zip";

        if (strMailId != "")
        {
            try
            {
                if (strMailId.EndsWith("|"))
                    strMailId = strMailId.Substring(0, strMailId.Length - 1);

                strMailFile = strMailId.Split('|');

                // 압축을 하기위에 자바 라이브러리에 포함되어 있는 Zip 압축 관련 라이브러리를 끌어쓴다.
                // 단, 자바 라이브러리를 사용하기 위해서는 MS Visual J# .Net 재배포 패키지를 설치해야
                // 자바 라이브러리를 사용할 수 있다.
                java.io.FileOutputStream fos = new java.io.FileOutputStream(UI.UserPath + "\\" + strCompressFile);
                java.util.zip.ZipOutputStream zos = new java.util.zip.ZipOutputStream(fos);

                for (int iLoop = 0; iLoop < strMailFile.Length; iLoop++)
                {
                    string[] arrMail = strMailFile[iLoop].Split(':');

                    string filename = UI.UserPath + "\\" + arrMail[0] + "\\" + arrMail[1];

                    java.io.FileInputStream fis = new java.io.FileInputStream(filename);
                    java.util.zip.ZipEntry ze = new java.util.zip.ZipEntry(arrMail[1]);
                    zos.putNextEntry(ze);
                    sbyte[] buf = new sbyte[1024];
                    int len = 0;

                    while ((len = fis.read(buf)) >= 0)
                        zos.write(buf, 0, len);

                    zos.closeEntry();
                    fis.close();
                }
                zos.close();
                fos.close();

                FileInfo f = new FileInfo(UI.UserPath + "\\" + strCompressFile);

                Response.Clear();
                Response.ClearContent();
                Response.ContentType = "Application/Octet-stream";
                Response.AddHeader("Content-Disposition", "attachment; filename=" + strCompressFile);
                Response.WriteFile(f.FullName);
                Response.End();
            }
            catch (Exception err)
            {
                WF.WriteMessage("선택한 편지를 백업하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "서버관리자에게 문의 하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                return;
            }
        }
    }
    #endregion

    #region 선택한 메일 복원
    protected void ibRestoreMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string[] arrMailId = null;
        string strMailPath = UI.UserPath + "\\";
        strMailBox = hidMailBox.Value;
        strSchType = hidSchType.Value;
        strSchVal = hidSchValue.Value;

        if (strMailId == "")
        {
            WF.WriteMessage("복원할 메일을 선택해 주세요.");
            WF.MovePage("MailSearchList.aspx?strMailBox=" + strMailBox + "&schType=" + strSchType + "&schValue=" + strSchVal);
            return;
        }
        else if (strMailId != "")
        {
            if (strMailId.EndsWith("|"))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            arrMailId = strMailId.Split('|');

            if (strMailBox == "delbox")
            {
                try
                {
                    for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                    {
                        string[] arrMail = arrMailId[iLoop].Split(':');

                        if (File.Exists(strMailPath + arrMail[0] + "\\" + arrMail[1]))
                            File.Move(strMailPath + arrMail[0] + "\\" + arrMail[1], UI.UserPath + "\\inbox\\" + arrMail[1]);
                    }
                }
                catch (Exception err)
                {
                    WF.WriteMessage("선택한 메일을 복구 하는 도중 오류가 발생했습니다.\\r\\n" +
                        "관리자에게 문의하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                    return;
                }
            }

            WF.WriteMessage("선택한 메일을 복원 하였습니다.");
            WF.MovePage("MailSearchList.aspx?strMailBox=" + strMailBox + "&schType=" + strSchType + "&schValue=" + strSchVal);
            return;
        }
    }
    #endregion

    #region 선택한 메일 삭제
    protected void ibDeleteMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string[] arrMailId = null;
        string strMailPath = UI.UserPath + "\\";
        strMailBox = hidMailBox.Value;
        strSchType = hidSchType.Value;
        strSchVal = hidSchValue.Value;

        if (strMailId == "")
        {
            WF.WriteMessage("삭제할 메일을 선택해 주세요.");
            WF.MovePage("MailSearchList.aspx?strMailBox=" + strMailBox + "&schType=" + strSchType + "&schValue=" + strSchVal);
            return;
        }

        if (strMailId != "")
        {
            if (strMailId.EndsWith("|"))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            arrMailId = strMailId.Split('|');

            try
            {
                if (strMailBox == "delete")
                {
                    for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                    {
                        string[] arrMail = arrMailId[iLoop].Split(':');

                        if (File.Exists(strMailPath + "\\" + arrMail[0] + "\\" + arrMail[1]))
                            File.Delete(strMailPath + "\\" + arrMail[0] + "\\" + arrMail[1]);
                    }
                }
                else if (strMailBox != "delbox")
                {
                    for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                    {
                        string[] arrMail = arrMailId[iLoop].Split(':');

                        if (File.Exists(strMailPath + "\\" + arrMail[0] + "\\" + arrMail[1]))
                            File.Move(strMailPath + "\\" + arrMail[0] + "\\" + arrMail[1], UI.UserPath + "\\delbox\\" + arrMail[1]);
                    }
                }
                else
                {
                    for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                    {
                        string[] arrMail = arrMailId[iLoop].Split(':');

                        if (File.Exists(strMailPath + "\\" + arrMail[0] + "\\" + arrMail[1]))
                            File.Delete(strMailPath + "\\" + arrMail[0] + "\\" + arrMail[1]);
                    }
                }
            }
            catch (Exception err)
            {
                WF.WriteMessage("선택한 메일을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "관리자에게 문의하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n").Replace("\"", "\\\""));
                return;
            }

            WF.WriteMessage("선택한 메일이 삭제 되었습니다.");
            WF.MovePage("MailSearchList.aspx?strMailBox=" + strMailBox + "&schType=" + strSchType + "&schValue=" + strSchVal);
            return;
        }
    }
    #endregion

    #region 선택한 메일 이동
    protected void ibMoveMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string[] arrMailId = null;
        string strSelMailbox = ddlMailBoxList.SelectedValue;
        string strSelMailboxName = ddlMailBoxList.SelectedItem.Text;
        strMailBox = hidMailBox.Value;
        strSchType = hidSchType.Value;
        strSchVal = hidSchValue.Value;

        if (strMailId == "")
        {
            // 2006년 11월 22일 수정
            // 출력 문구 수정
            WF.WriteMessage("이동할 메일을 선택해 주세요.");
            WF.MovePage("MailSearchList.aspx?strMailBox=" + strMailBox + "&schType=" + strSchType + "&schValue=" + strSchVal);
            return;
        }

        if (strMailId != "")
        {
            if (strMailId.EndsWith("|"))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            arrMailId = strMailId.Split('|');

            try
            {
                for (int iLoop = 0; iLoop < arrMailId.Length; iLoop++)
                {
                    string[] arrMail = arrMailId[iLoop].Split(':');

                    if (File.Exists(UI.UserPath + "\\" + arrMail[0] + "\\" + arrMail[1]))
                        File.Move(UI.UserPath + "\\" + arrMail[0] + "\\" + arrMail[1], UI.UserPath + "\\" + strSelMailbox + "\\" + arrMail[1]);
                }
            }
            catch (Exception err)
            {
                WF.WriteMessage("선택한 메일을 " + strSelMailboxName + " 편지함으로 이동 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                return;
            }
        }

        //WF.WriteMessage("선택한 메일을 " + strSelMailboxName + " 편지함으로 이동했습니다.");
        WF.MovePage("MailSearchList.aspx?strMailBox=" + strMailBox + "&schType=" + strSchType + "&schValue=" + strSchVal);
    }
    #endregion

    protected void ddlMailBox_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        string strMailBox = ddlMailBox.SelectedValue;

        if (strMailBox == "_line_")
            ddlMailBox.SelectedValue = "";
    }
}
