﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;

public partial class Mail_Main : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbDataAdapter Adap;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private UserInfo UI;
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    protected string strUserId = "";
    protected string strUserName = "";
    protected string strUserEmail = "";
    protected int iNoReadMailCnt = 0;
    protected int iNewMailCnt = 0;
    protected int iMailCnt = 0;
    protected double iUseSize = 0;
    protected double iMaxSize = 0;
    protected double iPer = 0;
    protected string strAutoReplyMsg = "";
    protected string strForwardingMsg = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
		WF.LoginCheck(Session["USER_ID"], "../log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
		strUserId = Session["USER_ID"].ToString();
		
		UI = new UserInfo(strUserId, strDomain, strCon);

        if (!Page.IsPostBack)
        {
            strUserName = UI.UserName;
            strUserEmail = strUserId + "@" + strDomain;
            iNoReadMailCnt = WF.NoReadMailCount(UI.UserPath + "\\inbox");
            iNewMailCnt = WF.ExtMailCount(UI.UserPath + "\\mailbox", ".eml");
            iMailCnt = WF.ExtMailCount(UI.UserPath + "\\inbox", ".eml");

            if (iMailCnt < 1) iMailCnt = iNewMailCnt;

            if (UI.UserMailBoxSize > 0)
            {
                iUseSize = Math.Round(UserUseMailBoxSize(UI.UserPath) / (1024 * 1024), 2);
                iMaxSize = Math.Round(Convert.ToDouble(UI.UserMailBoxSize), 2);

                iPer = Math.Round((iUseSize / iMaxSize) * 100, 2);
            }
            this.MailListBind();
            this.NewBoardDocDataBind();
            this.ScheduleDataBind();
            this.NoteDataBind();
            this.AutoReplyMsg();
            this.UseForwarding();

            Page.DataBind();
        }
    }

    public float UserUseMailBoxSize(string strPath)
    {
        float iSize = 0;
        DirectoryInfo di = new DirectoryInfo(strPath);

        foreach (DirectoryInfo subDi in di.GetDirectories())
        {
            foreach (FileInfo fi in subDi.GetFiles())
                iSize += fi.Length;

            iSize += UserUseMailBoxSize(subDi.FullName);
        }
        return iSize;
    }

    private void AutoReplyMsg()
    {
        if (File.Exists(UI.UserPath + "\\autoreply.htm"))
            strAutoReplyMsg = "※ <b><font color=#ff0000>부재중 자동응답</font></b> 사용중.";
    }

    private void UseForwarding()
    {
        if (File.Exists(UI.UserPath + "\\forwarding.txt"))
            strForwardingMsg = "※ <b><font color=#0000ff>포워딩 </font></b> 사용중.";
    }

    #region 메일 리스트 데이터 바인드
    /// <summary>
    /// 받은편지함에 있는 메일 상위 5개 목록만 보여준다.
    /// </summary>
    private void MailListBind()
    {
        int fileCnt = 0;
        NewMails newMails = new NewMails();
        DataTable dt = new DataTable();
        MailParser mParser = null;

        dt.Columns.Add("mailId", System.Type.GetType("System.String"));
        dt.Columns.Add("mailSubject", System.Type.GetType("System.String"));
        dt.Columns.Add("mailAddr", System.Type.GetType("System.String"));
        dt.Columns.Add("mailDate", System.Type.GetType("System.String"));
        dt.Columns.Add("mailSize", System.Type.GetType("System.String"));

        newMails = WF.NotReadMail(UI.UserPath);

        fileCnt = newMails.Count;

        if (fileCnt > 0)
        {
            string strMailFile = "";
            string strMailBox = "";

            try
            {
                foreach (NewMail nm in newMails)
                {
                    strMailFile = nm.MailFile;
                    strMailBox = nm.MailBox;

                    mParser = new MailParser(UI.UserPath + "\\" + strMailBox + "\\" + strMailFile);

                    DataRow dr = dt.NewRow();
                    dr["mailId"] = strMailFile;

                    // 날짜
                    // 보여주는 형식은 다음과 같다.
                    // 예) 2005-01-01
                    dr["mailDate"] = mParser.MailDateTime.ToString("u", System.Globalization.DateTimeFormatInfo.InvariantInfo).Substring(0, 10);

                    string strSubject = mParser.Subject;

                    // 제목
                    if (strSubject.Trim() == "")
                        strSubject = "제목이 없습니다.";
                    else
                        strSubject = WF.StrCutByte(strSubject, 56, "...");

                    dr["mailSubject"] = "<a href=\"viewMail.aspx?strMailBox=" + strMailBox + "&mailFile=" + strMailFile + "\">" + strSubject + "</a>";

                    string[] arrTmp = WF.linkMailAddress(mParser.MailFrom, "writeMail.aspx?email=", 6, "...");

                    dr["mailAddr"] = arrTmp[0];

                    if (dr["mailAddr"].ToString().Trim() == "")
                        dr["mailAddr"] = "&nbsp;";

                    dr["mailSize"] = WF.GetFileSize(UI.UserPath + "\\" + strMailBox + "\\" + strMailFile);

                    dt.Rows.Add(dr);
                }

                if (fileCnt < 5)
                {
                    for (int iCnt = 0; iCnt < (5 - fileCnt); iCnt++)
                    {
                        DataRow dr = dt.NewRow();
                        dr["mailId"] = "";
                        dt.Rows.Add(dr);
                    }
                }
            }
            catch (Exception err)
            {
                WF.WriteMessage("메일을 파싱해서 리스트를 생성하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "서버 관리자에게 문의하세요.\\r\\n\\r\\n" + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n") +
                    "\\r\\n\\r\\n오류 메일: " + strMailFile);
            }

            rptMailList.DataSource = dt.DefaultView;
            rptMailList.DataBind();
        }
        else
        {
            HtmlTableRow row = new HtmlTableRow();
            HtmlTableCell cell = new HtmlTableCell();

            tblMailList.Border = 0;

            row.BgColor = "#93b2dd";
            row.Height = "2";
            cell.ColSpan = 4;
            row.Cells.Add(cell);
            tblMailList.Rows.Add(row);

            row = new HtmlTableRow();
            row.BgColor = "#93b2dd";
            row.Height = "23";

            cell = new HtmlTableCell();
            cell.InnerHtml = "<b><font color=\"#ffffff\">보낸사람</font></b>";
            cell.Width = "100";
            cell.Align = "center";
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            cell.InnerHtml = "<b><font color=\"#ffffff\">제&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;목</font></b>";
            cell.Align = "center";
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            cell.InnerHtml = "<b><font color=\"#ffffff\">날짜</font></b>";
            cell.Width = "80";
            cell.Align = "center";
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            cell.InnerHtml = "<b><font color=\"#ffffff\">용량</font></b>";
            cell.Width = "80";
            cell.Align = "center";
            row.Cells.Add(cell);

            tblMailList.Rows.Add(row);

            row = new HtmlTableRow();
            cell = new HtmlTableCell();
            row.BgColor = "#E5E5E5";
            row.Height = "1";
            cell.ColSpan = 4;
            row.Cells.Add(cell);

            tblMailList.Rows.Add(row);

            row = new HtmlTableRow();
            cell = new HtmlTableCell();
            row.Height = "120";
            cell.ColSpan = 4;
            cell.Align = "center";
            cell.InnerHtml = "읽지 않은 새 편지가 없습니다.";
            row.Cells.Add(cell);

            tblMailList.Rows.Add(row);

            row = new HtmlTableRow();
            cell = new HtmlTableCell();
            row.BgColor = "#E5E5E5";
            row.Height = "2";
            cell.ColSpan = 4;
            row.Cells.Add(cell);
            tblMailList.Rows.Add(row);

            Page.DataBind();
        }
    }
    #endregion

    #region 최근 게시물 데이터 바인드
    /// <summary>
    /// 최근 게시물 데이터 바인드
    /// </summary>
    private void NewBoardDocDataBind()
    {
        int iRowCnt = 0;
        int iCnt = 0;
        string[,] arrDocInfo = null;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListTop5NewBoardDoc";

            // 도메인 명
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "DOC_INFO");
            dt = ds.Tables["DOC_INFO"];

            iRowCnt = dt.Rows.Count;

            arrDocInfo = new string[iRowCnt, 7];

            foreach (DataRow dr in dt.Rows)
            {
                arrDocInfo[iCnt, 0] = dr["USER_NAME"].ToString();				// 사용자 이름
                arrDocInfo[iCnt, 1] = dr["DOC_NO"].ToString();					// 게시물 번호
                arrDocInfo[iCnt, 2] = dr["BRD_NO"].ToString();					// 게시판 번호
                arrDocInfo[iCnt, 3] = dr["DOC_SUBJECT"].ToString();				// 게시물 제목
                arrDocInfo[iCnt, 4] = dr["DOC_WRITE_DATE"].ToString();			// 게시물 작성일자
                arrDocInfo[iCnt, 5] = dr["EMAIL"].ToString();					// 메일주소
                arrDocInfo[iCnt, 6] = dr["BRD_NAME"].ToString();				// 게시판 이름
                ++iCnt;
            }

            dt.Clear();
            dt.Columns.Remove("EMAIL");
            dt.Columns.Remove("DOC_NO");
            dt.Columns.Remove("BRD_NO");

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();

                // 글 작성자 메일 주소 링크
                dr["USER_NAME"] = "<a href=\"WriteMail.aspx?email=" + arrDocInfo[iLoop, 5] + "\">" + arrDocInfo[iLoop, 0] + "</a>";
                // 글 작성 일자
                dr["DOC_WRITE_DATE"] = arrDocInfo[iLoop, 4];
                // 제목에 게시물 보기 링크 걸기
                arrDocInfo[iLoop, 3] = "<a href=\"../Board/ViewDoc.aspx?brdNo=" + arrDocInfo[iLoop, 2] + "&docNo=" + arrDocInfo[iLoop, 1] +
                    "\">" + WF.StrCutByte(arrDocInfo[iLoop, 3], 45, "..") + "</a>";
                dr["DOC_SUBJECT"] = arrDocInfo[iLoop, 3];
                // 게시판 명
                dr["BRD_NAME"] = "[" + arrDocInfo[iLoop, 6] + "]";

                dt.Rows.Add(dr);
            }

            rptNewBoardDoc.DataSource = dt.DefaultView;
            rptNewBoardDoc.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("최근 등록된 게시물을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
            CommandInit();
        }
    }
    #endregion

    #region 오늘 일정 데이터 바인드
    /// <summary>
    /// 오늘 일정 데이터 바인드
    /// </summary>
    private void ScheduleDataBind()
    {
        DateTime dt = DateTime.Now;
        DataTable dTable = new DataTable();

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prTodaySchedule";

            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@chrSolYear", OleDbType.VarChar, 4);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@chrSolMonth", OleDbType.VarChar, 2);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@chrSolDay", OleDbType.VarChar, 2);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrSolYear"].Value = dt.Year.ToString();
            Cmd.Parameters["@chrSolMonth"].Value = WF.StrPlus(dt.Month.ToString(), 2, "0");
            Cmd.Parameters["@chrSolDay"].Value = WF.StrPlus(dt.Day.ToString(), 2, "0");

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SCHEDULE");
            dTable = ds.Tables["SCHEDULE"];

            int iRowCnt = dTable.Rows.Count;

            if (iRowCnt > 0)
            {
                string[,] arrSchedule = new string[iRowCnt, 5];

                for (int iCnt = 0; iCnt < iRowCnt; iCnt++)
                {
                    arrSchedule[iCnt, 0] = dTable.Rows[iCnt]["SCH_NO"].ToString();
                    arrSchedule[iCnt, 1] = dTable.Rows[iCnt]["SCH_ST_HOUR"].ToString();
                    arrSchedule[iCnt, 2] = dTable.Rows[iCnt]["SCH_ED_HOUR"].ToString();
                    arrSchedule[iCnt, 3] = dTable.Rows[iCnt]["SCH_TITLE"].ToString();
                    arrSchedule[iCnt, 4] = dTable.Rows[iCnt]["SCH_PUBLIC"].ToString();
                }

                dTable.Clear();
                dTable.Columns.Remove("SCH_ST_HOUR");
                dTable.Columns.Remove("SCH_ED_HOUR");
                dTable.Columns.Add("SCH_HOUR", Type.GetType("System.String"));
                dTable.Columns.Add("SCH_YEAR", Type.GetType("System.String"));
                dTable.Columns.Add("SCH_MONTH", Type.GetType("System.String"));
                dTable.Columns.Add("SCH_DAY", Type.GetType("System.String"));

                for (int iCnt = 0; iCnt < iRowCnt; iCnt++)
                {
                    DataRow dr = dTable.NewRow();

                    dr["SCH_NO"] = arrSchedule[iCnt, 0];
                    dr["SCH_HOUR"] = arrSchedule[iCnt, 1] + "시 ~ " + arrSchedule[iCnt, 2] + "시 일정";
                    dr["SCH_TITLE"] = WF.StrCut(arrSchedule[iCnt, 3], 10, "..");
                    dr["SCH_YEAR"] = dt.Year.ToString();
                    dr["SCH_MONTH"] = dt.Month.ToString();
                    dr["SCH_DAY"] = dt.Day.ToString();
                    dr["SCH_PUBLIC"] = arrSchedule[iCnt, 4];

                    dTable.Rows.Add(dr);
                }

                rptTodaySchedule.DataSource = dTable.DefaultView;
                rptTodaySchedule.DataBind();
            }
            else
            {
                HtmlTableRow row = new HtmlTableRow();
                HtmlTableCell cell = new HtmlTableCell();

                row.Height = "100";
                cell.InnerHtml = "등록된 일정이 없습니다.";
                cell.Align = "center";
                row.Cells.Add(cell);

                tblSchedule.Rows.Add(row);

                Page.DataBind();
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("오늘 일정을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
            CommandInit();
        }
    }
    #endregion

    #region 내 노트 데이터 바인드
    /// <summary>
    /// 내 노트 데이터 바인드
    /// </summary>
    private void NoteDataBind()
    {
        string strNote = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("내 노트 DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectNote";

            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "USER_NOTE");
            dt = ds.Tables["USER_NOTE"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    strNote = dr["NOTE_CONTENT"].ToString();
                    break;
                }
            }
        }
        catch (Exception err)
        {
            Con.Close();
            WF.WriteMessage("내 노트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
            CommandInit();
        }

        tbNote.Text = strNote;
    }
    #endregion

    #region 내 노트 수정
    /// <summary>
    /// 내 노트 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbModifyNote_Click(object sender, EventArgs e)
    {
        string strNoteContent = tbNote.Text;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("내 노트 DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertNote";

            Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@varNote", OleDbType.VarChar, strNoteContent.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varNote"].Value = strNoteContent;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue != 0)
            {
                Trans.Rollback();
                WF.WriteMessage("내 노트를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.HistoryBack();
                return;
            }
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("내 노트를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Trans.Commit();
            Con.Close();
            CommandInit();
        }

        Response.Redirect("Main.aspx");
    }
    #endregion

    #region Command 객체 초기화
    /// <summary>
    /// Command 객체 초기화
    /// </summary>
    private void CommandInit()
    {
        Cmd.Parameters.Clear();

    }
    #endregion
}
