﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;

public partial class Mail_SendResult : System.Web.UI.Page
{
    private Passkorea.WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private UserInfo UI;
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    protected string sendMsg;
    private string strUserId = "";
    private string strSendTo = "";
    private string strSendCc = "";
    private string strSendBcc = "";
    private string strSubject = "";
    private string strContent = "";
    private string strSign = "";
    private string strMailFile = "";
    private string strMailBox = "";
    private string strType = "";
    private string strLang = "";
    private string strWriteType = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new Passkorea.WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);
        strUserId = Session["USER_ID"].ToString();

        if (!Page.IsPostBack)
        {
            string strSaveTemp = Request.Params["hidSaveTemp"];
            strSendTo = Request.Params["txtSendTo"];
            strSendCc = Request.Params["txtSendCc"];
            strSendBcc = Request.Params["txtSendBcc"];
            strSubject = Request.Params["txtMailSubject"];
            strContent = Request.Params["hidContent"];
            strSign = Request.Params["tbSignature"];
            strMailFile = Request.Params["hidMailFile"];
            strMailBox = Request.Params["hidMailBox"];
            strType = Request.Params["hidType"];
            strLang = Request.Params["ddlLangType"];
            strWriteType = Request.Params["hidWriteType"];

            if (strSaveTemp == "false")
                SendProcess();
            else
                SaveTempEmail();
            //this.SendResultProc();
            Page.DataBind();
        }
    }

    #region 메일발송
    /// <summary>
    /// 메일을 발송합니다.
    /// </summary>
    private void SendProcess()
    {
        string strEncodingType = "";
        // 수신확인 주소
        string strConfirmUrl = Request.Url.AbsoluteUri.Substring(0, Request.Url.AbsoluteUri.LastIndexOf("/") + 1);
        string[] arrTo = null;
        string[] arrCc = null;
        string[] arrBcc = null;
        bool bFiles = false;
        
        // 본문 내용
        if (strLang.ToLower() == "euc-kr")
            strLang = "ks_c_5601-1987";

        // Set Encoding Type
        if (strLang == "iso-8859-1" || strLang == "iso-2022-jp")
            strEncodingType = "7bit";
        else
            strEncodingType = "8bit";

        Confirms confirms = new Confirms();

        // 수신확인 파일명
        strConfirmUrl += "ConfirmMail.aspx?code=";

        strSendTo = this.CheckGroup(strSendTo.Replace(",", ";"));
        arrTo = strSendTo.Split(';');

        if (strSendCc != "")
        {
            strSendCc = this.CheckGroup(strSendCc.Replace(",", ";"));
            arrCc = strSendCc.Split(';');
        }

        if (strSendBcc != "")
        {
            strSendBcc = this.CheckGroup(strSendBcc.Replace(",", ";"));
            arrBcc = strSendBcc.Split(';');
        }

        try
        {
            MimeConstructor mc = new MimeConstructor(strUserId, strDomain);

            // 사용자 폴더 박스 경로
            mc.UserPath = UI.UserPath;
            // 받는 사람
            mc.To = arrTo;
            // 참조
            if (strSendCc != "") mc.Cc = arrCc;
            // 숨은 참조
            if (strSendBcc != "") mc.Bcc = arrBcc;
            // 외국어 메일
            if (strLang.ToLower() != "euc-kr") mc.ForeignMail = true;
            // 제목
            mc.Subject = strSubject;
            // 보내는 사람
            mc.From = "\"" + UI.UserName + "\" <" + strUserId + "@" + strDomain + ">";
            // 케릭터 셋
            mc.CharSet = strLang;
            // 인코딩 형식
            mc.EncodeType = strEncodingType;

            // 서명 null값 체크
            if (strSign == null)
                strSign = "";

            if (strWriteType.ToLower() == "text")
            {
                // Text 내용
                mc.ContentText = strContent + "\r\n\r\n" + strSign;
                // Html 내용
                mc.ContentHtml = strContent.Replace("\r\n", "<br>") + strSign.Replace("\r\n", "<br>\r\n");
                // 메일 저장 옵션
                mc.SaveMailBox = true;
            }
            else if (strWriteType.ToLower() == "html")
            {
                System.Text.RegularExpressions.Regex regex = new System.Text.RegularExpressions.Regex("<[^<>]*>", System.Text.RegularExpressions.RegexOptions.IgnoreCase);

                // Text 내용
                mc.ContentText = regex.Replace(strContent.Replace("<br>", "\r\n").Replace("&nbsp;", " ").Replace("&lt;", "<").Replace("&gt;", ">"), "") + strSign;
                // Html 내용
                mc.ContentHtml = strContent + "<br><br>" + strSign.Replace("\r\n", "<br>\r\n");

                // 수신확인 사용여부 (수신확인은 기본적으로 메일이 저장되게 되어 있다.)
                mc.MailConfirm = true;

                // 수신확인을 사용하면 수신확인을 할 수 있는 주소를 mc 객체에 넣는다.
                if (mc.MailConfirm)
                    mc.ConfirmUrl = strConfirmUrl;
            }


            // 메일에 있는 첨부파일을 파싱해서 다시 첨부한다.
            if (strMailFile != null && strMailBox != null)
            {
                if (strMailFile != "" && strMailBox != "")
                {
                    if (File.Exists(UI.UserPath + "\\" + strMailBox + "\\" + strMailFile))
                    {
                        Passkorea.MailParse.MailParser mParser = new Passkorea.MailParse.MailParser(UI.UserPath + "\\" + strMailBox + "\\" + strMailFile);
                        mParser.GetAttachFIles();

                        if ((int)mParser.AttachFileCount > 0 || mParser.ImageAttach == true)
                        {
                            bFiles = true;
                            //foreach(object filename in mParser.AttachFiles)
                            foreach (AttachFileInfo fileInfo in mParser.AttachFiles)
                            {
                                // 첨부파일 임시 저장 폴더에 저장
                                if (!Directory.Exists(UI.UserPath + "\\attach_temp"))
                                    Directory.CreateDirectory(UI.UserPath + "\\attach_temp");

                                mParser.SaveAttachFile(UI.UserPath + "\\attach_temp\\", UI.UserPath + "\\" + strMailBox + "\\" + strMailFile, fileInfo.AttachFile);

                                /* 이전에 사용하던 코드
                                if (File.Exists(UI.UserPath + "\\attach_temp\\" + fileInfo.AttachFile))
                                {
                                    //mc.Attachments.Add(new Attachment(UI.UserPath + "\\temp\\" + filename.ToString()));
                                    mc.Attachments.Add(new Attachment(UI.UserPath + "\\attach_temp\\" + fileInfo.AttachFile, fileInfo.ContentID));
                                }
                                */
                            }
                        }
                    }
                }
            }

            // 첨부파일을 붙인다.
            DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\attach_temp");

            if (di.Exists)
            {
                foreach (FileInfo fi in di.GetFiles())
                {
                    if (File.Exists(fi.FullName))
                    {
                        mc.Attachments.Add(new Attachment(fi.FullName, ""));
                        fi.Delete();
                    }
                }
            }
            
            //메일 발송
            mc.SendMail(1);

            // 주소록에 등록되어 있지 않은 메일주소를 메일주소만 등록되는 테이블에 등록한다.
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();

            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertSendEmail";

            sParams = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strEmailAddr", OleDbType.VarChar, 512);
            sParams.Direction = ParameterDirection.Input;

            for (int i = 0; i < arrTo.Length; i++)
            {
                string strTmpEmail = arrTo[i];

                if (strTmpEmail.IndexOf(" ") > 0)
                {
                    strTmpEmail = strTmpEmail.Substring(strTmpEmail.IndexOf(" ") + 1);
                    strTmpEmail = strTmpEmail.Replace("<", "").Replace(">", "");
                }

                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@strEmailAddr"].Value = strTmpEmail;

                Cmd.ExecuteNonQuery();
            }

            Trans.Commit();

            // 메일을 발송하고 나면 수신확인 정보를 DB에 넣는다.
            if (mc.MailConfirm)
            {
                if (InsertConfirmDb(mc.Confirms) != 0)
                {
                    SendResultProc(false);
                    return;
                }
            }

            // 임시 저장함에 해당 메일이 존재하면 삭제한다.
            if (File.Exists(UI.UserPath + "\\SaveBox\\" + strMailFile))
                File.Delete(UI.UserPath + "\\SaveBox\\" + strMailFile);

            if (Directory.Exists(UI.UserPath + "\\attach_temp"))
                Directory.Delete(UI.UserPath + "\\attach_temp", true);

            DeleteTempDirectory(bFiles);
        }
        catch (MimeException err)
        {
            sendMsg = err.Message.Replace("\r\n", "<br><br>\r\n");
            SendResultProc(false);
            return;
        }

        if (File.Exists(UI.UserPath + "\\" + strMailBox + "\\" + strMailFile))
        {
            strType = strType.ToLower();

            // 메일이 답장쓰기 일때 파일명뒤에 답장 여부를 붙여준다.
            if (strType.Equals("re"))
                WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + strMailFile, 2);
            else if (strType.Equals("fw"))
                WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + strMailFile, 3);
        }

        SendResultProc(true);
    }
    #endregion

    #region 메일발송 결과
    /// <summary>
    /// 메일발송 결과를 표시합니다.
    /// </summary>
    /// <param name="bResult"></param>
    private void SendResultProc(bool bResult)
    {
        string[] arrToEmail = null;
        string[] arrCcEmail = null;
        string[] arrBccEmail = null;
        // 메일 발송 성공
        if (bResult)
        {
            // 발송 성공된 메일주소를 출력한다.
            if (strSendTo != "")
            {
                sendMsg = "메일발송 성공";

                // 받는이 메일 주소를 테이블에 출력한다.
                HtmlTableRow rows = new HtmlTableRow();
                HtmlTableCell cell = new HtmlTableCell();

                rows.Height = "23";
                cell.Width = "80";
                cell.Align = "left";
                cell.VAlign = "top";
                cell.InnerHtml = "받는이:";
                rows.Cells.Add(cell);

                cell = new HtmlTableCell();
                cell.Align = "left";
                cell.VAlign = "top";
                cell.Width = "500";

                arrToEmail = strSendTo.Split(';');

                for (int iLoop = 0; iLoop < arrToEmail.Length; iLoop++)
                    cell.InnerHtml += arrToEmail[iLoop].Replace("<", "&lt;") + "<br>";

                if (cell.InnerHtml.EndsWith("<br>"))
                    cell.InnerHtml = cell.InnerHtml.Substring(0, cell.InnerHtml.Length - 4);

                rows.Cells.Add(cell);
                tblSendResult.Rows.Add(rows);

                arrCcEmail = strSendCc.Split(';');

                // 함께 받는이 주소를 테이블에 출력한다.
                if (arrCcEmail.Length > 1)
                {
                    rows = new HtmlTableRow();
                    cell = new HtmlTableCell();

                    rows.Height = "1";
                    cell.Width = "550";
                    cell.Attributes.Add("background", "../images/dot_01.gif");
                    cell.ColSpan = 2;
                    rows.Cells.Add(cell);
                    tblSendResult.Rows.Add(rows);

                    rows = new HtmlTableRow();
                    cell = new HtmlTableCell();
                    rows.Height = "23";
                    cell.Width = "80";
                    cell.Align = "left";
                    cell.VAlign = "top";
                    cell.InnerHtml = "함께 받는이: ";
                    rows.Cells.Add(cell);

                    cell = new HtmlTableCell();
                    cell.Align = "left";
                    cell.VAlign = "top";
                    cell.Width = "500";

                    for (int iLoop = 0; iLoop < arrCcEmail.Length; iLoop++)
                        cell.InnerHtml += arrCcEmail[iLoop].Replace("<", "&lt;") + "<br>";

                    if (cell.InnerHtml.EndsWith("<br>"))
                        cell.InnerHtml = cell.InnerHtml.Substring(0, cell.InnerHtml.Length - 4);

                    rows.Cells.Add(cell);
                    tblSendResult.Rows.Add(rows);
                }

                rows = new HtmlTableRow();
                cell = new HtmlTableCell();

                rows.Height = "1";
                cell.Width = "550";
                cell.Attributes.Add("background", "../images/dot_01.gif");
                cell.ColSpan = 2;
                rows.Cells.Add(cell);
                tblSendResult.Rows.Add(rows);
            }
        }
        else
            sendMsg = sendMsg.Replace("\r\n", "<br><br>\r\n");
    }
    #endregion

    #region 그룹 확인
    private string CheckGroup(string strMailAddr)
    {
        string[] arrValue = null;
        string strValue = "";
        int iCnt = 0;

        if (strMailAddr == "") return "";

        arrValue = strMailAddr.Split(';');
        iCnt = arrValue.Length;

        if (iCnt > -1)
        {
            for (int iLoop = 0; iLoop < iCnt; iLoop++)
            {
                // 2006년 12월 22일 수정
                // 메일주소값이 빈문자열 일때 해당 루틴을 건너뛰도록 함.
                if (arrValue[iLoop].Trim() != "")
                {
                    if (arrValue[iLoop].Substring(0, 1) == "⊙")
                        strValue += this.GetGroupAddr(arrValue[iLoop].Substring(1));
                    else
                        strValue += arrValue[iLoop] + ";";
                }
            }

            if (strValue.Trim() != "")
                strValue = strValue.Substring(0, strValue.LastIndexOf(";"));
        }

        return strValue;
    }
    #endregion

    #region Temp 폴더 삭제
    private void DeleteTempDirectory(bool bFiles)
    {
        DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\temp");

        if (di.Exists)
        {
            di.Delete(true);
            di.Create();
        }
    }
    #endregion

    #region 수신확인 정보를 DB에 넣는다.
    /// <summary>
    /// 수신확인 정보를 수신확인 DB에 넣는다.
    /// </summary>
    /// <param name="confirms"></param>
    /// <returns></returns>
    private int InsertConfirmDb(Confirms confirms)
    {
        string strSubject = "";


        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("WriteMail.aspx");
            return -1;
        }


        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertMailConfirm";

            Cmd.Parameters.Clear();

            // Command Parameter (Send Mail ID)
            sParams = Cmd.Parameters.Add("@varSendMailId", OleDbType.VarChar, 50);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Save Mail ID)
            sParams = Cmd.Parameters.Add("@varSaveMailId", OleDbType.VarChar, 50);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mail Subject)
            sParams = Cmd.Parameters.Add("@varSubject", OleDbType.VarWChar, strSubject.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, 15);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Mail Type)
            sParams = Cmd.Parameters.Add("@chrMailType", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Receive Mail)
            sParams = Cmd.Parameters.Add("@varReceiveMail", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Send Date)
            sParams = Cmd.Parameters.Add("@dtSendDate", OleDbType.Date);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Is Read)
            sParams = Cmd.Parameters.Add("@bIsRead", OleDbType.Boolean);
            sParams.Direction = ParameterDirection.Input;

            foreach (Passkorea.MIME.Confirm c in confirms)
            {
                if (c.Subject.Length > 255)
                    strSubject = c.Subject.Substring(0, 255);
                else
                    strSubject = c.Subject;

                Cmd.Parameters["@varSendMailId"].Value = c.MailFile;
                Cmd.Parameters["@varSaveMailId"].Value = c.SaveMailFile;
                Cmd.Parameters["@varSubject"].Value = strSubject;
                Cmd.Parameters["@varUserId"].Value = c.UserId;
                Cmd.Parameters["@varDomain"].Value = c.Domain;
                Cmd.Parameters["@chrMailType"].Value = c.MailType;
                Cmd.Parameters["@varReceiveMail"].Value = c.ReceiveEmail;
                Cmd.Parameters["@dtSendDate"].Value = c.SendTime;
                Cmd.Parameters["@bIsRead"].Value = 0;

                Cmd.ExecuteNonQuery();
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            sendMsg = "수신확인 정보를 저장하는 도중 오류가 발생했습니다.<br><br>" +
                err.Message.Replace("\r\n", "<br><br>");
            return -1;
        }
        finally
        {
            Con.Close();
        }

        return 0;
    }
    #endregion

    #region 그룹에 등록된 주소를 가져온다.
    /// <summary>
    /// 그룹에 등록된 메일 주소를 가져온다.
    /// </summary>
    /// <param name="strGroup"></param>
    /// <returns></returns>
    private string GetGroupAddr(string strGroup)
    {
        string strAddr = "";
        string strCommon = "";

        // 2006년 11월 22일 수정
        // 그룹 메일 발송시 공유 그룹으로 발송 못하던 문제 수정
        // 그룹명에 구분자를 넣어서 공유 그룹인지 개인 그룹인지 확인
        if (strGroup.IndexOf("‡") > 0)
        {
            strCommon = strGroup.Substring(strGroup.IndexOf("‡") + 1, 1);
            strGroup = strGroup.Substring(0, strGroup.IndexOf("‡"));
        }
        else
            strCommon = "N";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return "";
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupEmail";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroup.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, strCommon.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroup;
            Cmd.Parameters["@chrCommon"].Value = strCommon;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];

            foreach (DataRow dr in dt.Rows)
                strAddr += dr["EMAIL_ADDR"].ToString() + ";";
        }
        catch (Exception err)
        {
            WF.WriteMessage(strGroup + " 그룹에서 주소를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }

        return strAddr;
    }
    #endregion

    private void SaveTempEmail()
    {
        string[] arrTo = null;
        string[] arrCc = null;
        string[] arrBcc = null;
        bool bFiles = false;

        if (strLang == null)
            strLang = "euc-kr";
        else if (!strLang.ToLower().Equals("ks_c_5601-1987"))
            strLang = "euc-kr";

        arrTo = strSendTo.Replace(",", ";").Split(';');
        if (strSendCc != "") arrCc = strSendCc.Replace(",", ";").Split(';');
        if (strSendBcc != "") arrBcc = strSendBcc.Replace(",", ";").Split(';');

        try
        {
            MimeConstructor mc = new MimeConstructor(strUserId, strDomain);

            mc.UserPath = UI.UserPath;
            mc.To = arrTo;
            if (strSendCc != "") mc.Cc = arrCc;
            mc.Subject = strSubject;
            mc.From = UI.UserName + " <" + strUserId + "@" + strDomain + ">";
            mc.CharSet = strLang;
            mc.EncodeType = "8bit";

            mc.ContentText = strContent;
            mc.ContentHtml = strContent;

            // 메일에 있는 첨부파일을 파싱해서 다시 첨부한다.
            if (strMailFile != null && strMailBox != null)
            {
                if (strMailFile != "" && strMailBox != "")
                {
                    Passkorea.MailParse.MailParser mParser = new MailParser(UI.UserPath + "\\" + strMailBox + "\\" + strMailFile);

                    if ((int)mParser.AttachFileCount > 0 || mParser.ImageAttach == true)
                    {
                        bFiles = true;
                        foreach (object filename in mParser.AttachFiles)
                        {
                            // 첨부파일을 저장한다.
                            mParser.SaveAttachFile(UI.UserPath + "\\attach_temp\\", UI.UserPath + "\\" + strMailBox + "\\" + strMailFile, filename.ToString());
                            /*
                            if (File.Exists(UI.UserPath + "\\attach_temp\\" + filename.ToString()))
                                mc.Attachments.Add(new Attachment(UI.UserPath + "\\attach_temp\\" + filename.ToString(), mParser.ContentID));
                            */
                        }
                    }
                }
            }

            // 첨부파일을 붙인다.
            DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\attach_temp");

            if (di.Exists)
            {
                foreach (FileInfo fi in di.GetFiles())
                {
                    if (File.Exists(fi.FullName))
                    {
                        mc.Attachments.Add(new Attachment(fi.FullName, ""));
                        fi.Delete();
                    }
                }
            }

            mc.SaveTempBox();

            if (Directory.Exists(UI.UserPath + "\\attach_temp"))
                Directory.Delete(UI.UserPath + "\\attach_temp", true);

            DeleteTempDirectory(bFiles);
        }
        catch (MimeException err)
        {
            sendMsg = err.Message;
            SendResultProc(false);
        }

        sendMsg = "임시저장함에 편지가 저장되었습니다.";
        SendResultProc(false);
    }
}
