﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;

public partial class Mail_ViewMail : System.Web.UI.Page
{
    protected System.Web.UI.WebControls.Label lblMailAttachFile;

    private MailParser mParser = null;

    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string iPage = "";
    private string mailname = "";
    private string strPort = "";
    protected string strMailBox = "";
    protected string rFileName = "";
    protected string strAttachFiles = "";
    protected string strSubject = "";
    protected string strMailFrom = "";
    protected string strMailTo = "";
    protected string strMailCc = "";
    protected string strUrl = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["strMailBox"];
        mailname = Request.Params["mailFile"];
        iPage = Request.Params["iPage"];

        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (!this.Page.IsPostBack)
        {
            strPort = Request.Url.Port.ToString();
            strUrl = Request.Url.LocalPath;
            strUrl = strUrl.Substring(0, strUrl.LastIndexOf("/") + 1);

            // 2006년 11월 22일 수정
            // 포트가 변경되어 있을 경우에 주소 뒤에 포트 번호를 붙여준다.
            if (strPort != "80")
                strUrl = "http://" + Request.ServerVariables["SERVER_NAME"] + ":" + strPort + strUrl;
            else
                strUrl = "http://" + Request.ServerVariables["SERVER_NAME"] + strUrl;

            rFileName = WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + mailname, 1);
            mailname = rFileName;

            this.ThisMailParse();
            this.MailBoxNameBind();

            // 파일이 존재하면 파일을 읽었는지 체크해서 읽었으면 파일명 뒤에
            // 읽었다는 표시를 붙여준다.
            //if (File.Exists(UI.UserPath + "\\" + strMailBox + "\\" + mailname))
            //rFileName = WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + mailname, 1);
            //else
            //	rFileName = mailname;
            //Page.DataBind();
        }
        else
            rFileName = WF.AddFileName(UI.UserPath + "\\" + strMailBox + "\\" + mailname, 1);

        Page.DataBind();
    }

    #region 해당 메일 파싱
    /// <summary>
    /// 해당 메일 파싱
    /// </summary>
    private void ThisMailParse()
    {
        string[] arrFrom = null;
        string[] arrTo = null;
        string[] arrCc = null;
        int iPos = 0;

        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strContent = null;
        // 메일 파일명 확인
        mailname = WF.CheckMailFile(UI.UserPath + "\\" + strMailBox, mailname);
        try
        {
            mParser = new MailParser(UI.UserPath, strMailBox, mailname);
            // 내용 파싱
            mParser.ParseBody();
            // 첨부파일 갯수
            mParser.GetAttachFIles();

            strSubject = mParser.Subject;

            if (strSubject.Trim() == "")
                strSubject = "메일 제목이 없습니다.";

            strSubject = strSubject.Replace("<", "&lt;");

            arrFrom = WF.linkMailAddress(mParser.MailFrom, "");
            arrTo = WF.linkMailAddress(mParser.MailTo, "");
            arrCc = WF.linkMailAddress(mParser.MailCc, "");

            strMailFrom = MailAddressDisplay(arrFrom, "from", "writeMail.aspx?email=");
            strMailTo = MailAddressDisplay(arrTo, "to", "writeMail.aspx?email=");
            strMailCc = MailAddressDisplay(arrCc, "cc", "writeMail.aspx?email=");
            lblMailDate.Text = mParser.MailDateTime.ToString();

            if (mParser.GetHtmlMailBody != "")
            {
                strContent = WF.ChkContentCid(mParser.GetHtmlMailBody, strUrl + "ViewCidImage.aspx", strMailBox, Server.UrlEncode(mailname));
                //strContent = mParser.GetHtmlMailBody;
                // 본문내용에 <body 태그가 있으면 잘라낸다.
                iPos = strContent.ToLower().IndexOf("<body");

                if (iPos > 0)
                {
                    int iTagEnd = 0;

                    string strHeader = strContent.Substring(0, iPos);
                    strContent = strContent.Substring(iPos + 5);

                    iTagEnd = strContent.IndexOf(">");
                    strContent = strContent.Substring(iTagEnd + 1);
                    strContent = strHeader + strContent;
                }
                
                iPos = strContent.ToLower().IndexOf("</head>");

                if (iPos > 0)
                    strContent = strContent.Substring(iPos + 7);
            }
            else
            {
                strContent = mParser.GetTextMailBody;
                //strContent = strContent.Replace("<", "&lt");
                strContent = strContent.Replace("\r\n", "<br>\r\n");
            }

            // 첨부파일에 이미지가 첨부되어 있을때 본문 내용 밑에 이미지를 출력한다.
            if (mParser.ImageAttach)
            {
                foreach (AttachFileInfo fileInfo in mParser.AttachFiles)
                {
                    string strFile = fileInfo.AttachFile;

                    if (fileInfo.ContentID.Trim() == "")
                    {
                        if (strFile.ToLower().EndsWith("png") ||
                            strFile.ToLower().EndsWith("gif") ||
                            strFile.ToLower().EndsWith("jpg") ||
                            strFile.ToLower().EndsWith("jpeg"))
                        {
                            if (strFile.StartsWith(" "))
                                strFile = strFile.Substring(1);

                            strContent += "<br>\r\n<img src=\"ViewAttachImage.aspx?mailfile=" + Server.UrlEncode(mailname) + "&image=" + Server.UrlEncode(strFile) + "&mailbox=" + strMailBox + "\">\r\n";
                        }
                    }
                }
            }

            // 첨부파일 링크
            if ((int)mParser.AttachFileCount > 0)
            {
                foreach (AttachFileInfo fileInfo in mParser.AttachFiles)
                {
                    string sFileName = fileInfo.AttachFile;

                    if (fileInfo.ContentID.Trim() == "")
                    {
                        if (sFileName.StartsWith(" "))
                            sFileName = sFileName.Substring(1);

                        strAttachFiles += "<a href=\"javascript: attachFileDownload('" + strMailBox + "', '" + sFileName.ToString().Replace("#", "＃") + "');\">" + sFileName.ToString() + "</a><br>";
                    }   
                }

                if (strAttachFiles.Trim() == "") strAttachFiles = "&nbsp;";
            }
            else
                strAttachFiles = "&nbsp;";

            lblMailContent.Text = strContent;
        }
        catch (Exception err)
        {
            WF.WriteMessage(mailname + " 파일명을 가진 메일을 파싱하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListMail.aspx?strMailBox=" + strMailBox + "&iPage=" + iPage.ToString());
            return;
        }
    }
    #endregion

    #region 메일 주소 링크
    /// <summary>
    /// 메일 주소 링크
    /// </summary>
    /// <param name="arrEmail"></param>
    /// <param name="fValue">to, cc 만 들어올 수 있다.</param>
    /// <returns></returns>
    private string MailAddressDisplay(string[] arrEmail, string fValue, string strUrlPage)
    {
        string strTmp = "";
        int iTotCnt = 0;

        if (arrEmail == null)
            return "&nbsp;";

        if (fValue != "from" && fValue != "to" && fValue != "cc")
            return "잘못된 구분값 입니다.";

        iTotCnt = arrEmail.Length;

        if (iTotCnt >= 2)
        {
            --iTotCnt;
            string[] arrTmp = arrEmail[0].Split('|');

            strTmp = "<a href=\"" + strUrlPage + arrTmp[0] + "\">" + arrTmp[1] + "</a>" + " 외 " +
                iTotCnt.ToString() + " 명에게 발송되었습니다.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                "<a href=\"javascript: DisplayEmail('div" + fValue + "');\">더 보기</a><br>" +
                "<div id=\"div" + fValue + "\" style=\"display: none\">";

            for (int iCnt = 0; iCnt <= iTotCnt; iCnt++)
            {
                arrTmp = arrEmail[iCnt].Split('|');

                strTmp += "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\r\n" +
                   "<tr style=\"height:23px;\"><td style=\"width:70%\">" +
                    "<a href=\"" + strUrlPage + arrTmp[0] + "\">" + arrTmp[1] + "</a>&nbsp;(" + arrTmp[0] + ")" +
                    "</td><td style=\"width:30%; padding-left:5px;\" align=\"right\">" +
                    "<a href=\"javascript: AddSpammer('" + arrTmp[0].Replace("'", "\'").Replace("\"", "\\\"") + "');\"><img src=\"../Images/btn_05.gif\" border=\"0\" align=\"absmiddle\"></a>&nbsp;&nbsp;" +
                    "<a href=\"javascript: AddAddress('" + arrTmp[0].Replace("'", "\'").Replace("\"", "\\\"") + "', '" + arrTmp[1].Replace("'", "\'").Replace("\"", "\\\"") + "');\"><img src=\"../images/btn_add.gif\" border=\"0\" align=\"absmiddle\"></a>" +
                    "</td></tr>\r\n" +
                    "</table>";

                if (iCnt == iTotCnt)
                    strTmp += "</div>";
            }
        }
        else
        {
            string[] arrTmp = arrEmail[0].Split('|');
            strTmp = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\r\n" +
                    "<tr style=\"height:23px;\"><td style=\"width:70%\">" +
                    "<a href=\"" + strUrlPage + arrTmp[0] + "\">" + arrTmp[1] + "</a>&nbsp;(" + arrTmp[0] + ")" +
                    "</td><td style=\"width:30%; padding-left:5px;\" align=\"right\">" +
                    "<a href=\"javascript: AddSpammer('" + arrTmp[0].Replace("'", "\'").Replace("\"", "\\\"") + "');\"><img src=\"../Images/btn_05.gif\" border=\"0\" align=\"absmiddle\"></a>&nbsp;&nbsp;" +
                    "<a href=\"javascript: AddAddress('" + arrTmp[0].Replace("'", "\'").Replace("\"", "\\\"") + "', '" + arrTmp[1].Replace("'", "\'").Replace("\"", "\\\"") + "');\"><img src=\"../images/btn_add.gif\" border=\"0\" align=\"absmiddle\"></a>" +
                    "</td></tr>\r\n" +
                    "</table>";
        }

        return strTmp;
    }
    #endregion

    #region 메일박스 이름
    private void MailBoxNameBind()
    {
        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter sParams = new OleDbParameter();
        OleDbDataAdapter Adap;
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        switch (strMailBox)
        {
            case "mailbox":
                lblMailBoxName.Text = "받은편지함";
                break;
            case "inbox":
                lblMailBoxName.Text = "받은편지함";
                break;
            case "outbox":
                lblMailBoxName.Text = "보낸편지함";
                break;
            case "delbox":
                lblMailBoxName.Text = "휴지통";
                break;
            default:
                try
                {
                    Con.Open();
                    Cmd.Connection = Con;
                    Cmd.CommandType = CommandType.StoredProcedure;
                    Cmd.CommandText = "prSelectMailBoxName";

                    // Command Parameter (User Id)
                    sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                    sParams.Direction = ParameterDirection.Input;

                    // Command Parameter (Domain)
                    sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                    sParams.Direction = ParameterDirection.Input;

                    // Command Parameter (MailBox)
                    sParams = Cmd.Parameters.Add("@varMailBox", OleDbType.VarChar, strMailBox.Length);
                    sParams.Direction = ParameterDirection.Input;

                    Cmd.Parameters["@varUserId"].Value = strUserId;
                    Cmd.Parameters["@varDomain"].Value = strDomain;
                    Cmd.Parameters["@varMailBox"].Value = strMailBox;

                    Adap = new OleDbDataAdapter(Cmd);
                    Adap.Fill(ds, "MAIL_BOX");
                    dt = ds.Tables["MAIL_BOX"];

                    int iRowCount = dt.Rows.Count;

                    if (iRowCount > 0)
                    {
                        DataRow dr = dt.Rows[0];
                        lblMailBoxName.Text = dr["M_MAILBOX_NAME"].ToString();
                    }
                }
                catch (Exception err)
                {
                    Con.Close();
                    WF.WriteMessage("메일박스 이름을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                    return;
                }
                finally
                {
                    Con.Close();
                }
                break;
        }
    }
    #endregion

    #region 메일 원문 다운로드
    /// <summary>
    /// 메일 원문 다운로드
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbOrgMailDownload_DownCommand(object sender, EventArgs e)
    {
        MailParser.OriginalMailDownload(this.Page, UI.UserPath, strMailBox, rFileName);
    }
    #endregion
}
