﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Net;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;
using WYSIWYG.Editor;

public partial class Mail_WriteMail : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private MailParser mParser = null;
    private UserInfo UI;
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strMailFile = "";
    private string strType = "";
    private string mTo = "";
    private string mCc = "";
    private string mSubject = "";
    private string mContent = "";
    protected string strUserId = "";
    protected string strDomain = "";
    protected string strEnc = "";
    protected string strMailBox = "";
    protected string strSign1 = "";
    protected string strSign2 = "";
    protected string strSign3 = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        string strScript = "";
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        string strEmail = Request.Params["email"];
        
        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailFile = Request.Params["MailFile"];
        strMailBox = Request.Params["Mailbox"];
        strType = Request.Params["Type"];

        Response.ContentEncoding = Encoding.UTF8;
        Request.ContentEncoding = Encoding.UTF8;

        UI = new UserInfo(strUserId, strDomain, strCon);

        Editor.Width = 760;
        Editor.Height = 250;
        Editor.Path = "../Common/Editor/";

        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        if (!IsPostBack)
        {
            AuthKey ak = new AuthKey();
            string strMsg = ak.CheckUserCount(UI.TotalUserCount(strDomain));

            if (strMsg != "")
                WF.WriteMessage(strMsg.Replace("\r\n", "\\r\\n"));

            if (strMailFile != null && strMailBox != null)
            {
                // 메일파일명과 메일박스명이 존재할때 해당 메일을 파싱해서
                // 쓰기폼으로 되돌려 준다.
                if (strMailFile != "" && strMailBox != "")
                    this.ThisMailParse();

                hidMailFile.Value = strMailFile;
                hidMailBox.Value = strMailBox;
                hidType.Value = strType;
            }

            // 답장일 경우 보낸사람 주소를 넣는다.
            if (strType != null)
            {
                if (strType.ToLower() == "re" || strType.ToLower() == "ar")
                    txtSendTo.Text = mTo;

                if (strType != "")
                    hidContent.Value = mContent;
            }
            else
            {
                if (strEmail != null)
                    mTo = strEmail;

                txtSendTo.Text = mTo;

                if (mCc != null)
                    txtSendCc.Text = mCc;

                hidContent.Value = mContent;
            }

            txtSendBcc.Text = "";
            txtSendCc.Text = "";
            txtMailSubject.Text = mSubject;
            Editor.Value = mContent;

            Signature();
            Page.DataBind();

            DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\temp");

            foreach (FileInfo fi in di.GetFiles())
            {
                if (di.Exists)
                {
                    di.Delete(true);
                    di.Create();
                    break;
                }
            }
        }
    }

    #region 회신, 전체회신, 전달시 또는 임시 저장메일 파싱
    /// <summary>
    /// 회신, 전체회신, 전달시 또는 임시 저장메일 파싱한다.
    /// </summary>
    private void ThisMailParse()
    {
        string strContent = null;
        string msgHeader = "";

        try
        {
            // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
            mParser = new MailParser(UI.UserPath, strMailBox, strMailFile);
            // 내용 파싱
            mParser.ParseBody();

            mSubject = mParser.Subject;

            // 전달 또는 답장이 아닐때 파싱한 주소를 쓰기폼으로 돌려준다.
            if (strType == null)
            {
                mTo = mParser.MailTo.Replace("|", " ").Replace("<", "").Replace(">", "");
                mTo = mTo.Replace(";", ",");
                /*
                string[] arrTo = mTo.Split(',');

                mTo = "";

                for (int i = 0; i < arrTo.Length; i++)
                {
                    string[] aTo = arrTo[i].Split(' ');

                    if (aTo.Length > 1)
                        mTo += aTo[1] + ",";
                    else
                        mTo += arrTo[i] + ",";
                }
                */
                if (mTo.EndsWith(","))
                    mTo = mTo.Substring(0, mTo.Length - 1);

                if (mParser.MailCc != null)
                    mCc = mParser.MailCc.Replace("|", " ").Replace("<", "").Replace(">", "");
            }
            else
            {
                // 쓰기 또는 전달일때
                if (strType.ToLower() == "re")
                {
                    mSubject = "Re: " + mSubject;
                    mTo = mParser.MailFrom.Replace("|", " ");
                }
                else if (strType.ToLower() == "ar")
                {
                    mSubject = "Re: " + mSubject;
                    // Sender Email Address (Mail From)
                    mTo = mParser.MailFrom.Replace("|", " ");
                    // Received Email Address (Mail To)
                    if (mParser.MailTo != null && mParser.MailTo != "")
                    {
                        string strValue = "";
                        string[] strTmp = mParser.MailTo.Split(',');

                        // 받는사람 메일 주소에 사용자 메일주소가 존재하는지 체크
                        // 존재하면 사용자 메일주소는 제외한다.
                        for (int iCnt = 0; iCnt < strTmp.Length; iCnt++)
                        {
                            if (strTmp[iCnt].IndexOf(strUserId + "@" + strDomain) < 0)
                                strValue += strTmp[iCnt] + ",";
                        }

                        // 문자열 마지막에 콤마(,)가 존재하면 제거한다.
                        if (strValue.Length == strValue.IndexOf(","))
                            strValue = strValue.Substring(0, strValue.Length - 1);

                        mTo += "," + mParser.MailTo.Replace("|", " ");
                    }
                    // Received Email Address (Mail Cc)
                    if (mParser.MailCc != null && mParser.MailCc != "")
                        mTo += "," + mParser.MailCc.Replace("|", " ");
                }
                else if (strType.ToLower() == "fw")
                    mSubject = "Fw: " + mSubject;
            }

            if (mParser.GetHtmlMailBody != "")
            {
                if (strType != null)
                {
                    if (strType.ToLower() == "fw")
                        msgHeader = "<br>\r\n<br>\r\n---------- Original Message ----------<br>\r\n";
                    else
                        msgHeader = "<br>\r\n<br>\r\n<hr><br>\r\n";

                    msgHeader += "From: " + WF.linkMailAddress(mParser.MailFrom) + "<br>\r\n" +
                        "To: " + WF.linkMailAddress(mParser.MailTo) + "<br>\r\n" +
                        "Sent: " + mParser.MailDateTime + "<br>\r\n" +
                        "Subject: " + mParser.Subject + "<br><br><br>\r\n";
                }

                strContent = mParser.GetHtmlMailBody;
            }
            else
            {
                if (strType != null)
                {
                    if (strType.ToLower() == "fw")
                        msgHeader = "---------- Original Message ----------<br>\r\n";
                    else
                        msgHeader = "<hr>\r\n";

                    msgHeader += "From: " + mParser.MailFrom + "\r\n" +
                        "To: " + mParser.MailTo + "\r\n" +
                        "Sent: " + mParser.MailDateTime + "\r\n" +
                        "Subject: " + mParser.Subject + "\r\n\r\n\r\n";
                }

                strContent = mParser.GetTextMailBody;
                strContent = strContent.Replace("<", "&lt");
                strContent = strContent.Replace("\r\n", "<br>\r\n");
            }
        }
        catch (Exception err)
        {
            // 오류 처리
            string strMsg = "";

            if (strType == null)
                strMsg = "임시 저장 편지 ";
            else if (strType.ToLower() == "re")
                strMsg = "회신";
            else if (strType.ToLower() == "ar")
                strMsg = "전체회신";
            else if (strType.ToLower() == "fw")
                strMsg = "전달";

            WF.WriteMessage(strMsg + " 중인 메일을 파싱하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.HistoryBack();
            return;
        }

        mContent = msgHeader + strContent;
    }
    #endregion

    #region 본문 내용을 hidContent에 넣는다.
    /// <summary>
    /// 본문 내용을 hidContent에 넣는다.
    /// </summary>
    private string ContentValue()
    {
        StringBuilder sb = new StringBuilder();
        sb.Append("	var getDocument = document.getElementById(\"wysiwygtxtEditor\").contentWindow.document;");
        sb.Append("");
        sb.Append("	if (document.frmWriteMail.chkWriteType[0].checked)");
        sb.Append("	{");
        sb.Append("		document.frmWriteMail.hidWriteType.value = 'Text';");
        sb.Append("		document.frmWriteMail.hidContent.value = document.frmWriteMail.txtTextContent.value;");
        sb.Append("	}");
        sb.Append("	else if (document.frmWriteMail.chkWriteType[1].checked)");
        sb.Append("	{");
        sb.Append("		document.frmWriteMail.hidWriteType.value = 'Html';");
        sb.Append("		document.frmWriteMail.hidContent.value = getDocument.body.innerHTML;");
        sb.Append("	}");

        return sb.ToString();
    }
    #endregion

    #region 그룹 확인
    private string CheckGroup(string strMailAddr)
    {
        string[] arrValue = null;
        string strValue = "";
        int iCnt = 0;

        if (strMailAddr == "") return "";

        arrValue = strMailAddr.Split(';');
        iCnt = arrValue.Length;

        if (iCnt > -1)
        {
            for (int iLoop = 0; iLoop < iCnt; iLoop++)
            {
                // 2006년 12월 22일 수정
                // 메일주소값이 빈문자열 일때 해당 루틴을 건너뛰도록 함.
                if (arrValue[iLoop].Trim() != "")
                {
                    if (arrValue[iLoop].Substring(0, 1) == "⊙")
                        strValue += this.GetGroupAddr(arrValue[iLoop].Substring(1));
                    else
                        strValue += arrValue[iLoop] + ";";
                }
            }

            if (strValue.Trim() != "")
                strValue = strValue.Substring(0, strValue.LastIndexOf(";"));
        }

        return strValue;
    }
    #endregion

    #region 그룹에 등록된 주소를 가져온다.
    /// <summary>
    /// 그룹에 등록된 메일 주소를 가져온다.
    /// </summary>
    /// <param name="strGroup"></param>
    /// <returns></returns>
    private string GetGroupAddr(string strGroup)
    {
        string strAddr = "";
        string strCommon = "";

        // 2006년 11월 22일 수정
        // 그룹 메일 발송시 공유 그룹으로 발송 못하던 문제 수정
        // 그룹명에 구분자를 넣어서 공유 그룹인지 개인 그룹인지 확인
        if (strGroup.IndexOf("‡") > 0)
        {
            strCommon = strGroup.Substring(strGroup.IndexOf("‡") + 1, 1);
            strGroup = strGroup.Substring(0, strGroup.IndexOf("‡"));
        }
        else
            strCommon = "N";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return "";
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupEmail";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroup.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, strCommon.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroup;
            Cmd.Parameters["@chrCommon"].Value = strCommon;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];

            foreach (DataRow dr in dt.Rows)
                strAddr += dr["EMAIL_ADDR"].ToString() + ";";
        }
        catch (Exception err)
        {
            WF.WriteMessage(strGroup + " 그룹에서 주소를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }

        return strAddr;
    }
    #endregion

    #region Temp 폴더 삭제
    private void DeleteTempDirectory(bool bFiles)
    {
        DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\temp");
        
        if (di.Exists)
        {
            di.Delete(true);
            di.Create();
        }
    }
    #endregion

    #region 서명정보 바인드
    /// <summary>
    /// 서명정보를 가져온다.
    /// </summary>
    private void Signature()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectSign";

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SIGN_INFO");
            dt = ds.Tables["SIGN_INFO"];
            int iRowCount = dt.Rows.Count;

            if (iRowCount > 0)
            {
                strSign1 = dt.Rows[0]["S_SIGN1"].ToString().Replace("\r\n", "<br>\r\n");
                strSign2 = dt.Rows[0]["S_SIGN2"].ToString().Replace("\r\n", "<br>\r\n");
                strSign3 = dt.Rows[0]["S_SIGN3"].ToString().Replace("\r\n", "<br>\r\n");
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("서명 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("WriteMail.aspx");
            return;
        }
    }
    #endregion
}
