﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class MailAddress_AddAddrInfo : System.Web.UI.Page
{
    protected string strGroupName = "";
    protected string isCommon = "";

    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = ""; 
    
    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strGroupName = Request.Params["groupName"];
        
        int iPos = strGroupName.IndexOf("│");

        if (iPos > -1)
        {
            isCommon = strGroupName.Substring(iPos + 1, 1);
            strGroupName = strGroupName.Substring(0, iPos);
        }
        else
        {
            isCommon = "N";
        }

        if (!Page.IsPostBack)
        {
            this.GroupDataBind();
        }

        string strScript = "if (!AddAddr()) return false; else return true;";
        ibAddAddrInfo.Attributes.Add("onclick", strScript);
    }

    #region 그룹 데이터 바인드
    /// <summary>
    /// 그룹 데이터를 바인드 한다.
    /// </summary>
    private void GroupDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListAddrInfo.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupName";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrCommon"].Value = "N";

            // 개인 그룹
            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP");
            dt = ds.Tables["MAIL_GROUP"];

            ListItem li = new ListItem("미지정", "");
            ddlAddrGroup.Items.Add(li);

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    li = new ListItem(dr["GROUP_NAME"].ToString(), dr["GROUP_NAME"].ToString() + "│N");
                    ddlAddrGroup.Items.Add(li);
                }
            }

            // 공유 그룹
            Cmd.Parameters["@chrCommon"].Value = "Y";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP_COMMON");
            dt = ds.Tables["MAIL_GROUP_COMMON"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    li = new ListItem(dr["GROUP_NAME"].ToString() + "(공유)", dr["GROUP_NAME"].ToString() + "│Y");
                    ddlAddrGroup.Items.Add(li);
                }
            }
            ddlAddrGroup.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("그룹 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListAddrInfo.aspx");
        }
        finally
        {
            Con.Close();
        }

        if (strGroupName != "" && isCommon != "")
        {
            string strTmp = "";
            strTmp = strGroupName + "│" + isCommon;

            ddlAddrGroup.SelectedValue = strTmp;
        }
    }
    #endregion

    #region 메일주소 등록
    /// <summary>
    /// 메일주소 등록
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAddAddrInfo_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strAddrName = tbAddrName.Text;
        string strAddrEmail = tbAddrEmail.Text;
        string strTel = tbTel1.Text + "-" + tbTel2.Text + "-" + tbTel3.Text;
        string strGroupName = ddlAddrGroup.SelectedValue;
        string strCellPhone = tbCellPhone1.Text + "-" + tbCellPhone2.Text + "-" + tbCellPhone3.Text;
        string strZipCode = tbZipCode1.Text + tbZipCode2.Text;
        string strAddress1 = tbAddress1.Text;
        string strAddress2 = tbAddress2.Text;
        string strCompanyName = tbCompanyName.Text;
        string strPosition = tbPosition.Text;
        string strOfficeTel = tbOfficeTel1.Text + "-" + tbOfficeTel2.Text + "-" + tbOfficeTel3.Text;
        string strOfficeFax = tbOfficeFax1.Text + "-" + tbOfficeFax2.Text + "-" + tbOfficeFax3.Text;
        string strEtcMemo = tbEtcMemo.Text;
        string isAddCommon = "";

        int iPos = 0;
        iPos = strGroupName.IndexOf("│");

        if (iPos > -1)
        {
            isAddCommon = strGroupName.Substring(iPos + 1, 1);
            strGroupName = strGroupName.Substring(0, iPos);
        }
        else
            isAddCommon = "N";

        if (strAddrName.Length > 50)
        {
            WF.WriteMessage("주소록 이름은 한글 25자 또는 영문 50자 이내로 입력해 주세요.");
            return;
        }

        if (strAddrEmail.Length > 255)
        {
            WF.WriteMessage("메일 주소는 255자 이내로 입력해 주세요.");
            return;
        }

        if (strAddress2 != "" && strAddress2.Length > 60)
        {
            WF.WriteMessage("동 이하 주소는 한글 30자 이내로 입력해 주세요.");
            return;
        }

        if (strCompanyName != "" && strCompanyName.Length > 30)
        {
            WF.WriteMessage("회사명(학교명)은 한글 15자 또는 영문 30자 이내로 입력해 주세요.");
            return;
        }

        if (strPosition != "" && strPosition.Length > 30)
        {
            WF.WriteMessage("소속(직위는)은 한글 15자 또는 영문 30자 이내로 입력해 주세요.");
            return;
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("AddAddrInfo.aspx");
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertEmailAddr";

            Cmd.Parameters.Clear();
        
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varEmail", OleDbType.VarChar, strAddrEmail.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varEmailName", OleDbType.VarChar, strAddrName.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varAddr1", OleDbType.VarWChar, strAddress1.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varAddr2", OleDbType.VarWChar, strAddress2.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@chrZipCode", OleDbType.Char, 6);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@chrTel", OleDbType.Char, strTel.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@chrCellPhone", OleDbType.Char, strCellPhone.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varCompanyName", OleDbType.VarWChar, strCompanyName.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varPosition", OleDbType.VarWChar, strPosition.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@chrOfficeTel", OleDbType.Char, strOfficeTel.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@chrOfficeFax", OleDbType.Char, strOfficeFax.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@txtEtcMemo", OleDbType.LongVarWChar, strEtcMemo.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroupName;
            Cmd.Parameters["@varEMail"].Value = strAddrEmail;
            Cmd.Parameters["@varEmailName"].Value = strAddrName;
            Cmd.Parameters["@varAddr1"].Value = strAddress1;
            Cmd.Parameters["@varAddr2"].Value = strAddress2;
            Cmd.Parameters["@chrZipCode"].Value = strZipCode;
            Cmd.Parameters["@chrTel"].Value = strTel;
            Cmd.Parameters["@chrCellPhone"].Value = strCellPhone;
            Cmd.Parameters["@varCompanyName"].Value = strCompanyName;
            Cmd.Parameters["@varPosition"].Value = strPosition;
            Cmd.Parameters["@chrOfficeTel"].Value = strOfficeTel;
            Cmd.Parameters["@chrOfficeFax"].Value = strOfficeFax;
            Cmd.Parameters["@txtEtcMemo"].Value = strEtcMemo;
            Cmd.Parameters["@chrCommon"].Value = isAddCommon;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage(strAddrEmail + " 메일주소를 주소록에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 원인: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("AddAddrInfo.aspx");
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strAddrEmail + " 메일주소를 주소록에 등록하였습니다.");
        WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
    }
    #endregion
}
