﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class MailAddress_AddOutlookAddr : System.Web.UI.Page
{
    protected string strGroupName = "";
    protected string isCommon = "";

    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;
    private UserInfo UI;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strGroupName = Request.Params["groupName"];
        strUserId = Session["USER_ID"].ToString();

        UI = new UserInfo(strUserId, strDomain, strCon);

        int iPos = strGroupName.IndexOf("│");

        if (iPos > 0)
        {
            isCommon = strGroupName.Substring(iPos + 1, 1);
            strGroupName = strGroupName.Substring(0, iPos);
        }
        else
        {
            strGroupName = "";
            isCommon = "N";
        }

        if (!Page.IsPostBack)
        {
            string strTmp = "";

            if (strGroupName != "" && isCommon != "")
                strTmp = strGroupName + "│" + isCommon;

            this.GroupListDataBind();
            ddlGroupList.SelectedValue = strTmp;
        }

        string strScript = "if (!AddOutlookAddr()) return false; else return true;";
        ibAddOutlook.Attributes.Add("onclick", strScript);
    }

    #region 그룹 리스트 데이터 바인드
    /// <summary>
    /// 그룹 리스트 데이터를 바인드한다.
    /// </summary>
    private void GroupListDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupName";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrCommon"].Value = "N";

            // 개인 주소록
            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP");
            dt = ds.Tables["MAIL_GROUP"];

            int iRowCnt = dt.Rows.Count + 1;

            string[,] arrGroup = new string[iRowCnt, 2];

            arrGroup[0, 0] = "미지정";
            arrGroup[0, 1] = "";

            for (int iLoop = 1; iLoop < iRowCnt; iLoop++)
            {
                arrGroup[iLoop, 0] = dt.Rows[iLoop - 1]["GROUP_NAME"].ToString();
                arrGroup[iLoop, 1] = arrGroup[iLoop, 0] + "│N";
            }

            // 공유 주소록
            Cmd.Parameters["@chrCommon"].Value = "Y";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP_COMMON");
            dt = ds.Tables["MAIL_GROUP_COMMON"];

            int iCommonRowCnt = dt.Rows.Count;

            string[,] arrCommonGroup = new string[iCommonRowCnt, 2];

            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                arrCommonGroup[iLoop, 0] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                arrCommonGroup[iLoop, 1] = arrCommonGroup[iLoop, 0] + "│Y";
            }

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrGroup[iLoop, 0], arrGroup[iLoop, 1]);
                ddlGroupList.Items.Add(li);
            }

            // 공유 주소록을 그룹(Drop Down List) 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrCommonGroup[iLoop, 0] + "(공유)", arrCommonGroup[iLoop, 1]);
                ddlGroupList.Items.Add(li);
            }
            ddlGroupList.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("그룹 리스트 데이터를 바인드 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 아웃룩 주소록 등록
    /// <summary>
    /// 아웃룩 주소록 등록
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAddOutlook_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        int iFldCnt = 0;
        int i = 0;
        int iCnt = 0;
        int iPos = 0;
        int iLoop = 0;
        string strFile = "";
        string strOutlookType = rblOutlookType.SelectedValue;
        string[] strField = null;
        string[,] strAddrInfo = new string[3000, 12];
        string strGroup = ddlGroupList.SelectedValue;
        string isAddCommon = "";
        string tmp = "";

        iPos = strGroup.IndexOf("│");

        if (iPos > 0)
        {
            isAddCommon = strGroup.Substring(iPos + 1, 1);
            strGroup = strGroup.Substring(0, iPos);
        }
        else
            isAddCommon = "N";

        iPos = 0;

        if (fOutlook.PostedFile != null)
        {
            strFile = fOutlook.Value;

            if (strFile != "")
            {
                strFile = Path.GetFileName(strFile);
                fOutlook.PostedFile.SaveAs(UI.UserPath + "\\temp\\" + strFile);
            }
        }

        if (!File.Exists(UI.UserPath + "\\temp\\" + strFile))
        {
            WF.WriteMessage("아웃룩 주소록 파일이 정상적으로 업로드 되지 않았습니다.\\r\\n\\r\\n파일을 다시 업로드 해 주세요.");
            return;
        }

        try
        {
            // 주소록 배열값 초기화
            for (iCnt = 0; iCnt < 1000; iCnt++)
            {
                for (int iCnt2 = 0; iCnt2 < 12; iCnt2++)
                    strAddrInfo[iCnt, iCnt2] = "";
            }

            FileStream fs = new FileStream(UI.UserPath + "\\temp\\" + strFile, FileMode.Open);
            using (StreamReader sr = new StreamReader(fs, System.Text.Encoding.Default, true))
            {
                string line = sr.ReadLine();

                strField = line.Split(',');
                iFldCnt = strField.Length;

                for (i = 0; i < iFldCnt; i++)
                    strField[i] = strField[i].Replace("\"", "");

                switch (strOutlookType)
                {
                    case "express":
                        // 아웃룩 익스프레스일 경우
                        while ((line = sr.ReadLine()) != null)
                        {
                            bool bMemo = false;
                            for (i = 0; i < iFldCnt; i++)
                            {
                                if (line == null)
                                    break;

                                iPos = line.IndexOf(",");

                                if (strField[i] == "메모")
                                {
                                    if (line.Trim() == "" && !bMemo)
                                    {
                                        strAddrInfo[iLoop, 11] = tmp;
                                        tmp = "";
                                        continue;
                                    }

                                    if (line.Length > 2 && line.StartsWith("\"") && line.EndsWith("\""))
                                    {
                                        strAddrInfo[iLoop, 11] = line;
                                        tmp = "";
                                    }
                                    else if (line == "\"\"")
                                    {
                                        strAddrInfo[iLoop, 11] = line;
                                        tmp = "";
                                    }
                                    else if (line.StartsWith("\"") && !bMemo)
                                    {
                                        bMemo = true;
                                        tmp += line;
                                        line = sr.ReadLine();
                                        --i;
                                    }
                                    else if (line.EndsWith("\"") && bMemo)
                                    {
                                        if (iPos > 0)
                                            tmp += line.Substring(0, iPos);
                                        else
                                            tmp += line;

                                        strAddrInfo[iLoop, 11] = tmp;
                                        tmp = "";
                                    }
                                    else
                                    {
                                        tmp += line + "\r\n";
                                        line = sr.ReadLine();
                                        --i;
                                    }
                                }
                                else
                                {
                                    if (iPos >= 0)
                                    {
                                        tmp = line.Substring(0, iPos);
                                        line = line.Substring(iPos + 1);
                                    }
                                    else if (line != "")
                                    {
                                        tmp = line;
                                        line = "";
                                    }

                                    if (tmp.StartsWith("\"")) tmp = tmp.Substring(1);
                                    if (tmp.EndsWith("\"")) tmp = tmp.Substring(0, tmp.Length - 1);

                                    switch (strField[i])
                                    {
                                        case "전자 메일 주소":
                                            // 메일주소
                                            strAddrInfo[iLoop, 0] = tmp;
                                            break;
                                        case "메일 주소":
                                            // 메일주소
                                            strAddrInfo[iLoop, 0] = tmp;
                                            break;
                                        case "전체 이름":
                                            // 이름이 20자가 넘으면 20자로 자른다.
                                            if (tmp.Length > 20)
                                                tmp = tmp.Substring(0, 20);

                                            strAddrInfo[iLoop, 1] = tmp;
                                            break;
                                        case "시/도(집)":
                                            // 주소1
                                            strAddrInfo[iLoop, 2] = tmp;
                                            break;
                                        case "구/군/시(집)":
                                            // 주소2
                                            strAddrInfo[iLoop, 3] = tmp;
                                            break;
                                        case "주소(집)":
                                            // 주소2
                                            strAddrInfo[iLoop, 3] += tmp;
                                            break;
                                        case "우편번호(집)":
                                            // 우편번호
                                            strAddrInfo[iLoop, 4] = tmp;
                                            break;
                                        case "집전화":
                                            // 전화번호
                                            strAddrInfo[iLoop, 5] = tmp;
                                            break;
                                        case "휴대폰":
                                            // 이동전화
                                            strAddrInfo[iLoop, 6] = tmp;
                                            break;
                                        case "회사":
                                            // 회사
                                            strAddrInfo[iLoop, 7] = tmp;
                                            break;
                                        case "직함":
                                            // 직함
                                            strAddrInfo[iLoop, 8] = tmp;
                                            break;
                                        case "회사 전화":
                                            // 사무실 전화번호
                                            strAddrInfo[iLoop, 9] = tmp;
                                            break;
                                        case "회사 팩스":
                                            // 사무실 팩스
                                            strAddrInfo[iLoop, 10] = tmp;
                                            break;
                                    }
                                }
                            }
                            iLoop++;
                        }
                        break;
                    case "outlook":
                        while ((line = sr.ReadLine()) != null)
                        {
                            for (i = 0; i < iFldCnt; i++)
                            {
                                if (iLoop == 539)
                                    i = i;

                                iPos = 0;

                                if (line == null)
                                    break;

                                iPos = line.IndexOf(",");

                                if (strField[i] == "메모")
                                {
                                    if (line.StartsWith("\"\","))
                                    {
                                        tmp = line.Substring(0, iPos);
                                        strAddrInfo[iLoop, 11] = tmp;
                                        line = line.Substring(iPos + 1);
                                    }
                                    else if (line.StartsWith("\","))
                                    {
                                        strAddrInfo[iLoop, 11] = tmp;
                                        tmp = "";
                                        line = line.Substring(iPos + 1);
                                    }
                                    else if (line.EndsWith("\""))
                                    {
                                        tmp = line.Substring(0, iPos);
                                        strAddrInfo[iLoop, 11] = tmp;
                                        line = line.Substring(iPos + 1);
                                    }
                                    else
                                    {
                                        tmp += line + "\r\n";
                                        line = sr.ReadLine();
                                        i--;
                                    }
                                }
                                else
                                {
                                    if (iPos >= 0)
                                    {
                                        tmp = line.Substring(0, iPos);
                                        line = line.Substring(iPos + 1);
                                    }
                                    else if (line != "")
                                    {
                                        tmp = line;
                                        line = "";
                                    }

                                    if (tmp.Trim() != "")
                                    {
                                        if (tmp.StartsWith("\"")) tmp = tmp.Substring(1);
                                        if (tmp.EndsWith("\"")) tmp = tmp.Substring(0, tmp.Length - 1);
                                    }

                                    switch (strField[i])
                                    {
                                        case "이름":
                                            // 이름
                                            strAddrInfo[iLoop, 1] = tmp;
                                            break;
                                        case "성":
                                            // 성
                                            if (strField[i] == "성")
                                            {
                                                strAddrInfo[iLoop, 1] = strAddrInfo[iLoop + 1, i] + strAddrInfo[iLoop, 1];

                                                if (strAddrInfo[iLoop, 1] == null || strAddrInfo[iLoop, 1] == "")
                                                    strAddrInfo[iLoop, 1] = "이름없음";
                                                else
                                                {
                                                    if (strAddrInfo[iLoop, 1].Length > 20)
                                                        strAddrInfo[iLoop, 1] = strAddrInfo[iLoop, 1].Substring(0, 20);
                                                }
                                            }
                                            else
                                            {
                                                if (strAddrInfo[iLoop, 1] == null || strAddrInfo[iLoop, 1] == "")
                                                    strAddrInfo[iLoop, 1] = "이름없음";
                                            }
                                            break;
                                        case "전자 메일 주소":
                                            // 메일주소
                                            strAddrInfo[iLoop, 0] = tmp;
                                            break;
                                        case "전자 우편 주소":
                                            // 메일주소
                                            strAddrInfo[iLoop, 0] = tmp;
                                            break;
                                        case "메일 주소":
                                            // 메일주소
                                            strAddrInfo[iLoop, 0] = tmp;
                                            break;
                                        case "집 주소 시/도":
                                            // 주소 1
                                            strAddrInfo[iLoop, 2] = tmp;
                                            break;
                                        case "집 주소 구/군/시":
                                            // 주소 2
                                            strAddrInfo[iLoop, 3] = tmp;
                                            break;
                                        case "집 주소 우편번호":
                                            // 우편번호
                                            strAddrInfo[iLoop, 4] = tmp;
                                            break;
                                        case "집 전화번호":
                                            // 전화번호
                                            strAddrInfo[iLoop, 5] = tmp;
                                            break;
                                        case "휴대폰":
                                            // 이동전화
                                            strAddrInfo[iLoop, 6] = tmp;
                                            break;
                                        case "회사":
                                            // 회사
                                            strAddrInfo[iLoop, 7] = tmp;
                                            break;
                                        case "직함":
                                            // 직함
                                            strAddrInfo[iLoop, 8] = tmp;
                                            break;
                                        case "근무처 전화":
                                            // 사무실 전화번호
                                            strAddrInfo[iLoop, 9] = tmp;
                                            break;
                                        case "근무지 팩스":
                                            // 사무실 팩스
                                            strAddrInfo[iLoop, 10] = tmp;
                                            break;
                                    }

                                    tmp = "";
                                    /*
                                    if (iCnt >= iFldCnt)
                                    {
                                        iCnt = 0;
                                        break;
                                    }
                                    */
                                }
                            }
                            iLoop++;
                        }
                        break;
                }
                sr.Close();
            }
            fs.Close();

            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertEmailAddr";

            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // User Id
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Domain
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Group
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroup.Length);
            sParams.Direction = ParameterDirection.Input;

            // Email Address
            sParams = Cmd.Parameters.Add("@varEmail", OleDbType.VarChar, 255);
            sParams.Direction = ParameterDirection.Input;

            // Email Address Name
            sParams = Cmd.Parameters.Add("@varEmailName", OleDbType.VarWChar, 50);
            sParams.Direction = ParameterDirection.Input;

            // Address 1
            sParams = Cmd.Parameters.Add("@varAddr1", OleDbType.VarWChar, 100);
            sParams.Direction = ParameterDirection.Input;

            // Address 2
            sParams = Cmd.Parameters.Add("@varAddr2", OleDbType.VarWChar, 60);
            sParams.Direction = ParameterDirection.Input;

            // Zip Code
            sParams = Cmd.Parameters.Add("@chrZipCode", OleDbType.Char, 6);
            sParams.Direction = ParameterDirection.Input;

            // Telephone
            sParams = Cmd.Parameters.Add("@chrTel", OleDbType.Char, 13);

            // CellPhone
            sParams = Cmd.Parameters.Add("@chrCellPhone", OleDbType.Char, 13);
            sParams.Direction = ParameterDirection.Input;

            // CompanyName
            sParams = Cmd.Parameters.Add("@varCompanyName", OleDbType.VarWChar, 30);
            sParams.Direction = ParameterDirection.Input;

            // Position
            sParams = Cmd.Parameters.Add("@varPosition", OleDbType.VarWChar, 30);
            sParams.Direction = ParameterDirection.Input;

            // Office Telephone
            sParams = Cmd.Parameters.Add("@chrOfficeTel", OleDbType.Char, 13);
            sParams.Direction = ParameterDirection.Input;

            // Office Fax
            sParams = Cmd.Parameters.Add("@chrOfficeFax", OleDbType.VarChar, 13);
            sParams.Direction = ParameterDirection.Input;

            // ETC Memo
            sParams = Cmd.Parameters.Add("@txtEtcMemo", OleDbType.LongVarWChar);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            for (iCnt = 0; iCnt < iLoop; iCnt++)
            {
                if (strAddrInfo[iCnt, 0].Trim() == "")
                    continue;

                // 메모 앞뒤로 큰따옴표(")를 제거한다.
                if (strAddrInfo[iCnt, 11].StartsWith("\"")) strAddrInfo[iCnt, 11] = strAddrInfo[iCnt, 11].Substring(1);
                if (strAddrInfo[iCnt, 11].EndsWith("\"")) strAddrInfo[iCnt, 11] = strAddrInfo[iCnt, 11].Substring(0, strAddrInfo[iCnt, 11].Length - 1);

                Cmd.Parameters["@varUserId"].Value = strUserId;
                Cmd.Parameters["@varDomain"].Value = strDomain;
                Cmd.Parameters["@varGroup"].Value = strGroup;
                Cmd.Parameters["@varEmail"].Value = strAddrInfo[iCnt, 0];
                Cmd.Parameters["@varEmailName"].Value = strAddrInfo[iCnt, 1];
                Cmd.Parameters["@varAddr1"].Value = strAddrInfo[iCnt, 2];
                Cmd.Parameters["@varAddr2"].Value = strAddrInfo[iCnt, 3];
                Cmd.Parameters["@chrZipCode"].Value = strAddrInfo[iCnt, 4];
                Cmd.Parameters["@chrTel"].Value = strAddrInfo[iCnt, 5];
                Cmd.Parameters["@chrCellPhone"].Value = strAddrInfo[iCnt, 6];
                Cmd.Parameters["@varCompanyName"].Value = strAddrInfo[iCnt, 7];
                Cmd.Parameters["@varPosition"].Value = strAddrInfo[iCnt, 8];
                Cmd.Parameters["@chrOfficeTel"].Value = strAddrInfo[iCnt, 9];
                Cmd.Parameters["@chrOfficeFax"].Value = strAddrInfo[iCnt, 10];
                Cmd.Parameters["@txtEtcMemo"].Value = strAddrInfo[iCnt, 11];
                Cmd.Parameters["@chrCommon"].Value = isAddCommon;

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("메일주소를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                    WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                    return;
                }
                else if (iValue != 0)
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("메일주소를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                    return;
                }
            }

            Trans.Commit();
            Con.Close();
        }
        catch (Exception err)
        {
            WF.WriteMessage("아웃룩 주소록을 주소록에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\r\n", "\\r\\n\\r\\n") + "\\r\\n" + iLoop.ToString());
            WF.HistoryBack();
            return;

        }

        if (File.Exists(UI.UserPath + "\\temp\\" + strFile))
            File.Delete(UI.UserPath + "\\temp\\" + strFile);

        WF.WriteMessage(strGroupName + " 그룹에 아웃룩(익스프레스 포함)에서 메일을 등록하였습니다.");
        WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
    }
    #endregion
}
