﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class MailAddress_EditAddrInfo : System.Web.UI.Page
{
    protected string strGroupName = "";
    protected string isCommon = "";

    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string strEmailId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strEmailId = Request.Params["emailId"];
        strGroupName = Request.Params["groupName"];

        int iPos = strGroupName.IndexOf("│");

        if (iPos > -1)
        {
            isCommon = strGroupName.Substring(iPos + 1, 1);
            strGroupName = strGroupName.Substring(0, iPos);
        }
        else
        {
            isCommon = "N";
            //strGroupName = "";
        }

        if (!Page.IsPostBack)
        {
            this.AddrInfoDataBind();
            this.GroupDataBind();
        }

        string strScript = "if (!DeleteAddr()) return false; else return true;";
        ibDelAddrInfo.Attributes.Add("onclick", strScript);
    }

    #region 주소록 데이터 바인드
    /// <summary>
    /// 주소록 데이터 바인드
    /// </summary>
    private void AddrInfoDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address Id)
            sParams = Cmd.Parameters.Add("@intEmailId", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 2006년 11월 23일 추가
            // Command Parameter (Return User Id)
            sParams = Cmd.Parameters.Add("@varRtnUserId", OleDbType.VarChar, 15);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@intEmailId"].Value = int.Parse(strEmailId);
            Cmd.Parameters["@varGroupName"].Value = strGroupName;
            Cmd.Parameters["@chrCommon"].Value = isCommon;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];


            // 2006년 11월 23일 추가
            // 공유 주소록을 수정하려는 사용자가 등록한 사용자 또는 관리자또 아닐경우에
            // 수정하지 못하게 한다.
            if ((isCommon == "Y") && (strUserId != Cmd.Parameters["@varRtnUserId"].Value.ToString()))
            {
                Con.Close();
                WF.WriteMessage("공유 주소록은 관리자만 수정할 수 있습니다.");
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                return;
            }

            if (dt.Rows.Count > 0)
            {
                string strTel = dt.Rows[0]["TEL"].ToString().Trim();
                string strCellPhone = dt.Rows[0]["CELL_PHONE"].ToString().Trim();
                string strZipCode = dt.Rows[0]["ZIP_CODE"].ToString().Trim();
                string strOfficeTel = dt.Rows[0]["OFFICE_TEL"].ToString().Trim();
                string strOfficeFax = dt.Rows[0]["OFFICE_FAX"].ToString().Trim();

                // 전화번호
                if (strTel != "")
                {
                    string[] arrTel = strTel.Split('-');

                    if (arrTel.Length == 3)
                    {
                        tbTel1.Text = arrTel[0];
                        tbTel2.Text = arrTel[1];
                        tbTel3.Text = arrTel[2];
                    }
                }

                // 이동전화
                if (strCellPhone != "")
                {
                    string[] arrCellPhone = strCellPhone.Split('-');

                    if (arrCellPhone.Length == 3)
                    {
                        tbCellPhone1.Text = arrCellPhone[0];
                        tbCellPhone2.Text = arrCellPhone[1];
                        tbCellPhone3.Text = arrCellPhone[2];
                    }
                }

                // 우편번호
                if (strZipCode != "")
                {
                    int iPos = strZipCode.LastIndexOf("-");

                    if (iPos > -1)
                    {
                        tbZipCode1.Text = strZipCode.Substring(0, iPos);
                        tbZipCode2.Text = strZipCode.Substring(iPos + 1);
                        hidZipCode.Value = strZipCode.Replace("-", "");
                    }
                    else
                    {
                        tbZipCode1.Text = strZipCode.Substring(0, 3);
                        tbZipCode2.Text = strZipCode.Substring(3);
                        hidZipCode.Value = strZipCode;
                    }
                }

                // 회사전화번호
                if (strOfficeTel != "")
                {
                    string[] arrOfficeTel = strOfficeTel.Split('-');

                    if (arrOfficeTel.Length == 3)
                    {
                        tbOfficeTel1.Text = arrOfficeTel[0];
                        tbOfficeTel2.Text = arrOfficeTel[1];
                        tbOfficeTel3.Text = arrOfficeTel[2];
                    }
                }

                // FAX
                if (strOfficeFax != "")
                {
                    string[] arrOfficeFax = strOfficeFax.Split('-');

                    if (arrOfficeFax.Length == 3)
                    {
                        tbOfficeFax1.Text = arrOfficeFax[0];
                        tbOfficeFax2.Text = arrOfficeFax[1];
                        tbOfficeFax3.Text = arrOfficeFax[2];
                    }
                }

                tbAddrName.Text = dt.Rows[0]["EMAIL_NAME"].ToString();
                tbAddrEmail.Text = dt.Rows[0]["EMAIL_ADDR"].ToString();
                tbAddress1.Text = dt.Rows[0]["ADDRESS1"].ToString();
                hidAddress1.Value = tbAddress1.Text;
                tbAddress2.Text = dt.Rows[0]["ADDRESS2"].ToString();
                tbCompanyName.Text = dt.Rows[0]["COMPANY_NAME"].ToString();
                tbPosition.Text = dt.Rows[0]["COMPANY_POSITION"].ToString();
                tbEtcMemo.Text = dt.Rows[0]["ETC_MEMO"].ToString();
            }
            else
            {
                WF.WriteMessage("선택한 주소록 정보가 없습니다..");
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                return;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("선택한 주소록 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
            return;
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }
    }
    #endregion

    #region 그룹 데이터 바인드
    /// <summary>
    /// 그룹 데이터를 바인드 한다.
    /// </summary>
    private void GroupDataBind()
    {
        string strTmpGrp = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupName";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 개인 주소록
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrCommon"].Value = "N";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP");
            dt = ds.Tables["MAIL_GROUP"];

            int iRowCnt = dt.Rows.Count + 1;

            string[,] arrGroup = new string[iRowCnt, 2];

            arrGroup[0, 0] = "미지정";
            arrGroup[0, 1] = "";

            for (int iLoop = 1; iLoop < iRowCnt; iLoop++)
            {
                arrGroup[iLoop, 0] = dt.Rows[iLoop - 1]["GROUP_NAME"].ToString();
                arrGroup[iLoop, 1] = arrGroup[iLoop, 0] + "│N";
            }

            // 공유 주소록
            Cmd.Parameters["@chrCommon"].Value = "Y";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP_COMMON");
            dt = ds.Tables["MAIL_GROUP_COMMON"];

            int iCommonRowCnt = dt.Rows.Count;

            string[,] arrCommonGroup = new string[iCommonRowCnt, 2];

            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                arrCommonGroup[iLoop, 0] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                arrCommonGroup[iLoop, 1] = arrCommonGroup[iLoop, 0] + "│Y";
            }

            // 개인 주소록을 그룹(Drop Down List) 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrGroup[iLoop, 0], arrGroup[iLoop, 1]);
                ddlAddrGroup.Items.Add(li);
            }

            // 공유 주소록을 그룹(Drop Down List) 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrCommonGroup[iLoop, 0] + "(공유)", arrCommonGroup[iLoop, 1]);
                ddlAddrGroup.Items.Add(li);
            }

            if (strGroupName != "" && isCommon != "")
                strTmpGrp = strGroupName + "│" + isCommon;

            ddlAddrGroup.DataBind();

            for (int iLoop = 0; iLoop < ddlAddrGroup.Items.Count; iLoop++)
            {
                if (ddlAddrGroup.Items[iLoop].Value == strTmpGrp)
                {
                    ddlAddrGroup.Items[iLoop].Selected = true;
                    break;
                }
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("그룹 리스트를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.HistoryBack();
        }
    }
    #endregion

    #region 메일주소록 수정
    /// <summary>
    /// 메일주소록 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibEditAddrInfo_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strAddrName = tbAddrName.Text;
        string strAddrEmail = tbAddrEmail.Text;
        string strTel = tbTel1.Text + "-" + tbTel2.Text + "-" + tbTel3.Text;
        string strGroup = ddlAddrGroup.SelectedValue;
        string strCellPhone = tbCellPhone1.Text + "-" + tbCellPhone2.Text + "-" + tbCellPhone3.Text;
        string strZipCode = hidZipCode.Value.Replace("-", ""); //tbZipCode1.Text + tbZipCode2.Text;
        string strAddress1 = hidAddress1.Value; //tbAddress1.Text;
        string strAddress2 = tbAddress2.Text;
        string strCompanyName = tbCompanyName.Text;
        string strPosition = tbPosition.Text;
        string strOfficeTel = tbOfficeTel1.Text + "-" + tbOfficeTel2.Text + "-" + tbOfficeTel3.Text;
        string strOfficeFax = tbOfficeFax1.Text + "-" + tbOfficeFax2.Text + "-" + tbOfficeFax3.Text;
        string strEtcMemo = tbEtcMemo.Text;
        string isCngCommon = "";
        int iPos = 0;

        if (strAddrName.Length > 50)
        {
            WF.WriteMessage("주소록 이름은 한글 25자 또는 영문 50자 이내로 입력해 주세요.");
            WF.HistoryBack();
        }

        if (strAddrEmail.Length > 255)
        {
            WF.WriteMessage("메일 주소는 255자 이내로 입력해 주세요.");
            WF.HistoryBack();
        }

        if (strAddress2 != "" && strAddress2.Length > 60)
        {
            WF.WriteMessage("동 이하 주소는 한글 30자 이내로 입력해 주세요.");
            WF.HistoryBack();
        }

        if (strCompanyName != "" && strCompanyName.Length > 30)
        {
            WF.WriteMessage("회사명(학교명)은 한글 15자 또는 영문 30자 이내로 입력해 주세요.");
            WF.HistoryBack();
        }

        if (strPosition != "" && strPosition.Length > 30)
        {
            WF.WriteMessage("소속(직위는)은 한글 15자 또는 영문 30자 이내로 입력해 주세요.");
            WF.HistoryBack();
        }

        // 그룹명에서 개인 그룹인지 공유 그룹인지 구분하는 분리자를 가져온다.
        iPos = strGroup.IndexOf("│");

        if (iPos > 0)
        {
            isCngCommon = strGroup.Substring(iPos + 1, 1);
            strGroup = strGroup.Substring(0, iPos);
        }
        else
        {
            isCngCommon = "N";
            strGroup = "";
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EditAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName) + "&emailId=" + strEmailId);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (Return Result Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Id)
            sParams = Cmd.Parameters.Add("@intEmailId", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Change Group Name)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroup.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address)
            sParams = Cmd.Parameters.Add("@varEmailAddr", OleDbType.VarChar, strAddrEmail.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Name)
            sParams = Cmd.Parameters.Add("@varEmailName", OleDbType.VarWChar, strAddrName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Address1)
            sParams = Cmd.Parameters.Add("@varAddress1", OleDbType.VarWChar, strAddress1.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Address2)
            sParams = Cmd.Parameters.Add("@varAddress2", OleDbType.VarWChar, strAddress2.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Zip Code)
            sParams = Cmd.Parameters.Add("@chrZipCode", OleDbType.Char, 6);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Telephone)
            sParams = Cmd.Parameters.Add("@chrTel", OleDbType.Char, strTel.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Cell Phone)
            sParams = Cmd.Parameters.Add("@chrCellPhone", OleDbType.Char, strCellPhone.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Company Name)
            sParams = Cmd.Parameters.Add("@varCompanyName", OleDbType.VarWChar, strCompanyName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Position)
            sParams = Cmd.Parameters.Add("@varPosition", OleDbType.VarWChar, strPosition.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Office Tel)
            sParams = Cmd.Parameters.Add("@chrOfficeTel", OleDbType.Char, strOfficeTel.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Office Fax)
            sParams = Cmd.Parameters.Add("@chrOfficeFax", OleDbType.Char, strOfficeFax.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Etc Memo)
            sParams = Cmd.Parameters.Add("@txtEtcMemo", OleDbType.LongVarWChar);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Change Common)
            sParams = Cmd.Parameters.Add("@chrCngCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Execute Result Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varGroup"].Value = strGroup;
            Cmd.Parameters["@varEmailAddr"].Value = strAddrEmail;
            Cmd.Parameters["@varEmailName"].Value = strAddrName;
            Cmd.Parameters["@varAddress1"].Value = strAddress1;
            Cmd.Parameters["@varAddress2"].Value = strAddress2;
            Cmd.Parameters["@chrZipCode"].Value = strZipCode;
            Cmd.Parameters["@chrTel"].Value = strTel;
            Cmd.Parameters["@chrCellPhone"].Value = strCellPhone;
            Cmd.Parameters["@varCompanyName"].Value = strCompanyName;
            Cmd.Parameters["@varPosition"].Value = strPosition;
            Cmd.Parameters["@chrOfficeTel"].Value = strOfficeTel;
            Cmd.Parameters["@chrOfficeFax"].Value = strOfficeFax;
            Cmd.Parameters["@txtEtcMemo"].Value = strEtcMemo;
            Cmd.Parameters["@intEmailId"].Value = strEmailId;
            Cmd.Parameters["@varGroupName"].Value = strGroupName;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrCommon"].Value = isCommon;
            Cmd.Parameters["@chrCngCommon"].Value = isCngCommon;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("EditAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소 정보를 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("EditAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();

            WF.WriteMessage(strAddrEmail + " 메일 주소록을 수정하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EditAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage(strAddrEmail + " 메일 주소록을 수정했습니다.");
        WF.MovePage("ViewAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroup + "│" + isCngCommon) + "&emailId=" + strEmailId);
    }
    #endregion

    #region 메일 주소록 삭제
    /// <summary>
    /// 메일 주소록 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelAddrInfo_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EditAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address Id)
            sParams = Cmd.Parameters.Add("@iEmailId", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroupName;
            Cmd.Parameters["@iEmailId"].Value = int.Parse(strEmailId);
            Cmd.Parameters["@chrCommon"].Value = isCommon;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("EditAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("EditAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
                return;

            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            Con.Close();
            WF.WriteMessage("해당 주소록을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("EditAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("해당 주소록을 삭제하였습니다.");
        WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
    }
    #endregion
}
