﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class MailAddress_ListAddrInfo : System.Web.UI.Page
{
    protected string strGroupName = "";
    protected string isCommon = "";
    protected int iGroupUserCount = 0;
    protected string strSchType = "";
    protected string strSchValue = "";

    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private int iPage = 0;
    private int iPageSize = 15;
    private string strSt = "";
    private string strEd = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        string strPage = Request.Params["iPage"];
        strSchType = WF.StringDefaultValue(Request.Params["schType"], "");
        strSchValue = WF.StringDefaultValue(Request.Params["schValue"], "");

        strUserId = Session["USER_ID"].ToString();
        strSt = Request.Params["strSt"];
        strEd = Request.Params["strEd"];

        strGroupName = WF.StringDefaultValue(Request.Params["groupName"], "");
        iPage = WF.StringToInt(Request.Params["iPage"], 1);

        int iPos = strGroupName.IndexOf("│");

        if (iPos > 0)
        {
            isCommon = strGroupName.Substring(iPos + 1, 1);
            strGroupName = strGroupName.Substring(0, iPos);
        }
        else
        {
            strGroupName = "";
            isCommon = "N";
        }

        if (!Page.IsPostBack)
        {
            this.GroupListDataBind();

            if ((strSt == "" && strEd == "") || (strSt == null || strEd == null))
                this.GroupAddrDataBind(strSchType, strSchValue);
            else
                this.StringSearch(strSt, strEd);

            this.SelectGroupList();

            Page.DataBind();
        }

        string strScript = "if (!QuickAdd()) return false; else return true;";
        ibAddAddr.Attributes.Add("onclick", strScript);

        strScript = "if (!SearchAddress()) return false; else return true;";
        ibSearch.Attributes.Add("onclick", strScript);

        strScript = "if (!DeleteAddress()) return false; else return true;";
        ibDeleteAddress.Attributes.Add("onclick", strScript);
    }

    #region 그룹 리스트 데이터 바인드
    /// <summary>
    /// 그룹 리스트 데이터를 바인드한다.
    /// </summary>
    private void GroupListDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupName";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // 개인 주소록
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrCommon"].Value = "N";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP");
            dt = ds.Tables["MAIL_GROUP"];

            int iRowCnt = dt.Rows.Count + 1;

            string[,] arrGroup = new string[iRowCnt, 2];

            arrGroup[0, 0] = "미지정";
            arrGroup[0, 1] = "";

            for (int iLoop = 1; iLoop < iRowCnt; iLoop++)
            {
                arrGroup[iLoop, 0] = dt.Rows[iLoop - 1]["GROUP_NAME"].ToString();
                arrGroup[iLoop, 1] = arrGroup[iLoop, 0] + "│N";
            }

            // 공유 주소록
            Cmd.Parameters["@chrCommon"].Value = "Y";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_GROUP_COMMON");
            dt = ds.Tables["MAIL_GROUP_COMMON"];

            int iCommonRowCnt = dt.Rows.Count;

            string[,] arrCommonGroup = new string[iCommonRowCnt, 2];

            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                arrCommonGroup[iLoop, 0] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                arrCommonGroup[iLoop, 1] = arrCommonGroup[iLoop, 0] + "│Y";
            }

            // 개인 주소록을 그룹(Drop Down List) 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrGroup[iLoop, 0], arrGroup[iLoop, 1]);
                ddlGroup.Items.Add(li);
                ddlGroupList.Items.Add(li);
            }

            // 공유 주소록을 그룹(Drop Down List) 컨트롤에 추가한다.
            for (int iLoop = 0; iLoop < iCommonRowCnt; iLoop++)
            {
                ListItem li = new ListItem(arrCommonGroup[iLoop, 0] + "(공유)", arrCommonGroup[iLoop, 1]);
                ddlGroup.Items.Add(li);
                ddlGroupList.Items.Add(li);
            }

            ddlGroup.DataBind();
            ddlGroupList.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("그룹 리스트 데이터를 바인드 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 주소록 데이터 바인드
    /// <summary>
    /// 해당 그룹에 등록된 주소록 데이터를 바인드한다.
    /// </summary>
    private void GroupAddrDataBind(string strSchType, string strSchValue)
    {
        int iAddrCnt = 0;
        int iTotalPage = 0;
        string strMovePage = "";
        string strArgs = "&groupName=" + Server.UrlPathEncode(strGroupName + "│" + isCommon) + "&schType=" + strSchType + "&schValue=" + strSchValue;

        strMovePage = Request.PhysicalPath;
        strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (This Page)
            sParams = Cmd.Parameters.Add("@iPage", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Page Size)
            sParams = Cmd.Parameters.Add("@iPageSize", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, 30);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Search Type)
            sParams = Cmd.Parameters.Add("@varSchType", OleDbType.VarWChar, strSchType.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Search Value)
            sParams = Cmd.Parameters.Add("@varSchValue", OleDbType.VarWChar, strSchValue.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Record Total Count -OUTPUT-)
            sParams = Cmd.Parameters.Add("@iTotCnt", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iPage"].Value = iPage;
            Cmd.Parameters["@iPageSize"].Value = iPageSize;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroupName"].Value = strGroupName;
            Cmd.Parameters["@chrCommon"].Value = isCommon;
            Cmd.Parameters["@varSchType"].Value = strSchType;
            Cmd.Parameters["@varSchValue"].Value = strSchValue;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];

            iAddrCnt = int.Parse(Cmd.Parameters["@iTotCnt"].Value.ToString());

            int iRowCnt = dt.Rows.Count;

            if (iRowCnt > 0)
            {
                dt.Columns.Add("GROUP", Type.GetType("System.String"));

                string[,] arrAddrInfo = new string[iRowCnt, 8];

                for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
                {
                    arrAddrInfo[iLoop, 0] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                    arrAddrInfo[iLoop, 1] = dt.Rows[iLoop]["EMAIL_ID"].ToString();
                    arrAddrInfo[iLoop, 2] = dt.Rows[iLoop]["EMAIL_ADDR"].ToString();
                    arrAddrInfo[iLoop, 3] = dt.Rows[iLoop]["EMAIL_NAME"].ToString();
                    arrAddrInfo[iLoop, 4] = dt.Rows[iLoop]["TEL"].ToString().Trim();
                    arrAddrInfo[iLoop, 5] = dt.Rows[iLoop]["CELL_PHONE"].ToString().Trim();
                    arrAddrInfo[iLoop, 6] = dt.Rows[iLoop]["IS_COMMON"].ToString();
                    arrAddrInfo[iLoop, 7] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                }

                dt.Clear();

                for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
                {
                    DataRow dr = dt.NewRow();
                    dr["GROUP_NAME"] = Server.UrlEncode(arrAddrInfo[iLoop, 0] + "│" + arrAddrInfo[iLoop, 6]);
                    dr["EMAIL_ID"] = int.Parse(arrAddrInfo[iLoop, 1]);
                    dr["EMAIL_ADDR"] = arrAddrInfo[iLoop, 2];
                    dr["EMAIL_NAME"] = arrAddrInfo[iLoop, 3];

                    // 전화번호
                    if (arrAddrInfo[iLoop, 4] == "" || arrAddrInfo[iLoop, 4] == "--")
                        dr["TEL"] = "&nbsp;";
                    else
                        dr["TEL"] = arrAddrInfo[iLoop, 4];

                    // 이동전화
                    if (arrAddrInfo[iLoop, 5] == "" || arrAddrInfo[iLoop, 5] == "--")
                        dr["CELL_PHONE"] = "&nbsp;";
                    else
                        dr["CELL_PHONE"] = arrAddrInfo[iLoop, 5];

                    dr["GROUP"] = arrAddrInfo[iLoop, 7];

                    dt.Rows.Add(dr);
                }

                iTotalPage = iAddrCnt / 15;

                if ((iAddrCnt % 15) > 0)
                    iTotalPage++;
            }
            rptAddrList.DataSource = dt.DefaultView;
            rptAddrList.DataBind();
        }
        catch (Exception err)
        {
            Con.Close();

            WF.WriteMessage(strGroupName + " 그룹에 등록된 주소록 수를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
        }
        finally
        {
            Con.Close();
        }

        iGroupUserCount = iAddrCnt;
        lblPageLink.Text = WF.PageLink(iTotalPage, iPage, strMovePage, strArgs, 10, "", "", "", "");
    }
    #endregion

    #region 그룹 리스트 셀렉트
    /// <summary>
    /// 
    /// </summary>
    private void SelectGroupList()
    {
        string strTmp = "";

        if (strGroupName != "" && isCommon != "")
            strTmp = strGroupName + "│" + isCommon;

        ddlGroupList.SelectedValue = strTmp;
        ddlGroup.SelectedValue = strTmp;
    }
    #endregion

    #region 빠른 주소록 추가 버튼
    /// <summary>
    /// 빠른 주소록 추가 버튼
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAddAddr_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strAddrName = tbAddrName.Text;
        string strAddrEmail = tbAddrEmail.Text;
        string strTel = tbTel1.Text + "-" + tbTel2.Text + "-" + tbTel3.Text;
        string strGroup = ddlGroup.SelectedValue;
        string isCommon = "";
        int iPos = 0;

        // 그룹이 개인 그룹인지 공유 그룹인지 확인한다.
        // 그룹 컨트롤에서 선택된 Value에 그룹 구분자가 들어있다.
        iPos = strGroup.LastIndexOf("│");

        if (iPos > 0)
        {
            isCommon = strGroup.Substring(iPos + 1, 1);
            strGroup = strGroup.Substring(0, iPos);
        }
        else
            isCommon = "N";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertQEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User ID)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, strGroup.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address)
            sParams = Cmd.Parameters.Add("@varEmailAddr", OleDbType.VarChar, strAddrEmail.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Name)
            sParams = Cmd.Parameters.Add("@varEmailName", OleDbType.VarWChar, strAddrName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Telephone)
            sParams = Cmd.Parameters.Add("@chrTel", OleDbType.Char, strTel.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroupName"].Value = strGroup;
            Cmd.Parameters["@varEmailAddr"].Value = strAddrEmail;
            Cmd.Parameters["@varEmailName"].Value = strAddrName;
            Cmd.Parameters["@chrCommon"].Value = isCommon;
            Cmd.Parameters["@chrTel"].Value = strTel;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroup + "│" + isCommon));
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소를 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroup + "│" + isCommon));
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();

            WF.WriteMessage(strAddrEmail + " 메일주소를 " + strGroup + " 그룹에 등록하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroup + "│" + isCommon));
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroup + "│" + isCommon));
    }
    #endregion

    #region 주소록 검색
    /// <summary>
    /// 주소록 검색
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strSchValue = txtSchValue.Text;
        string strSchType = ddlSchType.SelectedValue;

        if (strSchValue == "")
        {
            WF.WriteMessage("검색어를 입력해 주세요.");
            WF.HistoryBack();
            return;
        }

        this.GroupAddrDataBind(strSchType, strSchValue);
    }
    #endregion

    #region 주소록 정보 수정
    /// <summary>
    /// 주소록 정보 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibEditAddr_EditCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
    {
        string strEmailId = e.CommandArgument.ToString();

        WF.MovePage("EditAddrInfo.aspx?emailId=" + strEmailId + "&groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
    }
    #endregion

    #region 주소록 삭제
    /// <summary>
    /// 주소록 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelAddr_DeleteCommand(object sender, System.Web.UI.WebControls.CommandEventArgs e)
    {
        string strEmailId = e.CommandArgument.ToString();

        if (strEmailId != "")
        {
            if (isCommon == "")
            {
                int iPos = strGroupName.IndexOf("│");

                if (iPos > 0)
                {
                    isCommon = strGroupName.Substring(iPos + 1, 1);
                    strGroupName = strGroupName.Substring(0, iPos);
                }
                else
                    isCommon = "N";
            }

            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
                Trans = Con.BeginTransaction();
            }
            catch (Exception err)
            {
                WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                    err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                return;
            }

            try
            {
                Cmd.Connection = Con;
                Cmd.Transaction = Trans;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prDeleteEmailAddr";

                Cmd.Parameters.Clear();

                // Command Parameter (Execute Return Value)
                sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                sParams.Direction = ParameterDirection.ReturnValue;

                // Command Parameter (User Id)
                sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (Domain)
                sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (Group Name)
                sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroupName.Length);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (Email Address Id)
                sParams = Cmd.Parameters.Add("@iEmailId", OleDbType.Integer);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (Common)
                sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
                sParams.Direction = ParameterDirection.Input;

                // Command Parameter (Output Value)
                sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
                sParams.Direction = ParameterDirection.Output;

                Cmd.Parameters["@varUserId"].Value = strUserId;
                Cmd.Parameters["@varDomain"].Value = strDomain;
                Cmd.Parameters["@varGroup"].Value = strGroupName;
                Cmd.Parameters["@iEmailId"].Value = int.Parse(strEmailId);
                Cmd.Parameters["@chrCommon"].Value = isCommon;

                Cmd.ExecuteNonQuery();

                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("메일주소 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                    WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                    return;
                }
                else if (iValue != 0)
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("메일주소 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
                    return;
                }
                Trans.Commit();
            }
            catch (Exception err)
            {
                Trans.Rollback();

                WF.WriteMessage("해당 주소록을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
            }
            finally
            {
                Con.Close();
            }

            WF.WriteMessage("해당 주소록을 삭제했습니다.");
            WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
        }
    }
    #endregion

    #region 주소록 그룹 이동
    /// <summary>
    /// 주소록 그룹 이동
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ddlGroupList_SelectIndexChanged(object sender, EventArgs e)
    {
        int iRowCnt = ddlGroupList.Items.Count;
        string strGroup = ddlGroupList.SelectedValue;

        WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroup));
    }
    #endregion

    #region 주소록 이름 검색
    /// <summary>
    /// 주소록을 이름 첫자로 검색한다.
    /// </summary>
    /// <param name="strSt"></param>
    /// <param name="strEd"></param>
    private void StringSearch(string strSt, string strEd)
    {
        int iTotCnt = 0;

        if (isCommon == "")
        {
            int iPos = strGroupName.IndexOf("│");

            if (iPos > -1)
            {
                isCommon = strGroupName.Substring(iPos + 1, 1);
                strGroupName = strGroupName.Substring(0, iPos);
            }
            else
            {
                isCommon = "N";
                //strGroupName = "";
            }
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prStringSearchAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group)
            sParams = Cmd.Parameters.Add("@chrIsCommon", OleDbType.Char, isCommon.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Start Search String)
            sParams = Cmd.Parameters.Add("@chrSchSt", OleDbType.WChar, 2);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (End Search String)
            sParams = Cmd.Parameters.Add("@chrSchEd", OleDbType.WChar, 2);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Total Count)
            sParams = Cmd.Parameters.Add("@iTotCount", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroupName;
            Cmd.Parameters["@chrIsCommon"].Value = isCommon;
            Cmd.Parameters["@chrSchSt"].Value = strSt;
            Cmd.Parameters["@chrSchEd"].Value = strEd;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SEARCH_MAIL_ADDRESS");
            dt = ds.Tables["SEARCH_MAIL_ADDRESS"];

            iGroupUserCount = int.Parse(Cmd.Parameters["@iTotCount"].Value.ToString());

            int iRowCnt = dt.Rows.Count;
            // 2006년 11월 23일 수정
            // 주소록 검색시 이름 ㄱ~ㅎ 검색을 해서 나온 결과중 주소록 보기를 했을때
            // 주소록이 공유인지 아닌지 구분해주는 구분값이 없어서 
            string[,] arrAddrInfo = new string[iRowCnt, 8];

            dt.Columns.Add("GROUP", Type.GetType("System.String"));

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                arrAddrInfo[iLoop, 0] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
                arrAddrInfo[iLoop, 1] = dt.Rows[iLoop]["EMAIL_ID"].ToString();
                arrAddrInfo[iLoop, 2] = dt.Rows[iLoop]["EMAIL_ADDR"].ToString();
                arrAddrInfo[iLoop, 3] = dt.Rows[iLoop]["EMAIL_NAME"].ToString();
                arrAddrInfo[iLoop, 4] = dt.Rows[iLoop]["TEL"].ToString().Trim();
                arrAddrInfo[iLoop, 5] = dt.Rows[iLoop]["CELL_PHONE"].ToString().Trim();
                // 2006년 11월 23일 수정
                // 공유 주소록 구분필드 추가
                arrAddrInfo[iLoop, 6] = dt.Rows[iLoop]["IS_COMMON"].ToString();
                arrAddrInfo[iLoop, 7] = dt.Rows[iLoop]["GROUP_NAME"].ToString();
            }

            dt.Clear();

            for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
            {
                DataRow dr = dt.NewRow();
                // 2006년 11월 23일 수정
                // 그룹명에 공유 구분자 추가
                dr["GROUP_NAME"] = Server.UrlEncode(arrAddrInfo[iLoop, 0] + "│" + arrAddrInfo[iLoop, 6]);
                dr["EMAIL_ID"] = int.Parse(arrAddrInfo[iLoop, 1]);
                dr["EMAIL_ADDR"] = arrAddrInfo[iLoop, 2];
                dr["EMAIL_NAME"] = arrAddrInfo[iLoop, 3];

                // 전화번호
                if (arrAddrInfo[iLoop, 4] == "" || arrAddrInfo[iLoop, 4] == "--")
                    dr["TEL"] = "&nbsp;";
                else
                    dr["TEL"] = arrAddrInfo[iLoop, 4];

                // 이동전화
                if (arrAddrInfo[iLoop, 5] == "" || arrAddrInfo[iLoop, 5] == "--")
                    dr["CELL_PHONE"] = "&nbsp;";
                else
                    dr["CELL_PHONE"] = arrAddrInfo[iLoop, 5];

                dr["GROUP"] = arrAddrInfo[iLoop, 7];

                dt.Rows.Add(dr);
            }

            rptAddrList.DataSource = dt.DefaultView;
            rptAddrList.DataBind();
        }
        catch (Exception err)
        {
            WF.WriteMessage("'" + strSt + "' 검색어로 주소록을 검색하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region Repeater 컨트롤 아이템 데이터 바운드
    /// <summary>
    /// Repeater 컨트롤에 바운드 되는 ImageButton에 onclick 속성을 추가한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void rptAddrList_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        string strValue = "";
        string strDeleteScript = "";
        int iItemCnt = e.Item.Controls.Count;

        try
        {
            for (int i = 0; i < iItemCnt; i++)
            {
                ImageButton ibDelete = (ImageButton)e.Item.Controls[i].FindControl("ibDelAddr");

                if (ibDelete != null)
                {
                    strValue = ibDelete.CommandName.ToString();
                    strDeleteScript = "if (!confirm('해당 메일주소(" + strValue + ")를 삭제하겠습니까?')) return false; else return true;";
                    ibDelete.Attributes.Add("onclick", strDeleteScript);
                }
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage(err.Message.Replace("\r\n", "\\r\\n\\r\\n"));
        }
    }
    #endregion

    protected void ibDeleteAddress_Click(object sender, ImageClickEventArgs e)
    {
        string strEmails = hidAddrEmail.Value;
        string[] strEmail = null;
        int i = 0;

        if (strEmails.Trim() == "")
        {
            WF.WriteMessage("삭제하려는 메일주소가 선택되지 않았습니다.");
            return;
        }
        else
        {
            if (strEmails.EndsWith("|"))
                strEmails = strEmails.Substring(0, strEmails.Length - 1);
        }

        strEmail = strEmails.Split('|');

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address Id)
            sParams = Cmd.Parameters.Add("@iEmailId", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroupName;
            Cmd.Parameters["@chrCommon"].Value = isCommon;

            for (i = 0; i < strEmail.Length; i++)
            {
                Cmd.Parameters["@iEmailId"].Value = int.Parse(strEmail[i]);

                Cmd.ExecuteNonQuery();
                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("메일주소 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                    return;
                }
                else if (iValue != 0)
                {
                    Trans.Rollback();
                    Con.Close();
                    WF.WriteMessage("메일주소 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                        "SQL Error Number: " + iValue.ToString());
                    return;

                }
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage("해당 주소록을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("선택한 주소록을 삭제하였습니다.");
        WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
    }
}
