﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class MailAddress_ViewAddrInfo : System.Web.UI.Page
{
    protected string strEmailId = "";
    protected string strGroupName = "";
    
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    protected string isCommon = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strEmailId = Request.Params["emailId"];
        strGroupName = Request.Params["groupName"];

        if (!Page.IsPostBack)
        {
            int iPos = strGroupName.IndexOf("│");

            if (iPos > -1)
            {
                isCommon = strGroupName.Substring(iPos + 1, 1);
                strGroupName = strGroupName.Substring(0, iPos);
            }
            else
            {
                isCommon = "N";
                strGroupName = "";
            }

            this.AddrInfoDataBind();
        }

        string strScript = "if (!DeleteAddr()) return false; else return true;";
        ibDelAddrInfo.Attributes.Add("onclick", strScript);
    }

    #region 주소록 데이터 바인드
    /// <summary>
    /// 주소록 데이터 바인드
    /// </summary>
    private void AddrInfoDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName));
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Gropu Name)
            sParams = Cmd.Parameters.Add("@varGroupName", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address Id)
            sParams = Cmd.Parameters.Add("@intEmailId", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // 2006년 11월 23일 추가
            // Command Parameter (Return User Id)
            sParams = Cmd.Parameters.Add("@varRtnUserId", OleDbType.VarChar, 15);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@intEmailId"].Value = int.Parse(strEmailId);
            Cmd.Parameters["@varGroupName"].Value = strGroupName;
            Cmd.Parameters["@chrCommon"].Value = isCommon;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];

            if (dt.Rows.Count > 0)
            {
                lblAddrName.Text = dt.Rows[0]["EMAIL_NAME"].ToString();
                lblAddrEmail.Text = dt.Rows[0]["EMAIL_ADDR"].ToString();
                lblTel.Text = dt.Rows[0]["TEL"].ToString();
                lblAddrGroup.Text = strGroupName;
                lblCellPhone.Text = dt.Rows[0]["CELL_PHONE"].ToString();
                lblZipCode.Text = dt.Rows[0]["ZIP_CODE"].ToString();
                lblAddress.Text = dt.Rows[0]["ADDRESS1"].ToString() + " ";
                lblAddress.Text += dt.Rows[0]["ADDRESS2"].ToString();
                lblCompanyName.Text = dt.Rows[0]["COMPANY_NAME"].ToString();
                lblPosition.Text = dt.Rows[0]["COMPANY_POSITION"].ToString();
                lblOfficeTel.Text = dt.Rows[0]["OFFICE_TEL"].ToString();
                lblOfficeFax.Text = dt.Rows[0]["OFFICE_FAX"].ToString();
                lblEtcMemo.Text = dt.Rows[0]["ETC_MEMO"].ToString();
            }
            else
            {
                WF.WriteMessage("선택한 주소록 정보가 없습니다..");
                WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
            }

            // 2006년 11월 23일 추가
            // 공유 주소록을 수정하려는 사용자가 등록한 사용자 또는 관리자또 아닐경우에
            // 수정, 삭제버튼을 보여주지 않는다.
            if ((isCommon == "Y") && (strUserId != Cmd.Parameters["@varRtnUserId"].Value.ToString()))
            {
                imgBtn12.Visible = false;
                ibDelAddrInfo.Visible = false;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("선택한 주소록 정보를 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n"));
            WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 주소록 삭제
    /// <summary>
    /// 주소록 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDelAddrInfo_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        if (isCommon == "")
        {
            int iPos = strGroupName.IndexOf("│");

            if (iPos > -1)
            {
                isCommon = strGroupName.Substring(iPos + 1, 1);
                strGroupName = strGroupName.Substring(0, iPos);
            }
            else
            {
                isCommon = "N";
                //strGroupName = "";
            }
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ViewAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteEmailAddr";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Group Name)
            sParams = Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar, strGroupName.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Email Address Id)
            sParams = Cmd.Parameters.Add("@iEmailId", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Common)
            sParams = Cmd.Parameters.Add("@chrCommon", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 300);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@varGroup"].Value = strGroupName;
            Cmd.Parameters["@iEmailId"].Value = int.Parse(strEmailId);
            Cmd.Parameters["@chrCommon"].Value = isCommon;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.MovePage("ViewAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("메일주소 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("ViewAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
                return;

            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage("해당 주소록을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("ViewAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon) + "&emailId=" + strEmailId);
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("해당 주소록을 삭제하였습니다.");
        WF.MovePage("ListAddrInfo.aspx?groupName=" + Server.UrlEncode(strGroupName + "│" + isCommon));
    }
    #endregion
}
