﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Schedule_Schedule : System.Web.UI.Page
{
    protected string strYear = "";
    protected string strMonth = "";
    protected string strDay = "";
    protected string strHour = "";
    protected string strSchNo = "";

    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataTable dt = new DataTable();
    private DataSet ds = new DataSet();

    private WebFunction WF;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    private string strUserId = "";
    private string strPublic = "";
    private int iSchNo = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strSchNo = Request.Params["schNo"];
        strPublic = Request.Params["schPublic"];

        strYear = Request.Params["strYear"];
        strMonth = Request.Params["strMonth"];
        strDay = Request.Params["strDay"];
        strHour = Request.Params["strHour"];

        if (strSchNo != "" && strSchNo != null)
            iSchNo = int.Parse(strSchNo);

        if (!Page.IsPostBack)
        {
            if (strHour == null)
                strHour = DateTime.Now.Hour.ToString();

            this.ScheduleInit();
            this.ScheduleTypeDataBind();
            this.SchduleImportDataBind();

            if (iSchNo > 0)
            {
                ibDeleteSchedule.Visible = true;
                this.DefaultDataBind(iSchNo);
            }
            else
                ibModifySchedule.ImageUrl = "../images/btn_10.gif";

            this.DropDownListDataSelected(ddlYear, strYear);
            this.DropDownListDataSelected(ddlMonth, WF.StrPlus(strMonth, 2, "0"));
            this.DropDownListDataSelected(ddlDay, WF.StrPlus(strDay, 2, "0"));
        }
    }

    #region 일정등록 데이터 초기화
    /// <summary>
    /// 일정 등록 데이터 초기화
    /// </summary>
    private void ScheduleInit()
    {
        DateTime date = DateTime.Now;
        int iYear = date.Date.Year;
        int iMonth = int.Parse(strMonth);
        int iDay = 0;

        // 일정 시작, 종료 시간 데이터 바인드
        this.DdlDataBind(ddlStHour, 8, 23, "SCH_HOUR", 1);
        this.DdlDataBind(ddlEdHour, 8, 23, "SCH_HOUR", 1);
        // 일정 시작, 종료 시간(분) 데이터 바인드
        this.DdlDataBind(ddlStMin, 0, 55, "SCH_MINUTE", 5);
        this.DdlDataBind(ddlEdMin, 0, 55, "SCH_MINUTE", 5);
        // 일정 등록 일자(년) 데이터 바인드
        this.DdlDataBind(ddlYear, iYear - 1, iYear + 5, "SCH_YEAR", 1);
        // 일정 등록 일자(월) 데이터 바인드
        this.DdlDataBind(ddlMonth, 1, 12, "SCH_MONTH", 1);
        // 일정 등록 일자(일) 데이터 바인드

        if ((iMonth == 4 || iMonth == 6 || iMonth == 9 || iMonth == 11))
            iDay = 30;
        else if ((iMonth == 2) && !(iYear % 4 == 0))
            iDay = 28;
        else if ((iMonth == 2) && (iYear % 4) == 0)
        {
            if (iMonth % 100 == 100)
            {
                if (iMonth % 400 == 0)
                    iDay = 29;
                else
                    iDay = 28;
            }
            else
                iDay = 29;
        }
        else
            iDay = 31;

        this.DdlDataBind(ddlDay, 1, iDay, "SCH_DAY", 1);
    }
    #endregion

    #region 일정종류 데이터를 바인드한다.
    /// <summary>
    /// 일정종류 데이터를 바인드한다.
    /// </summary>
    private void ScheduleTypeDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("DaySchedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth + "&strDay=" + strDay);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListCodeData";

            Cmd.Parameters.Clear();

            // Command Parameter (Code Class)
            sParams = Cmd.Parameters.Add("@chrCodeClass", OleDbType.Char, 3);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@chrCodeClass"].Value = "SC";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SCH_TYPE");

            dt = ds.Tables["SCH_TYPE"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    ListItem li = new ListItem(dr["CODE_NAME"].ToString(), dr["CODE_ID"].ToString());
                    ddlSchType.Items.Add(li);
                }
                ddlSchType.DataBind();
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("일정 종류 데이터를 DropDownList 컨트롤에 바인드 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("DaySchedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth + "&strDay=" + strDay);
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 일정 중요도 데이터를 바인드 한다.
    /// <summary>
    /// 일정 중요도 데이터를 바인드 한다.
    /// </summary>
    private void SchduleImportDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("DaySchedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth + "&strDay=" + strDay);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListCodeData";

            Cmd.Parameters.Clear();

            // Command Parameter (Code Class)
            sParams = Cmd.Parameters.Add("@chrCodeClass", OleDbType.Char, 3);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@chrCodeClass"].Value = "ST";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SCH_IMPORT");

            dt = ds.Tables["SCH_IMPORT"];

            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    ListItem li = new ListItem(dr["CODE_NAME"].ToString(), dr["CODE_ID"].ToString());
                    ddlSchImport.Items.Add(li);
                }
                ddlSchImport.DataBind();
                ddlSchImport.SelectedIndex = 2;
            }
        }
        catch (Exception err)
        {
            WF.WriteMessage("일정 중요도 데이터를 DropDownList 컨트롤에 바인드 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("DaySchedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth + "&strDay=" + strDay);
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region DropDownList 컨트롤에 데이터를 추가한다.
    /// <summary>
    /// DropDownList 컨트롤에 데이터를 추가한다.
    /// </summary>
    /// <param name="objDDL"></param>
    /// <param name="iStart"></param>
    /// <param name="iEnd"></param>
    /// <param name="strColumn"></param>
    /// <param name="iStep"></param>
    private void DdlDataBind(DropDownList objDDL, int iStart, int iEnd, string strColumn, int iStep)
    {
        DataTable dt = new DataTable();
        string strValue = "";

        dt.Columns.Add(strColumn, System.Type.GetType("System.String"));

        for (int iLoop = iStart; iLoop <= iEnd; iLoop = iLoop + iStep)
        {
            if (iStart.ToString().Length == 1)
                strValue = WF.StrPlus(iLoop.ToString(), 2, "0");
            else
                strValue = iLoop.ToString();

            DataRow dr = dt.NewRow();
            dr[strColumn] = strValue;
            dt.Rows.Add(dr);
        }

        objDDL.DataSource = dt.DefaultView;
        objDDL.DataTextField = strColumn;
        objDDL.DataValueField = strColumn;
        objDDL.DataBind();
    }
    #endregion

    #region DropDownList 컨트롤에 아이템을 선택한다.
    /// <summary>
    /// DropDownList 컨트롤에 아이템을 선택한다.
    /// </summary>
    /// <param name="objDDL"></param>
    /// <param name="strData"></param>
    private void DropDownListDataSelected(DropDownList objDDL, string strData)
    {
        int iRowCnt = objDDL.Items.Count;

        for (int iLoop = 0; iLoop < iRowCnt; iLoop++)
        {
            if (objDDL.Items[iLoop].Value == strData)
            {
                objDDL.SelectedIndex = iLoop;
                //objDDL.Items[iLoop].Selected = true;
                break;
            }
        }
    }
    #endregion

    #region 일정 데이터 바인드
    /// <summary>
    /// 일정 데이터 바인드
    /// </summary>
    private void DefaultDataBind(int iSchNo)
    {
        string strStHour = "";
        string strStMinute = "";
        string strEdHour = "";
        string strEdMinute = "";
        string strTitle = "";
        string strContent = "";
        string strSchType = "";
        string strSchRepeat = "";
        string strSchImport = "";
        string strSchIsLunar = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectSchedule";

            Cmd.Parameters.Clear();

            // Command Parameter (Schedule No)
            sParams = Cmd.Parameters.Add("@iSchNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Public)
            sParams = Cmd.Parameters.Add("@chrPublic", OleDbType.VarChar, strPublic.Length);
            sParams.Direction = ParameterDirection.Input;

            Cmd.Parameters["@iSchNo"].Value = iSchNo;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrPublic"].Value = strPublic;

            OleDbDataReader sr = Cmd.ExecuteReader();

            while (sr.Read())
            {
                strStHour = sr["SCH_ST_HOUR"].ToString();
                strStMinute = sr["SCH_ST_MINUTE"].ToString();
                strEdHour = sr["SCH_ED_HOUR"].ToString();
                strEdMinute = sr["SCH_ED_MINUTE"].ToString();
                strSchIsLunar = sr["SCH_IS_LUNAR"].ToString();
                strTitle = sr["SCH_TITLE"].ToString();
                strContent = sr["SCH_CONTENT"].ToString();
                strSchType = sr["SCH_TYPE"].ToString();
                strSchRepeat = sr["SCH_REPEAT"].ToString();
                strSchImport = sr["SCH_IMPORT"].ToString();
                strPublic = sr["SCH_PUBLIC"].ToString();

                if (strSchIsLunar == "Y")
                {
                    strYear = sr["LUN_YEAR"].ToString();
                    strMonth = sr["LUN_MONTH"].ToString();
                    strDay = sr["LUN_DAY"].ToString();
                }
                else
                {
                    strYear = sr["SOL_YEAR"].ToString();
                    strMonth = sr["SOL_MONTH"].ToString();
                    strDay = sr["SOL_DAY"].ToString();
                }
                break;
            }

            if (strPublic.ToUpper() == "Y")
            {
                tbSchTitle.ReadOnly = true;
                tbContent.ReadOnly = true;
                ibModifySchedule.Visible = false;
                ibDeleteSchedule.Visible = false;
            }

            tbSchTitle.Text = strTitle;
            tbContent.Text = strContent;
            this.DropDownListDataSelected(ddlSchType, strSchType);
            this.DropDownListDataSelected(ddlSchImport, strSchImport);
            this.DropDownListDataSelected(ddlStHour, strStHour);
            this.DropDownListDataSelected(ddlStMin, strStMinute);
            this.DropDownListDataSelected(ddlEdHour, strEdHour);
            this.DropDownListDataSelected(ddlEdMin, strEdMinute);
        }
        catch (Exception err)
        {
            WF.WriteMessage("일정을 가져오는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }
    }
    #endregion

    #region 날짜가 바뀌면 발생하는 이벤트
    /// <summary>
    /// 날짜가 바뀌면 발생하는 이벤트
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ddlDay_SelectedIndexChanged(object sender, EventArgs e)
    {
        int iYear = int.Parse(ddlYear.SelectedValue);
        int iMonth = int.Parse(ddlMonth.SelectedValue);
        int iDay = int.Parse(ddlDay.SelectedValue);
        bool bLunar = false;

        int iItemCnt = rblSolLun.Items.Count;

        for (int iLoop = 0; iLoop < iItemCnt; iLoop++)
        {
            if (rblSolLun.Items[iLoop].Selected)
            {
                if (rblSolLun.Items[iLoop].Value == "Y")
                {
                    bLunar = true;
                    break;
                }
            }
        }

        if (bLunar)
        {
        }
        else
        {
            if ((iMonth == 4 || iMonth == 6 || iMonth == 9 || iMonth == 11) && (iDay > 30))
            {
                ddlDay.SelectedValue = "30";
                return;
            }
            else if ((iMonth == 2) && !(iYear % 4 == 0))
            {
                if (iDay > 28)
                    ddlDay.SelectedValue = "28";
            }
            else if ((iMonth == 2) && (iYear % 4) == 0)
            {
                if (iMonth % 100 == 100)
                {
                    if (iMonth % 400 == 0)
                    {
                        if (iDay > 29)
                            ddlDay.SelectedValue = "29";
                    }
                    else
                    {
                        if (iDay > 28)
                            ddlDay.SelectedValue = "28";
                    }
                }
                else
                {
                    if (iDay > 29)
                        ddlDay.SelectedValue = "29";
                }
            }
        }
    }
    #endregion

    #region 일정 데이터 수정
    /// <summary>
    /// 일정 데이터 수정
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibModifySchedule_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strSchTitle = tbSchTitle.Text;
        string strSchType = ddlSchType.SelectedValue;
        string strRepeat = rblRepeat.SelectedValue;
        string strSchImport = ddlSchImport.SelectedValue;
        string strSolLun = rblSolLun.SelectedValue;
        string strYear = ddlYear.SelectedValue;
        string strMonth = ddlMonth.SelectedValue;
        string strDay = ddlDay.SelectedValue;
        string strStHour = ddlStHour.SelectedValue;
        string strStMin = ddlStMin.SelectedValue;
        string strEdHour = ddlEdHour.SelectedValue;
        string strEdMin = ddlEdMin.SelectedValue;
        string strContent = tbContent.Text;
        string strSolDate = "";
        string strLunDate = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth +
                "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;

            Cmd.Parameters.Clear();

            if (strSolLun == "N")
            {
                // 양력 일때 음력 일자를 가져온다.
                Cmd.CommandText = "prTopOneLunarDate";
                strSolDate = strYear + "-" + WF.StrPlus(strMonth, 2, "0") + "-" + WF.StrPlus(strDay, 2, "0");

                sParams = Cmd.Parameters.Add("@chrSolarDate", OleDbType.Char, 10);
                sParams.Direction = ParameterDirection.Input;

                sParams = Cmd.Parameters.Add("@chrLunarDate", OleDbType.Char, 10);
                sParams.Direction = ParameterDirection.Output;

                Cmd.Parameters["@chrSolarDate"].Value = strSolDate;

                Cmd.ExecuteNonQuery();

                strLunDate = Cmd.Parameters["@chrLunarDate"].Value.ToString();

                if (strLunDate == "" || strLunDate == null)
                {
                    Trans.Rollback();

                    WF.WriteMessage("해당 날짜에 해당하는 음력 데이터가 DB에 존재하지 않습니다.\\r\\n\\r\\n서버 관리자에게 문의 하세요.");
                    WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth +
                        "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
                }
            }
            else
            {
                // 음력 일때 양력 일자를 가져온다.
                Cmd.CommandText = "prTopOneSolarDate";
                strLunDate = strYear + "-" + WF.StrPlus(strMonth, 2, "0") + "-" + WF.StrPlus(strDay, 2, "0");

                sParams = Cmd.Parameters.Add("@chrLunarDate", OleDbType.Char, 10);
                sParams.Direction = ParameterDirection.Input;

                sParams = Cmd.Parameters.Add("@chrSolarDate", OleDbType.Char, 10);
                sParams.Direction = ParameterDirection.Output;

                Cmd.Parameters["@chrLunarDate"].Value = strLunDate;

                Cmd.ExecuteNonQuery();

                strSolDate = Cmd.Parameters["@chrSolarDate"].Value.ToString();

                if (strSolDate == "" || strSolDate == null)
                {
                    Trans.Rollback();

                    WF.WriteMessage("해당 날짜에 해당하는 양력 데이터가 DB에 존재하지 않습니다.\\r\\n\\r\\n서버 관리자에게 문의 하세요.");
                    WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth +
                        "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
                }
            }

            Cmd.CommandText = "prModifySchedule"; ;

            Cmd.Parameters.Clear();

            // Stored Procedure 실행 결과값
            sParams = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;
            // 사용자 아이디
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;
            // 도메인
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;
            // 양력 일자(년)
            sParams = Cmd.Parameters.Add("@chrSolYear", OleDbType.Char, 4);
            sParams.Direction = ParameterDirection.Input;
            // 양력 일자(월)
            sParams = Cmd.Parameters.Add("@chrSolMonth", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 양력 일자(일)
            sParams = Cmd.Parameters.Add("@chrSolDay", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 음력 일자(년)
            sParams = Cmd.Parameters.Add("@chrLunYear", OleDbType.Char, 4);
            sParams.Direction = ParameterDirection.Input;
            // 음력 일자(월)
            sParams = Cmd.Parameters.Add("@chrLunMonth", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 음력 일자(일)
            sParams = Cmd.Parameters.Add("@chrLunDay", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 일정시작 시간(시)
            sParams = Cmd.Parameters.Add("@chrSchStHour", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 일정시작 시간(분)
            sParams = Cmd.Parameters.Add("@chrSchStMinute", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 일정종료 시간(시)
            sParams = Cmd.Parameters.Add("@chrSchEdHour", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 일정종료 시간(분)
            sParams = Cmd.Parameters.Add("@chrSchEdMinute", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 일정 제목
            sParams = Cmd.Parameters.Add("@varSchTitle", OleDbType.VarWChar, strSchTitle.Length);
            sParams.Direction = ParameterDirection.Input;
            // 일정 내용
            sParams = Cmd.Parameters.Add("@txtSchContent", OleDbType.LongVarWChar);
            sParams.Direction = ParameterDirection.Input;
            // 일정 종류
            sParams = Cmd.Parameters.Add("@chrSchType", OleDbType.VarChar, 2);
            sParams.Direction = ParameterDirection.Input;
            // 공휴일 여부
            sParams = Cmd.Parameters.Add("@chrSchHoliday", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;
            // 공용일정 여부
            sParams = Cmd.Parameters.Add("@chrSchPublic", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;
            // 일정 반복 여부
            sParams = Cmd.Parameters.Add("@chrSchRepeat", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;
            // 일정 중요도
            sParams = Cmd.Parameters.Add("@chrSchImport", OleDbType.Char, 2);
            sParams.Direction = ParameterDirection.Input;
            // 일정 음력 여부
            sParams = Cmd.Parameters.Add("@chrSchIsLunar", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;
            // 일정 번호
            sParams = Cmd.Parameters.Add("@intSchNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;
            
            Cmd.Parameters["@intSchNo"].Value = iSchNo;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrSolYear"].Value = strSolDate.Substring(0, 4);
            Cmd.Parameters["@chrSolMonth"].Value = strSolDate.Substring(5, 2);
            Cmd.Parameters["@chrSolDay"].Value = strSolDate.Substring(8, 2);
            Cmd.Parameters["@chrLunYear"].Value = strLunDate.Substring(0, 4);
            Cmd.Parameters["@chrLunMonth"].Value = strLunDate.Substring(5, 2);
            Cmd.Parameters["@chrLunDay"].Value = strLunDate.Substring(8, 2);
            Cmd.Parameters["@chrSchStHour"].Value = strStHour;
            Cmd.Parameters["@chrSchStMinute"].Value = strStMin;
            Cmd.Parameters["@chrSchEdHour"].Value = strEdHour;
            Cmd.Parameters["@chrSchEdMinute"].Value = strEdMin;
            Cmd.Parameters["@varSchTitle"].Value = strSchTitle;
            Cmd.Parameters["@txtSchContent"].Value = strContent;
            Cmd.Parameters["@chrSchType"].Value = strSchType;
            Cmd.Parameters["@chrSchHoliday"].Value = "N";
            Cmd.Parameters["@chrSchPublic"].Value = "N";
            Cmd.Parameters["@chrSchRepeat"].Value = strRepeat;
            Cmd.Parameters["@chrSchImport"].Value = strSchImport;
            Cmd.Parameters["@chrSchIsLunar"].Value = strSolLun;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

            if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage("일정을 등록(수정)하는 도중오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth +
                    "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
                return;

            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();

            WF.WriteMessage("일정을 등록(수정)하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n") + "\\r\\n\\r\\n" +
                "오류 소스: " + err.Source.ToString());
            WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth +
                "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("일정이 등록(수정)되었습니다.");
        WF.ParentPageReload();
        WF.WndClose();
    }
    #endregion

    #region 일정 데이터 삭제
    /// <summary>
    /// 일정 데이터를 삭제한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDeleteSchedule_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth + "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteSchedule";

            Cmd.Parameters.Clear();

            // Command Parameter (Execute Return Value)
            sParams = Cmd.Parameters.Add("@iValue", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            // Command Parameter (Schedule No)
            sParams = Cmd.Parameters.Add("@iSchNo", OleDbType.Integer);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (User Id)
            sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            // Command Parameter (Output Value)
            sParams = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iSchNo"].Value = iSchNo;
            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();

            int iValue = int.Parse(Cmd.Parameters["@iValue"].Value.ToString());

            if (iValue < 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("공유 일정을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
                WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth + "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
                return;
            }
            else if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();
                WF.WriteMessage("공유 일정을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth + "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
                return;
            }
            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            WF.WriteMessage("일정을 삭제하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("Schedule.aspx?strYear=" + strYear + "&strMonth=" + strMonth + "&strDay=" + strDay + "&schNo=" + iSchNo.ToString());
            return;
        }
        finally
        {
            Con.Close();
        }

        WF.WriteMessage("해당 일정이 삭제 되었습니다.");
        WF.ParentPageReload();
        WF.WndClose();
    }
    #endregion
}
