﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using Passkorea;

public partial class Setting_Setting : System.Web.UI.Page
{
    protected string strNode;
    private XmlDocument doc = new XmlDocument();
    private WebFunction WF = null;
    private bool bSetting = false;

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);

        doc.Load(Request.PhysicalApplicationPath + "\\Web.Config");

        // Web.Config파일에 appSetting 엘리먼트가 존재하는지 확인한다.
        XmlNodeList appNodeList = doc.GetElementsByTagName("appSetting");
        bSetting = this.SettingNodeList(appNodeList);

        if (bSetting)
        {
            // Web.Config파일에 add 엘리먼트가 존재하는지 확인한다.
            XmlNodeList addNodeList = doc.GetElementsByTagName("add");
            bSetting = this.SettingNodeList(addNodeList);

            // appSetting, add 엘리먼트가 존재하면 환경설정이 되어 있는것으로 간주한다.
            // 그래서 셋팅을 두번이상 할 수 없게 한다.
            if (bSetting)
            {
                WF.WriteMessage("환경설정이 되어 있습니다.\\r\\n\\r\\n환경설정은 두번 할 수 없습니다.");
                WF.MovePage("../Log/Login.aspx");
                return;
            }
        }

        if (!Page.IsPostBack)
        {
            WebhardTreeList();
        }

        ibSetting.Attributes.Add("onclick", "if (!Setting()) return false; else return true;");
    }

    public bool SettingNodeList(XmlNodeList NodeList)
    {
        foreach (XmlNode node in NodeList)
            return true;

        return false;
    }

    private void WebhardTreeList()
    {
        string strPath = Server.MapPath("../Images/style");

        DirectoryInfo di = new DirectoryInfo(strPath);

        foreach (DirectoryInfo d in di.GetDirectories())
        {
            ListItem item = new ListItem(d.Name, "../Images/style/" + d.Name);
            ddlTreeList.Items.Add(item);
        }

        ddlTreeList.DataBind();
    }

    protected void ibSetting_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strSqlServer = tbSQLServer.Text;
        string strSqlLoginId = tbSQLLoginId.Text;
        string strSqlLoginPwd = tbSQLLoginPwd.Text;
        string strDatabase = tbDatabase.Text;
        string strDomain = Passkorea.Configuration.GetConfigField("serverinfo", "root_domain");
        string strMailListCount = "15";
        string strMailListPagingCount = "15";
        string strUserName = tbUserName.Text;
        string strUserId = tbUserId.Text;
        string strUserPwd = tbUserPwd.Text;
        //string strCon = "Provider=SQLNCLI; Server=" + strSqlServer + "; Database=" + strDatabase + "; user id=" + strSqlLoginId + "; password=" + strSqlLoginPwd + ";";
        string strCon = "Provider=SQLOLEDB; Data Source=" + strSqlServer + "; Initial Catalog=" + strDatabase + "; user id=" + strSqlLoginId + "; password=" + strSqlLoginPwd + ";";
        string strUserPath = "";
        string strMaxSize = "";
        string strWebhardPath = tbWebhardPath.Text;
        string strDownLimitCount = tbDownLimitCount.Text;
        string strDownLimitDay = tbDownLimitDay.Text;
        string strDefaultSize = tbDefaultSize.Text;
        string strTreeType = ddlTreeList.SelectedValue;

        OleDbConnection Con = new OleDbConnection(strCon);
        OleDbTransaction Trans = null;
        OleDbCommand Cmd = new OleDbCommand();
        OleDbParameter Param = new OleDbParameter();

        // 웹하드 회원 등록에 사용되는 객체
        Webhard_Passkorea.WebSource.Member _member = new Webhard_Passkorea.WebSource.Member();
        _member.ConnectionString = strCon;

        // Add Administrator
        try
        {
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            WF.WriteMessage("DB Connection Fail!!!\\r\\n\\r\\n" +
                err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        try
        {
            strMaxSize = Passkorea.Configuration.GetConfigField("serverinfo", "default_maxsize");

            if (strMaxSize == "" || strMaxSize == null)
                strMaxSize = "10";

            // 사용자 수를 가져와 폴더 경로를 만든다.
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prUserCount";

            Param = Cmd.Parameters.Add("@intUserCount", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varDomain"].Value = strDomain;

            Cmd.ExecuteNonQuery();
            int iValue = int.Parse(Cmd.Parameters["@intUserCount"].Value.ToString(), System.Globalization.NumberStyles.Number);

            // 사용자 폴더를 2000명 단위로 나눠서 저장한다.
            iValue = iValue / 2000;

            strUserPath = Passkorea.Configuration.GetMailDirPath + "\\" + strDomain + "\\";

            switch (iValue.ToString().Length)
            {
                case 1:
                    strUserPath += "000";
                    break;
                case 2:
                    strUserPath += "00";
                    break;
                case 3:
                    strUserPath += "0";
                    break;
            }

            if (iValue > 0)
                --iValue;

            strUserPath += iValue.ToString() + "\\" + strUserId;

            // 사용자 정보를 Mail_User 테이블에 넣는다.
            // Mail_User 테이블은 메일 엔진에서 사용하기 때문에 넣지 않으면 안된다.
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertMailUser";

            Cmd.Parameters.Clear();

            // 메일 사용자 정보 입력 성공 여부값
            Param = Cmd.Parameters.Add("@iValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            // 사용자 아이디
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            // 사용자 이름
            Param = Cmd.Parameters.Add("@varUserName", OleDbType.VarWChar, strUserName.Length);
            Param.Direction = ParameterDirection.Input;

            // 사용자 비밀번호
            Param = Cmd.Parameters.Add("@varUserPwd", OleDbType.VarChar, strUserPwd.Length);
            Param.Direction = ParameterDirection.Input;

            // 사용자 할당 용량
            Param = Cmd.Parameters.Add("@intUserMaxSize", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            // 사용 권한 (관리자 또는 일반 사용자)
            Param = Cmd.Parameters.Add("@chrUserAuth", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            // 사용자 메일박스 경로
            Param = Cmd.Parameters.Add("@varMailboxPath", OleDbType.VarWChar, strUserPath.Length);
            Param.Direction = ParameterDirection.Input;

            // 메일 사용 여부
            Param = Cmd.Parameters.Add("@chrUserPermit", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            // 도메인
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            // 메일링 리스트 사용자 여부
            Param = Cmd.Parameters.Add("@bIsMailing", OleDbType.Boolean);
            Param.Direction = ParameterDirection.Input;

            // POP3 사용 여부
            Param = Cmd.Parameters.Add("@chrPop3Allow", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;


            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varUserName"].Value = strUserName;
            Cmd.Parameters["@varUserPwd"].Value = strUserPwd;
            Cmd.Parameters["@intUserMaxSize"].Value = int.Parse(strMaxSize);
            Cmd.Parameters["@chrUserAuth"].Value = "1";
            Cmd.Parameters["@varMailboxPath"].Value = strUserPath;
            Cmd.Parameters["@chrUserPermit"].Value = "1";
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@bIsMailing"].Value = 0;
            Cmd.Parameters["@chrPop3Allow"].Value = "1";

            Cmd.ExecuteNonQuery();

            iValue = int.Parse(Cmd.Parameters["@iValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

            if (iValue != 0)
            {
                Trans.Rollback();
                Con.Close();

                WF.WriteMessage("사용자 정보(MAIL_USER) 테이블에 사용자 정보를 입력하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Number: " + iValue);
                WF.MovePage("Setting.aspx");
                return;
            }

            // 사용자 개인정보를 User_Info 테이블에 넣는다.
            // User_Info 테이블은 사용자 신상 정보를 넣는 테이블이다.
            Cmd.Parameters.Clear();

            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prInsertUserInfo";

            // 메일 사용자 정보 입력 성공 여부값
            Param = Cmd.Parameters.Add("@iValue", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            // 사용자 아이디
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            // 도메인
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarWChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            // 사용자 권한
            Param = Cmd.Parameters.Add("@chrUserPermit", OleDbType.Char, 2);
            Param.Direction = ParameterDirection.Input;

            // 사용자 성별
            Param = Cmd.Parameters.Add("@chrSex", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            // 사용자 생일
            Param = Cmd.Parameters.Add("@chrBirthDay", OleDbType.Char, 10);
            Param.Direction = ParameterDirection.Input;

            // 학력
            Param = Cmd.Parameters.Add("@chrLastEdu", OleDbType.Char, 2);
            Param.Direction = ParameterDirection.Input;

            // 직업
            Param = Cmd.Parameters.Add("@chrJob", OleDbType.Char, 2);
            Param.Direction = ParameterDirection.Input;

            // 결혼여부
            Param = Cmd.Parameters.Add("@chrMarry", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            // 소속
            Param = Cmd.Parameters.Add("@varPosition", OleDbType.VarWChar, 30);
            Param.Direction = ParameterDirection.Input;

            // 전화번호
            Param = Cmd.Parameters.Add("@chrTel", OleDbType.Char, 13);
            Param.Direction = ParameterDirection.Input;

            // 이동전화
            Param = Cmd.Parameters.Add("@chrMobile", OleDbType.Char, 13);
            Param.Direction = ParameterDirection.Input;

            // 우편번호
            Param = Cmd.Parameters.Add("@chrZipCode", OleDbType.Char, 6);
            Param.Direction = ParameterDirection.Input;

            // 주소1
            Param = Cmd.Parameters.Add("@varAddress1", OleDbType.VarWChar, 100);
            Param.Direction = ParameterDirection.Input;

            // 주소2
            Param = Cmd.Parameters.Add("@varAddress2", OleDbType.VarWChar, 50);
            Param.Direction = ParameterDirection.Input;

            // 리턴값
            Param = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
            Param.Direction = ParameterDirection.Output;


            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@chrUserPermit"].Value = "1";
            Cmd.Parameters["@chrSex"].Value = "";
            Cmd.Parameters["@chrBirthDay"].Value = "";
            Cmd.Parameters["@chrLastEdu"].Value = "";
            Cmd.Parameters["@chrJob"].Value = "";
            Cmd.Parameters["@chrMarry"].Value = "";
            Cmd.Parameters["@varPosition"].Value = "";
            Cmd.Parameters["@chrTel"].Value = "";
            Cmd.Parameters["@chrMobile"].Value = "";
            Cmd.Parameters["@chrZipCode"].Value = "";
            Cmd.Parameters["@varAddress1"].Value = "";
            Cmd.Parameters["@varAddress2"].Value = "";

            Cmd.ExecuteNonQuery();

            iValue = int.Parse(Cmd.Parameters["@iValue"].Value.ToString(), System.Globalization.NumberStyles.Number);

            if (iValue != 0)
            {
                Trans.Rollback();

                WF.WriteMessage("사용자 정보(USER_INFO) 테이블에 사용자 정보를 입력하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                    "SQL Error Message: " + Cmd.Parameters["@varRtnVal"].ToString().Replace("\r\n", "\\r\\n") +
                    "SQL Error Number: " + iValue.ToString());
                WF.MovePage("UserJoin.aspx");
                return;
            }

            // 웹메일 도메인 정보를 넣는다.
            Cmd.Parameters.Clear();
            
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prAddDomain";
            
            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iAllocateSize", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iUserCount", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strJoinType", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iDefaultSize", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strPop3Allow", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strCopyright", OleDbType.VarChar, 6000);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 600);
            Param.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@iAllocateSize"].Value = 10000;
            Cmd.Parameters["@iUserCount"].Value = 100;
            Cmd.Parameters["@strJoinType"].Value = "Y";
            Cmd.Parameters["@iDefaultSize"].Value = int.Parse(strMaxSize);
            Cmd.Parameters["@strPop3Allow"].Value = "Y";
            Cmd.Parameters["@strCopyright"].Value = " ";

            Cmd.ExecuteNonQuery();

            if (iValue != 0)
            {
                Trans.Rollback();
                WF.WriteMessage(Cmd.Parameters["@strReturnValue"].Value.ToString().Replace("\r\n", "\\r\\n"));
                WF.HistoryBack();
                return;
            }

            // 웹하드 사용자 테이블에 사용자 정보를 넣는다.
            // 여기에 사용자를 넣어주지 않아도 되지만 나중에 웹하드를 설정하려면 꼭 등록해야 한다.
            // 등록하지 않으면 SQL 서버에 직접 접속해서 사용자 권한을 관리자로 변경해야 한다.
            _member.Domain = strDomain;
            _member.MemberId = strUserId;
            _member.MemberPwd = strUserPwd;
            _member.MemberName = strUserName;
            _member.EmailAddr = strUserId + "@" + strDomain;
            _member.Path = strWebhardPath + "\\" + strDomain + "\\User_Data\\" + strUserId;
            _member.AllocateSize = 1000;
            _member.Permission = "M0";

            if (!_member.JoinMember())
            {
                WF.WriteMessage(_member.ErrorMessage.Replace("\r\n", "\\r\\n\\r\\n"));
                WF.HistoryBack();
                return;
            }
        }
        catch (Exception err)
        {
            Trans.Rollback();

            _member.Domain = strDomain;
            _member.MemberId = strUserId;

            _member.DeleteMemberInfo();
            
            WF.WriteMessage("관리자를 등록 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n" +
                "프로그램 제조사에 문의 하세요.\\r\\n\\r\\n오류 내용: " + err.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n") + "\\r\\n\\r\\n" +
                "오류 소스: " + err.Source.ToString() + "\\r\\n\\r\\n" +
                "오류 트랙: " + err.StackTrace.ToString().Replace("\r\n", "\\r\\n\\r\\n"));
            return;
        }

        // Setting Web.Config
        try
        {
            doc.Load(Request.PhysicalApplicationPath + "\\Web.Config");
            XmlNamespaceManager xnm = new XmlNamespaceManager(doc.NameTable);
            //xnm.AddNamespace("WebmailNS", "http://" + strDomain + "/Webmail.xsd");
            //XmlNode targetNode = doc.SelectSingleNode("//WebmailNS:Webmail", xnm);

            // Create appSettings Element
            //XmlElement newAppSet = doc.CreateElement("appSettings", targetNode.NamespaceURI);
            XmlElement newAppSet = doc.CreateElement("appSettings");

            // Create add Element (DB Connection String)
            XmlElement addDbCon = doc.CreateElement("add");
            addDbCon.SetAttribute("key", "strConnection");
            addDbCon.SetAttribute("value", strCon);

            // add Child Element (DB Connection String) in appSetting Element
            newAppSet.AppendChild(addDbCon);

            // Create add Element (Use Domain String)
            XmlElement addDomain = doc.CreateElement("add");
            addDomain.SetAttribute("key", "strDomain");
            addDomain.SetAttribute("value", strDomain);

            // add Child Element (Use Domain String) in appSetting Element
            newAppSet.AppendChild(addDomain);

            // Creat add Element (Data List Count)
            XmlElement addDataList = doc.CreateElement("add");
            addDataList.SetAttribute("key", "intListCount");
            addDataList.SetAttribute("value", strMailListCount);

            // add Child Element (Data List Count) in appSetting Element
            newAppSet.AppendChild(addDataList);

            // Create add Element (Data List Paging Count)
            XmlElement addPageCount = doc.CreateElement("add");
            addPageCount.SetAttribute("key", "intPageCount");
            addPageCount.SetAttribute("value", strMailListPagingCount);

            // add Child Element (Data LIst Paging Count) in appSetting Element
            newAppSet.AppendChild(addPageCount);

            // add Webhard default path
            XmlElement addWebhardPath = doc.CreateElement("add");
            addWebhardPath.SetAttribute("key", "WebhardPath");
            addWebhardPath.SetAttribute("value", strWebhardPath);

            // add Child Element (Webhard Path) in appSetting Element
            newAppSet.AppendChild(addWebhardPath);

            // add Webhard file Download limit Count
            XmlElement addDownLimitCount = doc.CreateElement("add");
            addDownLimitCount.SetAttribute("key", "DownLimitCount");
            addDownLimitCount.SetAttribute("value", strDownLimitCount);

            // add Child Element (Webhard file Download limit count) in appSetting Element
            newAppSet.AppendChild(addDownLimitCount);

            // add Webhard admin Id
            XmlElement addAdminId = doc.CreateElement("add");
            addAdminId.SetAttribute("key", "AdminId");
            addAdminId.SetAttribute("value", strUserId);

            // add Child Element (Webhard admin User Id) in appSetting Element
            newAppSet.AppendChild(addAdminId);

            // add Webhard file download limit days
            XmlElement addDownLimitDay = doc.CreateElement("add");
            addDownLimitDay.SetAttribute("key", "DownLimitDay");
            addDownLimitDay.SetAttribute("value", strDownLimitDay);

            // add Child Element (Webhard file download limit days) in appSetting Element
            newAppSet.AppendChild(addDownLimitDay);

            // add Webhard Default size
            XmlElement addDefualtSize = doc.CreateElement("add");
            addDefualtSize.SetAttribute("key", "UserDefaultSize");
            addDefualtSize.SetAttribute("value", strDefaultSize);

            // add Child Element (Default size) in appSetting Element
            newAppSet.AppendChild(addDefualtSize);

            // add Webhard SMTP Server IP
            XmlElement addSmtpServer = doc.CreateElement("add");
            addSmtpServer.SetAttribute("key", "SmtpServer");
            addSmtpServer.SetAttribute("value", "127.0.0.1");

            newAppSet.AppendChild(addSmtpServer);

            // add Child Element (Tree Style) in appSetting Element
            XmlElement addTreeStyle = doc.CreateElement("add");
            addTreeStyle.SetAttribute("key", "TreeStyle");
            addTreeStyle.SetAttribute("value", strTreeType);

            newAppSet.AppendChild(addTreeStyle);

            // add appSetting Element in Xml Document
            doc.DocumentElement.AppendChild(newAppSet);

            XmlTextWriter xtr = new XmlTextWriter(Request.PhysicalApplicationPath + "\\Web.Config", null);
            xtr.Formatting = Formatting.Indented;
            doc.WriteContentTo(xtr);
            xtr.Close();

            Trans.Commit();
        }
        catch (XmlException xe)
        {
            Trans.Rollback();
            WF.WriteMessage("웹메일 환경설정을 하는 도중 오류가 발생했습니다.\\r\\n\\r\\n오류 내용: " +
                xe.Message.Replace("\\", "\\\\").Replace("\r\n", "\\r\\n\\r\\n"));
            WF.MovePage("Setting.aspx");
            return;
        }
        finally
        {
            Con.Close();
        }

        if (!Directory.Exists(strUserPath + "\\temp"))
            Directory.CreateDirectory(strUserPath + "\\temp");

        if (!Directory.Exists(strUserPath + "\\SaveBox"))
            Directory.CreateDirectory(strUserPath + "\\SaveBox");
        
        WF.WriteMessage("웹메일 환경설정이 완료되었습니다.\\r\\n\\r\\n확인을 누르시면 웹메일 로그인 화면으로 이동합니다.");
        WF.MovePage("../Mail/Main.aspx");
        return;
    }
}
