﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_User_UserCheck : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string userId = Request.Params["chkUserId"];
        string strCon = ConfigurationSettings.AppSettings["strConnection"];
        string strDomain = "";
        int iResult = 0;
        string strErr = "";
        WebFunction WF = new WebFunction(Page);

        strDomain = Request.Params["dm"];

        if (strDomain == null)
            strDomain = Request.Url.Host;

        if (userId != "" && userId != null)
        {
            ArrayList DomainList = Passkorea.Configuration.DomainList();

            if (DomainList != null)
            {
                bool bDomain = false;
                int iCnt = strDomain.Split('.').Length;

                for (int i = 0; i < iCnt; i++)
                {
                    for (int iDomainCount = 0; iDomainCount < DomainList.Count; iDomainCount++)
                    {
                        if (DomainList[iDomainCount].ToString() == strDomain)
                        {
                            strDomain = DomainList[iDomainCount].ToString();
                            bDomain = true;
                            break;
                        }
                    }

                    if (bDomain)
                        break;

                    int iPos = strDomain.IndexOf(".");

                    if (iPos > -1)
                        strDomain = strDomain.Substring(iPos + 1);
                }

                if (!bDomain)
                {
                    WF.WriteMessage("입력된 도메인은 메일서버에 등록되지 않은 도메인 입니다.\\r\\n접속 하는 도메인을 확인해주시거나 서버 관리자에게 문의하세요.\\r\\n" +
                        "접속도메인: " + Request.Url.Host);
                    WF.WndClose();
                    return;
                }
            }
            else
            {
                WF.WriteMessage("메일서버에 도메인이 등록되어 있지 않습니다.\\r\\n서버 관리자에게 문의하세요.");
                WF.WndClose();
                return;
            }

            OleDbConnection Con = new OleDbConnection(strCon);
            OleDbCommand Cmd = new OleDbCommand();
            OleDbParameter sParams = new OleDbParameter();

            try
            {
                Con.Open();
                Cmd.Connection = Con;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prExistUser";

                // 사용자 아이디 파라미터 설정
                sParams = Cmd.Parameters.Add("@intReturn", OleDbType.Integer);
                sParams.Direction = ParameterDirection.ReturnValue;
                
                sParams = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, userId.Length);
                sParams.Direction = ParameterDirection.Input;

                sParams = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                sParams.Direction = ParameterDirection.Input;

                Cmd.Parameters["@varUserId"].Value = userId;
                Cmd.Parameters["@varDomain"].Value = strDomain;

                Cmd.ExecuteNonQuery();
                iResult = int.Parse(Cmd.Parameters["@intReturn"].Value.ToString(), System.Globalization.NumberStyles.Number);
            }
            catch (Exception err)
            {
                iResult = -1;
                strErr = err.Message;
            }
            finally
            {
                Con.Close();
            }

            if (iResult == 0)
                lblMsg.Text = userId + " 아이디는 <font color=\"blue\"><b>사용할 수 있는 아이디</b></font> 입니다.";
            else if (iResult == 1)
                lblMsg.Text = userId + " 아이디는 <font color=\"red\"><b>이미 사용하고 있는 아이디</b></font> 입니다.";
            else
            {
                if (iResult != -1)
                    strErr += "<br><br>SQL 오류 입니다.<br><br>SQL Error Code Number: " + iResult;

                lblMsg.Text = "아이디 확인중 오류가 발생했습니다.<br><br>" + strErr;
            }
        }
        else
        {
            lblMsg.Text = "확인할 아이디가 입력되지 않았습니다.";
        }
    }
}
