﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Webhard_CreateFolder : System.Web.UI.Page
{
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;
    
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strDomain = "";
    private string strMemberId = "";
    protected string dir = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        string strScript = "";
        
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", true);

        strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];
        strDomain = Session["MAIL_DOMAIN"].ToString();
        dir = Request.Params["dir"];

        if (dir == null)
            dir = "";

        _js.Page = Page;

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../Default.aspx", "opener");
            _js.WindowsClose();
            return;
        }
        else
        {
            strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../Default.aspx", "opener");
                    _js.WindowsClose();
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../Default.aspx", "opener");
                _js.WindowsClose();
                return;
            }
        }

        if (!Page.IsPostBack)
        {
            
        }

        strScript = "if (!CreateFolder()) return false; else return true;";
        btnCreateFolder.Attributes.Add("onclick", strScript);
    }

    protected void btnCreateFolder_Click(object sender, EventArgs e)
    {
        bool result = false;
        bool bGroup = false;
        string folderName = tbFolderName.Text;
        string strGroupName = "";
        string strPath = "";
        string strDispMsg = "";

        if (folderName.Trim() == "")
        {
            _js.MessageBox("생성될 폴더명이 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (dir.StartsWith("G:"))
        {
            bGroup = true;
            strGroupName = dir.Substring(2);

            int iPos = strGroupName.IndexOf("|");

            if (iPos > -1)
                strGroupName = strGroupName.Substring(0, iPos);

            Group _group = new Group();
            _group.ConnectionString = strCon;

            try
            {
                result = _group.LoadGroupInfo(strDomain, strGroupName);
            }
            catch (Exception err)
            {
                _js.MessageBox(err.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(_group.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            strPath = _group.GroupPath;
            dir = dir.Substring(strGroupName.Length + 2);
        }
        else
        {
            Member _member = new Member();
            _member.ConnectionString = strCon;
            _member.Domain = strDomain;

            try
            {
                result = _member.LoadMemberInfo(strMemberId);
            }
            catch (Exception err)
            {
                _js.MessageBox(err.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.HistoryBack();
                return;
            }
            
            strPath = _member.Path;
        }

        if (dir.Trim() != "")
            dir = dir.Replace("|", "\\");

        if (!Directory.Exists(strPath + dir))
        {
            _js.MessageBox(dir + "폴더가 존재하지 않습니다.");
            _js.HistoryBack();
            return;
        }

        if (Directory.Exists(strPath + dir + "\\" + folderName))
        {
            _js.MessageBox(folderName + " 폴더가 " + dir + " 폴더 내에 존재합니다.");
            _js.HistoryBack();
            return;
        }

        Directory.CreateDirectory(strPath + dir + "\\" + folderName);

        dir = dir.Replace("\\", "|");

        if (!bGroup)
        {
            if (dir.Trim() != "")
            {
                strDispMsg = "내 웹하드" + dir;
                dir = dir + "|" + folderName;
            }
            else
            {
                dir = "";
                strDispMsg = "내 웹하드>";
            }
        }
        else
        {
            if (dir.Trim() != "")
            {
                if (!dir.StartsWith("|"))
                    dir = "|" + dir;
            }

            strDispMsg = "그룹: " + strGroupName + dir;
            dir = "G:" + strGroupName + dir + "|" + folderName;
        }

        _js.MessageBox(folderName + " 폴더가 " + strDispMsg.Replace("|", ">") + " 폴더 내에 생성되었습니다.");
        _js.MoveOpenerWindowChildPage("iFrmTreeMenu", "TreeMenu.aspx?dir=" + Server.UrlEncode(dir));
        _js.MoveOpenerWindowChildPage("iFrmDataList", "DataList.aspx?dir=" + Server.UrlEncode(dir));
        _js.WindowsClose();
    }
}
