﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Webhard_DataList : System.Web.UI.Page
{
    private JavaScript _js = new JavaScript();
    private Member _member = new Member();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebhardCommon _wc = new WebhardCommon();
    private DataTable _dataTable = new DataTable();
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strDomain = "";
    private string strMemberId = "";
    protected string dir = "";
    protected string strWebhard = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        dir = Request.Params["dir"];
        strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];
        strDomain = Session["MAIL_DOMAIN"].ToString();

        _js.Page = Page;

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../Default.aspx", "top");
            return;
        }
        else
        {
            strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../Default.aspx", "top");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../Default.aspx", "top");
                return;
            }
        }

        if (dir == null)
            dir = "";

        if (!Page.IsPostBack)
        {
            _member.ConnectionString = strCon;
            _member.Domain = strDomain;

            if (!_member.LoadMemberInfo(strMemberId))
                return;

            // 제목
            TitleLink(dir);
            // 폴더내 파일 리스트
            DirectoryContentBind(dir);
        }

        Page.DataBind();
    }

    private void TitleLink(string dir)
    {
        string[] dirs;
        string args = "";
        string strName = "";
        
        bool bGrp = false;

        if (dir.IndexOf("G:") < 0)
            strName = "내 웹하드";
            
        else
        {
            bGrp = true;
            int iPos = dir.IndexOf("|");

            if (iPos > 0)
                strName = dir.Substring(2, iPos - 2);
            else
                strName = dir.Substring(2);

            dir = dir.Substring(strName.Length + 2);
        }

        if (dir == null)
            return;

        // 디렉토리 경로를 자른다.
        if (dir.StartsWith("|"))
                dir = dir.Substring(1);

        dirs = dir.Split('|');

        // 그룹이면 이동되는 경로값에 G: 와 그룹명을 붙인다.
        if (bGrp)
        {
            //strWebhard = "<span onmouseover=\"javascript: this.style.cursor='hand';\" onclick=\"javascript: self.location.href='DataList.aspx?dir=G:" + Server.UrlEncode(strName) + "';\">" + strName + "</span>";
            strWebhard = "<span onmouseover=\"javascript: this.style.cursor='hand';\" onclick=\"javascript: MoveFolder('G:" + strName + "');\">" + strName + "</span>";
            args = "G:" + strName;
        }
        else
            //strWebhard = "<span onmouseover=\"javascript: this.style.cursor='hand';\" onclick=\"javascript: self.location.href='DataList.aspx';\">" + strName + "</span>";
            strWebhard = "<span onmouseover=\"javascript: this.style.cursor='hand';\" onclick=\"javascript: MoveFolder('');\">" + strName + "</span>";

        for (int i = 0; i < dirs.Length; i++)
        {
            args += "|" + dirs[i];
            //strWebhard += " > <span onmouseover=\"javascript: this.style.cursor='hand';\" onclick=\"javascript: self.location.href='DataList.aspx?dir=" + Server.UrlEncode(args) + "';\">" + dirs[i] + "</span>";
            strWebhard += " > <span onmouseover=\"javascript: this.style.cursor='hand';\" onclick=\"javascript: MoveFolder('" + args + "');\">" + dirs[i] + "</span>";
        }
    }

    private void DirectoryContentBind(string dir)
    {
        string path = "";
        string strName = "";
        bool bGrp = false;
        string strIcon = "";

        if (dir.StartsWith("G:"))
        {
            bGrp = true;
            int iPos = dir.IndexOf("|");

            if (iPos > 0)
                strName = dir.Substring(2, iPos - 2);
            else
                strName = dir.Substring(2);

            dir = dir.Substring(strName.Length + 2);

            Group _group = new Group();

            _group.ConnectionString = strCon;

            if (!_group.LoadGroupInfo(strDomain, strName))
            {
                _js.MessageBox(_group.ErrorMessage);

                return;
            }

            path = _group.GroupPath;
        }
        else
            path = _member.Path;

        _dataTable.Columns.Add("FILE_TYPE", Type.GetType("System.String"));
        _dataTable.Columns.Add("FILE_NAME_LINK", Type.GetType("System.String"));
        _dataTable.Columns.Add("FILE_NAME", Type.GetType("System.String"));
        _dataTable.Columns.Add("FILE_SIZE", Type.GetType("System.String"));
        _dataTable.Columns.Add("FILE_REAL_SIZE", Type.GetType("System.String"));
        _dataTable.Columns.Add("FILE_DATE", Type.GetType("System.String"));
        _dataTable.Columns.Add("IS_FILE", Type.GetType("System.String"));

        strIcon = "<img src=\"../images/icon/folder.gif\" alt=\"\" align=\"absmiddle\"/>";

        if (dir != null && dir != "")
        {
            string strTmpDir = "";

            if (dir.LastIndexOf("|") > 0)
                strTmpDir = dir.Substring(0, dir.LastIndexOf("|"));

            DataRow dr = _dataTable.NewRow();

            /*
            if (!bGrp)
                dr["FILE_NAME_LINK"] = strIcon + " <a href=\"DataList.aspx?dir=" + Server.UrlEncode(strTmpDir) + "\">..</a>";
            else
                dr["FILE_NAME_LINK"] = strIcon + " <a href=\"DataList.aspx?dir=G:" + Server.UrlEncode(strName + strTmpDir) + "\">..</a>";
            */
            if (!bGrp)
                dr["FILE_NAME_LINK"] = strIcon + " <a href=\"javascript: MoveFolder('" + strTmpDir + "');\">..</a>";
            else
                dr["FILE_NAME_LINK"] = strIcon + " <a href=\"javascript: MoveFolder('G:" + strName + strTmpDir + "');\">..</a>";
            dr["FILE_TYPE"] = "파일 폴더";
            dr["FILE_SIZE"] = "&nbsp;";
            dr["FILE_DATE"] = "&nbsp;";
            dr["IS_FILE"] = "D";

            _dataTable.Rows.Add(dr);

            if (!path.EndsWith("\\") && !dir.StartsWith("\\"))
                path += "\\" + dir.Replace("|", "\\");
            else
                path += dir.Replace("|", "\\");
        }

        if (Directory.Exists(path))
        {
            Webhard_Passkorea.Webhard_Passkorea _wp = new Webhard_Passkorea.Webhard_Passkorea();

            DirectoryInfo di = new DirectoryInfo(path);
            // 디렉토리 정보를 DataTable에 넣는다.
            foreach (DirectoryInfo d in di.GetDirectories())
            {
                DataRow dr = _dataTable.NewRow();

                /*
                if (!bGrp)
                    dr["FILE_NAME_LINK"] = strIcon + " <a href=\"DataList.aspx?dir=" + Server.UrlEncode(dir + "|" + d.Name) + "\">" + d.Name + "</a>";
                else
                    dr["FILE_NAME_LINK"] = strIcon + " <a href=\"DataList.aspx?dir=G:" + Server.UrlEncode(strName + dir + "|" + d.Name) + "\">" + d.Name + "</a>";
                */

                if (!bGrp)
                    dr["FILE_NAME_LINK"] = strIcon + "<a href=\"javascript: MoveFolder('" + dir + "|" + d.Name + "');\">" + d.Name + "</a>";
                else
                    dr["FILE_NAME_LINK"] = strIcon + "<a href=\"javascript: MoveFolder('G:" + strName + dir + "|" + d.Name + "');\">" + d.Name + "</a>";
                dr["FILE_TYPE"] = "파일 폴더";
                dr["FILE_NAME"] = d.Name;
                dr["FILE_SIZE"] = "&nbsp;";
                dr["FILE_DATE"] = d.CreationTime;
                dr["IS_FILE"] = "D";

                _dataTable.Rows.Add(dr);
            }

            foreach (FileInfo fi in di.GetFiles())
            {
                DataRow dr = _dataTable.NewRow();

                if (!bGrp)
                    dr["FILE_NAME_LINK"] = "<a href=\"Download.aspx?dir=" + Server.UrlEncode(dir) + "&file=" + Server.UrlEncode(fi.Name) + "\">" + fi.Name + "</a>";
                else
                    dr["FILE_NAME_LINK"] = "<a href=\"Download.aspx?dir=G:" + Server.UrlEncode(strName) + Server.UrlEncode(dir) + "&file=" + Server.UrlEncode(fi.Name) + "\">" + fi.Name + "</a>";

                dr["FILE_TYPE"] = FileExtType(fi.Name);
                dr["FILE_NAME"] = fi.Name.Replace("'", "＇");
                dr["FILE_SIZE"] = _wp.CalcSize(fi.Length);
                dr["FILE_REAL_SIZE"] = fi.Length.ToString();
                dr["FILE_DATE"] = fi.CreationTime;
                dr["IS_FILE"] = "F";

                _dataTable.Rows.Add(dr);
            }
        }

        rptFileList.DataSource = _dataTable;
        rptFileList.DataBind();
    }

    protected void rptFileList_ItemDataBound(Object sender, RepeaterItemEventArgs e)
    {
        HtmlInputCheckBox cb = (HtmlInputCheckBox)e.Item.FindControl("cbItem");

        if (cb != null)
        {
            string strValue = cb.Value;
            
            if (strValue.EndsWith("D"))
                cb.Disabled = true;
        }
    }

    private string FileExtType(string filename)
    {
        int iPos = 0;
        string fileExt = "";

        if (filename != "")
        {
            iPos = filename.LastIndexOf(".");

            if (iPos > 0)
            {
                fileExt = filename.Substring(iPos + 1);
                fileExt = fileExt.ToUpper() + " 파일";
            }
            else
                fileExt = "파일";
        }

        return fileExt;
    }
}
