﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Webhard_DownLimitDateModify : System.Web.UI.Page
{
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strDomain = "";
    private string strMemberId = "";
    private string strGuid = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", true);

        string strScript = "";
        strGuid = Request.Params["guid"];
        strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];
        strDomain = Session["MAIL_DOMAIN"].ToString();
        _js.Page = Page;

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../Default.aspx", "opener");
            _js.WindowsClose();
            return;
        }
        else
        {
            strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../Default.aspx", "opener");
                    _js.WindowsClose();
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../Default.aspx", "opener");
                _js.WindowsClose();
                return;
            }
        }

        if (!Page.IsPostBack)
        {
           ListFileSendData(strGuid);
        }

        strScript = "if (!LimitDay()) return false; else return true;";
        //strScript = "alert('데모라서 유효기간 일수를 재 설정할 수 없습니다.'); return false;";
        btnModifyLimitDay.Attributes.Add("onclick", strScript);
    }

    private void ListFileSendData(string strGuid)
    {
        bool result = false;
        FiledownLimit _fl = new FiledownLimit();
        DataTable _dt = new DataTable();

        if (strGuid.Trim() == "")
        {
            _js.MessageBox("유효기간을 재 설정할 파일이 선택되지 않았습니다.");
            _js.WindowsClose();
            return;
        }

        if (strGuid.Substring(strGuid.Length - 1, 1) == ",")
            strGuid = strGuid.Substring(0, strGuid.Length - 1);

        _fl.ConnectionString = strCon;

        try
        {
            _dt.Columns.Add("File_Path", Type.GetType("System.String"));
            _dt.Columns.Add("Down_Count", Type.GetType("System.Int32"));
            _dt.Columns.Add("Down_Limit_Date", Type.GetType("System.DateTime"));

            string[] guid = strGuid.Split(',');

            for (int i = 0; i < guid.Length; i++)
            {
                string strFilePath = "";

                if (!_fl.LoadDownFileInfo(guid[i]))
                {
                    _js.MessageBox(_fl.ErrorMessage);
                    _js.WindowsClose();
                    return;
                }

                DataRow dr = _dt.NewRow();

                strFilePath = _fl.FilePath;

                if (strFilePath.StartsWith("\\"))
                    strFilePath = strFilePath.Substring(1);

                if (strFilePath.Trim() != "")
                    strFilePath += "> " + _fl.FileName;
                else
                    strFilePath = _fl.FileName;

                dr["File_Path"] = strFilePath.Replace("\\", "> ");
                dr["Down_Count"] = _fl.DownloadCount;
                dr["Down_Limit_Date"] = _fl.DownLimitDate;

                _dt.Rows.Add(dr);
            }

            rptListFileSend.DataSource = _dt;
            rptListFileSend.DataBind();
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            _js.HistoryBack();
            return;
        }
    }

    protected void btnModifyLimitDay_Click(object sender, EventArgs e)
    {
        string strLimitDay = tbDownLimitDay.Text;

        if (strLimitDay.Trim() == "")
        {
            _js.MessageBox("유효기간 일수가 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        FiledownLimit _fl = new FiledownLimit();

        try
        {
            string[] guid = strGuid.Split(',');

            _fl.ConnectionString = strCon;
            for (int i = 0; i < guid.Length; i++)
            {
                if (!_fl.ModifyDownLimit(guid[i], strDomain, 1, DateTime.Now.AddDays(int.Parse(strLimitDay)), ""))
                {
                    _js.MessageBox(_fl.ErrorMessage);
                    _js.HistoryBack();
                    return;

                }
            }
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        _js.MessageBox("유효기간이 재 설정 되었습니다.");
        _js.OpenerWindowReload();
        _js.WindowsClose();
    }
}
