﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Webhard_Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Webhard_Download : System.Web.UI.Page
{
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private JavaScript _js = new JavaScript();
    private Member _member = new Member();
    private WebhardCommon _wc = new WebhardCommon();

    private string strDomain = "";
    private string strIdx = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strDir = "";
    private string strFilename = "";
    private string strMemberId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        _js.Page = Page;
        strIdx = Request.Params["idx"];
        strDir = Request.Params["dir"];
        strFilename = Request.Params["file"];
        
        if (strDir != null && strFilename != null)
        {
            // 중복 로그인 확인
            if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
            {
                _js.MovePage("../Default.aspx", "");
                return;
            }
            else
            {
                strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];
                strDomain = Session["MAIL_DOMAIN"].ToString();

                if (Session["LOGIN_INDEX"] != null)
                {
                    int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                    _login.ConnectionString = strCon;

                    if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                    {
                        _login.Logout(strDomain, strMemberId, idxNo);
                        _js.MessageBox(_login.ErrorMessage);
                        _js.MovePage("../Default.aspx", "top");
                        return;
                    }
                }
                else
                {
                    _js.MessageBox("로그인 정보값이 없습니다.");
                    _js.MovePage("../Default.aspx", "top");
                    return;
                }
            }
        }

        if (!Page.IsPostBack)
        {
            if (strIdx != null)
                FileDownload(strIdx);
            else
                FileDownload();
        }
    }

    private void FileDownload(string idx)
    {
        if (idx != null)
        {
            try
            {
                Webhard_Passkorea.File.FileDownload _fd = new Webhard_Passkorea.File.FileDownload();
                _fd.ConnectionString = strCon;
                _fd.WebPage = this.Page;
                _fd.DownloadFile(idx);
            }
            catch (Exception e)
            {
                _js.MessageBox(e.Message);
                _js.WindowsClose();
            }
            return;
        }
    }

    private void FileDownload()
    {
        string strPath = "";
        string strFolder = "";
        string strGroup = "";
        bool result = false;
        int iPos = 0;

        if (strDir == null)
            return;

        if (strFilename == null)
            return;

        if (strDir.StartsWith("G:"))
        {
            iPos = strDir.IndexOf("|");

            if (iPos > 0)
            {
                strGroup = strDir.Substring(2, iPos - 2);
                strFolder = strDir.Substring(iPos + 1);
            }
            else
                strGroup = strDir.Substring(2);

            Webhard_Passkorea.WebSource.Group _group = new Webhard_Passkorea.WebSource.Group();
            _group.ConnectionString = strCon;

            try
            {
                result = _group.LoadGroupInfo(strDomain, strGroup);
            }
            catch (Exception e)
            {
                _js.MessageBox(e.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(_group.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            strPath = _group.GroupPath;
        }
        else
        {
            Webhard_Passkorea.WebSource.Member _member = new Webhard_Passkorea.WebSource.Member();
            _member.Domain = strDomain;
            _member.MemberId = strMemberId;
            _member.ConnectionString = strCon;

            try
            {
                result = _member.LoadMemberInfo();
            }
            catch (Exception e)
            {
                _js.MessageBox(e.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            strPath = _member.Path;
            strFolder = strDir;
        }

        strFolder = strFolder.Replace("|", "\\");

        if (!strFolder.StartsWith("\\"))
            strFolder = "\\" + strFolder;

        Webhard_Passkorea.File.FileDownload _fd = new Webhard_Passkorea.File.FileDownload();
        _fd.ConnectionString = strCon;
        _fd.WebPage = this.Page;

        try
        {
            result = _fd.CheckDownloadPermission(strDomain, strMemberId, strGroup);
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_fd.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        try
        {
            _fd.DownloadFile(strPath + strFolder, strFilename);
        }
        catch (Exception e)
        {
            _js.MessageBox(_fd.ErrorMessage);
            _js.HistoryBack();
        }

        return;
    }
}
