﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Webhard_SendmailResult : System.Web.UI.Page
{
    protected string strPageLink = "";

    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strDomain = "";
    private string strMemberId = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strAdminId = ConfigurationSettings.AppSettings["AdminId"].ToString();
    private int iPage = 1;
    private int iPageSize = 15;

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        string strScript = "";
        string page = Request.Params["iPage"];
        strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];
        strDomain = Session["MAIL_DOMAIN"].ToString();
        _js.Page = Page;

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../Default.aspx", "");
            return;
        }
        else
        {
            strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../Default.aspx", "");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../Default.aspx", "");
                return;
            }
        }

        if (page != null && page != "")
            iPage = int.Parse(page);

        if (!Page.IsPostBack)
        {
            ListFileSendData();
        }

        // 다운로드 삭제 버튼에 속성 추가
        strScript = "if (!DeleteItem()) return false; else return true;";
        btnDeleteItem.Attributes.Add("onclick", strScript);

        // 다운로드 횟수 초기화 버튼 속성 추가
        strScript = "if (!DownCountInit()) return false; else return true;";
        //strScript = "alert('데모라서 다운로드 횟수를 초기화할 수 없습니다.'); return false;";
        btnDownCountInit.Attributes.Add("onclick", strScript);
    }

    private void ListFileSendData()
    {
        bool result = false;
        FiledownLimit _fl = new FiledownLimit();
        int iTotalPage = 0;

        _fl.ConnectionString = strCon;
        
        try
        {
            result = _fl.ListSendFile(strMemberId, strDomain, iPage, iPageSize);
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_fl.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        DataTable dt = _fl.ListSendFileData;

        int iCnt = dt.Rows.Count;
        string[,] strData = new string[7, iCnt];

        for (int i = 0; i < iCnt; i++)
        {
            strData[0, i] = dt.Rows[i]["Idx_Guid"].ToString();
            strData[1, i] = dt.Rows[i]["Group_Name"].ToString();
            strData[2, i] = dt.Rows[i]["File_Path"].ToString();
            strData[3, i] = dt.Rows[i]["FileName"].ToString();
            strData[4, i] = dt.Rows[i]["Down_Count"].ToString();
            strData[5, i] = dt.Rows[i]["Down_Limit_Date"].ToString();
            strData[6, i] = dt.Rows[i]["Add_Date"].ToString();  
        }

        dt.Rows.Clear();

        for (int i = 0; i < iCnt; i++)
        {
            if (strData[1, i].Trim() == "")
                strData[1, i] = "없음";

            if (strData[2, i].Trim() == "")
                strData[2, i] = "내 웹하드";
            else
            {
                if (strData[2, i].StartsWith("\\"))
                    strData[2, i] = strData[2, i].Substring(1).Replace("\\", "> ");
            }

            DataRow dr = dt.NewRow();
            dr["Idx_Guid"] = strData[0, i];
            dr["Group_Name"] = strData[1, i];
            dr["File_Path"] = strData[2, i] + "> " + strData[3, i];
            //dr["FileName"] = strData[3, i];
            dr["Down_Count"] = int.Parse(strData[4, i]);
            dr["Down_Limit_Date"] = DateTime.Parse(strData[5, i]);
            dr["Add_Date"] = DateTime.Parse(strData[6, i]);

            dt.Rows.Add(dr);
        }

        rptListFileSend.DataSource = dt;
        rptListFileSend.DataBind();

        WebhardCommon Wc = new WebhardCommon();

        iTotalPage = _fl.TotalCount / iPageSize;
        if ((_fl.TotalCount % iPageSize) > 0) ++iTotalPage;

        strPageLink = Wc.PageLink(iTotalPage, iPage, "FileSendList.aspx", "", 10, "", "", "", "");
    }

    protected void btnDeleteItem_Click(object sender, EventArgs e)
    {
        string strGuid = hfSelectItem.Value;

        if (strGuid.Trim() == "")
        {
            _js.MessageBox("삭제할 다운로드 파일을 선택해 주세요.");
            _js.HistoryBack();
            return;
        }
        else
        {
            if (strGuid.EndsWith(","))
                strGuid = strGuid.Substring(0, strGuid.Length - 1);
        }

        try
        {
            FiledownLimit _fl = new FiledownLimit();
            string[] guid = strGuid.Split(',');

            _fl.ConnectionString = strCon;
            for (int i = 0; i < guid.Length; i++)
            {
                if (!_fl.DeleteDownLimit(guid[i]))
                {
                    _js.MessageBox(_fl.ErrorMessage);
                    _js.HistoryBack();
                    return;
                }
            }
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        _js.MessageBox("선택한 다운로드 파일이 삭제되었습니다.");
        _js.MovePage("FileSendList.aspx?iPage=" + iPage.ToString(), "");
    }

    protected void btnDownCountInit_Click(object sender, EventArgs e)
    {
        string strGuid = hfSelectItem.Value;

        if (strGuid.Trim() == "")
        {
            _js.MessageBox("다운횟수를 초기화할 파일을 선택해 주세요.");
            _js.HistoryBack();
            return;
        }
        else
        {
            if (strGuid.EndsWith(","))
                strGuid = strGuid.Substring(0, strGuid.Length - 1);
        }

        try
        {
            FiledownLimit _fl = new FiledownLimit();
            string[] guid = strGuid.Split(',');

            _fl.ConnectionString = strCon;
            for (int i = 0; i < guid.Length; i++)
            {
                if (!_fl.ModifyDownLimit(guid[i], strDomain, 0, DateTime.Now, ""))
                {
                    _js.MessageBox(_fl.ErrorMessage);
                    _js.HistoryBack();
                    return;
                }
            }
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        _js.MovePage("FileSendList.aspx?iPage=" + iPage.ToString(), "");
    }
}
