﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Webhard_MailSendResult : System.Web.UI.Page
{
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strDomain = "";
    private string strMemberId = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strSmtpServer = ConfigurationSettings.AppSettings["SmtpServer"].ToString();
    protected string strDir = "";
    protected string strFiles = "";
    protected string strEmails = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        string strTo = Request.Params["txtSendTo"];
        string strCc = Request.Params["txtSendCc"];
        string strBcc = Request.Params["txtSendBcc"];
        string strSubject = Request.Params["tbSubject"];
        string strContent = Request.Params["hfContent"];

        strDir = Request.Params["dir"];
        strFiles = Request.Params["files"];
        strDomain = Session["MAIL_DOMAIN"].ToString();
        strEmails = strTo;
        _js.Page = Page;

        if (strDir == null)
            strDir = Request.Params["hfFolder"];

        if (strFiles == null)
            strFiles = Request.Params["hfFiles"];

        if (strEmails == null)
            strEmails = Request.Params["hfEmails"];

        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../Default.aspx", "");
            return;
        }
        else
        {
            strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../Default.aspx", "");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../Default.aspx", "");
                return;
            }
        }

        if (!Page.IsPostBack)
        {
            Sendmail(strTo, strCc, strBcc, strSubject, strContent);
            ResultProcess();
        }

        Page.DataBind();
    }

    private void Sendmail(string to, string cc, string bcc, string subject, string content)
    {
        string strTo = to;
        string strCc = cc;
        string strBcc = bcc;
        string strSubject = subject;
        string strContent = content;
        string strDownPage = Request.Url.AbsolutePath;
        string strHostName = Request.Url.Host;
        int iDownLimitDay = 0;
        int iPos = 0;
        bool result = false;

        if (strTo.Trim() == "")
        {
            _js.MessageBox("받는사람이 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strSubject.Trim() == "")
        {
            _js.MessageBox("제목이 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strContent.Trim() == "")
        {
            _js.MessageBox("내용이 입력되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        // 다운로드 경로
        iPos = strDownPage.LastIndexOf("/");

        if (!strDownPage.EndsWith("/") && iPos > 0)
            strDownPage = strDownPage.Substring(0, iPos);

        if (strFiles.EndsWith("|"))
            strFiles = strFiles.Substring(0, strFiles.Length - 1);

        Sendmail _sm = new Sendmail();

        try
        {
            UserInfo UI = new UserInfo(strMemberId, strDomain, strCon);
            iDownLimitDay = int.Parse(ConfigurationSettings.AppSettings["DownLimitDay"].ToString());

            strContent += "<br>\r\n첨부파일 다운로드 유효기간은 " + DateTime.Now.AddDays(iDownLimitDay).ToString() + " 입니다.<br><br>\r\n";

            if (strTo.EndsWith(" "))
                strTo = strTo.Substring(0, strTo.Length - 1);

            if (strTo.EndsWith(","))
                strTo = strTo.Substring(0, strTo.Length - 1);

            _sm.ConnectionString = strCon;
            // 도메인
            _sm.Domain = strDomain;
            // 메일이 생성되는 사용자 폴더
            _sm.UserPath = UI.UserPath;
            // 보내는사람
            _sm.From = strMemberId + "@" + strHostName;
            // 받는사람
            _sm.To = strTo;
            //참조
            if (strCc != "" && strCc != null)
                _sm.Cc = strCc;
            // 숨은참조
            if (strBcc != "" && strBcc != null)
                _sm.Bcc = strBcc;
            // 제목
            _sm.Subject = strSubject;
            // 본문 내용
            _sm.Content = strContent;
            // 파일이 저장되어 있는 사용자명
            _sm.Name = strMemberId;
            // 다운로드 파일 폴더
            _sm.DownloadFilePath = strDir.Replace("|", "\\");
            // 다운로드 제한기간
            _sm.DownloadDayCount = iDownLimitDay;
            // 다운로드 하려는 웹서버 주소
            _sm.DownloadServer = strHostName;
            // 다운로드 하려는 웹페이지
            _sm.DownloadPage = strDownPage + "/Download.aspx";
            // 다운로드 하려는 파일 리스트
            _sm.DownloadFiles = strFiles.Split('|');

            result = _sm.Send();
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_sm.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        return;
        //_js.MovePage("MailSendResult.aspx?dir=" + Server.UrlEncode(strDir) + "&files=" + Server.UrlEncode(strFiles) + "&email=" + Server.UrlEncode(strTo), "");
    }

    private void ResultProcess()
    {
        string[] files;
        string[] folders;
        string[] emails;

        if (strFiles.Trim() != "")
        {
            files = strFiles.Split('|');
            folders = strDir.Split(',');

            if (files.Length < folders.Length)
            {
                strDir = strDir.Substring(0, strDir.Length - 1);
                folders = strDir.Split(',');
            }
            
            strFiles = "";

            for (int i = 0; i < files.Length; i++)
            {
                if (folders.Length == 1)
                    strFiles += " <b>첨부파일 " + String.Format("{0}", i+1) + "</b>: " + DisplayPath(strDir) + files[i] + "<br>\r\n";
                else
                    strFiles += " <b>첨부파일 " + String.Format("{0}", i + 1) + "</b>: " + DisplayPath(folders[i]) + files[i] + "<br>\r\n";
            }
        }

        // 메일주소 출력
        if (strEmails.Trim() != "")
        {
            if (strEmails.LastIndexOf(",") > 0)
            {
                if (strEmails.LastIndexOf(",") == (strEmails.Length - 2))
                    strEmails = strEmails.Substring(0, strEmails.Length - 2);
            }

            emails = strEmails.Split('|');
            strEmails = "";

            for (int i = 0; i < emails.Length; i++)
                strEmails += emails[i].Replace("\"", "").Replace("<", "&lt;") + "<br>\r\n";
        }
    }

    private string DisplayPath(string strFolder)
    {
        string strTmp = "";

        if (strFolder.StartsWith("G:"))
        {
            string strGroupName = "";
            int iPos = 0;

            strFolder = strFolder.Substring(2);
            iPos = strFolder.IndexOf("|");

            if (iPos > 0)
                strGroupName = strFolder.Substring(0, iPos);
            else
            {
                strGroupName = strFolder;
                strFolder = "";
            }

            strTmp = "그룹명: " + strGroupName + "<br>\r\n" +
                    "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + strFolder.Replace("|", " > ");
        }
        else
        {
            if (strFolder.StartsWith("|"))
                strFolder = strFolder.Substring(1);

            strTmp = strFolder.Replace("|", " > ");
        }

        if (strTmp.Trim() != "" && !strTmp.EndsWith(" > "))
            strTmp = strTmp + "> ";

        return strTmp;
    }
}