﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Net.Mail;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using WYSIWYG.Editor;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Webhard_Sendmail : System.Web.UI.Page
{
    protected string strDir = "";

    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strSmtpServer = ConfigurationSettings.AppSettings["SmtpServer"].ToString();
    private string strDomain = "";
    private string strMemberId = "";
    private string strFiles = "";
    protected string strFileList = "";
    
    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDir = Request.Params["dir"];
        strFiles = Request.Params["files"];
        strDomain = Session["MAIL_DOMAIN"].ToString();

        if (strDir == null)
            strDir = Request.Params["hfFolder"];

        if (strFiles == null)
            strFiles = Request.Params["hfFiles"];

        strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

        _js.Page = Page;

        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../Default.aspx", "");
            return;
        }
        else
        {
            strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../Default.aspx", "");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../Default.aspx", "");
                return;
            }
        }

        Editor.Height = 250;
        Editor.Path = "../Common/Editor/";

        if (!Page.IsPostBack)
        {
            hfFolder.Value = strDir;
            hfFiles.Value = strFiles;

            ViewFileList();
        }

        Page.DataBind();
    }

    private void ViewFileList()
    {
        string strDirTmp = strDir;
        string strGroup = "";
        string[] strFileTmp = strFiles.Split('|');

        if (strDirTmp.StartsWith("|"))
            strDirTmp = strDirTmp.Substring(1);

        // 그룹명이 있는지 확인한다.
        if (strDirTmp.StartsWith("G:"))
        {
            int iPos = strDirTmp.IndexOf("|");
            if (iPos > 0)
            {
                strGroup = strDirTmp.Substring(2, iPos - 2);
                strDirTmp = strDirTmp.Substring(iPos + 1);
            }
            else
                strGroup = strDirTmp.Substring(2);
        }

        strDirTmp = strDirTmp.Replace("|", " > ");

        if (strDirTmp != "")
        {
            if (!strDirTmp.EndsWith(" > "))
                strDirTmp += " > ";
        }

        for (int i = 0; i < strFileTmp.Length; i++)
            strFileList += string.Format("{0}", i + 1) + " 번째 파일: " + strDirTmp + strFileTmp[i] + "<br>\r\n";
    }
}
