﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using obout_ASPTreeView_2_NET;
using Webhard_Passkorea.WebSource;

public partial class Webhard_TreeMenu : System.Web.UI.Page
{
    private Member _member = new Member();
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strTreeStyle = ConfigurationSettings.AppSettings["TreeStyle"].ToString();
    private string strDomain = "";
    private string strMemberId = "";
    private string dir = "";

    protected string strPercent = "";
    protected string strUseSize = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        dir = Request.Params["dir"];
        strDomain = Session["MAIL_DOMAIN"].ToString();
        _js.Page = Page;

        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../Default.aspx", "top");
            return;
        }
        else
        {
            strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../Default.aspx", "top");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../Default.aspx", "top");
                return;
            }
        }

        if (!Page.IsPostBack)
        {
            ViewTreeMenu();
        }

        Page.DataBind();
    }

    public void ViewTreeMenu()
    {
        obout_ASPTreeView_2_NET.Tree _tree = new Tree();
        string strPath = "";

        _member.ConnectionString = strCon;
        _member.Domain = strDomain;

        if (!_member.LoadMemberInfo(strMemberId))
        {
            return;
        }

        Webhard_Passkorea.Webhard_Passkorea _wp = new Webhard_Passkorea.Webhard_Passkorea();

        float fPer = (float.Parse(_member.UseSize().ToString()) / (_member.AllocateSize * 1048576)) * 100;
        strPercent = string.Format("{0:d}", fPer.ToString());
        strUseSize = _wp.CalcSize(_member.UseSize()) + " / " + _wp.CalcSize(_member.AllocateSize * 1048576);
        strPath = _member.Path;

        if (Directory.Exists(strPath))
        {
            string strLink = "<div onclick=\"javascript: MoveDirectory('');\" onmouseover=\"javascript: this.style.cursor='hand';\" onblur=\"javascript: TextChange();\">내 웹하드</div>";

            DirectoryInfo di = new DirectoryInfo(strPath);

            _tree.Add("root", di.Name, strLink, true, null, null);
            GetSubDirectory(strPath, _tree, "");
        }

        Group _group = new Group();

        _group.ConnectionString = strCon;

        if (!_group.GetMemberGroupList(strMemberId, strDomain))
        {
            return;
        }

        DataTable _dataTable = _group.MemberGroupList;

        if (_dataTable.Rows.Count > 0)
        {
            if (dir != null)
            {
                if (dir.IndexOf("G:") > -1 && dir.StartsWith("|"))
                    dir = dir.Substring(1);
            }

            for (int i = 0; i < _dataTable.Rows.Count; i++)
            {
                string strTmpPath = _dataTable.Rows[i]["Grp_Path"].ToString();
                string strGrpName = _dataTable.Rows[i]["Grp_Name"].ToString();

                if (Directory.Exists(strTmpPath))
                {
                    string strTmpGroup = "G:" + strGrpName;
                    string strLink = "<div onclick=\"javascript: MoveDirectory('" + Server.UrlEncode(strTmpGroup) + "');\" onmouseover=\"javascript: this.style.cursor='hand';\" onblur=\"javascript: TextChange();\">" + strGrpName + "</div>";

                    _tree.Add("root", strGrpName, strLink, true, null, null);
                    GetSubDirectory(strTmpPath, _tree, strTmpGroup);
                }
            }
        }

        _tree.FolderIcons = "../Images/TreeIcons";
        _tree.FolderScript = "../Images/script";
        _tree.FolderStyle = strTreeStyle;
        _treeView.Text = _tree.HTML();
    }

    public void GetSubDirectory(string path, Tree _tree, string strGrpName)
    {
        string strTmpGroup = "";
        string directoryName = "";
        string strTmp = "";
        bool bExtended = false;

        if (path.Trim() == "")
            return;

        DirectoryInfo di = new DirectoryInfo(path);
        
        directoryName = di.Name;

        foreach (DirectoryInfo d in di.GetDirectories())
        {
            if (!strGrpName.StartsWith("G:"))
                strTmp = d.FullName.Replace(_member.Path, "").Replace("\\", "|");
            else
            {
                int iPos = strGrpName.IndexOf("\\");

                if (iPos > -1)
                    strTmpGroup = strGrpName.Substring(2, iPos);
                else
                    strTmpGroup = strGrpName.Substring(2);

                iPos = d.FullName.IndexOf(strTmpGroup);
                strTmp = "G:" + d.FullName.Substring(iPos).Replace("\\", "|");
            }

            string strLink = "<div onclick=\"javascript: MoveDirectory('" + Server.UrlEncode(strTmp) + "');\" onmouseover=\"javascript: this.style.cursor='hand';\" onblur=\"javascript: TextChange();\">" + d.Name + "</div>";

            if (dir != null)
            {
                if (dir.IndexOf("G:") < 0 && !dir.StartsWith("|"))
                    dir = "|" + dir;

                int iLen = dir.LastIndexOf(strTmp);

                if (iLen > -1)
                {
                    iLen = strTmp.Length;
                    if (dir.Substring(0, iLen) == strTmp)
                        bExtended = true;
                    //if (dir == strTmp)
                    //    bExtended = true;
                }
            }
            
            _tree.Add(directoryName, d.Name, strLink, bExtended, null, null);
            GetSubDirectory(d.FullName, _tree, strGrpName);
        }
    }
}
