﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Webhard_Passkorea.WebSource;

public partial class Webhard_Webhard : System.Web.UI.Page
{
    private Webhard_Passkorea.WebSource.Login _login = new Webhard_Passkorea.WebSource.Login();
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript _js = new JavaScript();
    private WebFunction WF;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strAdminId = ConfigurationSettings.AppSettings["AdminId"].ToString();
    private string strSchValue = "";
    private int idxNo = 0;
    
    public string dir = "";

    protected string strDomain = "";
    protected string strExtFilter = "";
    protected string strMemberId = "";
    protected string strWebhardHeight = "350";
    protected bool bUpload = false;
    protected bool bSearch = false;

    protected void Page_Load(object sender, EventArgs e)
    {
        WF = new WebFunction(this.Page);
        WF.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        string strScript = "";

        dir = Request.Params["dir"];
        strDomain = Session["MAIL_DOMAIN"].ToString();
        _js.Page = Page;
        
        // 중복 로그인 확인
        if (!_wc.CheckLogin(Request.Cookies["WB_MEMBER_INFO"]))
        {
            _js.MovePage("../Default.aspx", "");
            return;
        }
        else
        {
            strMemberId = Request.Cookies["WB_MEMBER_INFO"]["WB_MEMBER_ID"];

            if (Session["LOGIN_INDEX"] != null)
            {
                int idxNo = int.Parse(Session["LOGIN_INDEX"].ToString());
                _login.ConnectionString = strCon;

                if (!_login.CheckLoginState(strDomain, strMemberId, idxNo))
                {
                    _login.Logout(strDomain, strMemberId, idxNo);
                    _js.MessageBox(_login.ErrorMessage);
                    _js.MovePage("../Default.aspx", "");
                    return;
                }
            }
            else
            {
                _js.MessageBox("로그인 정보값이 없습니다.");
                _js.MovePage("../Default.aspx", "");
                return;
            }
        }

        if (!Page.IsPostBack)
        {
            IpFilter();
        }

        // 폴더 삭제 버튼 속성 추가
        strScript = "if (!DeleteFolder()) return false; else return true;";
        btnDeleteFolder.Attributes.Add("onclick", strScript);

        // 파일 삭제 버튼 속성 추가
        strScript = "if (!DeleteFiles()) return false; else return true;";
        btnDeleteFile.Attributes.Add("onclick", strScript);

        // 검색 버튼 속성 추가
        strScript = "if (!SearchFile()) return false; else return true;";
        btnSearchFile.Attributes.Add("onclick", strScript);

        Page.DataBind();
    }

    #region 업로드 아이피 필터링
    /// <summary>
    /// 아이피로 업로드 하려는 클라이언트를 제한한다.
    /// </summary>
    /// <returns></returns>
    private void IpFilter()
    {
        bool result = false;
        string strRemoteIp = Request.UserHostAddress;
        UploadFilter _filter = new UploadFilter();
        
        _filter.ConnectionString = strCon;

        try
        {
            result = _filter.LoadUploadFilter(strDomain, strAdminId);
        }
        catch (Exception e)
        {
            _js.MessageBox(e.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_filter.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        strExtFilter = _filter.FileExtensions;

        string[] strIp = strRemoteIp.Split('.');

        // IP B Class Check
        strRemoteIp = strIp[0] + "." + strIp[1] + ".0.0";

        if (_filter.IpList.IndexOf(strRemoteIp) > -1)
            strWebhardHeight = "700";

        // IP C Class Check
        strRemoteIp = strIp[0] + "." + strIp[1] + "." + strIp[2] + ".0";

        if (_filter.IpList.IndexOf(strRemoteIp) > -1)
            strWebhardHeight = "700";

        // IP Check
        strRemoteIp = strRemoteIp[0] + "." + strIp[1] + "." + strIp[2] + "." + strIp[3];

        if (_filter.IpList.IndexOf(strRemoteIp) > -1)
            strWebhardHeight = "700";
        else
            bUpload = true;

        return;
    }
    #endregion

    #region 폴더 삭제 버튼
    /// <summary>
    /// 폴더를 삭제한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDeleteFolder_Click(object sender, EventArgs e)
    {
        bool result = false;
        bool bGroup = false;
        string strFolder = hfFolder.Value;
        string strPath = "";
        string strGroupName = "";
        string strDeleteFolder = "";
        string strDeleteFolderName = "";
        int iPos = 0;

        if (strFolder.Trim() == "")
        {
            _js.MessageBox("사용자 폴더는 삭제할 수 없습니다.");
            _js.HistoryBack();
            return;
        }

        //strFolder = strFolder.Replace("|", "\\");

        if (strFolder.StartsWith("G:"))
        {
            bGroup = true;
            // 그룹명 잘라내기
            strFolder = strFolder.Substring(2);

            iPos = strFolder.IndexOf("|");

            if (iPos > -1)
            {
                strGroupName = strFolder.Substring(0, iPos);
                strFolder = strFolder.Substring(iPos + 1);
            }
            else
            {
                iPos = strFolder.IndexOf(" ");
                strGroupName = strFolder.Substring(0, iPos);
                strFolder = strFolder.Substring(iPos + 1);
            }

            Group _group = new Group();
            _group.ConnectionString = strCon;

            try
            {
                result = _group.LoadGroupInfo(strDomain, strGroupName);
            }
            catch (Exception err)
            {
                _js.MessageBox(err.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(_group.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            strPath = _group.GroupPath;

            if (strFolder.Trim() == "")
            {
                _js.MessageBox(strGroupName + " 그룹 폴더는 관리자만 삭제할 수 있습니다.");
                _js.HistoryBack();
                return;
            }
        }
        else
        {
            Member _member = new Member();
            _member.ConnectionString = strCon;
            _member.Domain = strDomain;

            try
            {
                result = _member.LoadMemberInfo(strMemberId);
            }
            catch (Exception err)
            {
                _js.MessageBox(err.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            strPath = _member.Path;
        }

        iPos = strFolder.LastIndexOf(" ");

        if (iPos > 0)
        {
            strDeleteFolder = strFolder.Substring(iPos + 1);
            strFolder = strFolder.Substring(0, iPos);

            if (!strPath.EndsWith("\\") && strFolder.StartsWith("|"))
                strPath += strFolder.Replace("|", "\\");
        }
        else
            strDeleteFolder = strFolder;

        if (!strPath.EndsWith("\\") && !strPath.StartsWith("\\"))
            strPath += "\\";

        string[] folders = strDeleteFolder.Split('|');

        for (int i = 0; i < folders.Length; i++)
        {
            // 폴더 삭제
            if (folders[i].Trim() != "")
            {
                if (!Directory.Exists(strPath + folders[i]))
                {
                    _js.MessageBox(folders[i] + " 폴더가 사용자 폴더에 존재하지 않습니다.");
                    _js.HistoryBack();
                    return;
                }
                else
                    Directory.Delete(strPath + folders[i], true);

                strFolder = strFolder.Replace(folders[i], "").Replace("||", "|");

                if (bGroup)
                    strDeleteFolderName += "G:" + strGroupName + strFolder + "폴더내 " + folders[i] + ", ";
                else
                    strDeleteFolderName += folders[i] + ", ";
            }
        }

        /*
        iPos = strFolder.LastIndexOf("\\");

        if (iPos > 0)
            strFolder = strFolder.Substring(0, iPos);
        else
            strFolder = "";
        */
        if (bGroup)
            strFolder = "G:" + strGroupName + "\\" + strFolder;

        if (strDeleteFolderName.EndsWith(", "))
            strDeleteFolderName = strDeleteFolderName.Substring(0, strDeleteFolderName.Length - 2);
        
        /*
        iPos = strFolder.LastIndexOf("\\");
        
        strDeleteFolderName = strFolder;

        if (iPos > 0)
            strFolder = strFolder.Substring(0, iPos);
        else
            strFolder = "";

        if (bGroup)
        {
            strFolder = "G:" + strGroupName + strFolder;
            strDeleteFolderName = "G:" + strGroupName + strDeleteFolderName;
        }
        */
        _js.MessageBox(strDeleteFolderName.Replace("|", "\\") + " 폴더가 삭제되었습니다.");
        _js.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolder.Replace("\\", "|")), "");
    }
    #endregion

    #region 파일 삭제 버튼
    /// <summary>
    /// 선택된 파일을 삭제한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDeleteFile_Click(Object sender, EventArgs e)
    {
       
        string strFolders = hfFolder.Value;
        string strFiles = hfFiles.Value;
        
        string[] strFile;
        string[] strFolder;

        if (strFiles.Trim() == "")
        {
            _js.MessageBox("삭제할 파일이 선택되지 않았습니다.");
            _js.HistoryBack();
            return;
        }

        if (strFiles.EndsWith("|"))
            strFiles = strFiles.Substring(0, strFiles.Length - 1);

        if (strFolders.EndsWith(","))
            strFolders = strFolders.Substring(0, strFolders.Length - 1);

        strFile = strFiles.Split('|');
        strFolder = strFolders.Split(',');

        for (int i = 0; i < strFile.Length; i++)
        {
            if (strFolder.Length == 1)
                FIleDelete(strFolders, strFile[i]);
            else
                FIleDelete(strFolder[i], strFile[i]);
        }

        _js.MessageBox("선택한 파일이 삭제되었습니다.");

        if (strFolder.Length == 1)
            _js.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolders.Replace("\\", "|")), "");
        else
        {
            FileSearch(strSchValue);
            return;
            dir = "";
            _js.MovePage("Webhard.aspx", "");
        }
    }

    
    #endregion

    #region 파일검색
    /// <summary>
    /// 파일명 또는 파일내 단어를 검색한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSearchFile_Click(Object sender, EventArgs e)
    {
        strSchValue = tbSearchFile.Text;
        bSearch = true;
        FileSearch(strSchValue);
    }
    #endregion

    #region 파일 삭제
    private void FIleDelete(string strFolder, string strFile)
    {
        bool result = false;
        bool bGroup = false;
        string strPath = "";
        string strGroupName = "";

        strFolder = strFolder.Replace("|", "\\");

        if (strFolder.StartsWith("G:"))
        {
            bGroup = true;

            strGroupName = strFolder.Substring(2);

            int iPos = strGroupName.IndexOf("\\");

            if (iPos > -1)
                strGroupName = strGroupName.Substring(0, iPos);

            // 그룹 정보를 불러와 그룹 전체 경로를 가져온다.
            Group _group = new Group();
            _group.ConnectionString = strCon;

            try
            {
                result = _group.LoadGroupInfo(strDomain, strGroupName);
            }
            catch (Exception err)
            {
                _js.MessageBox(err.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(_group.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            strPath = _group.GroupPath;
            strFolder = strFolder.Substring(strGroupName.Length + 2);

            if (_group.OwnerId != strMemberId)
            {
                // 그룹에 등록되어 있는 회원인지 확인하고
                // 다운 받을수 있는 권한이 있는지 확인한다.
                GroupMember _gm = new GroupMember();

                _gm.ConnectionString = strCon;

                try
                {
                    result = _gm.CheckGroupMember(strDomain, strGroupName, strMemberId);
                }
                catch (Exception err)
                {
                    _js.MessageBox(err.Message);
                    _js.HistoryBack();
                    return;
                }

                if (!result)
                {
                    _js.MessageBox(_gm.ErrorMessage);
                    _js.HistoryBack();
                    return;
                }

                if (_gm.IsDeleteLimit != "Y")
                {
                    _js.MessageBox(strMemberId + " 회원님은 선택한 파일을 삭제할 수 없습니다.");
                    _js.HistoryBack();
                    return;
                }
            }

            /*
            if (strFolder.Trim() == "")
            {
                _js.MessageBox(strGroupName + " 그룹 폴더는 관리자만 삭제할 수 있습니다.");
                _js.HistoryBack();
                return;
            }
            */
        }
        else
        {
            Member _member = new Member();
            _member.ConnectionString = strCon;
            _member.Domain = strDomain;

            try
            {
                result = _member.LoadMemberInfo(strMemberId);
            }
            catch (Exception err)
            {
                _js.MessageBox(err.Message);
                _js.HistoryBack();
                return;
            }

            if (!result)
            {
                _js.MessageBox(_member.ErrorMessage);
                _js.HistoryBack();
                return;
            }

            strPath = _member.Path;
        }

        if (strFolder.Trim() != "")
        {
            if (!strPath.EndsWith("\\") && !strFolder.StartsWith("\\"))
                strPath += "\\" + strFolder;
            else
                strPath += strFolder;
        }

        if (strFile.Trim() != "")
        {
            if (File.Exists(strPath + "\\" + strFile))
                File.Delete(strPath + "\\" + strFile);
        }
    }
    #endregion

    #region 검색
    /// <summary>
    /// 웹하드에 있는 파일을 검색한다.
    /// </summary>
    /// <param name="strSchValue"></param>
    private void FileSearch(string strSchValue)
    {
        bool result = false;
        string strQuery = "";
        string strWhere = "";
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        if (strSchValue.Trim() == "")
        {
            _js.MessageBox("검색어를 입력해 주세요.");
            _js.HistoryBack();
            return;
        }

        Webhard_Passkorea.Webhard_Passkorea _wp = new Webhard_Passkorea.Webhard_Passkorea();
        Member _member = new Member();
        _member.ConnectionString = strCon;
        _member.Domain = strDomain;

        try
        {
            result = _member.LoadMemberInfo(strMemberId);
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        if (!result)
        {
            _js.MessageBox(_member.ErrorMessage);
            _js.HistoryBack();
            return;
        }

        strWhere = " Where FREETEXT (Contents, '" + strSchValue + "') or FREETEXT(Filename, '" + strSchValue + "') or filename like '%" + strSchValue + "%' ";
        strQuery = "Select Directory, Filename, Size, Write From N_Webhard..Scope('\"" + _member.Path + "\"') " +
            strWhere + " Order by FileName";

        OleDbConnection Con = new OleDbConnection("Provider=MSIDXS; Data Source=N_Webhard;");

        try
        {
            Con.Open();
        }
        catch (Exception err)
        {
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }

        try
        {
            int iRltCnt = 0;
            OleDbCommand Cmd = new OleDbCommand(strQuery, Con);
            OleDbDataAdapter Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "FIND_FILES");
            dt = ds.Tables["FIND_FILES"];

            iRltCnt = dt.Rows.Count;

            if (iRltCnt > 0)
            {
                
                string[,] strSearchFiles = new string[iRltCnt, 4];

                for (int i = 0; i < iRltCnt; i++)
                {
                    strSearchFiles[i, 0] = dt.Rows[i]["Directory"].ToString();
                    strSearchFiles[i, 1] = dt.Rows[i]["Filename"].ToString();
                    strSearchFiles[i, 2] = dt.Rows[i]["Size"].ToString();
                    strSearchFiles[i, 3] = dt.Rows[i]["Write"].ToString();

                    int iLen = _member.Path.Length;

                    if (strSearchFiles[i, 0].Substring(0, iLen).ToLower() == _member.Path.ToLower())
                        strSearchFiles[i, 0] = strSearchFiles[i, 0].Substring(iLen);

                    if (strSearchFiles[i, 0].StartsWith("\\"))
                        strSearchFiles[i, 0] = strSearchFiles[i, 0].Substring(1);

                    strSearchFiles[i, 0] = strSearchFiles[i, 0].Replace("\\", "|");
                }

                dt.Rows.Clear();
                dt.Columns.Clear();

                dt.Columns.Add("FILE_TYPE", Type.GetType("System.String"));
                dt.Columns.Add("FOLDER", Type.GetType("System.String"));
                dt.Columns.Add("FILE_NAME", Type.GetType("System.String"));
                dt.Columns.Add("FILE_PATH", Type.GetType("System.String"));
                dt.Columns.Add("FILE_SIZE", Type.GetType("System.String"));
                dt.Columns.Add("FILE_REAL_SIZE", Type.GetType("System.String"));
                dt.Columns.Add("FILE_DATE", Type.GetType("System.String"));

                for (int i = 0; i < iRltCnt; i++)
                {
                    string strFilePath = "";

                    if (strSearchFiles[i, 1].Trim() == "")
                        continue;

                    if (strSearchFiles[i, 0].Trim() != "")
                        strFilePath = strSearchFiles[i, 0].Replace("|", "> ") + "> " + strSearchFiles[i, 1];
                    else
                        strFilePath = strSearchFiles[i, 1];

                    DataRow dr = dt.NewRow();
                    dr["FILE_TYPE"] = FileExtType(strSearchFiles[i, 1]);
                    dr["FOLDER"] = strSearchFiles[i, 0];
                    dr["FILE_NAME"] = strSearchFiles[i, 1].Replace("'", "＇");
                    dr["FILE_PATH"] = "<a href=\"Download.aspx?dir=" + Server.UrlEncode(strSearchFiles[i, 0]) + "&file=" + Server.UrlEncode(strSearchFiles[i, 1]) + "\">" + strFilePath + "</a>"; 
                    dr["FILE_SIZE"] = _wp.CalcSize(long.Parse(strSearchFiles[i, 2])).ToString();
                    dr["FILE_REAL_SIZE"] = strSearchFiles[i, 2];
                    dr["FILE_DATE"] = strSearchFiles[i, 3];
                    dt.Rows.Add(dr);
                }

                btnDeleteFolder.Visible = false;

            }

            rptSearchFiles.DataSource = dt;
            rptSearchFiles.DataBind();
            return;
        }
        catch (Exception err)
        {
            Con.Close();
            _js.MessageBox(err.Message);
            _js.HistoryBack();
            return;
        }
    }
    #endregion

    private string FileExtType(string filename)
    {
        int iPos = 0;
        string fileExt = "";

        if (filename != "")
        {
            iPos = filename.LastIndexOf(".");

            if (iPos > 0)
            {
                fileExt = filename.Substring(iPos + 1);
                fileExt = fileExt.ToUpper() + " 파일";
            }
            else
                fileExt = "파일";
        }

        return fileExt;
    }
}
