SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prAddBoard
	(
		@varBrdName varchar(20),
		@varDomain varchar(255),
		@iDocCnt int,
		@iBrdListCnt int,
		@chrBrdIsAttach char(1),
		@varHeader varchar(3800),
		@varFooter varchar(3800),
		@chrAuthList char(1),
		@chrAuthRead char(1),
		@chrAuthWrite char(1),
		@chrAuthModify char(1),
		@chrAuthDelete char(1),
		@chrAuthReply char(1),
		@varAdminId varchar(15),
		@chrCreateIp char(15),
		@iBrdMaxNo int OUTPUT
	)
As

Declare @iMaxNo int
Declare @iMaxBrdNo int

If Exists(Select BRD_NAME FROM BRD_INFO WHERE BRD_NAME = @varBrdName And BRD_DOMAIN = @varDomain)
	Return -100

Select @iMaxNo = ISNULL(Max(BRD_NO), 0) FROM BRD_INFO

Set @iBrdMaxNo = @iMaxNo + 1

Select  @iMaxBrdNo = ISNULL(Max(BRD_VIEW_NO), 0)  FROM BRD_INFO WHERE BRD_DOMAIN = @varDomain


Insert Into BRD_INFO (BRD_NO, BRD_VIEW_NO, BRD_DOMAIN, BRD_NAME, BRD_DOC_CNT, BRD_LIST_CNT, BRD_IS_ATTACH,
			BRD_HEADER, BRD_FOOTER, BRD_AUTH_LIST, BRD_AUTH_READ, BRD_AUTH_WRITE, BRD_AUTH_MODIFY,
			BRD_AUTH_DELETE, BRD_AUTH_REPLY, BRD_ADMIN_ID, BRD_CREATE_DATE, BRD_CREATE_IP)
Values (@iMaxNo + 1, @iMaxBrdNo +1, @varDomain, @varBrdName, @iDocCnt, @iBrdListCnt, @chrBrdIsAttach, @varHeader,
	@varFooter, @chrAuthList, @chrAuthRead, @chrAuthWrite, @chrAuthModify, @chrAuthDelete, @chrAuthReply,
	@varAdminId, GetDate(), @chrCreateIp)

If @@ERROR <> 0 
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prAddDomain
(
	@strDomain varchar(255),
	@iAllocateSize int,
	@iUserCount int,
	@strJoinType char(1),
	@iDefaultSize int,
	@strPop3Allow char(1),
	@strCopyright varchar(6000),
	@strReturnValue varchar(600) OUTPUT
)
As

If Exists(Select WDC_Domain From Webmail_Domain_Config Where WDC_Domain = @strDomain)
Begin
	Set @strReturnValue = @strDomain + ' ε   մϴ.\r\nٸ  Է ּ.'
	Return -1
End

Insert Into Webmail_Domain_Config
	(WDC_Domain,	WDC_AllocateSize,	WDC_User_Count,	WDC_Join_Type,	WDC_Default_Size,	WDC_POP3_Allow,	WDC_Copyright)
Values
	(@strDomain,	@iAllocateSize,		@iUserCount,		@strJoinType,	@iDefaultSize,		@strPop3Allow,		@strCopyright)

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prAddDownFile
(
	@strGuid varchar(128),
	@strMemberId varchar(20),
	@strDomain varchar(255),
	@strGroupName varchar(30),
	@strFilePath varchar(500),
	@strFilename varchar(255),
	@strDownLimitDate datetime,
	@strReturnValue varchar(200) OUTPUT
)
As

If Exists(Select Idx_Guid From Wb_Filedown_Limit Where Idx_Guid = @strGuid And Wb_Domain = @strDomain)
Begin
	Set @strReturnValue = @strGuid + '   ε մϴ.'
	Return -1
End

Insert Into Wb_Filedown_Limit
	(Idx_Guid,	Member_Id,	Group_Name,	File_Path,	[FileName],	Down_Count,	Down_Limit_Date,	Is_Download,	Add_Date,	Wb_Domain)
Values
	(@strGuid,	@strMemberId,	@strGroupName,	@strFilePath,	@strFilename,	0,		@strDownLimitDate,	'Y',	GetDate(),	@strDomain)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prAddLoginInfo
(
	@strDomain varchar(255),
	@strMemberId varchar(20),
	@strRemoteIp char(15),
	@strLoginState char(1),
	@iLoginIdxNo int OUTPUT,
	@strReturnValue varchar(200) OUTPUT
)
As

Declare @iMaxNo int,
	@strState char(1),
	@remoteIp char(15)

Select Top 1 @strState = IsNull(Log_State, ''), @remoteIp = Remote_Ip From Wb_Login_Info Where Member_Id = @strMemberId And Log_Domain = @strDomain Order By Login_Date Desc

If @strState = 'I'
Begin
	Set @strReturnValue = @remoteIp + ' Ŭ̾Ʈ α ϰ ־ α  ϴ.'
	Return -1
End


Select @iMaxNo = IsNull(Max(Idx_No), 0) + 1 From Wb_Login_Info

Insert Into Wb_Login_Info
	(Idx_no,	Member_Id,	Remote_Ip,	Login_Date,	Log_State,	Log_Domain)
Values
	(@iMaxNo,	@strMemberId,	@strRemoteIp,	GetDate(),	@strLoginState,	@strDomain)

Set @iLoginIdxNo = @iMaxNo

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prAddWebhardGroupMemberId
(
	@strDomain varchar(255),
	@strGroupName varchar(30),
	@strMemberId varchar(30),
	@strReturnValue varchar(200) OUTPUT
)
As

Declare @iMaxIdxNo int
If Exists(Select Idx_No From Wb_Group_Member Where Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ̵ ' + @strGroupName + ' ׷쿡 ϵǾ ֽϴ.'
	Return -1
End

Select @iMaxIdxNo = IsNull(Max(Idx_No), 0) + 1 From Wb_Group_Member

Insert Into Wb_Group_Member
	(Idx_No,	Grp_Member_Id,	Is_Down_Limit,	Is_Upload_Limit,	Is_Delete_Limit,	Grp_Name,	Join_date,	Grp_Domain)
Values
	(@iMaxIdxNo,	@strMemberId,	'Y',	'Y',	'Y',	@strGroupName,	GetDate(),	@strDomain)

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prBoardInfo
	(
		@iBrdNo int,
		@varDomain varchar(255)
	)
As

Select
	BRD_VIEW_NO, BRD_NAME, BRD_DOC_CNT, BRD_LIST_CNT, BRD_IS_ATTACH, BRD_HEADER, BRD_FOOTER,
	BRD_AUTH_LIST, BRD_AUTH_READ, BRD_AUTH_WRITE, BRD_AUTH_MODIFY, BRD_AUTH_DELETE, BRD_AUTH_REPLY,
	BRD_ADMIN_ID, BRD_CREATE_DATE, BRD_MODIFY_DATE, BRD_CREATE_IP, BRD_MODIFY_IP
From
	BRD_INFO
Where
	BRD_NO = @iBrdNo And BRD_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prBoardList
	(
		@iPage int,
		@iPageSize int,
		@varDomain varchar(255)
	)
As

Set Transaction Isolation Level Read UnCommitted
Set NoCount On

Declare @varSql nvarchar(1500)

Set @varSql = 'Select Top ' + Str(@iPageSize)
Set @varSql = @varSql + '	BRD_NO,	BRD_VIEW_NO,	BRD_NAME,	BRD_DOC_CNT,	BRD_LIST_CNT,	BRD_IS_ATTACH, '
Set @varSql = @varSql + '	BRD_ADMIN_ID,	BRD_CREATE_DATE '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + '	BRD_INFO '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + '	BRD_NO NOT IN '
Set @varSql = @varSql + '	(Select Top ' + Str(@iPageSize * (@iPage - 1)) + ' BRD_NO From BRD_INFO '
Set @varSql = @varSql + '		Where BRD_DOMAIN = ''' + @varDomain + ''' Order by BRD_NO) And'
Set @varSql = @varSql + '	BRD_DOMAIN = ''' + @varDomain + ''' Order by BRD_VIEW_NO'

Exec (@varSql)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prChangeWebhardGroupMemberPerm
(
	@strDomain varchar(255),
	@strGroupName varchar(30),
	@strMemberId varchar(30),
	@strField char(2),
	@strPerm char(1),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From Wb_Group_Member Where Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ̵ ' + @strGroupName + ' ׷쿡 ϵǾ  ʽϴ.'
	Return -1
End

-- ٿε  
If @strField = 'DN'
Begin
	Update Wb_Group_Member Set
		Is_Down_Limit = @strPerm
	Where
		Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain
End
Else
Begin
	-- ε  
	If @strField = 'UP'
	Begin
		Update Wb_Group_Member Set
			Is_Upload_Limit = @strPerm
		Where
			Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain	
	End
	Else
	Begin
		--   
		Update Wb_Group_Member Set
			Is_Delete_Limit = @strPerm
		Where
			Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain
	End
End

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prCheckMemberId
(
	@strMemberId varchar(30),
	@strDomain varchar(255),
	@strReturnValue varchar(200) OUTPUT
)
As

If Exists(Select IDX_No From WB_Member_Info Where Member_ID = @strMemberId And WB_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ̵ ϵǾ ִ ̵ Դϴ.'
	Return -1
End

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prCode
(
	@strGrpCode char(3),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From Wb_Code Where Grp_Code_Id = @strGrpCode)
Begin
	Set @strReturnValue = @strGrpCode + '  ˻ ڵ尡 ϴ.'
	Return -1
End

Select 
	RTrim(Code_Id), Code_Name 
From 
	Wb_Code 
Where 
	Code_Id <> '***' And Grp_Code_Id = @strGrpCode
Order by Sort_No

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prCreateMailbox
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varMailbox varchar(30),
		@varMailboxName varchar(100),
		@varRtnVal varchar(200) OUTPUT
	)
As

Declare @iMaxNo int

If Exists(Select MAILBOX_NO From MAIL_BOX Where M_MAILBOX = @varMailbox And M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ   մϴ.\r\n\r\n : ' + @varMailbox
	Return -1
End
Else If Exists(Select MAILBOX_NO From MAIL_BOX Where M_MAILBOX_NAME = @varMailboxName And M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ  մϴ.\r\n\r\n ̸: ' + @varMailboxName
	Return -2
End

Select @iMaxNo = IsNull(Max(MAILBOX_NO), 0) From MAIL_BOX

If @iMaxNo Is Null
	Set @iMaxNo = 1
Else
	Set @iMaxNo = @iMaxNo + 1

Insert Into
	MAIL_BOX
	(MAILBOX_NO, 	M_USER_ID,	M_USER_DOMAIN,	M_MAILBOX,	M_MAILBOX_NAME)
Values
	(@iMaxNo,	@varUserId,	@varDomain,		@varMailbox,	@varMailboxName)

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prCreateWebhardGroup
(
	@strDomain varchar(255),
	@strGroupName varchar(30),
	@strOwnerId varchar(30),
	@iAllocateSize int,
	@strUseAccept char(1),
	@strPath varchar(512),
	@strReturnValue varchar(200) OUTPUT
)
As

Declare @IdxGrpNo int

If Exists(Select Idx_Grp_No From Wb_Group_Info Where Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Set @strReturnValue = @strGroupName + ' ()  ׷ ̹ ϵǾ ֽϴ.'
	Return -1
End

Select @IdxGrpNo = IsNull(Max(Idx_Grp_No), 0) + 1 From Wb_Group_Info

Insert Into Wb_Group_Info 
	(Idx_Grp_No,	Grp_Name,	Grp_Owner_Id,	Grp_Allocate_Size,	Grp_Create_Date,	Grp_Use_Accept,	Grp_Path,	Grp_Domain)
Values
	(@IdxGrpNo,	@strGroupName,	@strOwnerId,	@iAllocateSize,		GetDate(),	@strUseAccept,	@strPath,	@strDomain)

If @@ERROR <> 0
	Return @@ERROR

Return 0



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



Create  Procedure prDaySchedule
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@chrSolYear char(4),
		@chrSolMonth char(2),
		@chrSolDay char(2),
		@chrSchHoliday char(1),
		@chrSchPublic char(1)
	)
As

If @varUserId = ''
Begin
	Select	SCH_NO,	SCH_ST_HOUR,	SCH_ST_MINUTE,	SCH_ED_HOUR,	SCH_ED_MINUTE,
		SCH_TITLE,	SCH_CONTENT,	SCH_TYPE,	SCH_IMPORT
	From
		SCHEDULE
	Where
		SOL_DAY = @chrSolDay And SOL_MONTH = @chrSolMonth And SOL_YEAR = @chrSolYear And
		SCH_HOLIDAY = @chrSchHoliday And SCH_PUBLIC = @chrSchPublic And USER_DOMAIN = @varDomain
	Order By SCH_ST_HOUR, SCH_ST_MINUTE
End
Else
Begin
	Select	SCH_NO,	SCH_ST_HOUR,	SCH_ST_MINUTE,	SCH_ED_HOUR,	SCH_ED_MINUTE,
		SCH_TITLE,	SCH_CONTENT,	SCH_TYPE,	SCH_IMPORT
	From
		SCHEDULE
	Where
		SOL_DAY = @chrSolDay And SOL_MONTH = @chrSolMonth And SOL_YEAR = @chrSolYear And
		SCH_HOLIDAY = @chrSchHoliday And SCH_PUBLIC = @chrSchPublic And
		USER_ID = @varUserId And USER_DOMAIN = @varDomain
	Order By SCH_ST_HOUR, SCH_ST_MINUTE
End



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDeleteBoard
	(
		@iBrdNo int,
		@varDomain varchar(255),
		@varRtnVal varchar(100) OUTPUT
	)
As

If Exists(Select BRD_NO From BRD_INFO Where BRD_NO = @iBrdNo And BRD_DOMAIN = @varDomain)
Begin
	Select @varRtnVal = BRD_IS_ATTACH From BRD_INFO Where BRD_NO = @iBrdNO And BRD_DOMAIN = @varDomain

	Delete From DOC_INFO Where BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain

	Delete From BRD_INFO Where BRD_NO = @iBrdNo And BRD_DOMAIN = @varDomain
	
	If @@ERROR <> 0
		Return @@ERROR
End
Else
Begin
	Set @varRtnVal = ' Խ  ϴ.\r\n\r\nԽ ȣ: ' + Str(@iBrdNo)
	Return -1
End

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prDeleteDoc
	(
		@iBrdNo int,
		@iDocNo int,
		@varDomain varchar(255),
		@varRtnVal varchar(100) OUTPUT
	)
As

If Not Exists(Select DOC_NO From DOC_INFO Where DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ Խù  ʽϴ.\r\n\r\nԽù ȣ: ' + Str(@iDocNo)
	Return - 1
End

Delete From DOC_INFO Where DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prDeleteDomain
(
	@strDomain varchar(255),
	@strReturnValue varchar(600) OUTPUT
)
As

Declare @iUserCnt int

If Not Exists(Select WDC_Domain From Webmail_Domain_Config Where WDC_Domain = @strDomain)
Begin
	Set @strReturnValue = @strDomain + '     ʽϴ.'
	Return -1
End

Select @iUserCnt = Count(User_No) From Mail_User Where User_Domain = @strDomain

If @iUserCnt > 0
Begin
	Set @strReturnValue = @strDomain + ' ο ' + LTrim(Str(@iUserCnt)) + '  ڰ ϵǾ ־   ϴ.\r\n'
	Set @strReturnValue = @strReturnValue + 'Ϸ ڸ   ڿ Ͻʽÿ.'
	Return -2
End

Delete From Webmail_Domain_Config Where WDC_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDeleteDownLimit
(
	@strGuid varchar(128),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_Guid From Wb_Filedown_Limit Where Idx_Guid = @strGuid)
Begin
	Set @strReturnValue = @strGuid + '   ٿε  ϴ.'
	Return -1
End

Delete From Wb_Filedown_Limit Where Idx_Guid = @strGuid

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDeleteEmailAddr
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroup varchar(30),
		@iEmailId int,
		@chrCommon char(1),
		@varRtnVal varchar(300) OUTPUT
	)
As

Declare @vUserId varchar(15),
	@chrUserPermit char(1)

--  ּҷ 
If @chrCommon = 'Y'
Begin
	-- Ϸ ּҸ   ̵ ´.
	Select @vUserId = USER_ID From MAIL_ADDRESS Where EMAIL_ID = @iEmailId And IS_COMMON = @chrCommon And GROUP_NAME = @varGroup And USER_DOMAIN = @varDomain
	
	-- Ϸ  ּҷ ϴ ȮѴ.	
	If @vUserId Is Null
	Begin
		Set @varRtnVal = 'Ϸ  ּҰ ϴ.\r\n\r\nּ ̵: ' + Str(@iEmailId)
		Return -1
	End
	
	-- Ϸ   ´.
	Select @chrUserPermit = USER_PERMIT From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain
	
	If @chrUserPermit <> '1'
	Begin
		-- Ϸ ڰ  ڿ  ȮѴ.
		If @varUserId <> @vUserId
		Begin
			Set @varRtnVal = ' ּҷ   Ǵ ڸ   ֽϴ.\r\n\r\nּҷ ȣ: ' + Str(@iEmailId)
			Return -2
		End
	End

	Delete From MAIL_ADDRESS
	Where
		EMAIL_ID = @iEmailId And
		IS_COMMON = @chrCommon And
		GROUP_NAME = @varGroup And
		USER_DOMAIN = @varDomain
End
Else
Begin
	-- Ϸ  ּҷ ϴ ȮѴ.
	If Not Exists(Select EMAIL_ID From MAIL_ADDRESS Where EMAIL_ID = @iEmailId And IsNull(GROUP_NAME, '') = @varGroup And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Begin
		Set @varRtnVal = 'Ϸ  ּҰ ϴ.\r\n\r\nּ ̵: ' + Str(@iEmailId)
		Return -3
	End

	Delete From MAIL_ADDRESS
	Where
		EMAIL_ID = @iEmailId And
		USER_ID = @varUserId And
		USER_DOMAIN = @varDomain
End

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prDeleteFilter
	(
		@iFilterNo int,
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varRtnVal varchar(100) OUTPUT
	)
As

If Not Exists(Select FILTER_NO From FILTER Where FILTER_NO = @iFilterNo And F_USER_ID = @varUserId And F_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ  ڵз Ģ ϴ.\r\n\r\nڵз ȣ: ' + Str(@iFilterNo)
	Return -1
End

Delete From FILTER Where FILTER_NO = @iFilterNo And F_USER_ID = @varUserId And F_USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDeleteGroup
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroupName varchar(30),
		@chrCommon char(1)
	)
As

If @chrCommon = 'Y'
Begin
	--  ּҷ 
	If Exists(Select EMAIL_ID From MAIL_ADDRESS Where IS_COMMON = @chrCommon And GROUP_NAME =@varGroupName And USER_DOMAIN = @varDomain)
	Begin
		Delete From MAIL_ADDRESS Where IS_COMMON = @chrCommon And GROUP_NAME =@varGroupName And USER_DOMAIN = @varDomain
		
		If @@ERROR <> 0
			Return @@ERROR
	End
	
	--  ׷ 
	If Exists(Select GROUP_NAME From MAIL_GROUP Where IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_DOMAIN = @varDomain)
	Begin
		Delete From MAIL_GROUP Where IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_DOMAIN = @varDomain
		
		If @@ERROR <> 0
			Return @@ERROR
	End
End
Else
Begin
	--  ּҷ 
	If Exists(Select EMAIL_ID From MAIL_ADDRESS Where IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Begin
		Delete From MAIL_ADDRESS Where IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And USER_DOMAIN = @varDomain
		
		If @@ERROR <> 0
			Return @@ERROR
	End
	
	--  ׷ 
	If Exists(Select GROUP_NAME From MAIL_GROUP Where IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Begin
		Delete From MAIL_GROUP Where IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And USER_DOMAIN = @varDomain
		
		If @@ERROR <> 0
			Return @@ERROR
	End
End

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDeleteMailUser
(
	@varDomain varchar(255),
	@varUserId varchar(30),
	@varRtnVal varchar(200) OUTPUT
)
As
Declare @varUserPath varchar(255)

If Not Exists (Select USER_NO From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = @varUserId + ' ڴ ϵǾ   ڶ   ϴ.'
	Return - 1
End

--  ڵ з  
If Exists (Select FILTER_NO From FILTER Where F_USER_ID = @varUserId And F_USER_DOMAIN = @varDomain)
	Delete From FILTER Where F_USER_ID = @varUserId And F_USER_DOMAIN = @varDomain

-- Ϲڽ  
If Exists (Select MAILBOX_NO From MAIL_BOX Where M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
	Delete From MAIL_BOX Where M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain

--   
If Exists (Select SIGN_NO From SIGN_INFO Where S_USER_ID = @varUserId And S_USER_DOMAIN = @varDomain)
	Delete From SIGN_INFO Where S_USER_ID = @varUserId And S_USER_DOMAIN = @varDomain

--  Űź  
If Exists (Select [ID] From USERSPAMMER Where USERS = @varUserId And [DOMAIN] = @varDomain)
	Delete From USERSPAMMER Where USERS = @varUserId And [DOMAIN] = @varDomain

--  ޸ 
If Exists (Select NOTE_NO From USER_NOTE Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Delete From USER_NOTE Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

--   
If Exists (Select SCH_NO From SCHEDULE Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Delete From SCHEDULE Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

-- POP3  
If Exists (Select POP3_NO From MAIL_POP3 Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Delete From MAIL_POP3 Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

-- ּҷ ׷  
If Exists (Select USER_ID From MAIL_GROUP Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Delete From MAIL_GROUP Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

-- ּҷ  
If Exists (Select EMAIL_ID From MAIL_ADDRESS Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Delete From MAIL_ADDRESS Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

-- Ȯ  
If Exists (Select SEND_MAIL_ID From MAIL_CONFIRM Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Delete From MAIL_CONFIRM Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

--  α  
If Exists (Select CONN_ID From LOGIN_INFO Where LOGIN_ID = @varUserId And USER_DOMAIN = @varDomain)
	Delete From LOGIN_INFO Where LOGIN_ID = @varUserId And USER_DOMAIN = @varDomain

--   
If Exists (Select USER_ID From USER_INFO Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Delete From USER_INFO Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

-- ϻ  
If Exists (Select USER_NO From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Select @varUserPath = USER_MAILBOX_PATH From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain
	Delete From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain
End

If @@ERROR <> 0
	Return @@ERROR

Set @varRtnVal = @varUserPath

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prDeleteMailbox
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varMailbox varchar(30),
		@varRtnVal varchar(200) OUTPUT
	)
As

If Not Exists(Select MAILBOX_NO From MAIL_BOX Where M_MAILBOX = @varMailbox And M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ    ʽϴ.\r\n\r\n : ' + @varMailbox
	Return -1
End

Delete From
	MAIL_BOX 
Where
	M_MAILBOX = @varMailbox And
	M_USER_ID = @varUserId And
	M_USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDeleteMailing
	(
		@varMailingId varchar(255),
		@varDomain varchar(255)
	)
As

Declare @varSql nvarchar(765)

If @varMailingId = 'ADDRESS'
	Return -100

If @varMailingId = 'BOX' 
	Return -101

If @varMailingId = 'CONFIRM' 
	Return -102

If @varMailingId = 'GROUP' 
	Return -103

If @varMailingId = 'POP3' 
	Return -104

If @varMailingId = 'USER' 
	Return -105

Set @varSql = 'MAILING_' + @varMailingId

If Exists(Select * From dbo.sysobjects Where id = object_id(@varSql))
Begin
	Set @varSql = 'DROP TABLE MAILING_' + @varMailingId

	Exec (@varSql)
	
	If @@ERROR <> 0
		Return @@ERROR
End

If Exists(Select * From LIST Where [USER] = @varMailingId)
Begin
	Set @varSql = 'Delete From LIST Where [USER] = ''' + @varMailingId + ''''

	Exec (@varSql)

	If @@ERROR <> 0
		Return @@ERROR
End

If Exists(Select * From MAIL_USER Where USER_ID = @varMailingId And USER_DOMAIN = @varDomain)
Begin
	Set @varSql = 'Delete From MAIL_USER Where USER_ID = ''' + @varMailingId + ''' And USER_DOMAIN = ''' + @varDomain + ''''
	
	Exec (@varSql)
	
	If @@ERROR <> 0
		Return @@ERROR
End

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDeleteMailingListEmail
(
	@varMailingId varchar(255),
	@varEmail varchar(512)
)
As

Declare @varSql varchar(2000)

Set @varSql = 'Delete From MAILING_' + @varMailingId + ' Where LIST = ''' + @varEmail + ''''

exec(@varSql)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prDeletePop3
	(
		@iPop3No int,
		@varUserId varchar(15),	
		@varDomain varchar(255),
		@varRtnVal varchar(100) OUTPUT
	)
As

If Not Exists(Select POP3_NO From MAIL_POP3 Where POP3_NO = @iPop3No And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ POP3  ϴ.\r\n\r\nPOP3 ȣ: ' + Str(@iPop3No)
	Return -1
End

Delete From
	MAIL_POP3
Where
	POP3_NO = @iPop3No And
	USER_ID = @varUserId And
	USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prDeleteRejectEmail
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varRejectEmail varchar(1000),
		@varRtnVal varchar(1100) OUTPUT
	)
As

If Not Exists(Select [ID] As SPAMMER_EMAIL From USERSPAMMER Where SPAMMER_ADDR In (@varRejectEmail) And [USERS] = @varUserId And [DOMAIN] = @varDomain)
Begin
	Set @varRtnVal = ' ּҰ ϴ.\r\n\r\n ּ: ' + @varRejectEmail
	Return -1
End

Delete From USERSPAMMER Where SPAMMER_ADDR In (@varRejectEmail) And USERS = @varUserId And [DOMAIN] = @varDomain

If @@ERROR <> 0
	Return @@ERROR




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDeleteSchedule
	(
		@iSchNo int,
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varRtnVal varchar(100) OUTPUT
	)

As
If Not Exists(Select SCH_NO From SCHEDULE Where SCH_NO = @iSchNo And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ  ϴ.\r\n\r\n ȣ: ' + Str(@iSchNo)
	Return -1
	
End

Delete From SCHEDULE Where SCH_NO = @iSchNo And USER_ID = @varUserId And USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prDeleteSendEmailAddr
(
	@strUserId varchar(15),
	@strDomain varchar(256),
	@strEmailAddr varchar(512)
)
As

If Not Exists(Select Email_Addr From MailAddrList Where Email_Addr = @strEmailAddr And User_Id = @strUserId And User_Domain = @strDomain)
	Return -1

Delete From MailAddrList Where Email_Addr = @strEmailAddr And User_Id = @strUserId And User_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prDeleteWebhardGroup
(
	@strDomain varchar(255),
	@strGroupName varchar(30),
	@strPath varchar(512) OUTPUT,
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_Grp_No From Wb_Group_Info Where Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Set @strReturnValue = @strGroupName + ' ׷ ϵ  ׷Դϴ.'
	Return -1
End

Select @strPath = Grp_Path From Wb_Group_Info Where Grp_Name = @strGroupName And Grp_Domain = @strDomain

Delete From Wb_Group_Member Where Grp_Name = @strGroupName And Grp_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Delete From Wb_Group_Info Where Grp_Name = @strGroupName And Grp_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prDeleteWebhardGroupMember
(
	@strDomain varchar(255),
	@strMemberId varchar(30),
	@strGroupName varchar(30),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From Wb_Group_Member Where Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ̵ ' + @strGroupName + ' ׷쿡 ϵ ڰ ƴմϴ.'
	Return -1
End
Else
Begin
	Delete From Wb_Group_Member Where Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain
End

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prDeleteWebhardMember
(
	@strMemberId varchar(30),
	@strDomain varchar(255),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select IDX_No From Wb_Member_Info Where Member_Id = @strMemberId And Wb_Domain = @strDomain)
Begin
	Set @strReturnValue = 'Ϸ   ϴ.'
	Return -1
End

Delete From Wb_Member_Info Where Member_Id = @strMemberId And Wb_Domain = @strDomain

If @@ERROR <> 0 
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prDomainList


As

Select
	WDC_DOMAIN,	WDC_AllocateSize,	WDC_User_Count,	WDC_Default_Size,
	Case WDC_Join_Type When 'Y' Then 'ð' When 'N' Then ' ' End As WDC_Join_Type,
	IsNull(Mail.User_Count, 0) As User_Count,	IsNull(Mail.Use_Size, 0) As Use_Size
From
	Webmail_Domain_Config As WDC Left Outer Join
	(Select User_Domain, Count(User_No) As User_Count, Sum(User_MailBox_Size) As Use_Size From Mail_User Group By User_Domain) AS Mail On
	WDC.WDC_Domain = Mail.User_Domain
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prDomainUserCount
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@chrAuthority char(1),
		@intAuthCount int OUTPUT
	)
As

If @varUserId = ''
Begin
	Select
		@intAuthCount = Count(USER_AUTHORITY)
	From
		MAIL_USER
	WHERE
		USER_DOMAIN = @varDomain And
		USER_AUTHORITY = @chrAuthority
End
Else
Begin
	Select 
		 Count(USER_AUTHORITY)
	From
		MAIL_USER
	WHERE
		USER_ID = @varUserId And
		USER_DOMAIN = @varDomain And
		USER_AUTHORITY = @chrAuthority
End

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prExistMailUser
	(
		@varUserId varchar(20)
	)
As

Declare @numUserId numeric(9, 0)

If Not Exists(Select USER_NO From MAIL_USER Where USER_ID = @varUserId)
	Set @numUserId = 0
Else
	Set @numUserId = 1

If @@ERROR <> 0
	Set @numUserId = @@ERROR

Return @NumUserId


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE  Procedure prExistMailingUser
	(
		@varUserId varchar(20)
	)
As

Declare @numUserId numeric(9, 0)

If Not Exists(Select DEST From LIST Where USER = @varUserId)
	Set @numUserId = 0
Else
	Set @numUserId = 1

If @@ERROR <> 0
	Set @numUserId = @@ERROR

Return @NumUserId



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE   PROCEDURE prExistUser
	(
		@varUserId varchar(15),
		@varDomain varchar(255)
	)
As

Declare @numUserId numeric(9, 0)

If Not Exists(Select USER_NO From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Set @numUserId = 0
Else
	Set @numUserId = 1

If @@ERROR <> 0
	Set @numUserId = @@ERROR

Return @numUserId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prFindMemberPwd
(
	@strMemberId varchar(30),
	@strDomain varchar(255),
	@strEmail varchar(255),
	@strMemberName varchar(20) OUTPUT,
	@strMemberPwd varchar(20) OUTPUT,
	@strReturnValue varchar(200) OUTPUT
)
As

Declare @strEmail2 varchar(255)

If Not Exists(Select Idx_No From Wb_Member_Info Where Member_id = @strMemberId And Wb_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + '  ϵ ̵ ϴ.'
	Return -1
End
Else
Begin
	Select @strEmail2 = Email_Addr From Wb_Member_Info Where Member_id = @strMemberId And Wb_Domain = @strDomain
	
	If @strEmail <> @strEmail2
	Begin
		Set @strReturnValue = 'ּҰ ġ ʾƼ йȣ ã  ϴ.'
		Return -2
	End
End

Select @strMemberName = Member_Name, @strMemberPwd = Member_Pwd From Wb_Member_Info Where Member_id = @strMemberId And Wb_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prInsertDocInfo
	(
		@iBrdNo int,
		@varDomain varchar(255),
		@varWriterId varchar(15),
		@varSubject varchar(50),
		@txtContent text,
		@varRemoteIp char(15),
		@varAttachFile varchar(255),
		@iAttachSize numeric(10, 0)
	)
As

Declare @iMaxDocNo int
Declare @iMaxDocViewNo int

Select @iMaxDocNo = ISNULL(Max(DOC_NO), 0) + 1 From DOC_INFO
Select @iMaxDocViewNo = IsNull(Max(DOC_VIEW_NO), 0) + 1 From DOC_INFO Where BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain

Insert Into DOC_INFO (DOC_NO, BRD_NO, DOC_DOMAIN, DOC_WRITER_ID, DOC_SUBJECT, DOC_CONTENT,
			DOC_WRITE_DATE, DOC_READ_CNT, DOC_RECOM_CNT, DOC_REMOTE_IP,
			DOC_VIEW_NO, DOC_REF_NO, DOC_STEP, DOC_SORT, DOC_ATTACH_FILE, DOC_ATTACH_SIZE)
Values
	(@iMaxDocNo, @iBrdNo, @varDomain, @varWriterId, @varSubject, @txtContent, GetDate(), 0, 0, @varRemoteIp,
	@iMaxDocViewNo, @iMaxDocNo, 0, 0, @varAttachFile, @iAttachSize)

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prInsertEmailAddr
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroup varchar(30),
		@varEmail varchar(255),
		@varEmailName varchar(50),
		@varAddr1 varchar(100),
		@varAddr2 varchar(60),
		@chrZipCode char(6),
		@chrTel char(13),
		@chrCellPhone char(13),
		@varCompanyName varchar(30),
		@varPosition varchar(30),
		@chrOfficeTel char(13),
		@chrOfficeFax char(13),
		@txtEtcMemo text,
		@chrCommon char(1),
		@varRtnVal varchar(300) OUTPUT
	)
As

Declare @iMaxNo int

If @chrCommon = 'Y'
Begin
	If Exists(Select EMAIL_ID From MAIL_ADDRESS Where EMAIL_ADDR = @varEmail And IS_COMMON = @chrCommon And GROUP_NAME = @varGroup And USER_DOMAIN = @varDomain)
	Begin
		Set @varRtnVal = 'Ϸ ּҴ  ּҷϿ ϵǾ ִ ּ Դϴ.\r\n\r\nּ: ' + @varEmail
		Return -1
	End
End
Else
Begin
	If Exists(Select EMAIL_ID From MAIL_ADDRESS Where EMAIL_ADDR = @varEmail And IS_COMMON = @chrCommon And GROUP_NAME = @varGroup And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Begin
		Set @varRtnVal = 'Ϸ ּҴ ּҷϿ ϵǾ ִ ּ Դϴ.\r\n\r\nּ: ' + @varEmail
		Return -2
	End
End

Select @iMaxNo = IsNull(Max(EMAIL_ID), 0) From MAIL_ADDRESS

If @iMaxNo Is Null
	Set @iMaxNo = 1
Else
	Set @iMaxNo = @iMaxNo + 1

Insert Into MAIL_ADDRESS
	(EMAIL_ID,	USER_ID,	USER_DOMAIN,	GROUP_NAME,	EMAIL_ADDR,	EMAIL_NAME,
	ADDRESS1,	ADDRESS2,	ZIP_CODE,	TEL,		CELL_PHONE,	COMPANY_NAME,
	POSITION,	OFFICE_TEL,	OFFICE_FAX,	ETC_MEMO,	IS_COMMON)
Values
	(@iMaxNo,	@varUserId,	@varDomain,	@varGroup,	@varEmail,	@varEmailName,
	@varAddr1,	@varAddr2,	@chrZipCode,	@chrTel,		@chrCellPhone,	@varCompanyName,
	@varPosition,	@chrOfficeTel,	@chrOfficeFax,	@txtEtcMemo,	@chrCommon)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prInsertFiltering
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@varWords varchar(20),
		@chrTarget char(2),
		@varMailBox varchar(30)	,
		@chrIsUse char(1)
	)
As

Declare @iMaxNo int

Select
	@iMaxNo = IsNull(Max(FILTER_NO), 0) + 1
From
	FILTER

Insert Into
	FILTER
	(FILTER_NO,	F_USER_ID,	F_USER_DOMAIN,	F_WORDS,
	F_TARGET,	F_MAILBOX,	F_IS_USE)
Values
	(@iMaxNo,	@varUserId,	@varDomain,	@varWords,
	@chrTarget,	@varMailBox,	@chrIsUse)

If @@ERROR <> 0
	Return @@ERROR

Return


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prInsertGroup
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroupName varchar(30),
		@varGroupDesc varchar(100),
		@chrCommon char(1),
		@varRtnVal varchar(200) OUTPUT
	)
As

If Exists(Select GROUP_NAME From MAIL_GROUP Where GROUP_NAME = @varGroupName And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ ׷ ̹ ϵ ׷ Դϴ.\r\n\r\n׷: ' + @varGroupName
	Return -1
End

Insert Into MAIL_GROUP
	(USER_ID,	USER_DOMAIN,	GROUP_NAME,	GROUP_DESC,	IS_COMMON)
Values
	(@varUserId,	@varDomain,	@varGroupName,	@varGroupDesc,	@chrCommon)

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prInsertMailConfirm
	(
		@varSendMailId varchar(50),
		@varSaveMailId varchar(50),
		@varSubject varchar(200),
		@varUserId varchar(15),
		@varDomain varchar(255),
		@chrMailType char(2),
		@varReceiveMail varchar(255),
		@dtSendDate DateTime,
		@bIsRead Bit
	)
As

Insert Into MAIL_CONFIRM
	(SEND_MAIL_ID,	SAVE_MAIL_ID,	MAIL_SUBJECT,	USER_ID,	USER_DOMAIN,
	MAIL_TYPE,	RECEIVE_EMAIL,	SEND_DATE,	IS_READ)
Values
	(@varSendMailId,	@varSaveMailId,	@varSubject,	@varUserId,	@varDomain,
	@chrmailType,	@varReceiveMail,	@dtSendDate,	@bIsRead)


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE    PROCEDURE prInsertMailUser
	(
		@varUserId varchar(15),
		@varUserName varchar(20),
		@varUserPwd varchar(14),
		@intUserMaxSize numeric(9, 0),
		@chrUserAuth char(1),
		@varMailboxPath varchar(255),
		@chrUserPermit char(1),
		@varDomain varchar(255),
		@bIsMailing bit,
		@chrPop3Allow char(1)
	)
As

Declare @intUserMaxNo int

If Exists(Select USER_NO From MAIL_USER Where USER_ID = @varUserId)
Begin
	If Exists(Select USER_NO From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Begin
		Return -1
	End
	Else
	Begin
		If Exists(Select USER_NO From MAIL_USER Where USER_PWD = @varUserPwd And USER_ID = @varUserId)
		Begin
			Return -2
		End
	End
End

Select @intUserMaxNo = IsNull(Max(USER_NO), 0) From MAIL_USER

If @intUserMaxNo = 0
	Set @intUserMaxNo = 1
Else
	Set @intUserMaxNo = @intUserMaxNo + 1


If @chrUserPermit = '1'
Begin
	If Exists(Select USER_NO From MAIL_USER Where USER_PERMIT = '1' And USER_DOMAIN = @varDomain)
		Update MAIL_USER Set USER_PERMIT = '0' Where USER_DOMAIN = @varDomain
End

Insert Into MAIL_USER 
	(USER_NO, USER_ID, USER_NAME, USER_PWD, USER_MAILBOX_SIZE, USER_AUTHORITY, USER_MAILBOX_PATH,
	USER_PERMIT, USER_DOMAIN, IS_MAILING, POP3_ALLOW) VALUES
	(@intUserMaxNo, @varUserId, @varUserName, @varUserPwd, @intUserMaxSize, @chrUserAuth, @varMailboxPath,
	@chrUserPermit, @varDomain, @bIsMailing, @chrPop3Allow)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prInsertMailbox
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varMailbox varchar(30),
		@varMailboxName varchar(100),
		@varRtnVal varchar(200) OUTPUT
	)
As

Declare @iMaxNo int

If Exists(Select MAILBOX_NO From MAIL_BOX Where M_MAILBOX = @varMailbox And M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ   մϴ.\r\n\r\n : ' + @varMailbox
	Return -1
End
Else If Exists(Select MAILBOX_NO From MAIL_BOX Where M_MAILBOX_NAME = @varMailboxName And M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ  մϴ.\r\n\r\n ̸: ' + @varMailboxName
	Return -2
End

Select @iMaxNo = IsNull(Max(MAILBOX_NO), 0) From MAIL_BOX

If @iMaxNo Is Null
	Set @iMaxNo = 1
Else
	Set @iMaxNo = @iMaxNo + 1

Insert Into
	MAIL_BOX
	(MAILBOX_NO, 	M_USER_ID,	M_USER_DOMAIN,	M_MAILBOX,	M_MAILBOX_NAME)
Values
	(@iMaxNo,	@varUserId,	@varDomain,		@varMailbox,	@varMailboxName)

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prInsertMailingEmail
	(
		@varMailingId varchar(255),
		@varEmail varchar(255),
		@varDomain varchar(255)
	)
As

Declare @varSql nvarchar(765)

Set @varSql = 'Select List From MAILING_' + @varMailingId + ' Where List = ''' + @varEmail + ''''

Exec (@varSql)

If @@ROWCOUNT = 0 
Begin
	Set @varSql = 'Insert Into MAILING_' + @varMailingId + ' (LIST, DOMAIN) Values (''' + @varEmail + ''', ''' + @varDomain + ''')'

	Exec (@varSql)
End
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prInsertMailingUser
	(
		@varUserId varchar(15),
		@varUserName varchar(20),
		@varUserPwd varchar(14),
		@intUserMaxSize numeric(9, 0),
		@chrUserAuth char(1),
		@varMailboxPath varchar(255),
		@chrUserPermit char(1),
		@varDomain varchar(255),
		@bIsMailing bit,
		@varDest varchar(255),
		@varRtnVal varchar(100) OUTPUT
	)
As
Declare @varSql nvarchar(1000),
	@intUserMaxNo int

--   ̺ ϵǾ ִ Ȯ
If Exists(Select USER_NO From MAIL_USER Where USER_ID = @varUserId)
Begin
	Set @varRtnVal = @varUserId + ' ̵  ̵ Դϴ.'
	Return -1
End


Select @intUserMaxNo = IsNull(Max(USER_NO), 0) + 1 From MAIL_USER

-- ڸ Ѵ.
Insert Into MAIL_USER 
	(USER_NO, USER_ID, USER_NAME, USER_PWD, USER_MAILBOX_SIZE, USER_AUTHORITY, USER_MAILBOX_PATH,
	USER_PERMIT, USER_DOMAIN, IS_MAILING) VALUES
	(@intUserMaxNo, @varUserId, @varUserName, @varUserPwd, @intUserMaxSize, @chrUserAuth, @varMailboxPath,
	@chrUserPermit, @varDomain, @bIsMailing)

If @@ERROR <> 0
	Return @@ERROR

-- ϸ Ʈ ϵǾ ִ Ȯ Ѵ.
If Exists(Select * From LIST Where [USER] = @varUserId)
Begin
	Set @varRtnVal = @varUserId + ' ϸ ̵ ϵǾ ִ ̵ Դϴ.'
	Return -2
End

-- ϸ Ʈ ̺ Ѵ.
Insert Into LIST ([USER], DEST) VALUES (@varUserId, @varDest)

If @@ERROR <> 0
	Return @@ERROR

-- ̺ Ǿ ִ Ȯ Ѵ.
If Not Exists(Select * From dbo.sysobjects Where id = object_id(@varUserId))
Begin
	-- Ǿ   ̺ Ѵ.
	Set @varSql = 'Create Table MAILING_' + @varUserId + '(LIST VARCHAR(255), DOMAIN VARCHAR(255))'
	Exec (@varSql)

	If @@ERROR <> 0
		Return @@ERROR
End
Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prInsertNote
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varNote varchar(4000)
	)
As

Declare @iMaxNo int

If Exists(Select NOTE_NO From USER_NOTE Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Update USER_NOTE Set NOTE_CONTENT = @varNote Where USER_ID = @varUserId And USER_DOMAIN = @varDomain
End
Else
Begin
	Select @iMaxNo = IsNull(Max(NOTE_NO), 0) From USER_NOTE
	
	If @iMaxNo = 0
		Set @iMaxNo = 1
	Else
		Set @iMaxNo = @iMaxNo + 1

	Insert Into USER_NOTE Values (@iMaxNo, @varUserId, @varDomain, @varNote)
End

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prInsertPop3
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varPop3Server varchar(255),
		@varPop3UserId varchar(255),
		@varPop3UserPwd varchar(30),
		@chrPop3IsDel char(1),
		@varPop3Savebox varchar(30),
		@varRtnVal varchar(600) OUTPUT
	)
As

Declare @iMaxNo int

If Exists (Select POP3_NO From MAIL_POP3 Where POP3_USER_ID = @varPop3UserId And POP3_SERVER = @varPop3Server And
	USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = @varPop3Server + '  ' + @varPop3UserId + '  ̹ ϵǾ ֽϴ.'
	Return -1
End

Select @iMaxNo = IsNull(Max(POP3_NO), 0) From MAIL_POP3

If @iMaxNo Is Null
	Set @iMaxNo = 1
Else
	Set @iMaxNo = @iMaxNo + 1

Insert Into MAIL_POP3
	(POP3_NO, USER_ID, USER_DOMAIN, POP3_SERVER, POP3_USER_ID, POP3_USER_PWD, POP3_IS_DEL, POP3_SAVEBOX)
Values
	(@iMaxNo, @varUserId, @varDomain, @varPop3Server, @varPop3UserId, @varPop3UserPwd, @chrPop3IsDel, @varPop3Savebox)

If @@ERROR <> 0
	Return @@ERROR

Return 0




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prInsertQEmailAddr
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroupName varchar(30),
		@varEmailAddr varchar(255),
		@varEmailName varchar(30),
		@chrTel char(13),
		@chrCommon char(1),
		@varRtnVal varchar(300) OUTPUT
	)
As

Declare @iMaxNo int

If @chrCommon = 'Y'
Begin
	If Exists(Select EMAIL_ADDR From MAIL_ADDRESS Where EMAIL_ADDR = @varEmailAddr And IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_DOMAIN = @varDomain)
	Begin
		Set @varRtnVal = 'Ϸ ּҴ  ּҷϿ ϵǾ ִ  ּ Դϴ.\r\n\r\n ּ: ' + @varEmailAddr
		Return - 1
	End	
End
Else
Begin
	If Exists(Select EMAIL_ADDR From MAIL_ADDRESS Where EMAIL_ADDR = @varEmailAddr And IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Begin
		Set @varRtnVal = 'Ϸ ּҴ ϵǾ ִ  ּ Դϴ.\r\n\r\n ּ: ' + @varEmailAddr
		Return - 2
	End	
End


Select @iMaxNo = IsNull(Max(EMAIL_ID), 0) + 1 From MAIL_ADDRESS

Insert Into MAIL_ADDRESS
	(EMAIL_ID,	USER_ID,	USER_DOMAIN,	GROUP_NAME,	EMAIL_ADDR,	EMAIL_NAME,	TEL,	IS_COMMON)
Values
	(@iMaxNo,	@varUserId,	@varDomain,	@varGroupName,	@varEmailAddr,	@varEmailName,	@chrTel,		@chrCommon)

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prInsertRejectEmail
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varRejectEmail varchar(255),
		@varRtnVal varchar(300) OUTPUT
	)
As

Declare @iMaxId int

If Exists(Select [ID] From USERSPAMMER Where USERS = @varUserId And [DOMAIN] = @varDomain And SPAMMER_ADDR = @varRejectEmail)
Begin
	Set @varRtnVal = @varRejectEmail + ' ּҴ Űźο ϵǾ ִ ּԴϴ.'
	Return -1
End

Select @iMaxId = IsNull(Max([id]), 0) + 1 From USERSPAMMER

If @iMaxId Is Null
	Set @iMaxId = 1

Insert Into USERSPAMMER 
	([ID], USERS, [DOMAIN], SPAMMER_ADDR) Values
	(@iMaxId, @varUserId, @varDomain, @varRejectEmail)

If @@ERROR <> 0
	Return @@ERROR

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE  Procedure prInsertSchedule
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@chrSolYear char(4),
		@chrSolMonth char(2),
		@chrSolDay char(2),
		@chrLunYear  char(4),
		@chrLunMonth char(2),
		@chrLunDay char(2),
		@chrSchStHour char(2),
		@chrSchStMinute char(2),
		@chrSchEdHour char(2),
		@chrSchEdMinute char(2),
		@varSchTitle varchar(100),
		@txtSchContent text,
		@chrSchType char(2),
		@chrSchHoliday char(1),
		@chrSchPublic char(1),
		@chrSchRepeat char(1),
		@chrSchImport char(2),
		@chrSchIsLunar char(1)
	)
As

Declare @iMaxNo int

Select @iMaxNo = IsNull(Max(SCH_NO), 0) From SCHEDULE

If @iMaxNo Is Null
	Set @iMaxNo = 1
Else
	Set @iMaxNo = @iMaxNo + 1

Insert Into SCHEDULE 
	(SCH_NO, 	USER_ID, 	USER_DOMAIN, 	SOL_YEAR, 	SOL_MONTH, 
	SOL_DAY,	LUN_YEAR, 	LUN_MONTH, 	LUN_DAY, 	SCH_ST_HOUR,
	SCH_ST_MINUTE,	SCH_ED_HOUR, 	SCH_ED_MINUTE,	SCH_TITLE,	SCH_CONTENT, 
	SCH_TYPE, 	SCH_HOLIDAY, 	SCH_PUBLIC, 	SCH_REPEAT, 	SCH_IMPORT, 
	SCH_IS_LUNAR)
	VALUES
	(@iMaxNo,	@varUserId,	@varDomain,	@chrSolYear,	@chrSolMonth,
	@chrSolDay,	@chrLunYear,	@chrLunMonth,	@chrLunDay,	@chrSchStHour,
	@chrSchStMinute,@chrSchEdHour,	@chrSchEdMinute,@varSchTitle, 	@txtSchContent, 
	@chrSchType,	@chrSchHoliday,	@chrSchPublic,	@chrSchRepeat,	@chrSchImport,
	@chrSchIsLunar)

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prInsertSendEmail
(
	@strUserId varchar(15),
	@strDomain varchar(256),
	@strEmailAddr varchar(512)
) As

-- ּҷϿ ϵǾ ִ Ȯ
If Exists(Select Email_Id From Mail_Address Where Email_Addr = @strEmailAddr And User_Id = @strUserId And User_Domain = @strDomain)
	Return -1

--  ּҷϿ ϵǾ ִ Ȯ
If Exists(Select Email_Id From Mail_Address Where Email_Addr = @strEmailAddr And Is_Common = 'Y' and User_Domain = @strDomain)
	Return -2

-- Ϲ߼ ּҷ Ʈ ִ Ȯ
If Exists(Select Email_Addr From MailAddrList Where Email_Addr = @strEmailAddr And User_Id = @strUserId And User_Domain = @strDomain)
	Return -3

Insert Into MailAddrList (User_Id, User_Domain, Email_Addr) Values (@strUserId, @strDomain, @strEmailAddr)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE prInsertUserInfo
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@chrUserPermit char(1),
		@chrSex char(1),
		@chrBirthday char(10),
		@chrLastEdu char(2),
		@chrJob char(2),
		@chrMarry char(1),
		@varPosition varchar(30),
		@chrTel char(13),
		@chrMobile char(13),
		@chrZipCode char(6),
		@varAddress1 varchar(100),
		@varAddress2 varchar(50),
		@varRtnVal varchar(200) OUTPUT
	)
As

If Exists(Select USER_ID From USER_INFO Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = @varUserId + ' ڴ ϵǾ ִ  Դϴ.\r\n\r\nٸ ̵ Է ּ.'
	Return -1
End

If @chrUserPermit = '1'
Begin
	If Exists(Select USER_ID From USER_INFO Where USER_PERMIT = '1' And USER_DOMAIN = @varDomain)
		Update USER_INFO Set USER_PERMIT = '2' Where USER_DOMAIN = @varDomain
End

Insert Into USER_INFO 
	(USER_ID, USER_DOMAIN, USER_PERMIT, USER_SEX, USER_BIRTHDAY, USER_LAST_EDU, USER_JOB, USER_MARRY,
	USER_POSITION, USER_TEL, USER_MOBILE, USER_ZIPCODE, USER_ADDRESS1, USER_ADDRESS2)
	VALUES
	(@varUserId, @varDomain, @chrUserPermit, @chrSex, @chrBirthday, @chrLastEdu, @chrJob, @chrMarry, 
	@varPosition, @chrTel, @chrMobile, @chrZipCode, @varAddress1, @varAddress2)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prJoinMember
(
	@strMemberId varchar(30),
	@strDomain varchar(255),
	@strMemberName varchar(20),
	@strMemberPwd varchar(15),
	@strEmail varchar(255),
	@strBirthday char(8),
	@strTelNo char(13),
	@strCellNo char(13),
	@strZipCode char(6),
	@strAddress1 varchar(100),
	@strAddress2 varchar(60),
	@strJob char(3),
	@iAllocateSize int,
	@strPermission char(3),
	@strPath varchar(512),
	@strReturnValue varchar(200) OUTPUT
)
As

Declare @iMaxNo int

If Exists(Select IDX_No From WB_Member_Info Where Member_ID = @strMemberId And WB_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ̵ ϵǾ ִ ̵ Դϴ.'
	Return -1
End

Select @iMaxNo = IsNull(Max(IDX_No), 0) + 1 From WB_Member_Info

Insert Into WB_Member_Info
	(IDX_No, 	Member_Id, 	Member_Name, 	Member_Pwd, 	Email_addr,	Tel_No,
	Cell_No,		Job,		Zip_Code,	Address1,	Address2,	Allocate_Size,
	Permission,	BirthDay,	WB_Path,	WB_Domain)
Values
	(@iMaxNo,	@strMemberId,	@strMemberName, @strMemberPwd,	@strEmail,	@strTelNo,
	@strCellNo,	@strJob,		@strZipCode,	@strAddress1,	@strAddress2,	@iAllocateSize,
	@strPermission,	@strBirthday,	@strPath, 	@strDomain)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prLastLoginInfo
(
	@strDomain varchar(255),
	@strMemberId varchar(20)
)
As

Declare @idxNo int

Select Top 1 @idxNo = Idx_No From Wb_Login_Info Where Member_Id = @strMemberId And Log_Domain = @strDomain Order By Login_Date Desc

Select 
	Idx_No,	Remote_Ip,	Login_Date, IsNull(Logout_Date, '') As Logout_Date,	Log_State
From
	Wb_Login_Info
Where
	Idx_No = @idxNo And
	Member_Id = @strMemberId And Log_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prLastLoginInfo2
(
	@strDomain varchar(255),
	@strMemberId varchar(20),
	@idxNo int,
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From Wb_Login_Info Where Idx_No = @idxNo And Member_Id = @strMemberId And Log_Domain = @strDomain)
Begin
	Set @strReturnValue = Str(@idxNo) + '   α  ϴ.'
	Return - 1
End

Select 
	Idx_No,	Remote_Ip,	Login_Date, IsNull(Logout_Date, '') As Logout_Date,	Log_State
From
	Wb_Login_Info
Where
	Idx_No = @idxNo And
	Member_Id = @strMemberId And Log_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListBoard
	(
		@varDomain varchar(255),
		@iBoardCnt int OUTPUT
	)
As

Select @iBoardCnt = IsNull(Count(BRD_NO), 0)  From BRD_INFO Where BRD_DOMAIN = @varDomain

Select BRD_NO, BRD_NAME From BRD_INFO Where BRD_DOMAIN = @varDomain Order By BRD_NAME

If @@ERROR <> 0
	Return @@ERROR


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE  Procedure prListCodeData
	(
		@chrCodeClass char(3)
	)
As
Select 
	Rtrim(CODE_ID) As CODE_ID, CODE_NAME 
From 
	CODE 
Where 
	CODE_ID <> '===' And
	CODE_CLASS = Rtrim(@chrCodeClass) Order by CODE_SORT ASC



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListDaysOffSchedule
	(
		@chrMonth char(2)
	)
As

Select
	SOL_DAY,	SCH_TITLE,	SCH_REST_CNT
From
	SCHEDULE
Where
	SOL_MONTH = @chrMonth And
	SCH_HOLIDAY = 'Y' And
	SCH_IS_LUNAR = 'N'


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListDoc
	(
		@iPage int,
		@iPageSize int,
		@iBrdNo int,
		@varDomain varchar(255),
		@varSchType char(4),
		@varSchVal varchar(50),
		@iTotCnt int OUTPUT
	)
As

Set Transaction Isolation Level Read UnCommitted
Set NoCount On

Declare @varSql nvarchar(1000)
Declare @varQry varchar(100)
Declare @bSch bit

Set @bSch = 0
--  ˻
If RTrim(@varSchType) = 'SUB'
Begin
	Set @bSch = 1
	Set @varSchVal = ' D.DOC_SUBJECT LIKE ''%' + @varSchVal + '%'' AND '
	Select 
		@iTotCnt = IsNull(Count(DOC_NO), 0) 
	From 
		(Select 
			DOC_NO, DOC_SUBJECT 
		From 
			DOC_INFO As D Left Outer Join MAIL_USER As M On 
			D.DOC_WRITER_ID = M.USER_ID
		Where
			D.DOC_DOMAIN = M.USER_DOMAIN AND
			D.BRD_NO = @iBrdNo AND
			D.DOC_DOMAIN = @varDomain) As DI
	Where
		DI.DOC_SUBJECT LIKE '''%' +@varSchVal + '%'''
End

-- ۾ ˻
If RTrim(@varSchType) = 'NAME'
Begin
	Set @bSch = 1
	Set @varSchVal = ' M.USER_NAME LIKE ''%' + @varSchVal + '%'' AND '
	Select 
		@iTotCnt = IsNull(Count(DOC_NO), 0) 
	From 
		(Select 
			DOC_NO, USER_NAME 
		From 
			DOC_INFO As D Left Outer Join MAIL_USER As M On 
			D.DOC_WRITER_ID = M.USER_ID
		Where
			D.DOC_DOMAIN = M.USER_DOMAIN AND
			D.BRD_NO = @iBrdNo AND
			D.DOC_DOMAIN = @varDomain) As DI
	Where
		DI.USER_NAME LIKE '''%' +@varSchVal + '%'''
End

--  ˻
If RTrim(@varSchType) = 'CON'
Begin
	Set @bSch = 1
	Set @varSchVal = ' D.DOC_CONTENT LIKE ''%' + @varSchVal + '%'' AND '
	Select 
		@iTotCnt = IsNull(Count(DOC_NO), 0) 
	From 
		(Select 
			DOC_NO, DOC_CONTENT 
		From 
			DOC_INFO As D Left Outer Join MAIL_USER As M On 
			D.DOC_WRITER_ID = M.USER_ID
		Where
			D.DOC_DOMAIN = M.USER_DOMAIN AND
			D.BRD_NO = @iBrdNo AND
			D.DOC_DOMAIN = @varDomain) As DI
	Where
		DI.DOC_CONTENT LIKE '''%' +@varSchVal + '%'''
End

If @bSch = 0
Begin
	Select 
		@iTotCnt = IsNull(Count(DOC_NO), 0) 
	From 
		(Select 
			DOC_NO, DOC_CONTENT 
		From 
			DOC_INFO As D Left Outer Join MAIL_USER As M On 
			D.DOC_WRITER_ID = M.USER_ID
		Where
			D.DOC_DOMAIN = M.USER_DOMAIN AND
			D.BRD_NO = @iBrdNo AND
			D.DOC_DOMAIN = @varDomain) As DI
End

Set @varSql = 'Select Top ' + Str(@iPageSize) + ' '
Set @varSql = @varSql + '	DOC_NO,	USER_NAME,	DOC_SUBJECT,	DOC_WRITE_DATE, '
Set @varSql = @varSql + '	DOC_READ_CNT,	DOC_VIEW_NO,	DOC_STEP, EMAIL '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + '	(Select '
Set @varSql = @varSql + '		DOC_NO, BRD_NO, DOC_WRITER_ID, DOC_SUBJECT, DOC_WRITE_DATE, DOC_READ_CNT, '
Set @varSql = @varSql + '		DOC_VIEW_NO, DOC_REF_NO, DOC_STEP, DOC_SORT, USER_NAME, USER_ID + ''@'' + USER_DOMAIN As EMAIL '
Set @varSql = @varSql + '	From '
Set @varSql = @varSql + '		DOC_INFO As D Left Outer Join MAIL_USER As m On D.DOC_WRITER_ID = M.USER_ID '
Set @varSql = @varSql + '	Where '
Set @varSql = @varSql + '		' + @varSchVal + ' '
Set @varSql = @varSql + '		D.DOC_DOMAIN = M.USER_DOMAIN AND '
Set @varSql = @varSql + '		D.BRD_NO = ' + Str(@iBrdNo) + ' AND '
Set @varSql = @varSql + '		D.DOC_DOMAIN = ''' + @varDomain + ''' ) As DI '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + '	DI.DOC_NO NOT IN '
Set @varSql = @varSql + '	(Select Top ' + Str(@iPageSize * (@iPage - 1)) + ' DOC_NO '
Set @varSql = @varSql + '	From '
Set @varSql = @varSql + '		DOC_INFO As D Left Outer Join MAIL_USER As m On D.DOC_WRITER_ID = M.USER_ID '
Set @varSql = @varSql + '	Where '
Set @varSql = @varSql + '		' +@varSchVal + ' '
Set @varSql = @varSql + '		D.DOC_DOMAIN = M.USER_DOMAIN AND '
Set @varSql = @varSql + '		D.BRD_NO = ' + Str(@iBrdNo) + ' AND '
Set @varSql = @varSql + '		D.DOC_DOMAIN = ''' + @varDomain + ''' '
Set @varSql = @varSql + '		Order By DOC_REF_NO * -1, DOC_SORT) '
Set @varSql = @varSql + '	Order By DOC_REF_NO * -1, DOC_SORT '

Exec sp_executeSql @varSql

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListEmail
	(
		@varDomain varchar(255)
	)
As

Select 
	USER_ID + '@' + USER_DOMAIN As USER_EMAIL, USER_NAME
From
	MAIL_USER
Where
	IS_MAILING = 0 And
	USER_DOMAIN = @varDomain


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListGroup
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@chrCommon char(1),
		@iNullGroup int OUTPUT
	)
As

If @chrCommon = 'Y'
Begin
	--  ׷ ϵ ּҷ  ´.
	Set @iNullGroup = 0
	Select
		IsNull(Count(EMAIL_ID), 0) As EMAIL_COUNT,		G.GROUP_NAME As GROUP_NAME,
		G.GROUP_DESC AS GROUP_DESC,			G.IS_COMMON As IS_COMMON
	From
		MAIL_GROUP G LEFT OUTER JOIN MAIL_ADDRESS A ON 
		G.IS_COMMON = A.IS_COMMON And G.GROUP_NAME = A.GROUP_NAME And G.USER_DOMAIN = A.USER_DOMAIN
	Where
		G.IS_COMMON = @chrCommon And
		G.USER_DOMAIN = @varDomain
	Group By G.GROUP_NAME, G.GROUP_DESC, G.IS_COMMON Order by G.GROUP_NAME
End
Else
Begin
	-- ̵ ׷쿡 ϵ  
	Select @iNullGroup = IsNull(Count(EMAIL_ID), 0) From MAIL_ADDRESS Where GROUP_NAME = '' And USER_ID = @varUserId And USER_DOMAIN = @varDomain
	
	-- ׷ ش ׷쿡 ϵ ڼ
	Select
		IsNull(Count(EMAIL_ID), 0) As EMAIL_COUNT,		G.GROUP_NAME As GROUP_NAME,	
		G.GROUP_DESC AS GROUP_DESC,			G.IS_COMMON As IS_COMMON
	From
		MAIL_GROUP G LEFT OUTER JOIN MAIL_ADDRESS A ON 
		G.GROUP_NAME = A.GROUP_NAME And G.USER_ID = A.USER_ID And G.USER_DOMAIN = A.USER_DOMAIN
	Where
		G.IS_COMMON = @chrCommon And G.USER_ID = @varUserId And G.USER_DOMAIN = @varDomain
	Group By G.GROUP_NAME, G.GROUP_DESC, G.IS_COMMON Order by G.GROUP_NAME
End

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListGroupEmail
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroup varchar(30),
		@chrCommon char(1)
	)
As

If @chrCommon ='Y'
Begin
	Select
		EMAIL_ADDR
	From
		MAIL_ADDRESS
	Where
		IS_COMMON = @chrCommon And
		GROUP_NAME = @varGroup And
		USER_DOMAIN = @varDomain
End
Else
Begin
	Select
		EMAIL_ADDR
	From
		MAIL_ADDRESS
	Where
		GROUP_NAME = @varGroup And
		USER_ID = @varUserId And
		USER_DOMAIN = @varDomain
End


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure prListGroupEmailAddr
	(
		@iPage int,
		@iPageSize int,
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroupName varchar(30),
		@chrCommon char(1),
		@varSchType varchar(10),
		@varSchValue varchar(50),
		@iTotCnt int OUTPUT
	)
As

Declare @varSql varchar(1100),
	 @varSchQry varchar(100),
	@varUserQry varchar(300)


If @varSchType = 'Name' 
Begin
	-- ̸ ˻
	Set @varSchQry = ' AND EMAIL_NAME LIKE ''%' + @varSchValue + '%'' '

	-- ׷  
	If @varGroupName <> '' 
	Begin
		Select 
			@iTotCnt = Count(GROUP_NAME) 
		From 
			MAIL_ADDRESS 
		Where 
			IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And 
			USER_DOMAIN = @varDomain And EMAIL_NAME LIKE '%' + @varSchValue + '%'
	End
	Else
	Begin
		-- ׷   ü ּҷ ´.
		Select 
			@iTotCnt = Count(GROUP_NAME) 
		From 
			MAIL_ADDRESS 
		Where 
			IS_COMMON = @chrCommon And USER_ID = @varUserId And 
			USER_DOMAIN = @varDomain And EMAIL_NAME LIKE '%' + @varSchValue + '%'
	End
End
Else
Begin
	If @varSchType = 'Email'
	Begin
		-- ׷  
		If @varGroupName <> ''
		Begin
			Set @varSchQry = ' AND EMAIL_ADDR LIKE ''%' + @varSchValue + '%'' '
	
			Select 
				@iTotCnt = Count(GROUP_NAME) 
			From 
				MAIL_ADDRESS 
			Where 
				IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And 
				USER_DOMAIN = @varDomain And EMAIL_ADDR LIKE '%' + @varSchValue + '%'
		End
		Else
		Begin
			-- ׷   ü ּҷ ´.
			Set @varSchQry = ' AND EMAIL_ADDR LIKE ''%' + @varSchValue + '%'' '
	
			Select 
				@iTotCnt = Count(GROUP_NAME) 
			From 
				MAIL_ADDRESS 
			Where 
				IS_COMMON = @chrCommon And USER_ID = @varUserId And 
				USER_DOMAIN = @varDomain And EMAIL_ADDR LIKE '%' + @varSchValue + '%'
		End
	End
	Else
	Begin
		If @varSchType = 'Tel'
		Begin
			-- ׷  
			If @varGroupName <> ''
			Begin
				Set @varSchQry = ' AND TEL LIKE ''%' + @varSchValue + '%'' '
	
				Select 
					@iTotCnt = Count(GROUP_NAME) 
				From 
					MAIL_ADDRESS 
				Where 
					IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And 
					USER_DOMAIN = @varDomain And TEL LIKE '%' + @varSchValue + '%'
			End
			Else
			Begin
				-- ׷   ü ּҷ ´.
				Set @varSchQry = ' AND TEL LIKE ''%' + @varSchValue + '%'' '
	
				Select 
					@iTotCnt = Count(GROUP_NAME) 
				From 
					MAIL_ADDRESS 
				Where 
					IS_COMMON = @chrCommon And USER_ID = @varUserId And 
					USER_DOMAIN = @varDomain And TEL LIKE '%' + @varSchValue + '%'
			End
		End
		Else
		Begin
			-- ׷  
			If @varGroupName <> ''
			Begin
				Select 
					@iTotCnt = Count(GROUP_NAME) 
				From 
					MAIL_ADDRESS 
				Where 
					IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And 
					USER_DOMAIN = @varDomain
			End
			Else
			Begin
				-- ׷   ü ּҷ ´.
				Select 
					@iTotCnt = Count(GROUP_NAME) 
				From 
					MAIL_ADDRESS 
				Where 
					IS_COMMON = @chrCommon And USER_ID = @varUserId And 
					USER_DOMAIN = @varDomain
			End
		End
	End
End

If @chrCommon = '' or @chrCommon = 'N'
Begin
	Set @chrCommon = 'N'
	Set @varUserQry = ' IS_COMMON = ''' + @chrCommon + ''' And '
	-- ׷  
	If @varGroupName <> ''
		Set @varUserQry = @varUserQry + '	GROUP_NAME = ''' + @varGroupName + ''' And '

	Set @varUserQry = @varUserQry + ' USER_ID = ''' + @varUserId + ''' And '
	Set @varUserQry = @varUserQry + ' USER_DOMAIN = ''' + @varDomain + ''' '
End
Else
Begin
	Set @varUserQry = ' IS_COMMON = ''' + @chrCommon + ''' And '
	-- ׷  
	If @varGroupName <> ''
		Set @varUserQry = @varUserQry + ' GROUP_NAME = ''' + @varGroupName + ''' And '

	Set @varUserQry = @varUserQry + ' USER_DOMAIN = ''' + @varDomain + ''' '
End

If @varSchQry Is Null
	Set @varSchQry = ''

Set @varSql = 'Select Top ' + Str(@iPageSize) + ' '
Set @varSql = @varSql + '	GROUP_NAME,	EMAIL_ID,	EMAIL_ADDR,	EMAIL_NAME,	TEL, '
Set @varSql = @varSql + '	CELL_PHONE,	IS_COMMON '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + '	MAIL_ADDRESS '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + '	EMAIL_ID NOT IN '
Set @varSql = @varSql + '	(Select Top ' + Str((@iPage - 1) * @iPageSize) + ' '
Set @varSql = @varSql + '	EMAIL_ID From MAIL_ADDRESS Where ' + @varUserQry
Set @varSql = @varSql + @varSchQry + ' Order By EMAIL_NAME ASC) And '
Set @varSql = @varSql + @varUserQry
Set @varSql = @varSql + @varSchQry + 'Order By EMAIL_NAME'

Exec (@varSql)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListGroupEmailInfo
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroupName varchar(30),
		@chrCommon char(1)
	)
As

If @chrCommon = 'Y'
Begin
	If @varGroupName = ''
	Begin
		--  ּҷϿ ִ  ּҷ ´.
		Select
			EMAIL_ID,	(Case GROUP_NAME 
						When '' Then ''
						Else GROUP_NAME + ') '
					End) + EMAIL_NAME + ' [' + EMAIL_ADDR + ']' AS EMAIL_ADDR
		From
			MAIL_ADDRESS
		Where
			IS_COMMON = @chrCommon And
			USER_DOMAIN = @varDomain
		Order By GROUP_NAME, EMAIL_NAME ASC
	End
	Else
	Begin
		--  ּҷ
		Select
			EMAIL_ID,	EMAIL_NAME + ' [' + EMAIL_ADDR + ']' AS EMAIL_ADDR
		From
			MAIL_ADDRESS
		Where
			IS_COMMON = @chrCommon And
			GROUP_NAME = @varGroupName And
			USER_DOMAIN = @varDomain
	End
End
Else
Begin
	--  ּҷ
	If @varGroupName = ''
	Begin
		-- ׷  ּҷϿ ϵ  ּҷ ´.
		Select
			EMAIL_ID,	EMAIL_NAME + ' [' + EMAIL_ADDR + ']' AS EMAIL_ADDR
		From
			MAIL_ADDRESS
		Where
			IS_COMMON = @chrCommon And
			USER_ID = @varUserId And
			USER_DOMAIN = @varDomain
		Order by EMAIL_ADDR
	End
	Else
	Begin
		-- ش ׷쿡 ϵ ּҷ ´.
		Select
			EMAIL_ID,	EMAIL_NAME + ' [' + EMAIL_ADDR + ']' AS EMAIL_ADDR
		From
			MAIL_ADDRESS
		Where
			IS_COMMON = @chrCommon And
			GROUP_NAME = @varGroupName And
			USER_ID = @varUserId And
			USER_DOMAIN = @varDomain
		Order by EMAIL_ADDR
	End
End

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListGroupName
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@chrCommon char(1)
	)
As

If @chrCommon = 'Y'
	Select GROUP_NAME From MAIL_GROUP where IS_COMMON = @chrCommon And USER_DOMAIN = @varDomain Order By Group_Name
Else
	Select GROUP_NAME From MAIL_GROUP Where IS_COMMON = @chrCommon And USER_ID = @varUserId And USER_DOMAIN = @varDomain Order By Group_Name

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListHolidaySchedule
	(
		@chrYear char(4),
		@chrMonth char(2)
	)
As

Select
	SOLAR_DATE,	SCH_TITLE,	SCH_REST_CNT
From
	(Select 
		@chrYear + '-' + LUN_MONTH + '-' + LUN_DAY AS LUN_DATE, 
		SCH_TITLE,	SCH_REST_CNT
	From
		SCHEDULE
	Where LUN_YEAR = '0000') A, 
	SOL_LUN_DATE B 
Where
	A.LUN_DATE = B.LUNAR_DATE And 
	(SOLAR_DATE > @chrYear + '-' + @chrMonth + '-00' And
	SOLAR_DATE < @chrYear + '-' + @chrMonth + '-32')
Order By SOLAR_DATE


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListJob
As
	Select Rtrim(CODE_ID) As CODE_ID, CODE_NAME From CODE Where CODE_ID <> '===' And
	CODE_CLASS = 'JO' Order By CODE_SORT Asc


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE prListLastEdu
As
	Select Rtrim(CODE_ID) As CODE_ID, CODE_NAME From CODE Where CODE_ID <> '===' And
	CODE_CLASS = 'LE' Order by CODE_SORT ASC


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE  Procedure prListMailBox
	(
		@varUserId varchar(20),
		@varDomain varchar(255)
	)
As

Select
	M_MAILBOX,	M_MAILBOX_NAME
From
	MAIL_BOX
Where
	M_USER_ID = @varUserId And
	M_USER_DOMAIN = @varDomain
Order By
	M_MAILBOX_NAME 

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListMailConfirm
	(
		@iPage int,
		@iPageSize int,
		@varUserId varchar(15),
		@varDomain varchar(255),
		@iTotCnt varchar(200) OUTPUT
	)
As

Set Transaction Isolation Level Read UnCommitted
Set NoCount On

Declare @varSql nvarchar(1000)

Select @iTotCnt = Count(SEND_MAIL_ID) From MAIL_CONFIRM Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

Set @varSql = 'Select Top ' + Str(@iPageSize) + ' '
Set @varSql = @varSql + ' SEND_MAIL_ID,	SAVE_MAIL_ID,	MAIL_SUBJECT,	MAIL_TYPE, '
Set @varSql = @varSql + ' RECEIVE_EMAIL,	SEND_DATE,	IS_READ,	READ_DATE '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + ' MAIL_CONFIRM '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + ' SEND_MAIL_ID NOT IN '
Set @varSql = @varSql + ' (Select TOP ' + Str((@iPage - 1) * @iPageSize) + ' SEND_MAIL_ID From MAIL_CONFIRM '
Set @varSql = @varSql + ' Where USER_ID = ''' + @varUserId + ''' And USER_DOMAIN = ''' + @varDomain + ''' Order by SEND_DATE Desc) '
Set @varSql = @varSql + ' And USER_ID = ''' + @varUserId + ''' And USER_DOMAIN = ''' + @varDomain + ''' Order by SEND_DATE Desc'

Exec (@varSql)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListMailingEmail
	(
		@iPage int,
		@iPageSize int,
		@varMailingId varchar(15),
		@iTotCnt int OUTPUT
	)
As

Declare @varSql nvarchar(1000)

Set @varSql = 'Select LIST,  [DOMAIN] AS THIS_DOMAIN From MAILING_' + @varMailingId

Exec (@varSql)

Set @iTotCnt = @@ROWCOUNT

Set @varSql = 'Select Top ' + Str(@iPageSize) + ' '
Set @varSql = @varSql + '	LIST, [DOMAIN] AS THIS_DOMAIN '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + '	MAILING_' + @varMailingId + ' '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + '	LIST Not In '
Set @varSql = @varSql + '	(Select Top ' + Str(@iPageSize * (@iPage - 1)) + ' LIST From MAILING_' + @varMailingId + ' ORDER BY LIST ASC) '
Set @varSql = @varSql + 'ORDER BY LIST ASC'

Exec (@varSql)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListMailingUser
	(
		@varDomain varchar(255)
	)
As
	Select [USER] As USER_ID, [USER] + '@' + @varDomain As EMAIL, DEST From LIST



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListPSchedule
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@chrYear char(4),
		@chrMonth char(2)
	)
As

Select
	Str(SCH_NO) As SCH_NO,	SOL_YEAR,	SOL_MONTH,	SOL_DAY,	SCH_TITLE,	SCH_PUBLIC
From
	SCHEDULE
Where
	(
		SOL_YEAR = @chrYear And SOL_MONTH = @chrMonth And 
		(
			(SCH_HOLIDAY = 'N' And SCH_PUBLIC = 'N' And SCH_REPEAT = 'N' And USER_ID = @varUserId) 
			Or
			(SCH_HOLIDAY = 'N' AND SCH_PUBLIC = 'Y' AND SCH_REPEAT = 'N')
		) Or SOL_MONTH = @chrMonth And
			(SCH_HOLIDAY = 'N' And SCH_PUBLIC = 'N' And SCH_REPEAT = 'Y' And USER_ID = @varUserId)
	) And
	USER_DOMAIN = @varDomain Order by SOL_YEAR, SOL_MONTH, SOL_DAY

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListPop3
	(
		@varUserId varchar(15),
		@varDomain varchar(255)
	)
As

Select 
	POP3_NO, POP3_SERVER, POP3_USER_ID, POP3_USER_PWD, POP3_IS_DEL, POP3_SAVEBOX
From
	MAIL_POP3
Where
	USER_ID = @varUserId And USER_DOMAIN = @varDomain Order by POP3_SERVER Asc

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListRejectEmailAddr
	(
		@iPage int,
		@iPageSize int,
		@varUserId varchar(15),
		@varDomain varchar(255),
		@iTotCnt int OUTPUT
	)
As


Set Transaction Isolation Level Read UnCommitted
Set NoCount On

Declare @varSql nvarchar(1000)

Select @iTotCnt = Count([ID]) From USERSPAMMER Where USERS = @varUserId And [DOMAIN] = @varDomain

Set @varSql = 'Select Top ' + Str(@iPageSize) + ' '
Set @varSql = @varSql + '	[ID] As SPAMMER_ID, 	SPAMMER_ADDR As REJECT_EMAIL '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + '	USERSPAMMER '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + '	[ID] Not In '
Set @varSql = @varSql + '	(Select Top ' + Str(@iPageSize * (@iPage - 1)) + ' [ID] From USERSPAMMER '
Set @varSql = @varSql + '	Where USERS = ''' + @varUserId + ''' And [DOMAIN] = ''' + @varDomain + ''' Order by SPAMMER_ADDR ASC) And'
Set @varSql = @varSql + '	USERS = ''' + @varUserId + ''' And [DOMAIN] = ''' + @varDomain + ''' Order By SPAMMER_ADDR ASC'

Exec (@varSql)


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListSchedule
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@chrSolYear char(4),
		@chrSolMonth char(2),
		@chrSolDay char(2),
		@chrSchHoliday char(1),
		@chrSchPublic char(1)
	)
As

If @varUserId = ''
Begin
	Select	SCH_NO,	SCH_ST_HOUR,	SCH_ST_MINUTE,	SCH_ED_HOUR,	SCH_ED_MINUTE,
		SCH_TITLE,	SCH_CONTENT,	SCH_TYPE,	SCH_IMPORT
	From
		SCHEDULE
	Where
		SOL_DAY = @chrSolDay And SOL_MONTH = @chrSolMonth And SOL_YEAR = @chrSolYear And
		SCH_HOLIDAY = @chrSchHoliday And SCH_PUBLIC = @chrSchPublic And USER_DOMAIN = @varDomain
	Order By SCH_ST_HOUR, SCH_ST_MINUTE
End
Else
Begin
	Select	SCH_NO,	SCH_ST_HOUR,	SCH_ST_MINUTE,	SCH_ED_HOUR,	SCH_ED_MINUTE,
		SCH_TITLE,	SCH_CONTENT,	SCH_TYPE,	SCH_IMPORT
	From
		SCHEDULE
	Where
		((SOL_DAY = @chrSolDay And SOL_MONTH = @chrSolMonth And SOL_YEAR = @chrSolYear And
		SCH_HOLIDAY = @chrSchHoliday And SCH_PUBLIC = @chrSchPublic) Or
		(SOL_DAY = @chrSolDay And SOL_MONTH = @chrSolMonth And SCH_HOLIDAY = @chrSchHoliday And
		SCH_PUBLIC = @chrSchPublic And SCH_REPEAT = 'Y')) And
		USER_ID = @varUserId And USER_DOMAIN = @varDomain
	Order By SCH_ST_HOUR, SCH_ST_MINUTE
End

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prListSendEmailAddr
(
	@strUserId varchar(15),
	@strDomain varchar(256),
	@iTotalCount int OUTPUT
)
As

Select @iTotalCount = Count(Email_Addr) From MailAddrList Where User_Id = @strUserId And User_Domain = @strDomain

Select Email_Addr From MailAddrList Where User_Id = @strUserId And User_Domain = @strDomain Order By Email_Addr

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure prListSendFile
(
	@iPage int,
	@iPageSize int,
	@strMemberId varchar(20),
	@strDomain varchar(255),
	@iTotalCount int OUTPUT
)
As

Declare @strSql varchar(2000)

Select @iTotalCount = Count(Idx_Guid) From Wb_Filedown_Limit Where Member_Id = @strMemberId And Wb_Domain = @strDomain

Set @strSql = 'Select Top ' + Str(@iPageSize) + ' '
Set @strSql = @strSql + '	Idx_Guid,	Group_Name,	File_Path,	[FileName],	Down_Count,	Down_Limit_Date,	Add_Date '
Set @strSql = @strSql + 'From '
Set @strSql = @strSql + '	Wb_Filedown_Limit '
Set @strSql = @strSql + 'Where '
Set @strSql = @strSql + '	Idx_Guid Not In (Select Top ' + Str((@iPage - 1) * @iPageSize) + ' Idx_Guid From Wb_Filedown_Limit Where Member_Id = ''' + @strMemberId + ''' And '
Set @strSql = @strSql + '	Wb_Domain = ''' + @strDomain + ''' Order by Add_Date Desc) And '
Set @strSql = @strSql + '	Member_Id = ''' + @strMemberId + ''' And Wb_Domain = ''' + @strDomain + ''' Order by Add_Date Desc'

Exec (@strSql)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListTop5NewBoardDoc
	(
		@varDomain varchar(256)
	)
As

Select Top 5 
	USER_NAME,	DOC_NO,	BRD_NAME,	DI.BRD_NO AS BRD_NO,	DOC_SUBJECT,
	DOC_WRITE_DATE,	DOC_WRITER_ID + '@' + @varDomain AS EMAIL
From 
	DOC_INFO AS DI Left Outer Join BRD_INFO AS BI On
	DI.BRD_NO = BI.BRD_NO And DI.DOC_DOMAIN = BI.BRD_DOMAIN Left Outer Join MAIL_USER AS MU On
	DI.DOC_WRITER_ID = MU.USER_ID And DI.DOC_DOMAIN = MU.USER_DOMAIN
Where 
	DOC_STEP = 0 And 
	DOC_DOMAIN = @varDomain
Order By DOC_WRITE_DATE Desc

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prListTotalMember
(
	@strDomain varchar(255),
	@strReturnValue varchar(200) OUTPUT
)
As

If @strDomain = ''
Begin
	Set @strReturnValue = ' Էµ ʾҽϴ.'
	Return -1
End

Select 
	User_No,	MU.User_Id As User_Id,	User_Name,	User_Pwd,	UI.User_Permit As User_Permit
From 
	Mail_User As MU Left Outer Join User_Info As UI On
	MU.User_Id = UI.User_Id And MU.User_Domain = UI.User_Domain
Where 
	MU.User_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prListUserData
	(
		@iPage int,
		@iPageSize int,
		@varDomain varchar(255),
		@varSchType varchar(30),
		@varSchValue varchar(30),
		@chrUserAuth char(1),
		@iTotCnt int OUTPUT
	)
As

Declare @varSql nvarchar(1000),
	@varQry varchar(100)

If @chrUserAuth <> ''
	Set @varQry = ' USER_AUTHORITY = ''' + @chrUserAuth + ''' And '
Else
	Set @varQry = ''

If @varSchType = ''
Begin
	If @chrUserAuth = ''
		Select @iTotCnt = Count(USER_ID) From MAIL_USER Where USER_DOMAIN = @varDomain
	Else
		Select @iTotCnt = Count(USER_ID) From MAIL_USER Where USER_AUTHORITY = @chrUserAuth And USER_DOMAIN = @varDomain

	Set @varSql = 'Select Top ' + Str(@iPageSize) + ' '
	Set @varSql = @varSql + '	USER_ID, USER_NAME, USER_MAILBOX_PATH, USER_MAILBOX_SIZE, '
	Set @varSql = @varSql + '	USER_AUTHORITY, MAX_CONN_DATE '
	Set @varSql = @varSql + 'From '
	Set @varSql = @varSql + '	MAIL_USER Left Outer Join '
	Set @varSql = @varSql + '	(Select '
	Set @varSql = @varSql + '		LOGIN_ID, USER_DOMAIN, MAX(CONN_DATE) AS MAX_CONN_DATE '
	Set @varSql = @varSql + '	From '
	Set @varSql = @varSql + '		LOGIN_INFO Group By LOGIN_ID, USER_DOMAIN) L '
	Set @varSql = @varSql + '	ON USER_ID = L.LOGIN_ID And MAIL_USER.USER_DOMAIN = L.USER_DOMAIN '
	Set @varSql = @varSql + 'Where '
	Set @varSql = @varSql + '	USER_NO Not In '
	Set @varSql = @varSql + '	(Select Top ' + Str(@iPageSize * (@iPage - 1)) + ' USER_NO From MAIL_USER Where ' + @varQry
	Set @varSql = @varSql + '	USER_DOMAIN Like ''%' + @varDomain + '%'' Order by USER_NAME Asc) And '
	Set @varSql = @varSql + @varQry 
	Set @varSql = @varSql + '	MAIL_USER.USER_DOMAIN = ''' + @varDomain + ''' Order by USER_NAME Asc'

End
Else
Begin
	If Lower(@varSchType) = 'userid'
	Begin
		Set @varSchType = 'USER_ID'

		If @chrUserAuth = ''
			Select @iTotCnt = Count(USER_ID) From MAIL_USER Where USER_DOMAIN = @varDomain And USER_ID Like '''%' + @varSchValue + '%'''
		Else
			Select @iTotCnt = Count(USER_ID) From MAIL_USER Where USER_AUTHORITY = @chrUserAuth And USER_DOMAIN = @varDomain And USER_ID Like '''%' + @varSchValue + '%'''
	End
	Else
	Begin
		Set @varSchType = 'USER_NAME'
		
		If @chrUserAuth = ''
			Select @iTotCnt = Count(USER_ID) From MAIL_USER Where USER_DOMAIN = @varDomain And USER_NAME Like '''%' + @varSchValue + '%'''
		Else
			Select @iTotCnt = Count(USER_ID) From MAIL_USER Where USER_AUTHORITY = @chrUserAuth And USER_DOMAIN = @varDomain And USER_NAME Like '''%' + @varSchValue + '%'''
	End
	
	Set @varSql = 'Select Top ' + Str(@iPageSize) + ' '
	Set @varSql = @varSql + '	USER_ID, USER_NAME, USER_MAILBOX_PATH, USER_MAILBOX_SIZE, '
	Set @varSql = @varSql + '	USER_AUTHORITY, MAX_CONN_DATE '
	Set @varSql = @varSql + 'From '
	Set @varSql = @varSql + '	MAIL_USER Left Outer Join '
	Set @varSql = @varSql + '	(Select '
	Set @varSql = @varSql + '		LOGIN_ID, USER_DOMAIN, MAX(CONN_DATE) AS MAX_CONN_DATE '
	Set @varSql = @varSql + '	From '
	Set @varSql = @varSql + '		LOGIN_INFO Group By LOGIN_ID, USER_DOMAIN) L '
	Set @varSql = @varSql + '	ON USER_ID = L.LOGIN_ID And MAIL_USER.USER_DOMAIN = L.USER_DOMAIN '
	Set @varSql = @varSql + 'Where '
	Set @varSql = @varSql + '	USER_NO Not In '
	Set @varSql = @varSql + '	(Select Top ' + Str(@iPageSize * (@iPage - 1)) + ' USER_NO From MAIL_USER Where '
	Set @varSql = @varSql + '	USER_DOMAIN Like ''%' + @varDomain + '%'' And ' + @varQry
	Set @varSql = @varSql + '	' + @varSchType + ' = ''' + @varSchValue + ''' Order by USER_NAME Asc) And '
	Set @varSql = @varSql + '	MAIL_USER.USER_DOMAIN = ''' + @varDomain + ''' And ' + @varQry
	Set @varSql = @varSql + '	' + @varSchType + ' Like ''%' + @varSchValue + '%'' Order by USER_NAME Asc'
End

Exec (@varSql)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListUserEmailAddr
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroup varchar(30),
		@chrCommon char(1)
	)
As

If @varGroup = ''
Begin
	Select 
		EMAIL_ADDR, EMAIL_NAME 
	From 
		MAIL_ADDRESS 
	Where 
		(USER_ID = @varUserId Or IS_COMMON = 'Y') And USER_DOMAIN = @varDomain
	Order by EMAIL_NAME 
End
Else
Begin
	If @chrCommon = 'Y' 
	Begin
		Select 
			EMAIL_ADDR, EMAIL_NAME 
		From 
			MAIL_ADDRESS 
		Where 
			IS_COMMON = @chrCommon And GROUP_NAME = @varGroup And USER_DOMAIN = @varDomain
		Order by EMAIL_NAME 
	End
	Else
	Begin
		Select 
			EMAIL_ADDR, EMAIL_NAME 
		From 
			MAIL_ADDRESS 
		Where 
			IS_COMMON = @chrCommon And GROUP_NAME = @varGroup And USER_ID = @varUserId And USER_DOMAIN = @varDomain
		Order by EMAIL_NAME 
	End
End


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListUserFiltering
	(
		@varUserId varchar(20),
		@varDomain varchar(255)
	)
As

Select
	FILTER_NO,	F_WORDS,	CODE_NAME AS F_TARGET,	F_MAILBOX,
	M_MAILBOX_NAME,	F_IS_USE
From
	FILTER Left Join
	(Select
		CODE_ID,	CODE_NAME
	From
		CODE
	Where
		CODE_CLASS = 'MF' And
		CODE_ID <> '===') CODE On
	F_TARGET = CODE_ID Left Join
	(Select
		M_MAILBOX,	M_MAILBOX_NAME
	From
		MAIL_BOX
	Where
		M_USER_ID = @varUserId And
		M_USER_DOMAIN = @varDomain) M On
	F_MAILBOX = M.M_MAILBOX
Where
	F_USER_ID = @varUserId And
	F_USER_DOMAIN = @varDomain 


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListUserGroup
	(
		@varUserId varchar(15),
		@varDomain varchar(255)
	)
As

Select
	IsNull(Count(EMAIL_ID), 0) As EMAIL_COUNT,	G.GROUP_NAME AS GROUP_NAME,	G.IS_COMMON AS IS_COMMON 
From
	MAIL_GROUP G Left Outer Join MAIL_ADDRESS A On 
	G.GROUP_NAME = A.GROUP_NAME And
	G.USER_ID = A.USER_ID And
	G.USER_DOMAIN = A.USER_DOMAIN
Where
	(G.USER_ID = @varUserId And
	G.USER_DOMAIN = @varDomain) Or (G.IS_COMMON = 'Y' And G.USER_DOMAIN = @varDomain)
Group By G.GROUP_NAME, G.IS_COMMON Order By G.GROUP_NAME

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prListUserId
	(
		@iPage int,
		@iPageSize int,
		@varDomain varchar(255),
		@iTotPage int OUTPUT
	)
As

Set Transaction Isolation Level Read UnCommitted
Set NoCount On

Select @iTotPage = Count(USER_ID) From MAIL_USER Where USER_DOMAIN = @varDomain

Declare @varSql nvarchar(3000)

Set @varSql = 'Select Top ' + Str(@iPageSize)
Set @varSql = @varSql + '	USER_ID, USER_NAME '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + '	MAIL_USER '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + '	IS_MAILING = 0 AND USER_NO Not In '
Set @varSql = @varSql + '	(Select Top ' + Str(@iPageSize * (@iPage - 1)) + ' USER_NO From MAIL_USER '
Set @varSql = @varSql + '	Where IS_MAILING = 0 AND USER_DOMAIN = ''' + @varDomain + ''' Order by USER_ID) AND '
Set @varSql = @varSql + '	USER_DOMAIN = ''' + @varDomain + ''' Order by USER_ID'

Exec(@varSql)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prListUserMailBox
	(
		@varUserId varchar(20),
		@varDomain varchar(255)
	)
As

Select
	M_MAILBOX, M_MAILBOX_NAME
From
	MAIL_BOX
Where
	M_USER_ID = @varUserId And
	M_USER_DOMAIN = @varDomain


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE prListZipCode
	(
		@varDong varchar(43)
	)
As
	Select ZIPCODE, SIDO + ' ' + GUGUN + ' ' + DONG AS ADDR1, SIDO + ' ' + GUGUN + ' ' + DONG + ' ' + ISNULL(BUNJI, '') AS ADDR2
	From ZIP_CODE Where DONG LIKE '%' + @varDong + '%' ORDER BY SEQ


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prLoadDomain
(
	@strDomain varchar(255),
	@strReturnValue varchar(600) OUTPUT
)
As

If Not Exists(Select WDC_Domain From Webmail_Domain_Config Where WDC_Domain = @strDomain)
Begin
	Set @strReturnValue = @strDomain + '    ϴ.'
	Return -1
End

Select
	WDC_AllocateSize,	WDC_User_Count,	WDC_Join_Type,	WDC_Default_Size,	WDC_POP3_Allow,	WDC_Copyright,
	IsNull(Mail.User_Count, 0) As User_Count,	IsNull(Mail.Use_Size, 0) As Use_Size
From
	Webmail_Domain_Config As WDC Left Outer Join 
	(Select User_Domain, Count(User_No) As User_Count, Sum(User_MailBox_Size) As Use_Size From Mail_User Group By User_Domain) AS Mail On
	WDC.WDC_Domain = Mail.User_Domain
Where
	WDC_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return -1

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prLoadDownFileInfo
(
	@strGuid varchar(128),
	@strReturnValue varchar(200) OUTPUT
)
As

Declare @strMemberId varchar(20),
	@strGroupName varchar(30)

If Not Exists(Select Idx_Guid From Wb_Filedown_Limit Where Idx_Guid = @strGuid)
Begin
	Set @strReturnValue = @strGuid + '  ϵ   ϴ.'
	Return -1
End

Select @strMemberId = Member_Id, @strGroupName = IsNull(Group_Name, '') From Wb_Filedown_Limit Where Idx_Guid = @strGuid

If @strGroupName <> ''
Begin

	Select 
		wgi.Grp_Path + '\' + File_Path As Full_File_Path,	File_Path,	[Filename],	Down_Count,	Down_Limit_Date,	Is_Download
	From
		Wb_Group_Info as wgi,
		Wb_Filedown_Limit as wfl
	Where
		Upper(wgi.Grp_Name) = wfl.Group_Name And wgi.Grp_Domain = wfl.WB_Domain And 
		wfl.Idx_Guid = @strGuid
End
Else
Begin
	Select 
		wmi.Wb_path + '\' + File_Path As Full_File_Path,	File_Path,	[Filename],	Down_Count,	Down_Limit_Date,	Is_Download
	From
		Wb_Member_Info as wmi,
		Wb_Filedown_Limit as wfl
	Where
		wmi.Member_Id = wfl.Member_Id And wmi.WB_Domain = wfl.WB_Domain And
		wfl.Idx_Guid = @strGuid
End

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prLoadMemberInfo
(
	@strMemberId varchar(30),
	@strDomain varchar(255),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From WB_Member_Info Where Member_Id = @strMemberId And WB_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ̵  ϴ.'
	Return -1
End

Select
	Member_Name,	Email_Addr,	Tel_No,	Cell_No,	Job,	Zip_Code,
	Address1,	Address2,	Birthday,	Allocate_Size,	Permission,
	Wb_Path
From
	WB_Member_Info
Where
	Member_Id = @strMemberId And
	WB_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prLoadSendEmailAddr
(
	@strUserId varchar(15),
	@strDomain varchar(256),
	@strEmailAddr varchar(512)
)
As

Select Email_Addr From MailAddrList Where Email_Addr Like '%' + @strEmailAddr + '%' And User_Id = @strUserId And User_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prLoadUploadFilter
(
	@strDomain varchar(255),
	@strMemberId varchar(30)
)
As

Select Upload_Limit_Ext,	Upload_Limit_Ip From Wb_Upload_Filter Where Owner_id = @strMemberId And Wb_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prLoadWebhardGroupInfo
(
	@strDomain varchar(255),
	@strGroupName varchar(30),
	@strReturnValue varchar(200) OUTPUT
)
As

If @strGroupName = ''
Begin
	Set @strReturnValue = '׷ ϴ.'
	Return -1
End

If Not Exists(Select Idx_Grp_No From Wb_Group_Info Where Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Set @strReturnValue = @strGroupName + ' ()  ׷  ϴ.'
	Return - 2
End

Select Top 1 
	Idx_Grp_No,	Grp_Owner_Id,	Grp_Allocate_Size,	Grp_Create_Date,	Grp_Use_Accept,	Grp_Path
From
	Wb_Group_Info
Where
	Grp_Name = @strGroupName And Grp_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prLoadWebhardGroupMemberInfo
(
	@strDomain varchar(255),
	@strGroupName varchar(30),
	@strMemberId varchar(30),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From Wb_Group_Member Where Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ̵ ' + @strGroupName + ' ׷쿡 ϵǾ  ʽϴ.'
	Return -1
End

Select Top 1
	Idx_No,	Is_Down_Limit,	Is_Upload_Limit,	Is_Delete_Limit,	Join_Date
From
	Wb_Group_Member
Where
	Grp_Member_Id = @strMemberId And Grp_Name = @strGroupName And Grp_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prLogin
(
	@strMemberId varchar(30),
	@strDomain varchar(255),
	@strMemberPwd varchar(15),
	@strMemberName varchar(20) OUTPUT,
	@strPath varchar(512) OUTPUT,
	@strReturnValue varchar(200) OUTPUT
)
As

Declare @strPwd varchar(15)

If Not Exists(Select Idx_No From WB_Member_Info Where Member_Id = @strMemberId And Wb_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ̵ ϵ  ̵ Դϴ.'
	Return -1
End
Else
Begin
	Select @strPwd = Member_Pwd, @strMemberName = Member_Name, @strPath = WB_Path From WB_Member_Info Where Member_Id = @strMemberId And Wb_Domain = @strDomain
	
	If @strMemberPwd <> @strPwd
	Begin
		Set @strReturnValue = 'йȣ Ʋϴ.\r\nйȣ ٽ Է ּ.'
		Return -2
	End
End

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prLoginUser
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varUserPwd varchar(30),
		@varSessionID varchar(50),
		@varRemoteIP varchar(15),
		@varRtnVal varchar(200) OUTPUT
	)
As

Declare @varOrgPwd varchar(30),
	@chrUserAuth char(1),
	@bIsMailing bit

If Not Exists (Select USER_ID From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'ϵ   Դϴ.\r\n\r\n ̵: ' + @varUserId
	Return - 1
End

Select @varOrgPwd = USER_PWD, @chrUserAuth = USER_AUTHORITY, @bIsMailing = IS_MAILING From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

If @varUserPwd <> @varOrgPwd
Begin
	Set @varRtnVal = 'йȣ Ʋϴ.'
	Return -2
End

If @chrUserAuth = '0'
Begin
	Set @varRtnVal = ' 㰡  ʾҽϴ.\r\n\r\nڰ ¶   ٷ ֽʽÿ.'
	Return -3
End

If @bIsMailing = 1
Begin
	Set @varRtnVal = 'ϸ Ʈ ڴ α   ϴ.\r\n\r\n ̵: ' + @varUserId
	Return -4
End

Insert Into LOGIN_INFO
	(CONN_ID,	LOGIN_ID,	USER_DOMAIN,	REMOTE_IP,	CONN_DATE)
Values
	(@varSessionID,	@varUserId,	@varDomain,	@varRemoteIP,	GetDate())

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prMailBoxCount
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@varMailbox varchar(30),
		@intMailboxCount int OUTPUT
	)
As

If @varMailbox = ''
Begin
Select
	@intMailboxCount = Count(MAILBOX_NO)
From
	MAIL_BOX
Where
	M_USER_ID = @varUserId And
	M_USER_DOMAIN = @varDomain
End
Else
Begin
Select
	@intMailboxCount = Count(MAILBOX_NO)
From
	MAIL_BOX
Where
	M_MAILBOX = @varMailbox And
	M_USER_ID = @varUserId And
	M_USER_DOMAIN = @varDomain
End

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prMemberList
(
	@strDomain varchar(255),
	@iPage int,
	@iPageSize int,
	@strSchType varchar(20),
	@strSchValue varchar(30),
	@strSortField varchar(20),
	@strSortFormat char(1),
	@iTotalCount int OUTPUT
)
As

Declare @strSql varchar(2000),
	@strQry varchar(100),
	@strSort varchar(50)

-- ȸ ̵ ˻ 
If @strSchType = 'Mb_Id'
Begin
	Select @iTotalCount = Count(Idx_No) From Wb_Member_Info Where Member_Id Like '%' + @strSchValue + '%' And WB_Domain = @strDomain
	Set @strQry = ' Member_Id Like ''%' + @strSchValue + '%'' And '
End
Else
Begin
	-- ȸ ̸ ˻ 
	If @strSchType = 'Mb_Name'
	Begin
		Select @iTotalCount = Count(Idx_No) From Wb_Member_Info Where Member_Name Like '%' + @strSchValue + '%' And WB_Domain = @strDomain
		Set @strQry = ' Member_Name Like ''%' + @strSchValue + '%'' And '
	End
	Else
	Begin
		Select @iTotalCount = Count(Idx_No) From Wb_Member_Info Where WB_Domain = @strDomain
		Set @strQry = ''
	End
End

If @strSortField = 'Mb_Id'
Begin
	Set @strSort = ' Member_Id '
End
Else
Begin
	If @strSortField = 'Mb_Name'
	Begin
		Set @strSort = ' Member_Name '
	End
	Else
	Begin
		Set @strSort = ' Member_Name '	
	End
End

If @strSortFormat = 'D'
Begin
	Set @strSortFormat = @strSort + ' Desc '
End
Else
Begin
	If @strSortFormat = 'A'
	Begin
		Set @strSort = @strSort + ' Asc '
	End
	Else
	Begin
		Set @strSort = @strSort + ' Asc '
	End
End

Set @strSql = 'Select Top ' + Str(@iPageSize)
Set @strSql = @strSql + '	Idx_No, Member_Id, Member_Name, JB.Code_Name, PM.Code_Name As Member_Permission, Allocate_Size, Wb_Path '
Set @strSql = @strSql + 'From '
Set @strSql = @strSql + '	Wb_Member_Info Left Outer Join '
Set @strSql = @strSql + '	(Select Code_Id, Code_Name From Wb_Code Where RTrim(Grp_Code_Id) = ''PM'') As PM On '
Set @strSql = @strSql + '	Permission = PM.Code_Id Left Outer Join '
Set @strSql = @strSql + '	(Select Code_Id, Code_Name From Wb_Code Where RTrim(Grp_Code_Id) = ''JB'') As JB On '
Set @strSql = @strSql + '	Job = JB.Code_Id '
Set @strSql = @strSql + 'Where '
Set @strSql = @strSql + '	' + @strQry + '  WB_Domain = ''' + @strDomain + ''' And '
Set @strSql = @strSql + '	Idx_No Not In (Select Top ' + Str((@iPage - 1) * @iPageSize) + ' Idx_no From Wb_Member_Info Where ' + @strQry + ' WB_Domain = ''' + @strDomain + '''  Order by '  + @strSort + ') '
Set @strSql = @strSql + '	Order By ' + @strSort

Exec (@strSql)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prModifyBoard
	(
		@iBrdNo int, 
		@varBrdName varchar(20),
		@varDomain varchar(255),
		@iDocCnt int,
		@iBrdListCnt int,
		@chrBrdIsAttach char(1),
		@varHeader varchar(3800),
		@varFooter varchar(3800),
		@chrAuthList char(1),
		@chrAuthRead char(1),
		@chrAuthWrite char(1),
		@chrAuthModify char(1),
		@chrAuthDelete char(1),
		@chrAuthReply char(1),
		@varAdminId varchar(15),
		@chrModifyIp char(15)
	)
As

If Not Exists(Select brd_no From BRD_INFO Where brd_no = @iBrdNo And brd_domain = @varDomain)
	Return -200


Update BRD_INFO Set
	BRD_DOMAIN = @varDomain,	BRD_NAME = @varBrdName,		BRD_DOC_CNT = @iDocCnt,
	BRD_LIST_CNT = @iBrdListCnt,	BRD_IS_ATTACH = @chrBrdIsAttach,	BRD_HEADER = @varHeader,
	BRD_FOOTER = @varFooter,	BRD_AUTH_LIST = @chrAuthList,		BRD_AUTH_READ = @chrAuthRead,
	BRD_AUTH_WRITE = @chrAuthWrite,BRD_AUTH_MODIFY = @chrAuthModify,	BRD_AUTH_DELETE = @chrAuthDelete,
	BRD_AUTH_REPLY = @chrAuthReply,	BRD_ADMIN_ID = @varAdminId,		BRD_MODIFY_DATE = GetDate(),
	BRD_MODIFY_IP = @chrModifyIp
Where
	BRD_NO = @iBrdNo And BRD_DOMAIN = @varDomain

If @@ERROR <> 0
	Return -1

Return 0	


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prModifyDoc
	(
		@iBrdNo int,
		@iDocNo int,
		@varDomain varchar(255),
		@varSubject varchar(50),
		@txtContent text,
		@varAttachFile varchar(255),
		@iAttachSize numeric(10, 0),
		@varRtnVal varchar(100) OUTPUT
	)
As

If Not Exists(Select DOC_NO From DOC_INFO Where DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ Խù  ʽϴ.\r\n\r\nԽù ȣ: ' +Str(@iDocNo)
	Return -1
End

Update DOC_INFO Set
	DOC_SUBJECT = @varSubject,
	DOC_CONTENT = @txtContent,
	DOC_ATTACH_FILE = @varAttachFile,
	DOC_ATTACH_SIZE = @iAttachSize
Where
	DOC_NO = @iDocNo And
	BRD_NO = @iBrdNo And
	DOC_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prModifyDocReadCnt
	(
		@iBrdNo int,
		@iDocNo int,
		@varDomain varchar(255),
		@varRtnVal varchar(100) OUTPUT
	)
As

If Not Exists(Select DOC_NO From DOC_INFO Where DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'ȸ Ϸ Խù ϴ.\r\n\r\nԽù ȣ: ' + Str(@iDocNo)
	Return -1
End

Update
	DOC_INFO
Set
	DOC_READ_CNT = ISNULL(DOC_READ_CNT, 0) + 1
Where
	DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prModifyDomain
(
	@strDomain varchar(255),
	@iAllocateSize int,
	@iUserCount int,
	@strJoinType char(1),
	@iDefaultSize int,
	@strPop3Allow char(1),
	@strCopyright varchar(6000),
	@strReturnValue varchar(600) OUTPUT
)
As

Declare @useSize int,
	@userCnt int

--  翩 Ȯ
If Not Exists(Select WDC_Domain From Webmail_Domain_Config Where WDC_Domain = @strDomain)
Begin
	Set @strReturnValue = @strDomain + ' ε   ʽϴ.'
	Return -1
End

-- ϵ ڼ 
Select @userCnt = Count(User_No) From Mail_User Where User_Domain = @strDomain

If @iUserCount < @userCnt
Begin
	Set @strReturnValue = 'ϰ ִ ڼ  Ϸ Ҵ  ۽ϴ.\r\n'
	Set @strReturnValue = @strReturnValue + 'ϰ ִ  : ' + Str(@userCnt) + '\r\n'
	Set @strReturnValue = @strReturnValue + 'Ϸ  Ҵ: ' + Str(@iUserCount)
	Return -2	
End

-- ϰ ִ 뷮 
Select @useSize = Sum(User_MailBox_Size) From Mail_User Where User_Domain = @strDomain

-- Ϸ 뷮 ϰ ִ 뷮 ϱ
If @iAllocateSize < @useSize
Begin
	Set @strReturnValue = 'Ϸ 뷮 ϰ ִ 뷮 ۽ϴ.\r\n'
	Set @strReturnValue = @strReturnValue + 'ϰ ִ 뷮: ' + Str(@useSize) + '\r\n'
	Set @strReturnValue = @strReturnValue + 'Ϸ 뷮: ' + Str(@iAllocateSize)
	Return -2
End

Update Webmail_Domain_Config Set
	WDC_AllocateSize = @iAllocateSize,
	WDC_User_Count = @iUserCount,
	WDC_Join_Type = @strJoinType,
	WDC_Default_Size = @iDefaultSize,
	WDC_POP3_Allow = @strPop3Allow,
	WDC_Copyright = @strCopyright
Where
	WDC_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyDownLimitDay
(
	@strGuid varchar(128),
	@strDomain varchar(255),
	@iDownCount int,
	@strLimitDate datetime,
	@isDown char(1),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_Guid From Wb_Filedown_Limit Where Idx_Guid = @strGuid And Wb_Domain = @strDomain)
Begin
	Set @strReturnValue = @strGuid + '   ٿε  ϴ.'
	Return -1
End

-- Ϸ ȿⰣ ̸ ȿⰣ  ʴ´.
If DateDiff(d, getdate(), @strLimitDate) <= 0
	Select @strLimitDate = Down_Limit_Date From Wb_Filedown_Limit Where Idx_Guid = @strGuid And Wb_Domain = @strDomain

-- Ϸ ٿε Ƚ 0 ũ ٿε Ƚ  ʴ´.
If @iDownCount > 0
	Select @iDownCount = Down_Count From Wb_Filedown_Limit Where Idx_Guid = @strGuid And Wb_Domain = @strDomain

If @isDown = ''
	Select @isDown = Is_Download From Wb_Filedown_Limit Where Idx_Guid = @strGuid And Wb_Domain = @strDomain

Update Wb_Filedown_Limit Set
	Down_Count = @iDownCount,
	Down_Limit_Date = @strLimitDate
From
	Wb_Filedown_Limit
Where
	Idx_Guid = @strGuid And Wb_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyEmailAddr
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@intEmailId int,
		@varGroupName varchar(30),
		@varGroup varchar(30),
		@varEmailAddr varchar(255),
		@varEmailName varchar(50),
		@varAddress1 varchar(100),
		@varAddress2 varchar(60),
		@chrZipCode char(6),
		@chrTel char(13),
		@chrCellPhone char(13),
		@varCompanyName varchar(30),
		@varPosition varchar(30),
		@chrOfficeTel char(13),
		@chrOfficeFax char(13),
		@txtEtcMemo Text,
		@chrCommon char(1),
		@chrCngCommon char(1),
		@varRtnVal varchar(200) OUTPUT
	)
As
Declare @vUserId varchar(15),
	@chrUserPermit char(1)

-- Ϸ ּҷ  ּҷ 
If @chrCommon = 'Y'
Begin
	-- Ϸ  ּҷ ϴ ȮѴ.
	Select 
		@vUserId = USER_ID 
	From 
		MAIL_ADDRESS 
	Where
		EMAIL_ID = @intEmailId And IS_COMMON = @chrCommon And
		GROUP_NAME = @varGroupName And USER_DOMAIN = @varDomain
	
	If @vUserId Is Null
	Begin
		Set @varRtnVal = 'Ϸ  ּҷ  ϴ.\r\n\r\nּҷ ȣ: ' + Str(@intEmailId)
		Return - 1
	End
	
	-- Ϸ   ´.
	Select @chrUserPermit = USER_PERMIT From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain
	
	If @chrUserPermit <> '1'
	Begin
		-- Ϸ ڰ  ڿ  ȮѴ.
		If @varUserId <> @vUserId
		Begin
			Set @varRtnVal = ' ּҷ   Ǵ ڸ   ֽϴ.\r\n\r\nּҷ ȣ: ' + Str(@intEmailId)
			Return -2
		End
	End
	
	--  ּҷ  Ѵ.
	Update MAIL_ADDRESS Set
		GROUP_NAME = @varGroup,	EMAIL_ADDR = @varEmailAddr,	EMAIL_NAME = @varEmailName,
		ADDRESS1 = @varAddress1,	ADDRESS2 = @varAddress2,	ZIP_CODE = @chrZipCode,
		TEL = @chrTel,			CELL_PHONE = @chrCellPhone,	COMPANY_NAME = @varCompanyName,	
		POSITION = @varPosition,		OFFICE_TEL = @chrOfficeTel,	OFFICE_FAX = @chrOfficeFax,	
		ETC_MEMO = @txtEtcMemo,	IS_COMMON = @chrCngCommon
	Where
		EMAIL_ID = @intEmailId And
		IS_COMMON = @chrCommon And
		GROUP_NAME = @varGroupName And
		USER_DOMAIN = @varDomain

End
Else
Begin
	If Not Exists(Select EMAIL_ID From MAIL_ADDRESS Where EMAIL_ID = @intEmailId And IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Begin
		Set @varRtnVal = 'Ϸ ּҷ  ϴ.\r\n\r\nּҷ ȣ: ' + Str(@intEmailId)
		Return -3
	End	

	Update MAIL_ADDRESS Set
		GROUP_NAME = @varGroup,	EMAIL_ADDR = @varEmailAddr,	EMAIL_NAME = @varEmailName,
		ADDRESS1 = @varAddress1,	ADDRESS2 = @varAddress2,	ZIP_CODE = @chrZipCode,
		TEL = @chrTel,			CELL_PHONE = @chrCellPhone,	COMPANY_NAME = @varCompanyName,	
		POSITION = @varPosition,		OFFICE_TEL = @chrOfficeTel,	OFFICE_FAX = @chrOfficeFax,	
		ETC_MEMO = @txtEtcMemo,	IS_COMMON = @chrCngCommon
	Where
		EMAIL_ID = @intEmailId And
		IS_COMMON = @chrCommon And
		GROUP_NAME = @varGroupName And
		USER_ID = @varUserId And
		USER_DOMAIN = @varDomain

End
If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prModifyFilter
	(
		@iFilterNo int,
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varWords varchar(20),
		@chrTarget char(2),
		@varMailBox  varchar(30),
		@chrIsUse char(1),
		@varRtnVal varchar(100) OUTPUT
	)
As

If Not Exists(Select FILTER_NO From FILTER Where FILTER_NO = @iFilterNo And F_USER_ID = @varUserId And F_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ  ڵз Ģ ϴ.\r\n\r\nڵз ȣ: ' + Str(@iFilterNo)
	Return -1
End

Update
	FILTER
Set
	F_WORDS = @varWords,
	F_TARGET = @chrTarget,
	F_MAILBOX = @varMailbox,
	F_IS_USE = @chrIsUse
Where
	FILTER_NO = @iFilterNo And 
	F_USER_ID = @varUserId And 
	F_USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyGroupInfo
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroupName varchar(30),
		@varGroup varchar(30),
		@varGroupDesc varchar(100),
		@chrCommon char(1),
		@intAddrCnt int,
		@varCngValue varchar(100)
	)
As

Declare @varSql varchar(1000)

If @chrCommon = 'Y'
Begin
	If Exists(Select GROUP_NAME From MAIL_GROUP Where IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_DOMAIN = @varDomain)
	Begin
		Update MAIL_GROUP Set
			GROUP_NAME = @varGroup,	GROUP_DESC = @varGroupDesc
		Where
			IS_COMMON = @chrCommon And
			GROUP_NAME = @varGroupName And
			USER_DOMAIN = @varDomain
		
		Update MAIL_ADDRESS Set
			GROUP_NAME = ''
		Where
			IS_COMMON = @chrCommon And
			GROUP_NAME = @varGroupName And
			USER_DOMAIN = @varDomain
		
		If @varCngValue <> '' And @varCngValue Is Not Null
		Begin
			Set @varSql = 'Update MAIL_ADDRESS Set '
			Set @varSql = @varSql + '	GROUP_NAME = ''' + @varGroup + ''' '
			Set @varSql = @varSql + 'Where '
			Set @varSql = @varSql + '	EMAIL_ID IN (' + @varCngValue + ') And '
			Set @varSql = @varSql + '	IS_COMMON = ''' + @chrCommon + ''' And '
			Set @varSql = @varSql + '	USER_DOMAIN = ''' + @varDomain + ''''
			
			Exec (@varSql)
		End
	End
End
Else
Begin
	If Exists(Select GROUP_NAME From MAIL_GROUP Where IS_COMMON = @chrCommon And GROUP_NAME = @varGroupName And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
	Begin
		Update MAIL_GROUP Set
			GROUP_NAME = @varGroup,	GROUP_DESC = @varGroupDesc
		Where
			IS_COMMON = @chrCommon And
			GROUP_NAME = @varGroupName And
			USER_ID = @varUserId And
			USER_DOMAIN = @varDomain
	End
	
	If @intAddrCnt > 0
	Begin
		Update MAIL_ADDRESS Set
			GROUP_NAME = ''
		Where
			IS_COMMON = @chrCommon And
			GROUP_NAME = @varGroupName And
			USER_ID = @varUserId And
			USER_DOMAIN = @varDomain
		
		If @varCngValue <> '' And @varCngValue Is Not Null
		Begin
			Set @varSql = 'Update MAIL_ADDRESS Set '
			Set @varSql = @varSql + '	GROUP_NAME = ''' + @varGroup + ''' '
			Set @varSql = @varSql + 'Where '
			Set @varSql = @varSql + '	EMAIL_ID IN (' + @varCngValue + ') And '
			Set @varSql = @varSql + '	IS_COMMON = ''' + @chrCommon + ''' And '
			Set @varSql = @varSql + '	USER_ID = ''' + @varUserId + ''' And '
			Set @varSql = @varSql + '	USER_DOMAIN = ''' + @varDomain + ''''
			
			Exec (@varSql)
		End
	End
	Else
	Begin
		Update MAIL_ADDRESS Set
			GROUP_NAME = ''
		Where
			IS_COMMON = @chrCommon And
			GROUP_NAME = @varGroupName And
			USER_ID = @varUserId And
			USER_DOMAIN = @varDomain
	End
End

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyLoginInfo
(
	@strDomain varchar(255),
	@strMemberId varchar(20),
	@idxNo int,
	@strLoginState char(1),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From Wb_Login_Info Where Idx_No = @idxNo And Member_Id = @strMemberId And Log_Domain = @strDomain)
Begin
	Set @strReturnValue = Str(@idxNo) + '   α  ϴ.'
	Return -1
End

Update Wb_Login_Info Set
	Logout_Date = GetDate(),
	Log_State = @strLoginState
Where
	Idx_No = @idxNo And
	Member_Id = @strMemberId And Log_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyMailConfirm
	(
		@varCode varchar(50)
	)
As

If Exists (Select SEND_MAIL_ID From MAIL_CONFIRM Where READ_DATE Is Null And SEND_MAIL_ID = @varCode)
	Update MAIL_CONFIRM Set READ_DATE = GetDate(), IS_READ = 1 Where SEND_MAIL_ID = @varCode

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyMailbox
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varMailbox varchar(30),
		@varMailboxName varchar(100),
		@varRtnVal varchar(200) OUTPUT
	)
As

If Not Exists(Select MAILBOX_NO From MAIL_BOX Where M_MAILBOX = @varMailbox And M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ    ʽϴ.\r\n\r\n : ' + @varMailbox
	Return -1
End
Else If Exists(Select MAILBOX_NO From MAIL_BOX Where M_MAILBOX_NAME = @varMailboxName And M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = '  ̸ մϴ.\r\n\r\n ̸: ' + @varMailboxName
	Return -2
End

Update 
	MAIL_BOX 
Set
	M_MAILBOX_NAME = @varMailboxName
Where
	M_MAILBOX = @varMailbox And
	M_USER_ID = @varUserId And
	M_USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyMemberInfo
(
	@strMemberId varchar(30),
	@strDomain varchar(255),
	@strMemberName varchar(20),
	@strMemberPwd varchar(15),
	@strEmail varchar(255),
	@strTelNo char(13),
	@strCellNo char(13),
	@strJob char(3),
	@strZipCode char(6),
	@strAddress1 varchar(100),
	@strAddress2 varchar(60),
	@iAllocateSize int,
	@strPermission char(3),
	@strBirthday char(8),
	@strPath varchar(512),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From Wb_Member_Info Where Member_Id = @strMemberId And WB_Domain = @strDomain)
Begin
	Set @strReturnValue = @strMemberId + ' ȸ  ã ϴ.'
	Return -1
End

--   
Update Wb_Member_Info Set
	Member_Name = @strMemberName,	Email_addr = @strEmail,
	Tel_No = @strTelNo,			Cell_No = @strCellNo,
	Job = @strJob,				Zip_Code = @strZipCode,
	Address1 = @strAddress1,			Address2 = @strAddress2,
	Birthday = @strBirthday
Where
	Member_Id = @strMemberId And
	WB_Domain = @strDomain

-- йȣ 
If @strMemberPwd <> ''
Begin
	Update Wb_Member_Info Set
		Member_Pwd = @strMemberPwd
	Where
		Member_Id = @strMemberId And
		WB_Domain = @strDomain
End

--  뷮 
If @iAllocateSize > 0
Begin
	Update Wb_Member_Info Set
		Allocate_Size = @iAllocateSize
	Where
		Member_Id = @strMemberId And
		WB_Domain = @strDomain
End

--  
If @strPermission <> ''
Begin
	Update Wb_Member_Info Set
		Permission = @strPermission
	Where
		Member_Id = @strMemberId And
		WB_Domain = @strDomain
End

--   
If @strPath <> ''
Begin
	Update Wb_Member_Info Set
		Wb_Path = @strPath
	Where
		Member_Id = @strMemberId And
		WB_Domain = @strDomain
End

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyMemberPwd
(
	@strMemberId varchar(30),
	@strDomain varchar(255),
	@strMemberPwd varchar(20),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_No From WB_Member_Info Where Member_Id = @strMemberId And WB_Domain = @strDomain)
Begin
	Set @strReturnValue = 'йȣ Ϸ ' + @strMemberId + ' ȸ  ϴ.'
	Return -1
End

Update
	Wb_Member_Info
Set
	Member_Pwd = @strMemberPwd
Where
	Member_Id = @strMemberId And
	WB_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyPop3
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@iPop3No int,
		@varPop3Server varchar(255),
		@varPop3UserId varchar(255),
		@varPop3UserPwd varchar(30),
		@chrPop3IsDel char(1),
		@varPop3Savebox varchar(30),
		@varRtnVal varchar(200) OUTPUT		
	)
As
Declare @iMaxNo int

If Not Exists(Select POP3_NO From MAIL_POP3 Where POP3_NO = @iPop3No And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϸ POP3  ϴ.\r\n\r\nPOP3 ȣ: ' + Str(@iPop3No)
	Return - 1
End

If @varPop3UserPwd <> '' 
	Update MAIL_POP3 Set POP3_USER_PWD = @varPop3UserPwd Where POP3_NO = @iPop3No And USER_ID = @varUserId And USER_DOMAIN = @varDomain

Update MAIL_POP3 Set 
	POP3_SERVER = @varPop3Server,	POP3_USER_ID = @varPop3UserId,	POP3_USER_PWD = @varPop3UserPwd,
	POP3_IS_DEL = @chrPop3IsDel,	POP3_SAVEBOX = @varPop3Savebox
Where
	POP3_NO = @iPop3No And USER_ID = @varUserId And USER_DOMAIN = @varDomain

If Not Exists (Select MAILBOX_NO From MAIL_BOX Where (M_MAILBOX = @varPop3Savebox or M_MAILBOX_NAME = @varPop3Savebox) And M_USER_ID = @varUserId And M_USER_DOMAIN = @varDomain)
Begin
	Select @iMaxNo = IsNull(Max(MAILBOX_NO), 0) From MAIL_BOX
	
	If @iMaxNo Is Null
		Set @iMaxNo = 1
	Else
		Set @iMaxNo = @iMaxNo + 1

	Insert Into MAIL_BOX
		(MAILBOX_NO,	M_USER_ID,	M_USER_DOMAIN,	M_MAILBOX,	M_MAILBOX_NAME)
	Values
		(@iMaxNo,	@varUserId,	@varDomain,	@varPop3Savebox,	@varPop3Savebox)
End


If @@ERROR <> 0 
	Return @@ERROR

return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE  Procedure prModifySchedule
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@chrSolYear char(4),
		@chrSolMonth char(2),
		@chrSolDay char(2),
		@chrLunYear char(4),
		@chrLunMonth char(2),
		@chrLunDay char(2),
		@chrSchStHour char(2),
		@chrSchStMinute char(2),
		@chrSchEdHour char(2),
		@chrSchEdMinute char(2),
		@varSchTitle varchar(100),
		@txtSchContent text,
		@chrSchType char(2),
		@chrSchHoliday char(1),
		@chrSchPublic char(1),
		@chrSchRepeat char(1),
		@chrSchImport char(2),
		@chrSchIsLunar char(1),
		@intSchNo int
	)
As

If @intSchNo = 0
Begin

	Declare @iMaxNo int
	
	Select @iMaxNo = Max(IsNull(SCH_NO, 0)) From SCHEDULE
	
	If @iMaxNo Is Null
		Set @iMaxNo = 1
	Else
		Set @iMaxNo = @iMaxNo + 1
	
	Insert Into SCHEDULE 
		(SCH_NO, 	USER_ID, 	USER_DOMAIN, 	SOL_YEAR, 	SOL_MONTH, 
		SOL_DAY,	LUN_YEAR, 	LUN_MONTH, 	LUN_DAY, 	SCH_ST_HOUR,
		SCH_ST_MINUTE,	SCH_ED_HOUR, 	SCH_ED_MINUTE,	SCH_TITLE,	SCH_CONTENT, 
		SCH_TYPE, 	SCH_HOLIDAY, 	SCH_PUBLIC, 	SCH_REPEAT, 	SCH_IMPORT, 
		SCH_IS_LUNAR)
		VALUES
		(@iMaxNo,	@varUserId,	@varDomain,	@chrSolYear,	@chrSolMonth,
		@chrSolDay,	@chrLunYear,	@chrLunMonth,	@chrLunDay,	@chrSchStHour,
		@chrSchStMinute,@chrSchEdHour,	@chrSchEdMinute,@varSchTitle, 	@txtSchContent, 
		@chrSchType,	@chrSchHoliday,	@chrSchPublic,	@chrSchRepeat,	@chrSchImport,
		@chrSchIsLunar)
End
Else
Begin
	UPDATE 
		SCHEDULE
	SET 
		SOL_YEAR = @chrSolYear,		SOL_MONTH = @chrSolMonth,	SOL_DAY = @chrSolDay,
		LUN_YEAR = @chrLunYear,	LUN_MONTH = @chrLunMonth,	LUN_DAY = @chrLunDay,
		SCH_ST_HOUR = @chrSchStHour,	SCH_ST_MINUTE = @chrSchStMinute,
		SCH_ED_HOUR = @chrSchEdHour,	SCH_ED_MINUTE = @chrSchEdMinute,
		SCH_TITLE = @varSchTitle,		SCH_CONTENT = @txtSchContent,
		SCH_TYPE = @chrSchType,	SCH_HOLIDAY = @chrSchHoliday,	SCH_PUBLIC = @chrSchPublic,
		SCH_REPEAT = @chrSchRepeat,	SCH_IMPORT = @chrSchImport,	SCH_IS_LUNAR = @chrSchIsLunar
	WHERE
		SCH_NO = @intSchNo And USER_ID = @varUserId And USER_DOMAIN = @varDomain
End

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifySign
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varSign1 varchar(2000),
		@varSign2 varchar(2000),
		@varSign3 varchar(2000),
		@varRtnVal varchar(200) OUTPUT
	)
As

If Not Exists(Select S_SIGN1 From SIGN_INFO Where S_USER_ID = @varUserId And S_USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = ' ̺ ϵ  ϴ.'
	Return -1
End

Update SIGN_INFO Set
	 S_SIGN1 = @varSign1,	S_SIGN2 = @varSign2,	S_SIGN3 = @varSign3
Where
	S_USER_ID = @varUserId AND S_USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prModifyUploadFilter
(
	@strDomain varchar(255),
	@strMemberId varchar(30),
	@strFileExtensions text,
	@strIpList text
)
As

Declare @iMaxNo int

If Not Exists(Select Idx_No From Wb_Upload_Filter Where Owner_Id = @strMemberId And Wb_Domain = @strDomain)
Begin
	Select @iMaxNo = IsNull(Max(Idx_No),0) + 1 From Wb_Upload_Filter
	
	Insert Into Wb_Upload_Filter
		(Idx_no,	Owner_id, Wb_Domain)
	Values
		(@iMaxNo,	@strMemberId,	@strDomain)
End

Update Wb_Upload_Filter Set
	Upload_Limit_Ext = @strFileExtensions,
	Upload_Limit_Ip = @strIpList
Where
	Owner_id = @strMemberId And Wb_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE  Procedure prModifyUserInfo
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varUserName varchar(30),
		@varUserPwd varchar(20),
		@chrUserSex char(1),
		@chrBirthday char(10),
		@chrLastEdu char(2),
		@chrJob char(2),
		@chrMarry char(1),
		@varPosition varchar(30),
		@chrTel char(13),
		@chrMobile char(13),
		@chrZipCode char(6),
		@varAddress1 varchar(100),
		@varAddress2 varchar(50)
	)
As

If @varUserName <> ''
	Update MAIL_USER Set USER_NAME = @varUserName Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

If @varUserPwd <> ''
	Update MAIL_USER Set USER_PWD = @varUserPwd where USER_ID = @varUserId And USER_DOMAIN = @varDomain

If Not Exists(Select USER_ID From USER_INFO Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	-- ο ȸ  Ѵ.
	Insert Into USER_INFO (USER_ID,	USER_DOMAIN,	USER_SEX,	USER_BIRTHDAY,	USER_LAST_EDU,
			USER_JOB,	USER_MARRY,	USER_POSITION,	USER_TEL,	USER_MOBILE,
			USER_ZIPCODE,	USER_ADDRESS1,	USER_ADDRESS2)
	Values
		(@varUserId,	@varDomain,	@chrUserSex,	@chrBirthday,	@chrLastEdu,	@chrJob,
		@chrMarry,	@varPosition,	@chrTel,	@chrMobile,	@chrZipCode,	@varAddress1,
		@varAddress2)
End
Else
Begin
	Update USER_INFO Set 
		USER_SEX = @chrUserSex,	USER_BIRTHDAY = @chrBirthday,	USER_LAST_EDU = @chrLastEdu,
		USER_JOB = @chrJob,	USER_MARRY = @chrMarry,	USER_POSITION = @varPosition,
		USER_TEL = @chrTel,	USER_MOBILE = @chrMobile,	USER_ZIPCODE = @chrZipCode,
		USER_ADDRESS1 = @varAddress1,	USER_ADDRESS2 = @varAddress2
	Where
		USER_ID = @varUserId And USER_DOMAIN = @varDomain
End

If @@ERROR <> 0 
	Return @@ERROR

return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prModifyUserMailBoxSize
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@iMailBoxSize int,
		@varRtnVal varchar(200) OUTPUT
	)
As

If Not Exists(Select USER_MAILBOX_SIZE From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = 'Ϲڽ 뷮 Ϸ ڰ  ʽϴ.\r\n\r\n'
	Set @varRtnVal = @varRtnVal + ' ̵: ' + @varUserId
	
	Return -1
End
Else
Begin
	Update 
		MAIL_USER 
	Set 
		USER_MAILBOX_SIZE = @iMailBoxSize 
	Where
		USER_ID = @varUserId And
		USER_DOMAIN = @varDomain
End

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prModifyWebhardGroup
(
	@strDomain varchar(255),
	@strGroupName varchar(30),
	@strOwnerId varchar(30),
	@iAllocateSize int,
	@strUseAccept char(1),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_Grp_No From Wb_Group_Info Where Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Set @strReturnValue = @strGroupName + ' ׷ ϵ  ׷Դϴ.'
	Return -1
End

Update Wb_Group_Info Set
	Grp_Owner_Id = @strOwnerId,	Grp_Allocate_Size = @iAllocateSize,	Grp_Use_Accept = @strUseAccept
Where
	Grp_Name = @strGroupName And Grp_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure prNoGroupMemberList
(
	@strDomain varchar(255),
	@iPage int,
	@iPageSize int,
	@strGroupName varchar(30),
	@iTotalCount int OUTPUT
)
As

Declare @strSql varchar(2000),
	@strQry varchar(100),
	@strSort varchar(50)

If Not Exists(Select Idx_No From Wb_Group_Member Where Grp_Name = @strGroupName And Grp_Domain = @strDomain)
Begin
	Select 
		@iTotalCount = Count(wmi.Idx_No) 
	From 
		Wb_Member_Info As wmi Right Outer Join Wb_Group_Member As wgm On
		wmi.Member_Id = wgm.Grp_Member_Id
	Where
		Grp_Name = @strGroupName And Wb_Domain = Grp_Domain And Wb_Domain = @strDomain
	
	Set @strSql = 'Select Top ' + Str(@iPageSize)
	Set @strSql = @strSql + '	wmi.Idx_No As Idx_No, Member_Id, Member_Name '
	Set @strSql = @strSql + 'From '
	Set @strSql = @strSql + '	(Select Idx_No, Member_Id, Member_Name, Wb_Domain From Wb_Member_Info Where Member_Id Not In '
	Set @strSql = @strSql + '	(Select Grp_Member_Id From Wb_Group_Member Where Grp_Name = ''' + @strGroupName + ''' And Grp_Domain = ''' + @strDomain + ''') And '
	Set @strSql = @strSql + '	WB_Domain = ''' + @strDomain + ''') as wmi '
	Set @strSql = @strSql + 'Where '
	Set @strSql = @strSql + '	wmi.Idx_No Not In (Select Top ' + Str((@iPage - 1) * @iPageSize) + ' m.Idx_no From Wb_Member_Info  '
	Set @strSql = @strSql + '	as m Right Outer Join Wb_Group_Member As g On Member_Id <> g.Grp_Member_Id '
	Set @strSql = @strSql + '	Where Wb_Domain = ''' + @strDomain + ''' Group By m.Idx_No, Member_Id Order by Member_Id) And '
	Set @strSql = @strSql + '	wmi.Wb_Domain = ''' + @strDomain + ''' Order By Member_Id'

End
Else
Begin
	Select 
		@iTotalCount = Count(Idx_No) 
	From 
		Wb_Member_Info As m Left Outer Join 
		(Select Grp_Member_Id, Grp_Name, Grp_Domain From Wb_Group_Member Where Grp_Name = @strGroupName) As wgm On
			Member_Id = Grp_Member_Id And Wb_Domain = Grp_Domain
		Where
			IsNull(Grp_Name, '') = '' And Wb_Domain = @strDomain
	
	Set @strSql = 'Select Top ' + Str(@iPageSize)
	Set @strSql = @strSql + '	wmi.Idx_No As Idx_No, Member_Id, Member_Name '
	Set @strSql = @strSql + 'From '
	Set @strSql = @strSql + '	(Select Idx_No, Member_id, Member_Name, Wb_Domain From '
	Set @strSql = @strSql + '		Wb_Member_Info As m Left Outer Join '
	Set @strSql = @strSql + '		(Select Grp_Member_Id, Grp_Name, Grp_Domain From Wb_Group_Member Where Grp_Name = ''' + @strGroupName + ''') As g '
	Set @strSql = @strSql + '		On Member_Id = Grp_Member_Id And Wb_Domain = Grp_Domain '
	Set @strSql = @strSql + '	Where '
	Set @strSql = @strSql + '		IsNull(Grp_Name, '''') = '''' And '
	Set @strSql = @strSql + '		Wb_Domain = ''' + @strDomain + ''') As wmi '
	Set @strSql = @strSql + 'Where '
	Set @strSql = @strSql + '	wmi.Idx_No Not In '
	Set @strSql = @strSql + '	(Select Top ' + Str((@iPage - 1) * @iPageSize) + ' m.Idx_no From Wb_Member_Info as m Left Outer Join '
	Set @strSql = @strSql + '	(Select Grp_Member_Id, Grp_Name, Grp_Domain From Wb_Group_Member Where Grp_Name = ''' + @strGroupName + ''') As g On '
	Set @strSql = @strSql + '	Member_Id = g.Grp_Member_Id And Wb_Domain = Grp_Domain ' 
	Set @strSql = @strSql + '	Where '
	Set @strSql = @strSql + '		IsNull(Grp_Name, '''') = '''' And '
	Set @strSql = @strSql + '		Wb_Domain = ''' + @strDomain + ''' Order By Member_Id) And'
	Set @strSql = @strSql + '	wmi.Wb_Domain = ''' + @strDomain + ''' Order By Member_Id '
End

Exec (@strSql)

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



Create  Procedure prPubMonthSchedule
	(
		@varDomain varchar(255),
		@chrSolYear char(4),
		@chrSolMonth char(2)
	)
As

Select
	Str(SCH_NO) As SCH_NO,	SOL_YEAR,	SOL_MONTH,	SOL_DAY,	SCH_TITLE,	SCH_PUBLIC
From
	SCHEDULE
Where
	SOL_MONTH = @chrSolMonth And SOL_YEAR = @chrSolYear And SCH_REPEAT = 'N' And
	SCH_HOLIDAY = 'N' And SCH_PUBLIC = 'Y' And USER_DOMAIN = @varDomain
Order By SOL_YEAR, SOL_MONTH, SOL_DAY



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prReplyDoc
	(
		@iBrdNo int,
		@iDocNo int,
		@varDomain varchar(255),
		@varWriterId varchar(15),
		@varSubject varchar(50),
		@txtContent text,
		@varRemoteIp char(15),
		@varAttachFile varchar(255),
		@iAttachSize numeric(10, 0),
		@varRtnVal varchar(255) OUTPUT
	)
As

Declare @iMaxDocNo int
Declare @iRefNo int
Declare @iStep int
Declare @iSort int
Declare @iMaxDocSort int

If Not Exists(Select DOC_NO From DOC_INFO Where DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = '亯 ޷  Խù  ϴ.\r\n\r\nԽù ȣ: ' + Str(@iDocNo)
	Return - 1
End

Select 
	@iRefNo = IsNull(DOC_REF_NO, 0), @iStep = IsNull(DOC_STEP, 0), @iSort = IsNull(DOC_SORT, 0) 
From 
	DOC_INFO 
Where
	DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain

If @iStep = 0
Begin
	Select @iSort = IsNull(Max(DOC_SORT), 0) + 1 From DOC_INFO where DOC_REF_NO = @iRefNo And BRD_no = @iBrdNo And DOC_DOMAIN = @varDomain
	Set @iStep = @iStep + 1
End
Else
Begin
	Select @iMaxDocSort = IsNull(Max(DOC_SORT), 0) From DOC_INFO Where DOC_STEP > @iStep And DOC_SORT > @iSort And DOC_REF_NO = @iRefNo And BRD_no = @iBrdNo And DOC_DOMAIN = @varDomain
	If @iMaxDocSort <> 0
		Set @iSort = @iMaxDocSort

	Update DOC_INFO Set DOC_SORT = DOC_SORT + 1 Where DOC_SORT > @iSort And DOC_REF_NO = @iRefNo And BRD_no = @iBrdNo And DOC_DOMAIN = @varDomain

	Set @iStep = @iStep + 1
	Set @iSort = @iSort + 1
End

Select @iMaxDocNo = IsNull(Max(DOC_NO), 0) + 1 From DOC_INFO

Insert Into DOC_INFO 
(DOC_NO, BRD_NO, DOC_DOMAIN, DOC_WRITER_ID, DOC_SUBJECT, DOC_CONTENT, DOC_WRITE_DATE, 
DOC_READ_CNT, DOC_RECOM_CNT, DOC_REMOTE_IP, DOC_VIEW_NO, DOC_REF_NO, DOC_STEP, DOC_SORT,
DOC_ATTACH_FILE, DOC_ATTACH_SIZE) Values
(@iMaxDocNo, @iBrdNo, @varDomain, @varWriterId,  @varSubject, @txtContent, getDate(), 0, 0, @varRemoteIp,
0, @iRefNo, @iStep, @iSort, @varAttachFile, @iAttachSize)

If @@ERROR <> 0
	Return @@ERROR

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure prSearchAddr
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varSch varchar(100)
	)
As

Declare @varSql varchar(1000),
	@varSubSql varchar(100)

Select
	EMAIL_ADDR,	EMAIL_NAME
From
	MAIL_ADDRESS
Where
	(EMAIL_ADDR Like '%' + @varSch + '%' Or EMAIL_NAME Like '%' + @varSch + '%') And
	(USER_ID = @varUserId Or IS_COMMON = 'Y') And
	USER_DOMAIN = @varDomain
Group By EMAIL_ADDR, EMAIL_NAME
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prSearchZipCode
(
	@strDong varchar(43)
)
As

Select 
	ZipCode, Rtrim(SiDo) + ' ' + Rtrim(GuGun) + ' ' + Rtrim(Dong) As Addr1, 
	Rtrim(SiDo) + ' ' + Rtrim(GuGun) + ' ' + Rtrim(Dong) + ' ' + Rtrim(IsNull(Bunji, '')) As Addr2
From
	Wb_ZipCode
Where
	Dong Like '%' + @strDong + '%' Order by Seq

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prSelectEmailAddr
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroupName varchar(30),
		@chrCommon char(1),
		@intEmailId int,
		@varRtnUserId varchar(15) OUTPUT
--		@varRtnVal varchar(300) OUTPUT
	)
As
Declare @vUserId varchar(15),
	@varUserPermit char(1)


Select @varUserPermit = IS_COMMON, @varRtnUserId = USER_ID From MAIL_ADDRESS Where EMAIL_ID = @intEmailId

If @chrCommon = 'Y'
Begin
	/*
	Select 
		@vUserId = USER_ID 
	From 
		MAIL_ADDRESS 
	Where
		EMAIL_ID = @intEmailId And IS_COMMON = @chrCommon And
		GROUP_NAME = @varGroupName And USER_DOMAIN = @varDomain

	If @vUserId Is Null
	Begin
		Set @varRtnVal = 'Ϸ  ּҷ  ϴ.\r\n\r\nּҷ ȣ: ' + Str(@intEmailId)
		Return - 1
	End
	
	-- Ϸ   ´.
	Select @varUserPermit = USER_PERMIT From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain
	
	If @varUserPermit <> '1'
	Begin
		-- Ϸ ڰ  ڿ  ȮѴ.
		If @varUserId <> @vUserId
		Begin
			Set @varRtnVal = ' ּҷ   Ǵ ڸ   ֽϴ.\r\n\r\nּҷ ȣ: ' + Str(@intEmailId)
			Return -2
		End
	End
	*/	
	Select
		EMAIL_ADDR,	EMAIL_NAME,	ADDRESS1,	ADDRESS2,	
		SUBSTRING(ZIP_CODE, 1, 3) + '-' + SUBSTRING(ZIP_CODE, 4, 3) AS ZIP_CODE,	TEL,	CELL_PHONE,
		COMPANY_NAME,		POSITION AS COMPANY_POSITION,	OFFICE_TEL,	OFFICE_FAX,	ETC_MEMO 
	From
		MAIL_ADDRESS
	Where
		EMAIL_ID = @intEmailId And 
		IS_COMMON = @chrCommon And
		GROUP_NAME = @varGroupName And
		USER_DOMAIN = @varDomain
End
Else
Begin
	If @varUserPermit = 'Y'
	Begin
		Select
			EMAIL_ADDR,	EMAIL_NAME,	ADDRESS1,	ADDRESS2,	
			SUBSTRING(ZIP_CODE, 1, 3) + '-' + SUBSTRING(ZIP_CODE, 4, 3) AS ZIP_CODE,	TEL,	CELL_PHONE,
			COMPANY_NAME,		POSITION AS COMPANY_POSITION,	OFFICE_TEL,	OFFICE_FAX,	ETC_MEMO 
		From
			MAIL_ADDRESS
		Where
			EMAIL_ID = @intEmailId And 
			IS_COMMON = 'Y' And
			GROUP_NAME = @varGroupName And
			USER_DOMAIN = @varDomain
	End
	Else
	Begin
		Select
			EMAIL_ADDR,	EMAIL_NAME,	ADDRESS1,	ADDRESS2,	
			SUBSTRING(ZIP_CODE, 1, 3) + '-' + SUBSTRING(ZIP_CODE, 4, 3) AS ZIP_CODE,	TEL,	CELL_PHONE,
			COMPANY_NAME,		POSITION AS COMPANY_POSITION,	OFFICE_TEL,	OFFICE_FAX,	ETC_MEMO 
		From
			MAIL_ADDRESS
		Where
			EMAIL_ID = @intEmailId And 
			GROUP_NAME = @varGroupName And
			USER_ID = @varUserId And 
			USER_DOMAIN = @varDomain
	End
End

If @@ERROR <> 0
	Return @@ERROR
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prSelectFiltering
	(
		@varUserId varchar(15),
		@varDomain varchar(255)
	)
As

Select 
	F_WORDS,	F_TARGET,	F_MAILBOX
From
	FILTER
Where
	F_IS_USE = 'Y' And
	F_USER_ID = @varUserId And
	F_USER_DOMAIN = @varDomain


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prSelectGroupDesc
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroupName varchar(30),
		@chrCommon char(1)
	)
As

If @chrCommon = 'Y'
Begin
	Select 
		GROUP_DESC,
		IS_COMMON
	From 
		MAIL_GROUP 
	Where 
		IS_COMMON = @chrCommon And 
		GROUP_NAME = @varGroupName And
		USER_DOMAIN = @varDomain
End
Else
Begin
	Select
		GROUP_DESC,
		IS_COMMON
	From
		MAIL_GROUP
	Where
		IS_COMMON = @chrCommon And
		GROUP_NAME = @varGroupName And
		USER_ID = @varUserId And
		USER_DOMAIN = @varDomain
End

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prSelectMailBoxName
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varMailBox varchar(30)
	)
As

Select
	M_MAILBOX_NAME
From
	MAIL_BOX
Where
	M_MAILBOX = @varMailBox And
	M_USER_ID = @varUserId And
	M_USER_DOMAIN = @varDomain


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prSelectNote
	(
		@varUserId varchar(15),
		@varDomain varchar(255)
	)
As

Select NOTE_CONTENT From USER_NOTE Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prSelectPop3
	(
		@iPop3No int,
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varRtnVal varchar(200) OUTPUT
	)
As

If Not Exists(Select POP3_NO From MAIL_POP3 Where POP3_NO = @iPop3No And USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = ' POP3   ʽϴ.\r\n\r\nPOP3  ȣ: ' + Str(@iPop3No)
	Return -1
End

Select
	POP3_SERVER,	POP3_USER_ID,	POP3_USER_PWD,	POP3_SAVEBOX,	POP3_IS_DEL
From
	MAIL_POP3
Where
	POP3_NO = @iPop3No And
	USER_ID = @varUserId And
	USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prSelectSchedule
	(
		@iSchNo int,
		@varUserId varchar(15),
		@varDomain varchar(255) ,
		@chrPublic char(1)
	)

As

If @chrPublic = 'Y'
Begin
	Select
		SOL_YEAR, SOL_MONTH, SOL_DAY, LUN_YEAR, LUN_MONTH, LUN_DAY,
		SCH_ST_HOUR, SCH_ST_MINUTE, SCH_ED_HOUR, SCH_ED_MINUTE, SCH_TITLE,
		SCH_CONTENT, SCH_TYPE, SCH_REPEAT, SCH_IMPORT, SCH_IS_LUNAR,
		SCH_PUBLIC
	From
		SCHEDULE
	Where
		SCH_NO = @iSchNo And USER_DOMAIN = @varDomain And SCH_PUBLIC = @chrPublic
End
Else
Begin
	Select
		SOL_YEAR, SOL_MONTH, SOL_DAY, LUN_YEAR, LUN_MONTH, LUN_DAY,
		SCH_ST_HOUR, SCH_ST_MINUTE, SCH_ED_HOUR, SCH_ED_MINUTE, SCH_TITLE,
		SCH_CONTENT, SCH_TYPE, SCH_REPEAT, SCH_IMPORT, SCH_IS_LUNAR,
		SCH_PUBLIC
	From
		SCHEDULE
	Where
		SCH_NO = @iSchNo And USER_ID = @varUserId And USER_DOMAIN = @varDomain And SCH_PUBLIC = @chrPublic
End


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prSelectSign
	(
		@varUserId varchar(15),
		@varDomain varchar(255)
	)
As

Declare @iMaxNo int

If Not Exists(Select S_SIGN1 From SIGN_INFO Where S_USER_ID = @varUserId And S_USER_ID = @varUserId And S_USER_DOMAIN = @varDomain)
Begin
	Select @iMaxNo = IsNull(Max(SIGN_NO), 0) From SIGN_INFO
	
	If @iMaxNo Is Null
		Set @iMaxNo = 1
	Else
		Set @iMaxNo = @iMaxNo + 1

	Insert Into
		SIGN_INFO
		(SIGN_NO, S_USER_ID, S_USER_DOMAIN)
	Values
		(@iMaxNo, @varUserId, @varDomain)
End

Select
	S_SIGN1,	S_SIGN1_USE,	S_SIGN2,	S_SIGN2_USE,	S_SIGN3,	S_SIGN3_USE
From
	SIGN_INFO
Where
	S_USER_ID = @varUserId And
	S_USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prSelectUserInfo
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varRtnVal varchar(200) OUTPUT
	)
As

If Not Exists(Select USER_NO From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = '   ʽϴ.\r\n\r\n ̵: ' + @varUserId
	Return -1
End

Select
	USER_NAME,	USER_SEX,	USER_BIRTHDAY,		USER_LAST_EDU,		USER_JOB,
	USER_MARRY,	USER_POSITION,	USER_TEL,	USER_MOBILE,	USER_ZIPCODE,	USER_ADDRESS1,
	USER_ADDRESS2
From
	MAIL_USER Left Join USER_INFO 
	On 
	MAIL_USER.USER_ID = USER_INFO.USER_ID And
	MAIL_USER.USER_DOMAIN = USER_INFO.USER_DOMAIN
Where
	MAIL_USER.USER_ID = @varUserId And
	MAIL_USER.USER_DOMAIN = @varDomain
	

If @@ERROR <> 0
	Return @@ERROR

Return 0



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE Procedure prStringSearchAddr
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@varGroup varchar(30),
		@chrIsCommon char(1),
		@chrSchSt char(2),
		@chrSchEd char(2),
		@iTotCount int OUTPUT
	)
As

Declare @varSql varchar(1500),
	@varSubSql varchar(300),
	@varSubQuery varchar(300)

If @chrSchSt <> ''
Begin
	If @chrSchSt = '' And @chrSchEd = 'A'
	Begin
		Set @varSubSql = 'SUBSTRING(EMAIL_NAME, 1, 1) < ''' + @chrSchSt + ''' AND '
		Set @varSubSql = @varSubSql + ' SUBSTRING(EMAIL_NAME, 1, 1) < ''' + @chrSchEd + ''' AND '
	End
	Else
	Begin
		Set @varSubSql = 'SUBSTRING(EMAIL_NAME, 1, 1) >= ''' + @chrSchSt + ''' AND '
		
		If @chrSchEd <> ''
			Set @varSubSql = @varSubSql + 'SUBSTRING(EMAIL_NAME, 1, 1) < ''' + @chrSchEd + ''' AND '
	End
End

If @varGroup <> ''
Begin
	Set @varSubSql = @varSubSql + ' GROUP_NAME = ''' + @varGroup + ''' AND '
End

If @chrIsCommon = 'Y'
Begin
	Set @varSubQuery = ' Or '
End
Else
Begin
	Set @varSubQuery =  ' And '
End

If @chrSchSt <> '' And @chrSchEd <> ''
Begin
	If @chrIsCommon = 'Y'
	Begin
		-- Ÿ ˻
		If @chrSchSt = '' And @chrSchEd = 'A' 
		Begin
			If @varGroup <> ''
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) < @chrSchSt And SubString(Email_Name, 1, 1) < @chrSchEd And
				GROUP_NAME = @varGroup And IS_COMMON = @chrIsCommon And USER_DOMAIN = @varDomain
			End
			Else
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) < @chrSchSt And SubString(Email_Name, 1, 1) < @chrSchEd And
				IS_COMMON = @chrIsCommon And USER_DOMAIN = @varDomain
			End
		End
		Else
		Begin
			If @varGroup <> ''
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) >= @chrSchSt And SubString(Email_Name, 1, 1) <= @chrSchEd And
				GROUP_NAME = @varGroup And IS_COMMON = @chrIsCommon And USER_DOMAIN = @varDomain
			End
			Else
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) >= @chrSchSt And SubString(Email_Name, 1, 1) <= @chrSchEd And
				IS_COMMON = @chrIsCommon And USER_DOMAIN = @varDomain
			End
		End
	End
	Else
	Begin
		-- Ÿ ˻
		If @chrSchSt = '' And @chrSchEd = 'A' 
		Begin
			If @varGroup <> ''
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) < @chrSchSt And SubString(Email_Name, 1, 1) < @chrSchEd And
				GROUP_NAME = @varGroup And USER_ID = @varUserId And USER_DOMAIN = @varDomain
			End
			Else
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) < @chrSchSt And SubString(Email_Name, 1, 1) < @chrSchEd And
				USER_ID = @varUserId And USER_DOMAIN = @varDomain
			End
		End
		Else
		Begin
			If @varGroup <> ''
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) >= @chrSchSt And SubString(Email_Name, 1, 1) <= @chrSchEd And
				GROUP_NAME = @varGroup And USER_ID = @varUserId And USER_DOMAIN = @varDomain
			End
			Else
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) >= @chrSchSt And SubString(Email_Name, 1, 1) <= @chrSchEd And
				USER_ID = @varUserId And USER_DOMAIN = @varDomain
			End
		End
	End
End
Else
Begin
	If @chrSchSt <> '' 
	Begin
		If @chrIsCommon = 'Y'
		Begin
			If @varGroup <> ''
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) >= @chrSchSt And
				GROUP_NAME = @varGroup And IS_COMMON = @chrIsCommon And USER_DOMAIN = @varDomain
			End
			Else
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) >= @chrSchSt And
				IS_COMMON = @chrIsCommon And USER_DOMAIN = @varDomain
			End
		End
		Else
		Begin
			If @varGroup <> ''
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) >= @chrSchSt And
				GROUP_NAME = @varGroup And USER_ID = @varUserId And USER_DOMAIN = @varDomain
			End
			Else
			Begin
				Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) >= @chrSchSt And
				USER_ID = @varUserId And USER_DOMAIN = @varDomain
			End
		End
	End
	Else
	Begin
		If @chrSchEd <> ''
		Begin
			If @chrIsCommon = 'Y'
			Begin
				If @varGroup <> ''
				Begin
					Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) <= @chrSchEd And
					GROUP_NAME = @varGroup And IS_COMMON = @chrIsCommon And USER_DOMAIN = @varDomain
				End
				Else
				Begin
					Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) <= @chrSchEd And
					IS_COMMON = @chrIsCommon And USER_DOMAIN = @varDomain
				End
			End
			Else
			Begin
				If @varGroup <> ''
				Begin
					Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) <= @chrSchEd And
					GROUP_NAME = @varGroup And USER_ID = @varUserId And USER_DOMAIN = @varDomain
				End
				Else
				Begin
					Select @iTotCount = Count(GROUP_NAME) From MAIL_ADDRESS Where SubString(Email_Name, 1, 1) <= @chrSchEd And
					USER_ID = @varUserId And USER_DOMAIN = @varDomain
				End
			End
		End
	End
End

Set @varSql = 'SELECT '
Set @varSql = @varSql + '	GROUP_NAME,	EMAIL_ID,	EMAIL_ADDR,	EMAIL_NAME,	TEL, '
Set @varSql = @varSql + '	CELL_PHONE,	IS_COMMON '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + '	MAIL_ADDRESS '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + @varSubSql
Set @varSql = @varSql + ' (USER_ID = ''' + @varUserId + ''' ' + @varSubQuery + ' IS_COMMON = ''' + @chrIsCommon + ''') And '
Set @varSql = @varSql + '	USER_DOMAIN = ''' + @varDomain + ''' Order By EMAIL_NAME ASC'

Exec (@varSql)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prStringSearchGroup
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@chrSchSt char(2),
		@chrSchEd char(2)
	)
As

Declare @varSql varchar(1000),
	@varSubSql varchar(100)

If @chrSchSt <> ''
Begin
	Set @varSubSql = 'SUBSTRING(G.GROUP_NAME, 1, 1) >= ''' + @chrSchSt + ''' AND '
	
	If @chrSchEd <> ''
		Set @varSubSql = @varSubSql + 'SUBSTRING(G.GROUP_NAME, 1, 1) < ''' + @chrSchEd + ''' AND '
End
	
Set @varSql = 'SELECT '
Set @varSql = @varSql + '	IsNull(Count(EMAIL_ID), 0) As EMAIL_COUNT, G.GROUP_NAME As GROUP_NAME, G.IS_COMMON As IS_COMMON '
Set @varSql = @varSql + 'From '
Set @varSql = @varSql + '	MAIL_GROUP G Left Outer Join MAIL_ADDRESS A On  '
Set @varSql = @varSql + '	G.GROUP_NAME = A.GROUP_NAME And '
Set @varSql = @varSql + '	G.USER_ID = A.USER_ID And '
Set @varSql = @varSql + '	G.USER_DOMAIN = A.USER_DOMAIN '
Set @varSql = @varSql + 'Where '
Set @varSql = @varSql + @varSubSql
Set @varSql = @varSql + '	(G.USER_ID = ''' + @varUserId + ''' Or G.IS_COMMON = ''Y'') And '
Set @varSql = @varSql + '	G.USER_DOMAIN = ''' + @varDomain + ''' Group By G.GROUP_NAME, G.IS_COMMON Order By GROUP_NAME ASC'

Exec (@varSql)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prTodaySchedule
	(
		@varUserId varchar(15),
		@varDomain varchar(255),
		@chrSolYear char(4),
		@chrSolMonth char(2),
		@chrSolDay char(2)
	)

As

Select
	Str(SCH_NO) As SCH_NO, SOL_YEAR, SOL_MONTH, SOL_DAY, SCH_ST_HOUR, SCH_ED_HOUR, SCH_TITLE, SCH_PUBLIC
From
	SCHEDULE
Where
	SOL_DAY = @chrSolDay And SOL_MONTH = @chrSolMonth And SOL_YEAR = @chrSolYear And
	 USER_ID = @varUserId And USER_DOMAIN = @varDomain

If @@ERROR <> 0
	return @@ERROR

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




Create   Procedure prTopOneLunarDate
	(
		@chrSolarDate char(10),
		@chrLunarDate char(10) OUTPUT
	)
As
	Select Top 1 @chrLunarDate = LUNAR_DATE From SOL_LUN_DATE Where SOLAR_DATE = @chrSolarDate
	
If @@ERROR <> 0
	Set @chrLunarDate = @@ERROR



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




Create   Procedure prTopOneSolarDate
	(
		@chrLunarDate char(10),
		@chrSolarDate char(10) OUTPUT
	)
As
	Select Top 1 @chrSolarDate = SOLAR_DATE From SOL_LUN_DATE Where LUNAR_DATE = @chrLunarDate
	
If @@ERROR <> 0
	Set @chrSolarDate = @@ERROR



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prUpdateDownloadCount
(
	@strGuid varchar(128),
	@strReturnValue varchar(200) OUTPUT
)
As

If Not Exists(Select Idx_Guid From Wb_Filedown_Limit Where Idx_Guid = @strGuid)
Begin
	Set @strReturnValue = @strGuid + '  ϵ   ϴ.'
	Return -1
End

Update Wb_Filedown_Limit Set
	Down_Count = Down_Count + 1
Where
	Idx_Guid = @strGuid

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prUpdateMailBoxSize
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@intMailboxSize int,
		@strReturnValue varchar(300) OUTPUT
	)
As

Declare @iTotalSize int,
	@iTotalCount int,
	@iAllocateSize int

If @varUserId <> ''
Begin
	Select @iAllocateSize = WDC_AllocateSize From Webmail_Domain_Config Where WDC_Domain = @varDomain
	
	Select @iTotalSize = Sum(User_Mailbox_Size) From Mail_User Where User_Id <> @varUserId And User_Domain = @varDomain
	
	If @iAllocateSize < (@iTotalSize + @intMailboxSize)
	Begin
		Set @strReturnValue = 'Ϸ 뷮 Ҵ 뷮 ʰϿϴ.\r\n'
		Set @strReturnValue = @strReturnValue + 'Ҵ 뷮: ' + Str(@iAllocateSize) + ' MB\r\n'
		Set @strReturnValue = @strReturnValue + 'ϸ鼭   뷮: ' + Str(@iTotalSize) + ' MB\r\n'
		Set @strReturnValue = @strReturnValue + 'Ϸ 뷮: ' + Str(@intMailboxSize) + ' MB'
		Return -1
	End

	Update
		MAIL_USER
	Set
		USER_MAILBOX_SIZE = @intMailboxSize
	Where
		USER_ID = @varUserId And
		USER_DOMAIN = @varDomain
End
Else
Begin
	Select @iAllocateSize = WDC_AllocateSize From Webmail_Domain_Config Where WDC_Domain = @varDomain
	
	Select @iTotalSize = Sum(User_Mailbox_Size), @iTotalCount = Count(User_No) From Mail_User Where User_Domain = @varDomain

	If @iAllocateSize < (@iTotalCount * @intMailboxSize)
	Begin
		Set @strReturnValue = 'Ϸ 뷮 Ҵ 뷮 ʰϿϴ.\r\n'
		Set @strReturnValue = @strReturnValue + 'Ҵ 뷮: ' + Str(@iAllocateSize) + ' MB\r\n'
		Set @strReturnValue = @strReturnValue + ' : ' + Str(@iTotalCount) + ' \r\n'
		Set @strReturnValue = @strReturnValue + 'Ϸ 뷮: ' + Str(@intMailboxSize) + ' MB'
		Return -2
	End

	Update
		MAIL_USER
	Set
		USER_MAILBOX_SIZE = @intMailboxSize
	Where
		USER_DOMAIN = @varDomain
End

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE  Procedure prUpdateSchedule
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@chrSolYear char(4),
		@chrSolMonth char(2),
		@chrSolDay char(2),
		@chrLunYear char(4),
		@chrLunMonth char(2),
		@chrLunDay char(2),
		@chrSchStHour char(2),
		@chrSchStMinute char(2),
		@chrSchEdHour char(2),
		@chrSchEdMinute char(2),
		@varSchTitle varchar(100),
		@txtSchContent text,
		@chrSchType char(2),
		@chrSchHoliday char(1),
		@chrSchPublic char(1),
		@chrSchRepeat char(1),
		@chrSchImport char(2),
		@chrSchIsLunar char(1),
		@intSchNo int
	)
As

UPDATE 
	SCHEDULE
SET 
	SOL_YEAR = @chrSolYear,		SOL_MONTH = @chrSolMonth,	SOL_DAY = @chrSolDay,
	LUN_YEAR = @chrLunYear,	LUN_MONTH = @chrLunMonth,	LUN_DAY = @chrLunDay,
	SCH_ST_HOUR = @chrSchStHour,	SCH_ST_MINUTE = @chrSchStMinute,
	SCH_ED_HOUR = @chrSchEdHour,	SCH_ED_MINUTE = @chrSchEdMinute,
	SCH_TITLE = @varSchTitle,		SCH_CONTENT = @txtSchContent,
	SCH_TYPE = @chrSchType,	SCH_HOLIDAY = @chrSchHoliday,	SCH_PUBLIC = @chrSchPublic,
	SCH_REPEAT = @chrSchRepeat,	SCH_IMPORT = @chrSchImport,	SCH_IS_LUNAR = @chrSchIsLunar
WHERE
	SCH_NO = @intSchNo And USER_ID = @varUserId And USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prUpdateUserAuth
(
	@varUserId varchar(15),
	@varDomain varchar(255),
	@chrUserAuth char(1)
)

As

If @varUserId <> ''
Begin
	Update MAIL_USER Set
		USER_AUTHORITY = @chrUserAuth
	Where
		IS_MAILING = 0 And
		USER_ID = @varUserId And 
		USER_DOMAIN = @varDomain

End
Else
Begin 
	Update MAIL_USER Set
		USER_AUTHORITY = @chrUserAuth
	Where
		IS_MAILING = 0 And
		USER_DOMAIN = @varDomain
End

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prUpdateUserInfo
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@varUserName varchar(30),
		@chrUserPermit char(1),
		@chrUserAuth char(1),
		@intUserMaxSize int,
		@chrPop3Allow char(1),
		@varRtnVal varchar(100) OUTPUT
	)
As

Declare @iPermitCnt int,
	@chrOrgPermit char(1)

Select @chrOrgPermit = USER_PERMIT From USER_INFO Where USER_ID = @varUserId And USER_DOMAIN = @varDomain

If @chrOrgPermit <> '1'
Begin
	Select @iPermitCnt = Count(USER_PERMIT) From USER_INFO Where USER_DOMAIN = @varDomain And USER_PERMIT = '1'
	
	If @chrUserPermit = '1'
	Begin
		
		Set @iPermitCnt = @iPermitCnt + 1
		
		If @iPermitCnt > 1
		Begin
			Set @varRtnVal = '̹ ϵǾ ִ ڰ  մϴ.\r\n\r\nڸ Ϸ  ڸ   ּ.'
			Return -1
		End
	End
End

If @varUserName = ''
	Set @varUserName = @varUserId

Update 
	MAIL_USER 
Set
	USER_NAME = @varUserName,
	USER_PERMIT = @chrUserPermit,
	USER_AUTHORITY = @chrUserAuth,
	USER_MAILBOX_SIZE = @intUserMaxSize,
	POP3_ALLOW = @chrPop3Allow
Where
	USER_ID = @varUserId And
	USER_DOMAIN = @varDomain

If Not Exists(Select [User_Id] From USER_INFO Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Insert Into USER_INFO (USER_ID,	USER_DOMAIN,	USER_PERMIT) Values
			(@varUserId,	@varDomain,	@chrUserPermit)
End
Else
Begin
	Update
		USER_INFO
	Set
		USER_PERMIT = @chrUserPermit
	Where
		USER_ID = @varUserId And
		USER_DOMAIN = @varDomain	
End

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prUpdateUserPwd
	(
		@varUserPwd varchar(15),
		@varUserId varchar(20),
		@varDomain varchar(255)
	)
As

Update
	MAIL_USER
Set
	USER_PWD = @varUserPwd
Where
	USER_ID = @varUserId And USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE prUserCount
	(
		@varDomain varchar(255)
	)
As

Declare @intUserCnt int

Select @intUserCnt = Count(USER_NO) From MAIL_USER Where USER_DOMAIN = @varDomain

If @@ERROR > 0
	Set @intUserCnt = @@ERROR

Return @intUserCnt



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prUserPermit
As
	Select Rtrim(CODE_ID) As CODE_ID, CODE_NAME From CODE Where CODE_ID <> '===' And
	CODE_CLASS = 'UP' Order by CODE_SORT ASC



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE Procedure prViewDoc
	(
		@iBrdNo int,
		@iDocNo int,
		@varDomain varchar(255)
	)
As

Select
	USER_NAME, USER_ID + '@' + USER_DOMAIN AS EMAIL, DOC_WRITE_TYPE, DOC_SUBJECT, DOC_CONTENT, DOC_WRITE_DATE,
	DOC_READ_CNT, DOC_RECOM_CNT, DOC_VIEW_NO, DOC_ATTACH_FILE, DOC_ATTACH_SIZE
From
	DOC_INFO,
	MAIL_USER
Where
	DOC_WRITER_ID = USER_ID And
	DOC_NO = @iDocNo And
	BRD_NO = @iBrdNo And
	DOC_DOMAIN = USER_DOMAIN And
	DOC_DOMAIN = @varDomain

If @@ERROR <> 0 
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


Create Procedure prViewFilteringInfo
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@intFilterNo int
	) 
As

Select
	F_WORDS,	F_TARGET,	F_MAILBOX,	F_IS_USE
From
	FILTER
Where
	FILTER_NO = @intFilterNo And
	F_USER_ID = @varUserId And
	F_USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE  Procedure prViewMailUserInfo
	(
		@varUserId varchar(20),
		@varDomain varchar(255),
		@varRtnVal varchar(200) OUTPUT
	)
As

If Not Exists(Select USER_NO From MAIL_USER Where USER_ID = @varUserId And USER_DOMAIN = @varDomain)
Begin
	Set @varRtnVal = @varUserId + '  ϵ ڰ ϴ.\r\n\r\nڸ Ȯ ּ.'
	Return - 1
End

Select 
	USER_NO,	USER_NAME,	USER_PWD,	USER_MAILBOX_SIZE,	USER_AUTHORITY,
	USER_MAILBOX_PATH,		Case IsNull(UI.USER_PERMIT, MU.USER_PERMIT) When 0 Then 2 Else IsNull(UI.USER_PERMIT, MU.USER_PERMIT) End AS USER_PERMIT,	POP3_ALLOW,
	USER_SEX,	USER_BIRTHDAY,	LE.CODE_NAME AS USER_LAST_EDU,	JO.CODE_NAME AS USER_JOB,
	USER_MARRY,	USER_POSITION,	USER_TEL,	USER_MOBILE,		USER_ZIPCODE,
	USER_ADDRESS1, USER_ADDRESS2
From
	MAIL_USER MU LEFT JOIN USER_INFO UI ON
	MU.USER_ID = UI.USER_ID AND MU.USER_DOMAIN = UI.USER_DOMAIN LEFT JOIN
	(SELECT CODE_ID, CODE_NAME FROM CODE WHERE CODE_CLASS = 'LE' AND CODE_ID <> '===') LE ON
	RTRIM(UI.USER_LAST_EDU) = RTRIM(LE.CODE_ID) LEFT JOIN
	(SELECT CODE_ID, CODE_NAME FROM CODE WHERE CODE_CLASS = 'JO' AND CODE_ID <> '===') JO ON
	UI.USER_JOB = JO.CODE_ID
WHERE
	MU.USER_ID = @varUserId AND MU.USER_DOMAIN = @varDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prWebhardGroupList
(
	@strDomain varchar(255)
)
As


Select 
	Idx_Grp_No,	Grp.Grp_name As Group_name,	Grp_Owner_Id,	Grp_Allocate_Size,	Grp_Create_Date,
	Case Grp_Use_Accept When 'Y' Then '' When 'N' Then '' End As Grp_Use_Accept,
	IsNull(Member_Count, 0) As Member_Count
From
	Wb_Group_Info As Grp Left Outer Join 
	(Select Count(Idx_No) As Member_Count, Grp_Name From Wb_Group_Member Where Grp_Domain = @strDomain Group By Grp_Name) As Mb On
	Grp.Grp_Name = Mb.Grp_Name
Where
	Grp_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create Procedure prWebhardGroupMemberList
(
	@strDomain varchar(255),
	@strGroupName varchar(30)
)
As

Select
	wgm.Idx_No As Idx_No,	Grp_Member_id,	wmi.Member_Name As Member_Name,	Is_Down_Limit,	Is_Upload_Limit,	Is_Delete_Limit,	Join_Date
From
	Wb_Group_Member As wgm Left Outer Join Wb_Member_Info As wmi On
	wgm.Grp_Member_id = wmi.Member_Id
Where
	Grp_Name = @strGroupName And wgm.Grp_Domain = wmi.Wb_Domain And wmi.Wb_Domain = @strDomain
Order By Grp_Member_Id

If @@ERROR <> 0
	Return @@ERROR

Return 0




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE Procedure prWebhardMemberGroupList
(
	@strMemberId varchar(30),	
	@strDomain varchar(255)
)
As

Select 
	Idx_No,	Is_Down_Limit,	Is_Upload_Limit,	Is_Delete_Limit,	wgm.Grp_Name As Grp_Name,	wgi.Grp_Path As Grp_Path
From
	Wb_Group_Member As wgm Left Outer Join Wb_Group_Info As wgi On
	wgm.Grp_Name = wgi.Grp_Name
Where
	wgi.Grp_Use_Accept = 'Y' And Grp_Member_Id = @strMemberId And
	wgm.Grp_Domain = wgi.Grp_Domain And wgi.Grp_Domain = @strDomain

If @@ERROR <> 0
	Return @@ERROR

Return 0


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

